Package: MungeSumstats
Type: Package
Title: Standardise summary statistics from GWAS
Version: 1.20.0
Authors@R: 
    c(person(given = "Alan",
           family = "Murphy",
           role = c("aut","cre"),
           email = "alanmurph94@hotmail.com",
           comment = c(ORCID = "0000-0002-2487-8753")),
     person(given = "Brian",
           family = "Schilder",
           role = c("aut","ctb"),
           email = "brian_schilder@alumni.brown.edu",
           comment = c(ORCID = "0000-0001-5949-2191")),
    person(given = "Nathan",
           family = "Skene",
           role = c("aut"),
           email = "nathan.skene@gmail.com",
           comment = c(ORCID = "0000-0002-6807-3180"))) 
Description: 
  The *MungeSumstats* package is designed to facilitate the standardisation of 
  GWAS summary statistics. It reformats inputted summary statisitics to include 
  SNP, CHR, BP and can look up these values if any are missing. It also pefrorms 
  dozens of QC and filtering steps to ensure high data quality and
  minimise inter-study differences. 
URL: https://github.com/neurogenomics/MungeSumstats,
        https://al-murphy.github.io/MungeSumstats/
BugReports: https://github.com/neurogenomics/MungeSumstats/issues
License: Artistic-2.0
Depends: R(>= 4.1)
Imports: data.table, utils, R.utils, dplyr, stats, GenomicRanges,
        GenomeInfoDb, IRanges, ieugwasr(>= 1.0.1), BSgenome,
        Biostrings, stringr, VariantAnnotation, methods, parallel,
        rtracklayer(>= 1.59.1), RCurl
biocViews: SNP, WholeGenome, Genetics, ComparativeGenomics,
        GenomeWideAssociation, GenomicVariation, Preprocessing
RoxygenNote: 7.3.2
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
Suggests: SNPlocs.Hsapiens.dbSNP144.GRCh37,
        SNPlocs.Hsapiens.dbSNP144.GRCh38,
        SNPlocs.Hsapiens.dbSNP155.GRCh37,
        SNPlocs.Hsapiens.dbSNP155.GRCh38,
        BSgenome.Hsapiens.1000genomes.hs37d5,
        BSgenome.Hsapiens.NCBI.GRCh38, BiocGenerics, S4Vectors,
        rmarkdown, markdown, knitr, testthat (>= 3.0.0), UpSetR,
        BiocStyle, covr, Rsamtools, MatrixGenerics, badger,
        BiocParallel, GenomicFiles
Config/testthat/edition: 3
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/MungeSumstats
git_branch: RELEASE_3_23
git_last_commit: 63fc668
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:31:41 UTC; biocbuild
Author: Alan Murphy [aut, cre] (ORCID: <https://orcid.org/0000-0002-2487-8753>),
  Brian Schilder [aut, ctb] (ORCID:
    <https://orcid.org/0000-0001-5949-2191>),
  Nathan Skene [aut] (ORCID: <https://orcid.org/0000-0002-6807-3180>)
Maintainer: Alan Murphy <alanmurph94@hotmail.com>

`MungeSumstats`: Standardise the format of GWAS summary statistics
================
<h5>  
<i>Authors</i>: Alan Murphy, Brian Schilder and Nathan Skene  
</h5>
<h5>  
<i>Updated</i>: Nov-06-2025  
</h5>

<!-- Readme.md is generated from Readme.Rmd. Please edit that file -->

<!-- badges: start -->

[![](https://img.shields.io/badge/release%20version-1.16.0-black.svg)](https://www.bioconductor.org/packages/MungeSumstats)
[![](https://img.shields.io/badge/devel%20version-1.13.4-black.svg)](https://github.com/neurogenomics/MungeSumstats)
[![](https://img.shields.io/github/last-commit/neurogenomics/MungeSumstats.svg)](https://github.com/neurogenomics/MungeSumstats/commits/master)
[![](https://img.shields.io/badge/download-31127/total-blue.svg)](https://bioconductor.org/packages/stats/bioc/MungeSumstats)
[![License:
Artistic-2.0](https://img.shields.io/badge/license-Artistic--2.0-blue.svg)](https://cran.r-project.org/web/licenses/Artistic-2.0)
[![](https://img.shields.io/badge/doi-https://doi.org/10.1093/bioinformatics/btab665-blue.svg)](https://doi.org/https://doi.org/10.1093/bioinformatics/btab665)
<!-- badges: end -->
<!--[![R build status](https://github.com/neurogenomics/MungeSumstats/workflows/rworkflows/badge.svg)](https://github.com/neurogenomics/MungeSumstats/actions)-->
<!--`[![](https://codecov.io/gh/neurogenomics/MungeSumstats/branch/master/graph/badge.svg)](https://app.codecov.io/gh/neurogenomics/MungeSumstats) -->

# Introduction

The `MungeSumstats` package is designed to facilitate the
standardisation of GWAS summary statistics.

## Overview

The package is designed to handle the lack of standardisation of output
files by the GWAS community. The [MRC IEU Open
GWAS](https://gwas.mrcieu.ac.uk/) team have provided full summary
statistics for \>10k GWAS, which are API-accessible via the
[`ieugwasr`](https://mrcieu.github.io/ieugwasr/) and
[`gwasvcf`](https://github.com/MRCIEU/gwasvcf) packages. But these GWAS
are only standardised in the sense that they are VCF format, and can be
fully standardised with `MungeSumstats`.

`MungeSumstats` provides a framework to standardise the format for any
GWAS summary statistics, including those in VCF format, enabling
downstream integration and analysis. It addresses the most common
discrepancies across summary statistic files, and offers a range of
adjustable Quality Control (QC) steps.

## Citation

If you use `MungeSumstats`, please cite the original authors of the GWAS
as well as:

> Alan E Murphy, Brian M Schilder, Nathan G Skene (2021) MungeSumstats:
> A Bioconductor package for the standardisation and quality control of
> many GWAS summary statistics. *Bioinformatics*, btab665,
> <https://doi.org/10.1093/bioinformatics/btab665>

# Installing `MungeSumstats`

`MungeSumstats` is available on
[Bioconductor](https://bioconductor.org/packages/MungeSumstats). To
install `MungeSumstats` on Bioconductor run:

``` r
if (!require("BiocManager")) install.packages("BiocManager")

BiocManager::install("MungeSumstats")
```

You can then load the package and data package:

``` r
library(MungeSumstats)
```

Note that there is also a [docker image for
MungeSumstats](https://hub.docker.com/r/neurogenomicslab/mungesumstats).

Note that for a number of the checks implored by `MungeSumstats` a
reference genome is used. If your GWAS summary statistics file of
interest relates to *GRCh38*, you will need to install
`SNPlocs.Hsapiens.dbSNP155.GRCh38` and `BSgenome.Hsapiens.NCBI.GRCh38`
from Bioconductor as follows:

``` r
BiocManager::install("SNPlocs.Hsapiens.dbSNP155.GRCh38")
BiocManager::install("BSgenome.Hsapiens.NCBI.GRCh38")
```

If your GWAS summary statistics file of interest relates to *GRCh37*,
you will need to install `SNPlocs.Hsapiens.dbSNP155.GRCh37` and
`BSgenome.Hsapiens.1000genomes.hs37d5` from Bioconductor as follows:

``` r
BiocManager::install("SNPlocs.Hsapiens.dbSNP155.GRCh37")
BiocManager::install("BSgenome.Hsapiens.1000genomes.hs37d5")
```

These may take some time to install and are not included in the package
as some users may only need one of *GRCh37*/*GRCh38*. If you are unsure
of the genome build, MungeSumstats can also infer this information from
your data.

# Getting started

See the [Getting started vignette
website](https://al-murphy.github.io/MungeSumstats/articles/MungeSumstats.html)
for up-to-date instructions on usage.

See the [OpenGWAS vignette
website](https://al-murphy.github.io/MungeSumstats/articles/OpenGWAS.html)
for information on how to use MungeSumstats to access, standardise and
perform quality control on GWAS Summary Statistics from the MRC IEU
[Open GWAS Project](https://gwas.mrcieu.ac.uk/).

**NOTE** to authenticate, you need to generate a token from the OpenGWAS
website. The token behaves like a password, and it will be used to
authorise the requests you make to the OpenGWAS API. Here are the steps
to generate the token and then have `ieugwasr` automatically use it for
your queries:

1.  Login to <https://api.opengwas.io/profile/>
2.  Generate a new token
3.  Add `OPENGWAS_JWT=<token>` to your .Renviron file, thi can be edited
    in R by running `usethis::edit_r_environ()`
4.  Restart your R session
5.  To check that your token is being recognised, run
    `ieugwasr::get_opengwas_jwt()`. If it returns a long random string
    then you are authenticated.
6.  To check that your token is working, run `ieugwasr::user()`. It will
    make a request to the API for your user information using your
    token. It should return a list with your user information. If it
    returns an error, then your token is not working.
7.  Make sure you have submitted use

Please read carefully through the [FAQ
website](https://github.com/Al-Murphy/MungeSumstats/wiki/FAQ) for an
queries about running MungeSumstats. If you have any outside of this
problems please do file an
[Issue](https://github.com/al-murphy/MungeSumstats/issues) here on
GitHub.

# Future Enhancements

The `MungeSumstats` package aims to be able to handle the most common
summary statistic file formats including VCF. If your file can not be
formatted by `MungeSumstats` feel free to report the
[Issue](https://github.com/al-murphy/MungeSumstats/issues) on GitHub
along with your summary statistics file header.

We also encourage people to edit the code to resolve their particular
issues too and are happy to incorporate these through pull requests on
github. If your summary statistic file headers are not recognised by
`MungeSumstats` but correspond to one of

    SNP, BP, CHR, A1, A2, P, Z, OR, BETA, LOG_ODDS, SIGNED_SUMSTAT, N, N_CAS, N_CON, 
    NSTUDY, INFO or FRQ, 

Feel free to update the `data("sumstatsColHeaders")` following the
approach in the *data.R* file and add your mapping. Then use a [Pull
Request](https://github.com/al-murphy/MungeSumstats/pulls) on GitHub and
we will incorporate this change into the package.

# Contributors

We would like to acknowledge all those who have contributed to
`MungeSumstats` development:

- [Alan Murphy](https://github.com/Al-Murphy)
- [Nathan Skene](https://github.com/NathanSkene)
- [Brian Schilder](https://github.com/bschilder)
- [Shea Andrews](https://github.com/sjfandrews)
- [Jonathan Griffiths](https://github.com/jonathangriffiths)
- [Kitty Murphy](https://github.com/KittyMurphy)
- [Mykhaylo Malakhov](https://github.com/MykMal)
- [Alasdair Warwick](https://github.com/rmgpanw)
- [Ao Lu](https://github.com/leoarrow1)
- [Sufyan Sualeman](https://github.com/sufyansuleman)
- [Toby Clark](https://github.com/toby-clark4)

#' Read -log10 p-value column
#' 
#' Parse p-value column in VCF file.of other general -loq10 p-values
#' 
#' @param sumstats_dt Summary stats data.table. 
#' @param return_list Binary, whether to return the dt in a list or not - list 
#' is standard for the `format_sumstats()` function.
#' @inheritParams format_sumstats 
#' 
#' @returns Null output.
#' @keywords internal
#' @importFrom data.table setnames
read_log_pval <- function(sumstats_dt,mapping_file = sumstatsColHeaders,
                          return_list=TRUE){
    P <- NULL
    # Need to convert P-value, currently -log10
    #cgreate a check based on mapping file
    column_headers <- names(sumstats_dt) 
    column_headers_upper <- toupper(names(sumstats_dt))
    #get all p mappings 
    mapping_file_p <- mapping_file[mapping_file$Corrected=="P",]
    #now create all possible -log10 p-value
    log_p_col <- c(paste0("-LOG10_",mapping_file_p$Uncorrected),
                   paste0("LOG10_",mapping_file_p$Uncorrected),
                   paste0("-LOG10 ",mapping_file_p$Uncorrected),
                   paste0("LOG10 ",mapping_file_p$Uncorrected),
                   paste0("-LOG10-",mapping_file_p$Uncorrected),
                   paste0("LOG10-",mapping_file_p$Uncorrected),
                   paste0("-LOG10.",mapping_file_p$Uncorrected),
                   paste0("LOG10.",mapping_file_p$Uncorrected),
                   paste0("-LOG10",mapping_file_p$Uncorrected),
                   paste0("LOG10",mapping_file_p$Uncorrected),
                   paste0("LOG_",mapping_file_p$Uncorrected),
                   paste0("-L_",mapping_file_p$Uncorrected),
                   paste0("L_",mapping_file_p$Uncorrected),
                   paste0("LOG-",mapping_file_p$Uncorrected),
                   paste0("-L-",mapping_file_p$Uncorrected),
                   paste0("L-",mapping_file_p$Uncorrected),
                   paste0("LOG.",mapping_file_p$Uncorrected),
                   paste0("-L.",mapping_file_p$Uncorrected),
                   paste0("L.",mapping_file_p$Uncorrected),
                   paste0("-L",mapping_file_p$Uncorrected),
                   paste0("L",mapping_file_p$Uncorrected),
                   "LP")
    lp_found <- FALSE
    for(col_i in  column_headers_upper){
      if(isTRUE(any(col_i==log_p_col))){
        lp_found<-TRUE
        lp_col_up<-col_i
      }
    }
    if (isTRUE(lp_found)) {
        messager("sumstats has -log10 P-values; these will be",
                 "converted to unadjusted p-values in the 'P' column.")
        lp_col <- column_headers[[which(column_headers_upper %in% lp_col_up)]]
        #check if -log10 or log10
        if(max(sumstats_dt[,get(lp_col)])<=0){
          #log10 - less likely so more lenient check
          sumstats_dt[, P := 10^(as.numeric(get(lp_col)))]
        }else{
          #-log10 - more likely
          sumstats_dt[, P := 10^(-1 * as.numeric(get(lp_col)))]  
        }
        
    }
    #### Return format ####
    if(return_list){
      return(list("sumstats_dt" = sumstats_dt))
    }else {
      return(sumstats_dt)
    }
}

#' Sort sum stats: data.table
#' 
#' Sort summary statistics table by genomic coordinates using a fast
#'  \code{data.table}-native strategy
#' @param chr_col Chromosome column name.
#' @param start_col Genomic start position column name.
#' @param start_col Genomic end position column name.
#' @inheritParams sort_coords
#' @returns Sorted sumstats_dt
#' 
#' @keywords internal
#' @importFrom data.table := setorderv
#' @importFrom GenomeInfoDb rankSeqlevels
sort_coords_datatable <- function(sumstats_dt,
                                  chr_col="CHR",
                                  start_col="BP",
                                  end_col=start_col){
    CHR <- NULL;
    
    #### Check args ####
    if(!chr_col %in% names(sumstats_dt)){
        stp <- "chr_col must be in colnames of sumstats_dt."
        stop(stp)
    }
    if(!start_col %in% names(sumstats_dt)){
        stp <- "start_col must be in colnames of sumstats_dt."
        stop(stp)
    }
    if(!end_col %in% names(sumstats_dt)){
        stp <- "end_col must be in colnames of sumstats_dt."
        stop(stp)
    }
    #### Order seqnames #### 
    ans_seqnames <- sumstats_dt[,chr_col,with=FALSE][[1]]
    seqlevels <- levels(ans_seqnames)
    if (is.null(seqlevels)) {
        seqlevels <- unique(ans_seqnames)
        if (!is.character(seqlevels)) seqlevels <- as.character(seqlevels)
    }
    seqlevels[GenomeInfoDb::rankSeqlevels(seqnames = seqlevels)] <- seqlevels 
    ### Turn CHR into an ordered factor to account for X/Y/MT chroms
    sumstats_dt[, CHR:=factor(CHR, levels = seqlevels, ordered = TRUE)]
    ## IMPORTANT: genomic position columns must be integers,
    ## NOT numeric (which can cause issues when tabix-indexing).
    bp_cols <- unique(c(start_col, end_col))
    sumstats_dt[, (bp_cols):=lapply(.SD, as.integer), 
                .SDcols=bp_cols] 
    ### setorderv is much more efficient than dplyr::arrange
    data.table::setorderv(x = sumstats_dt, 
                          cols = unique(c(chr_col, start_col, end_col)))
    return(sumstats_dt) 
}

#' Check that FRQ column refers to minor/effect allele frequency not major
#'
#' @inheritParams format_sumstats
#' @return sumstats_dt, the modified summary statistics data table object
#' @keywords internal
check_frq_maf <- function(sumstats_dt, frq_is_maf) {
    ## Set variables to be used in in place data.table functions to NULL
    ## to avoid confusing BiocCheck.
    FRQ <- .N <- NULL
    col_headers <- names(sumstats_dt)
    if ("FRQ" %in% col_headers) {
        # get proportion of SNPs with FRQ>0.5, this will mean major for
        # bi-allelic SNPs but not major allele frq for
        # non bi-allelic SNPs may be lower
        num_major <- sumstats_dt[FRQ > 0.5, .N, ]
        # only continue if there are some
        if (num_major > 0) {
            per_major <- round(num_major / nrow(sumstats_dt) * 100, 1)
            # get mappings for message
            frq_choices <-
                paste0(
                    sumstatsColHeaders[
                        sumstatsColHeaders$Corrected == "FRQ", ]$Uncorrected, 
                    collapse = ", ")
            msg <-
                paste0(
                    formatC(num_major, big.mark = ",", format = "fg"),
                    " SNPs (", per_major, "%) have FRQ values > 0.5. ",
                    "Conventionally the FRQ column is intended to show the",
                    " minor/effect allele frequency.\nThe FRQ column was",
                    " mapped from one of the following from the inputted ",
                    " summary statistics file:\n", frq_choices
                )
            message(msg)
            # if frq is minor allele frequency is set to TRUE 
            # just accept that it is and don't rename FRQ. 
            # If FALSE and  there are some SNPS with FRQ>0.5 then do
            if (isFALSE(frq_is_maf)) {
                msg <- paste0(
                    "As frq_is_maf=FALSE, the FRQ column will be ",
                    "renamed MAJOR_ALLELE_FRQ to differentiate the",
                    " values from \nminor/effect allele frequency."
                )
                message(msg)
                setnames(sumstats_dt, "FRQ", "MAJOR_ALLELE_FRQ")
            } else { # frq_is_maf =TRUE, i.e. don't rename
                msg <- paste0(
                    "As frq_is_maf=TRUE, the FRQ column will not be ",
                    "renamed. If the FRQ values were intended to ",
                    "represent major allele frequency,\nset ",
                    "frq_is_maf=FALSE to rename the column as ",
                    "MAJOR_ALLELE_FRQ and differentiate it",
                    " from minor/effect allele frequency."
                )
                message(msg)
            }
        }
    }
    return(sumstats_dt)
}

#' Tabix-index file: VCF
#' 
#' Convert summary stats file to tabix format
#'
#' @source Borrowed function from 
#' \href{https://github.com/RajLabMSSM/echotabix/blob/main/R/convert.R}{
#' echotabix}.
#' 
#' @param path Path to VCF.
#' @param verbose Print messages.
#' 
#' @return Path to tabix-indexed tabular file
#'
#' @family tabix
#' @keywords internal
#' @importFrom methods is
#' @importFrom R.utils gunzip
#' @importFrom VariantAnnotation indexVcf
#' @examples 
#' eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
#'                                  package = "MungeSumstats")
#' sumstats_dt <- data.table::fread(eduAttainOkbayPth, nThread = 1)
#' sumstats_dt <- 
#' MungeSumstats:::standardise_sumstats_column_headers_crossplatform(
#'     sumstats_dt = sumstats_dt)$sumstats_dt
#' sumstats_dt <- MungeSumstats:::sort_coords(sumstats_dt = sumstats_dt)
#' path <- tempfile(fileext = ".tsv")
#' MungeSumstats::write_sumstats(sumstats_dt = sumstats_dt, save_path = path)
#'     
#' indexed_file <- MungeSumstats::index_tabular(path = path)
index_vcf <- function(path,
                      verbose=TRUE){ 
    #### When remote ####
    if(!file.exists(path) && 
       any(startsWith(tolower(path),c("http","ftp")))){  
        messager("File inferred to be remote.",v=verbose)
        return(path)
        #### When already tabix ####
    } else if(is_tabix(path = path)){
        messager("File already tabix-indexed.",v=verbose)
        return(path)
        #### When local and non-tabix ####
    } else {
        requireNamespace("Rsamtools")
        #### Round 1: assume .gz is bgz-compressed ####
        sfx <- supported_suffixes(tabular = FALSE, 
                                  tabular_compressed = FALSE, 
                                  vcf = FALSE)
        if(!any(endsWith(path,sfx))){
            messager("bgzip-compressing VCF file.",v=verbose)
            path <- Rsamtools::bgzip(file = path, 
                                     dest = sprintf("%s.bgz",
                                                    sub("\\.gz$|\\.bgz$", "",
                                                        path)),
                                     overwrite = TRUE)
        } 
        out <- tryCatch({
            VariantAnnotation::indexVcf(x = path)$path
        }, error = function(e){e}) 
        #### Round 2: assume .gz is NOT bgz-compressed ####
        if(methods::is(out,"error") &&
           grepl("file does not appear to be bgzip",out$message, 
                 ignore.case = TRUE)
           ){
            if(endsWith(tolower(path),".gz")){
                path <- R.utils::gunzip(path, overwrite=TRUE)
            }
            path <- Rsamtools::bgzip(file = path, 
                                     dest = sprintf("%s.bgz",
                                                    sub("\\.gz$|\\.bgz$", "",
                                                        path)),
                                     overwrite = TRUE)
            path <- VariantAnnotation::indexVcf(x = path)$path
            
        }
        return(path)
    } 
}

#' Is tabix
#' 
#' Is a file bgz-compressed and tabix-indexed.
#' @param path Path to file.
#' @returns logical: whether the file is tabix-indexed or not.
#' @keywords internal
#' @return logical
is_tabix <- function(path) {
    ## Must meet all of these conditions 
    ## in order to use a pre-existing tabix files.
    check_func <- function(path){
        all_suffixes <- supported_suffixes(tabular = FALSE,
                                           vcf = FALSE)
        file.exists(path) &&
            any(endsWith(path, all_suffixes)) &&
            file.exists(paste0(path, ".tbi")) &&
            file.size(path) > 0
    }
    #### Iterate over multiple inputs ####
    res <- unlist(lapply(path, check_func))
    return(res)
}

#' Check if save path and log folder is appropriate
#'
#' @return Corrected \code{save_path}, the file type, the separator, corrected
#' \code{log_folder},the log file extension.
#' @param verbose Print messages.
#'
#' @inheritParams format_sumstats
#' @keywords internal
check_save_path <- function(save_path,
                            log_folder,
                            log_folder_ind,
                            tabix_index,
                            write_vcf = FALSE,
                            verbose = TRUE) {
    #### Add warning to users that temp files aren't actually saved ####
    if (dirname(save_path) == tempdir()) {
        messager(
            "\n\n******::NOTE::******\n",
            "- Formatted results will be saved to `tempdir()` by default.\n",
            "- This means all formatted summary stats will be deleted",
            "upon ending the R session.\n",
            "- To keep formatted summary stats, change `save_path` ",
            "( e.g. `save_path=file.path('./formatted',basename(path))` ),",
            "  or make sure to copy files elsewhere after processing ",
            "( e.g. `file.copy(save_path, './formatted/' )`.\n",
            "********************",
            "\n",
            v=verbose
        )
    }
    
    if (!is.logical(log_folder_ind)) {
        stop("log_folder_ind must be either TRUE or FALSE")
    }
    
    if (log_folder_ind && log_folder == tempdir()) {
        messager(
            "******::NOTE::******\n",
            "- Log results will be saved to `tempdir()` by default.\n",
            "- This means all log data from the run will be ",
            "deleted upon ending the R session.\n",
            "- To keep it, change `log_folder` to an actual directory ",
            "(e.g. log_folder='./').\n",
            "********************",
            "\n",
            v=verbose
        )
    }
    
    #### Do a bit of QC to get the full path ####
    ## Expand "~" into full path bc isn't recognized in certain envs(eg Python)
    save_path <- path.expand(save_path)
    log_folder <- path.expand(log_folder)
    ## Expand relative path "./" into absolute path bc it's less ambiguous
    save_path <- gsub("^[.]/", paste0(getwd(), "/"), save_path)
    log_folder <- gsub("^[.]/", paste0(getwd(), "/"), log_folder)
    
    suffixes <- supported_suffixes()
    if (is.null(save_path)) {
        save_path <- paste0(tempfile(), ".tsv.gz")
        # get extension of save path for log files
        extension <- ".tsv.gz"
        file_type <- "tempfile"
        sep <- "\t"
    } else {
        suffix_match <-
            vapply(suffixes, function(x) {
                grepl(paste0("*", x, "$"), tolower(save_path),
                      ignore.case = TRUE
                )
            },
            FUN.VALUE = logical(1)
            )
        if (sum(suffix_match) > 0) {
            file_type <- names(suffix_match)[suffix_match][1]
            # get extension of save path for log files
            extension <- file_type
            sep <- if (grepl(".csv", file_type)) "," else "\t"
        } else {
            if (write_vcf == FALSE) {
                stop(
                    "save_path file format not recognized: ", save_path,
                    "\nMust be one of: \n   ",
                    paste(suffixes, collapse = "\n   ")
                )
            }
        }
    }
    #### Distinguish between VCF and tabular formats ####
    if (write_vcf) {
        save_path <- gsub(paste(suffixes, collapse = "|"),
                          ".vcf.bgz", save_path)
        sep <- "\t"
        file_type <- "vcf"
        # Don't have to worry about tabix_index bc if writing to VCF format, 
        # will always be compresed (vcf.gz) anyway.
    } else {
        #### Account for mismatch between write_vcf and save_path ####
        suffixes.vcf <- supported_suffixes(
            tabular = FALSE,
            tabular_compressed = FALSE
        )
        if (any(endsWith(save_path, suffixes.vcf))) {
            vcf_msg <- paste(
                "save_path suggests VCF output but write_vcf=FALSE.",
                "Switching output to tabular format (.tsv.gz)."
            )
            messager(vcf_msg,v=verbose)
            save_path <-
                gsub(paste(suffixes.vcf, collapse = "|"),
                     ".tsv.gz", save_path)
            sep <- "\t"
            file_type <- ".tsv"
            # get extension of save path for log files
            # if output vcf, save log file .tsv.gz
            extension <- ".tsv.gz"
        }
        #### Check for tabix-indexing ####
        if(tabix_index){
            # Using slightly modified version of 
            #  Rsamtools::bgzip default
            if(grepl("\\.gz$",save_path)){
                bgz_msg <- paste(
                    "save_path suggests .gz output but tabix_index=TRUE",
                    "Switching output to tabix-indexed format (.bgz)."
                )
                messager(bgz_msg,v=verbose)
            }
            save_path <- sprintf("%s.bgz",
                                 sub("\\.gz$|\\.bgz$", "", save_path)) 
            extension <- sprintf("%s.bgz",
                                 sub("\\.gz$|\\.bgz$", "", extension)) 
        }
        #### get extension of save path for log files ###
        if (!exists("extension")) {
            # if output vcf, save log file type just .tsv.gz
            extension <- ".tsv.gz"
        } 
    } 
    #### Make sure dir exists ####
    if (is.character(save_path)) {
        dir.create(dirname(save_path),
                   showWarnings = FALSE, recursive = TRUE)
    }
    dir.create(log_folder,
               showWarnings = FALSE, recursive = TRUE)
    
    messager("Formatted summary statistics will be saved to ==> ", save_path,
             v=verbose)
    if (log_folder_ind) {
        messager("Log data to be saved to ==> ", log_folder,v=verbose)
    }
    
    #### Check the folder for save_path was indeed created ####
    if(!dir.exists(dirname(save_path))){
        stop_msg <- paste("Unable to create folder for save_path :",
                          dirname(save_path),
                          "\nDo you have permission to write here,",
                          "is there space on the disk,",
                          "and does the path exist?")
        stop(stop_msg)
    }
    
    return(list(
        save_path = save_path,
        file_type = file_type,
        sep = sep,
        log_folder = log_folder,
        extension = extension
    ))
}

test_that("check_range_p_val works", {
    
    sumstats_dt <- MungeSumstats:::formatted_example()
    #copy the org
    sumstats_dt_org <- copy(sumstats_dt)
    #add Indel
    sumstats_dt_indel <- sumstats_dt[1,]
    sumstats_dt_indel[1,A2:='CG']
    sumstats_dt <- data.table::rbindlist(list(sumstats_dt,
                                              sumstats_dt_indel))
    check_save_out <- check_save_path(
      save_path = tempfile(fileext = ".tsv.gz"),
      log_folder = tempdir(),
      log_folder_ind = TRUE,
      tabix_index = FALSE,
      write_vcf = FALSE
    )
    
    sumstats <- check_drop_indels(sumstats_dt = sumstats_dt,
                                  drop_indels = TRUE,
                                  path = tempfile(fileext = ".tsv.gz"),
                                  log_folder_ind = TRUE,
                                  check_save_out=check_save_out,
                                  tabix_index = FALSE,
                                  nThread=1,
                                  log_files=vector(mode = "list"))
    testthat::expect_equal(
        sumstats$sumstats_dt,sumstats_dt_org)
})

#' Ensure that A1:A2 or A1/A2 or A1>A2 or A2>A1 aren't merged into 1 column
#'
#' @param sumstats_dt data table obj of the summary statistics file for the GWAS
#' @param path Filepath for the summary statistics file to be formatted
#' @return list containing sumstats_dt, the modified summary
#' statistics data table object.
#' @keywords internal
#' @importFrom data.table tstrsplit
#' @importFrom data.table :=
check_allele_merge <- function(sumstats_dt, path) {
    message("Checking for merged allele column.")
    # get col headers
    col_headers <- names(sumstats_dt)
    # Obtain a row of the actual data
    row_of_data <- as.character(sumstats_dt[1, ])
    # criteria for alleles column are: contains spliter of : or / or > or <
    # and be three characters in length minus whitespaces: A/G
    twoAlleleCol <- grep(
        ".*[/:><].*",
        gsub(" ", "", row_of_data, fixed = TRUE)
    )
    corr_nchar <- (lapply(
        gsub(" ", "", row_of_data, fixed = TRUE),
        function(x) nchar(x)
    ) == 3)[twoAlleleCol]
    # filter twoAlleleCol to those of nchar 3
    twoAlleleCol <- twoAlleleCol[corr_nchar]
    # in case there are more than one column just take first one
    if (length(twoAlleleCol) > 1 && sum(c("A1", "A2") %in% col_headers) <= 1) {
        # sort to get most recent genome build
        # (cols: alleles_hg19, alleles_hg18)
        keep_col <- sort(col_headers[twoAlleleCol], decreasing = TRUE)[1]
        drop_cols <- sort(col_headers[twoAlleleCol], decreasing = TRUE)[-1]
        msg <- paste0(
            "Warning: Multiple columns in the sumstats file seem to ",
            "relate to alleles A1>A2.\nThe column ",
            keep_col, " will be kept whereas the column(s) ",
            drop_cols, " will be removed.\nIf this is not the correct ",
            "column to keep, please remove all incorrect columns from ",
            "those listed here before \nrunning `format_sumstats()`."
        )
        message(msg)
        # Get data without dropped
        sumstats_dt[, (drop_cols) := NULL]
        twoAlleleCol <- which(col_headers == keep_col)
    }
    if (length(twoAlleleCol)) {
        keep_col <- col_headers[twoAlleleCol]
        # now get character which is splitting the alleles in first row
        splitter <-
            substring(sub(" ", "", row_of_data,
                fixed = TRUE
            )[twoAlleleCol], 2, 2)
        # split out col into separate values, keep names
        format <- strsplit(keep_col, ":")[[1]]
        if (length(format) != 2) { # check : and / and < and > in name
            format <- strsplit(keep_col, "/")[[1]]
        }
        if (length(format) != 2) { # check : and / and < and > in name
            format <- strsplit(keep_col, "<")[[1]]
        }
        if (length(format) != 2) { # check : and / and < and > in name
            format <- strsplit(keep_col, ">")[[1]]
        }
        if (length(format) != 2) { # If neither found assign name
            format <- c("A1", "A2")
            # lastly if symbol is < implies order is A2, A1 not A1,A2
            if (splitter == "<") {
                format <- c("A2", "A1")
            }
        }
        sumstats_dt[, (format) := data.table::tstrsplit(get(keep_col),
            split = splitter, fixed = TRUE
        )]
        # remove any leading/trailing whitespaces
        for (format_i in format) {
            sumstats_dt[, (format_i) := gsub("\\s+$", "",
                get(format_i),
                fixed = TRUE
            )]
        }
        # remove combined column
        sumstats_dt[, (keep_col) := NULL]
        msg <- paste0(
            "Column ", keep_col, " has been separated into the columns ",
            paste(format, collapse = ", ")
        )
        message(msg)

        return(list("sumstats_dt" = sumstats_dt))
    } else {
        return(list("sumstats_dt" = sumstats_dt))
    }
}

#' Ensure that CHR:BP:A2:A1 aren't merged into 1 column
#'
#' @param sumstats_dt data table obj of the summary statistics file for the GWAS
#' @param path Filepath for the summary statistics file to be formatted
#' @return list containing sumstats_dt, the modified
#' summary statistics data table object
#' @keywords internal
#' @importFrom data.table tstrsplit
#' @importFrom data.table :=
check_four_step_col <- function(sumstats_dt, path) {
    A2 <- A1 <- NULL
    # get col headers
    col_headers <- names(sumstats_dt)
    # Obtain a row of the actual data
    row_of_data <- as.character(sumstats_dt[1, ])
    # Check if there is a column of data with CHR:BP:A2:A1 format
    fourStepCol <- grep(".*:.*:\\w:\\w", row_of_data)
    # in case there are more than one column with ":", just take first one
    if (length(fourStepCol) > 1) {
        # sort to get most recent genome build by default
        # (cols: SNP_hg19, SNP_hg18)
        keep_col <- sort(col_headers[fourStepCol], decreasing = TRUE)[1]
        drop_cols <- sort(col_headers[fourStepCol], decreasing = TRUE)[-1]
        msg <- paste0(
            "Warning: Multiple columns in the sumstats file seem to ",
            "relate to Chromosome:Base Pair position:A2:A1.\nThe column",
            " ", keep_col, " will be kept whereas the column(s) ",
            drop_cols, " will be removed.\nIf this is not the correct ",
            "column to keep, please remove all incorrect columns from ",
            "those listed here before \nrunning `format_sumstats()`."
        )
        message(msg)
        # Get data without dropped
        sumstats_dt[, (drop_cols) := NULL]
        fourStepCol <- which(col_headers == keep_col)
    }
    if (length(fourStepCol)) {
        keep_col <- col_headers[fourStepCol]
        # split out col into separate values, keep names
        format <- strsplit(keep_col, ":")[[1]]
        if (length(format) != 4) { # check : and underscore in name
            format <- strsplit(keep_col, "_")[[1]]
        }
        if (length(format) != 4) { # If neither found
            # first check if allele col exists and assign based on that
            fourStepCol_val <- row_of_data[fourStepCol]
            if (sum("A2" %in% col_headers) == 1 && 
                sum("A1" %in% col_headers) == 1){
              A2_val <- sumstats_dt[1,A2]
              A1_val <- sumstats_dt[1,A1]
              split_fourStepCol <- strsplit(fourStepCol_val,split=":")[[1]]
              A1_fnd <- any(split_fourStepCol==A1_val)
              A2_fnd <- any(split_fourStepCol==A2_val)
              A1_ind <- which(split_fourStepCol==A1_val)
              A2_ind <- which(split_fourStepCol==A2_val)
            }
            #make sure you got a hit for A1 and A2 vals
            if(sum("A2" %in% col_headers) == 1 && 
               sum("A1" %in% col_headers) == 1 && 
               A1_fnd && A2_fnd){
              #bought A1 and A2 are present and we know their position
              format <- vector(mode="character", length=4)
              othrs <- c('CHR','BP')
              j <- 1
              for (i in seq_len(4)){
                if (i == A1_ind){
                  format[[i]] <- 'A1'
                } else if (i == A2_ind){
                  format[[i]] <- 'A2'
                } else{
                  format[[i]] <- othrs[[j]]
                  j = j+1
                }
              }
            } else if(sum("A2" %in% col_headers) == 1){
              A2_val <- sumstats_dt[1,A2]
              split_fourStepCol <- strsplit(fourStepCol_val,split=":")[[1]]
              A2_fnd <- any(split_fourStepCol==A2_val)
              A2_ind <- which(split_fourStepCol==A2_val)
              if (A2_ind == 4){
                format <- c("CHR", "BP", "A1", "A2")
              } else if(A2_ind == 3){
                format <- c("CHR", "BP", "A2", "A1")
              } else if(A2_ind == 2){
                format <- c("CHR", "A2","BP", "A1")
              } else if(A2_ind == 1){
                format <- c("A2", "CHR","BP", "A1")
              } else{
                #not found....
                format <- c("CHR", "BP", "A2", "A1")
              }
            } else if(sum("A1" %in% col_headers) == 1){
              A1_val <- sumstats_dt[1,A1]
              split_fourStepCol <- strsplit(fourStepCol_val,split=":")[[1]]
              A1_fnd <- any(split_fourStepCol==A1_val)
              A1_ind <- which(split_fourStepCol==A1_val)
              if (A1_ind == 4){
                format <- c("CHR", "BP", "A2", "A1")
              } else if(A1_ind == 3){
                format <- c("CHR", "BP", "A1", "A2")
              } else if(A1_ind == 2){
                format <- c("CHR", "A1","BP", "A2")
              } else if(A1_ind == 1){
                format <- c("A1", "CHR","BP", "A2")
              } else{
                #not found....
                format <- c("CHR", "BP", "A2", "A1")
              }
            }
            else{
              #otherwise, just use this as default order
              format <- c("CHR", "BP", "A1", "A2")
            }
            
        }
        sumstats_dt[, (format) := data.table::tstrsplit(get(keep_col),
            split = ":", fixed = TRUE,
            type.convert = TRUE
        )]
        # remove combined column
        sumstats_dt[, (keep_col) := NULL]
        msg <- paste0(
            "Column ", keep_col, " has been separated into the columns ",
            paste(format, collapse = ", "),"\nIf this is the incorrect ",
            "format for the column, update the column name to the correct ",
            "format e.g.`CHR:BP:A2:A1` and format_sumstats()."
        )
        message(msg)

        return(list("sumstats_dt" = sumstats_dt))
    } else {
        return(list("sumstats_dt" = sumstats_dt))
    }
}

#' Add user supplied sample size
#'
#' @inheritParams compute_sample_size
#' @return No return
#' @keywords internal
compute_sample_size_n <- function(sumstats_dt,
                                  method,
                                  force_new = FALSE) {

    # Avoid confusing Biocheck
    N <- NULL

    if ("N" %in% names(sumstats_dt) & (!force_new)) {
        message("N already exists within sumstats_dt.")
    } else {
        if (method > 0) {
            message("Assigning N=", method, " for all SNPs.")
            sumstats_dt[, N := method]
        } else {
            msg <- "Warning: When method is an integer, must be >0."
            message(msg)
        }
    }
}

#' Infers the genome build of the summary statistics file (GRCh37 or GRCh38)
#' from the data. Uses SNP (RSID) & CHR & BP to get genome build.
#'
#' @param sumstats data table/data frame obj of the summary statistics file for
#' the GWAS ,or file path to summary statistics file.
#' @param nThread Number of threads to use for parallel processes.
#' @param sampled_snps Downsample the number of SNPs used when inferring genome
#' build to save time.
#' @param standardise_headers Run
#' @param standardise_headers Run
#' \code{standardise_sumstats_column_headers_crossplatform}.
#' @param mapping_file \pkg{MungeSumstats} has a pre-defined
#' column-name mapping file
#' which should cover the most common column headers and their interpretations.
#' However, if a column header that is in your file is missing of the mapping we
#' give is incorrect you can supply your own mapping file. Must be a 2 column
#' dataframe with column names "Uncorrected" and "Corrected". See
#' \code{data(sumstatsColHeaders)} for default mapping and necessary format.
#' @param dbSNP version of dbSNP to be used (144 or 155). Default is 155.
#' @param header_only Instead of reading in the entire \code{sumstats} file,
#' only read in the first N rows where N=\code{sampled_snps}.
#' This should help speed up cases where you have to read in \code{sumstats}
#' from disk each time.
#' @param allele_match_ref Instead of returning the genome_build this will 
#' return the proportion of matches to each genome build for each allele 
#' (A1,A2).
#' @inheritParams format_sumstats
#' @inheritParams get_genome_builds 
#' 
#' @return ref_genome the genome build of the data
#' @importFrom data.table setDT :=
#' @keywords internal
get_genome_build <- function(sumstats,
                             nThread = 1,
                             sampled_snps = 10000,
                             standardise_headers = TRUE,
                             mapping_file = sumstatsColHeaders,
                             dbSNP=155,
                             dbSNP_tarball = NULL,
                             header_only = FALSE,
                             allele_match_ref = FALSE,
                             ref_genome = NULL,
                             chr_filt = NULL) {
    ### Add this to avoid confusing BiocCheck
    seqnames <- CHR <- SNP <- BP <- alt_alleles <- NULL 
    if(isFALSE(allele_match_ref)){
      message("Inferring genome build.")
    }
    # if not a data.table, must be a path
    if (!is.data.frame(sumstats)) {
        # Checking if the file exists should happen first
        if (!file.exists(sumstats)) {
            stop("Path to GWAS sumstats is not valid")
        }
        if (header_only) {
            # Read in N lines of the data
            message("Reading in only the first ",
                    sampled_snps, " rows of sumstats.")
            sumstats <- read_sumstats(
                path = sumstats,
                nThread = nThread,
                nrows = sampled_snps
            )
        } else {
            # Read in full data
            sumstats <- read_sumstats(
                path = sumstats,
                nThread = nThread
            )
        }
    } else {
        # ensure data table obj
        sumstats <- data.table::setDT(sumstats)
    }
    # need SNP ID column (RS ID) CHR and BP (POS) to infer build 
    # - check these are present, considering all known names
    if (standardise_headers) {
        sumstats_return <-
            standardise_sumstats_column_headers_crossplatform(
                sumstats_dt = sumstats,
                mapping_file = mapping_file
            )
        sumstats <- sumstats_return$sumstats_dt
    }

    err_msg <-
        paste0(
            "SNP ID column (RS ID), CHR and BP (POSITION) columns are needed ",
            "to infer the genome build. These could not be\nfound in your ",
            "dataset. Please specify the genome build manually to run ",
            "format_sumstats()."
        )
    # Infer genome build using SNP & CHR & BP
    if (!all(c("SNP", "CHR", "BP") %in% colnames(sumstats))) {
      #want it returned rather than throwing an error
      if(isTRUE(allele_match_ref)){
        return(err_msg)
      }
      else{  
        stop(err_msg)
      }
    }

    #### Do some filtering first to avoid errors ####
    nrow_org <- nrow(sumstats)
    sumstats <- sumstats[complete.cases(SNP, BP, CHR)]
    err_msg2 <-
        paste0(
            "SNP ID column (RS ID), CHR and BP (POSITION)",
            "columns are needed to",
            " infer the genome build.",
            "These contain too many\nmissing values in",
            " your dataset to be used.",
            "Please specify the genome build manually",
            " to run format_sumstats()"
        )
    # also remove common incorrect formatting of SNP
    sumstats <- sumstats[grepl("^rs", SNP), ]
    sumstats <- sumstats[SNP != ".", ]
    #also deal with common misformatting of CHR
    # if chromosome col has chr prefix remove it
    sumstats[, CHR := gsub("chr", "", CHR)]
    
    #for internal testing - filter to specified chromosomes
    if(!is.null(chr_filt)){
      sumstats <- sumstats[CHR %in% chr_filt]
    }
    
    # if removing erroneous cases leads to <min(10k,50% org dataset) will fail -
    # NOT ENOUGH DATA TO INFER
    nrow_clean <- nrow(sumstats)
    size_okay <- FALSE
    if (nrow_clean > sampled_snps || (nrow_clean != 0 && 
                                      (nrow_clean / nrow_org) > .5)) {
        size_okay<- TRUE
    }
    if (!size_okay) {
      #want it returned rather than throwing an error
      if(isTRUE(allele_match_ref)){
        return(err_msg2)
      }
      else{  
        stop(err_msg2)
      }
    }
    #### Downsample SNPs to save time ####
    if ((nrow(sumstats) > sampled_snps) && !(is.null(sampled_snps))) {
        snps <- sample(sumstats$SNP, sampled_snps)
    } else { # nrow(sumstats)<10k
        snps <- sumstats$SNP
    }

    sumstats <- sumstats[SNP %in% snps, ]

    #now split into functions two roles
    if(isTRUE(allele_match_ref)){
      #1. checking for matches for A1/A2 to ref genomes
      if (is.null(ref_genome)){
        #have to check multiple
        snp_loc_data_37 <- load_ref_genome_data(
          snps = snps,
          ref_genome = "GRCH37",
          dbSNP = dbSNP,
          dbSNP_tarball = dbSNP_tarball
        )
        snp_loc_data_38 <- load_ref_genome_data(
          snps = snps,
          ref_genome = "GRCH38",
          dbSNP = dbSNP,
          dbSNP_tarball = dbSNP_tarball
        )
        # convert CHR filed in ref genomes to character not factor
        snp_loc_data_37[, seqnames := as.character(seqnames)]
        snp_loc_data_38[, seqnames := as.character(seqnames)]
        # convert CHR filed in data to character if not already
        sumstats[, CHR := as.character(CHR)]
        # Now check which genome build has more matches to data
        num_37 <-
          nrow(snp_loc_data_37[sumstats, ,
                               on = c("SNP"="SNP","pos"="BP","seqnames"="CHR"),
                               nomatch = FALSE
          ])
        num_38 <-
          nrow(snp_loc_data_38[sumstats, ,
                               on = c("SNP"="SNP","pos"="BP","seqnames"="CHR"),
                               nomatch = FALSE
          ])
        
        if (num_37 > num_38) {
          ref_gen_num <- num_37
          ref_genome <- "GRCH37"
          snp_loc_data <- snp_loc_data_37
          
        } else {
          ref_gen_num <- num_38
          ref_genome <- "GRCH38"
          snp_loc_data <- snp_loc_data_38
        }
      }
      else{
        #only check one chosen
        snp_loc_data <- load_ref_genome_data(
          snps = snps,
          ref_genome = ref_genome,
          dbSNP = dbSNP,
          dbSNP_tarball = dbSNP_tarball
        )
        
        # convert CHR filed in ref genomes to character not factor
        snp_loc_data[, seqnames := as.character(seqnames)]
        # convert CHR filed in data to character if not already
        sumstats[, CHR := as.character(CHR)]
      }
      # Now check which allele has more matches to data
      # want to match on ref and alt alleles too 
      # need to take first alt from list to do this
      snp_loc_data[,alt_alleles := unlist(lapply(alt_alleles, 
                                                 function(x) x[[1]]))]
      #Need to ensure ref and alt are upper case for this check
      sumstats_return <-
        make_allele_upper(sumstats_dt = sumstats,
                          log_files = NA)
      sumstats <- sumstats_return$sumstats_dt
      
      num_a1 <-
        nrow(snp_loc_data[sumstats, ,
                          on = c("SNP"="SNP","pos"="BP","seqnames"="CHR",
                                 "ref_allele"="A1","alt_alleles"="A2"),
                          nomatch = FALSE
        ])
      num_a2 <-
        nrow(snp_loc_data[sumstats, ,
                          on = c("SNP"="SNP","pos"="BP","seqnames"="CHR",
                                 "ref_allele"="A2","alt_alleles"="A1"),
                          nomatch = FALSE
        ])
      
      if(num_a1>=num_a2){
        message("Effect/frq column(s) relate to A2 in the inputted sumstats")
        #this is what MSS expects so no action required
        switch_req <- FALSE
      }else{#num_a1<num_a2
        message("Effect/frq column(s) relate to A1 in the inputted sumstats")
        switch_req <- TRUE
      }
      
      return(switch_req)
    }  
    else{
      #2. checking for ref genome
      # otherwise SNP, CHR, BP were all found and can infer
      snp_loc_data_37 <- load_ref_genome_data(
        snps = snps,
        ref_genome = "GRCH37",
        dbSNP = dbSNP,
        dbSNP_tarball = dbSNP_tarball,
        chr_filt = chr_filt
      )
      snp_loc_data_38 <- load_ref_genome_data(
        snps = snps,
        ref_genome = "GRCH38",
        dbSNP = dbSNP,
        dbSNP_tarball = dbSNP_tarball,
        chr_filt = chr_filt
      )
      # convert CHR filed in ref genomes to character not factor
      snp_loc_data_37[, seqnames := as.character(seqnames)]
      snp_loc_data_38[, seqnames := as.character(seqnames)]
      # convert CHR filed in data to character if not already
      sumstats[, CHR := as.character(CHR)]
      # Now check which genome build has more matches to data
      num_37 <-
        nrow(snp_loc_data_37[sumstats, ,
                             on = c("SNP"="SNP", "pos"="BP", "seqnames"="CHR"),
                             nomatch = FALSE
        ])
      num_38 <-
        nrow(snp_loc_data_38[sumstats, ,
                             on = c("SNP"="SNP", "pos"="BP", "seqnames"="CHR"),
                             nomatch = FALSE
        ])
      #if no matches throw error
      if(num_37==0 && num_38==0){
        msg_err <- 
          paste0("No matches found in either reference genome for your ",
                 "SNPs.\nPlease check their formatting (SNP, CHR and BP",
                 " columns) or supply the genome build.")
        stop(msg_err)
      }
      if (num_37 > num_38) {
        ref_gen_num <- num_37
        ref_genome <- "GRCH37"
      } else {
        ref_gen_num <- num_38
        ref_genome <- "GRCH38"
      }
      
      message("Inferred genome build: ", ref_genome)
      # add a warning if low proportion of matches found
      msg <- paste0(
        "WARNING: Less than 10% of your sampled SNPs matched that of ",
        "either reference genome, this may question the quality of ",
        "your summary statistics file."
      )
      if (ref_gen_num / length(snps) < 0.1) {
        message(msg)
      }
      
      return(ref_genome)
      
    }
}

#' Parse number of SNPs dropped due to being on chrom X, Y or MT
#' 
#' Support function for \link[MungeSumstats]{parse_logs}.
#' 
#' @param l Lines of text from log file.
#' 
#' @return Numeric
#' @keywords internal
parse_dropped_chrom <- function(l){
  line <- grep("are on chromosomes X, Y, MT and will be removed",l,
               value = TRUE)[1]
  if(is.na(line)) return(NA)
  as.integer(trimws(gsub(",","",strsplit(line," ")[[1]][1])))
}

#' Parse number/percent of SNPs with FREQ values >0.5
#' 
#' Support function for \link[MungeSumstats]{parse_logs}.
#' 
#' @param l Lines of text from log file.
#' 
#' @return Numeric
#' @keywords internal
parse_snps_freq_05 <- function(l,
                               percent=FALSE){
    line <- grep("have FRQ values > 0.5.",l,
                 value = TRUE)[1]
    if(is.na(line)) return(NA)
    if(percent){
        as.numeric(gsub("[()]|[)]|%","",strsplit(line," ")[[1]][3]))
    } else { 
        as.integer(trimws(gsub("There are|,","",strsplit(line," SNPs")[[1]][1])))
    } 
}

#' Read VCF: parallel
#' 
#' Read a VCF file across 1 or more threads in parallel.
#' If \code{tilewidth} is not specified, the size of each chunk will be
#'  determined by total genome size divided by \code{ntile}. 
#' By default, \code{ntile} is equal to the number of threads, \code{nThread}.
#' For further discussion on how this function was optimised, 
#' see 
#' \href{https://github.com/Bioconductor/VariantAnnotation/issues/59}{here}
#' and
#' \href{https://github.com/Bioconductor/VariantAnnotation/issues/57}{here}.
#'  
#' @inheritParams read_vcf
#' @inheritParams check_empty_cols
#' @inheritParams downloader
#' @inheritParams download_vcf
#' @inheritParams import_sumstats
#' @inheritParams GenomicRanges::tileGenome
#' @inheritParams BiocParallel::register
#' 
#' @keywords internal
#' @importFrom VariantAnnotation ScanVcfParam VcfFile readVcf rbind
#' @importFrom GenomicRanges seqinfo tileGenome 
#' @importFrom GenomeInfoDb keepSeqlevels 
#' @importFrom data.table rbindlist
#' @returns VCF file.
#' @source 
#' \code{
#' path <- "https://gwas.mrcieu.ac.uk/files/ieu-a-298/ieu-a-298.vcf.gz"
#' #### Single-threaded ####
#' vcf <- MungeSumstats:::read_vcf_parallel(path = path)
#' #### Parallel ####
#' vcf2 <- MungeSumstats:::read_vcf_parallel(path = path, nThread=11)
#' }
read_vcf_parallel <- function(path,
                              samples = 1,
                              which = NULL,
                              use_params = TRUE,
                              as_datatable = TRUE, 
                              sampled_rows = 1e4L,
                              include_xy = FALSE,
                              
                              download = TRUE,
                              vcf_dir = tempdir(),
                              download_method = "download.file",
                              force_new = FALSE,
                              
                              tilewidth = NULL, # 1e7L
                              mt_thresh = 1e5L,
                              nThread = 1,
                              ntile = nThread,
                              verbose = TRUE){
    # echoverseTemplate:::source_all()
    # echoverseTemplate:::args2vars(read_vcf_parallel) 
    requireNamespace("GenomicFiles")
    requireNamespace("VariantAnnotation") 
    
    data.table::setDTthreads(threads = nThread)
    # data.table::getDTthreads()
    ##### Download the VCF to temp ####
    ## This makes importing much faster, 
    ## especially in parallel since you would be makings hundreds 
    ## network calls to OpenGWAS.
    if(nThread>1 && isFALSE(download)){
        messager("Warning: download arg must be TRUE when nThread>1",
                 "to avoid making too many queries to remote file.",
                 "Setting download=TRUE.",
                 v=verbose)
        download <- TRUE
    }
    if(isTRUE(download)){
        vcf_paths <- download_vcf(vcf_url = path,
                                  vcf_dir = vcf_dir,
                                  download_method = download_method,
                                  force_new = force_new,
                                  quiet = !verbose, 
                                  nThread = nThread)
        path <- vcf_paths$save_path
    } 
    #### Optimise query #### 
    if((!is.null(which)) || isTRUE(use_params)){
        #### Make sure file is compressed and indexed ####
        ## File must be indexed in order to use param 
        ## (even if only specifying columns) 
        path <- index_vcf(path = path,
                          verbose = verbose)
        param <- select_vcf_fields(path = path, 
                                   which = which, 
                                   samples = samples,
                                   sampled_rows = sampled_rows,
                                   nThread = nThread)
    } else {
        param <- VariantAnnotation::ScanVcfParam()
    }  
    #### Create VcfFile object #### 
    vcf_file <- VariantAnnotation::VcfFile(file = path, 
                                           index = paste0(path,".tbi"))
    ### Read header ####
    header <- VariantAnnotation::scanVcfHeader(file = vcf_file)
    samples <- VariantAnnotation::samples(header)
    ## Get genome build
    genome <- read_vcf_genome(header = header, 
                              default_genome="HG19/GRCh37",
                              verbose = verbose) 
    ## Report total variants
    n_variants <- header@header$SAMPLE$TotalVariants
    if(!is.null(n_variants) &&
       isTRUE(verbose)){
        messager("VCF contains:",
                 formatC(as.integer(n_variants),big.mark = ","),"variant(s)",
                 "x",
                 formatC(nrow(header@header$SAMPLE),big.mark = ","),
                 "sample(s)"
                 )
    }  
    #### Make sure multi-threading makes sense given VCF size ####
    if((as.integer(n_variants)<mt_thresh) && (nThread>1)){
        messager("Processing will be more efficient in single-threaded mode",
                 paste0("when nrows<",mt_thresh,"."),
                 "Temporarily setting nThread=1.",
                 v=verbose)
        nThread <- 1
    }
    #### Single-threaded ####
    t1 <- Sys.time()
    if(nThread==1){
        messager("Reading VCF file: single-threaded",v=verbose) 
        vcf <- VariantAnnotation::readVcf(file = path, 
                                          param = param) 
        if(as_datatable){
            vcf <- vcf2df(vcf = vcf, 
                          add_sample_names = length(samples)!=1,
                          verbose = verbose)
        } 
        
    #### Parallel ####
    ## Uses GenomicFiles to parallelise and speed up reading.
    } else {
        messager("Reading VCF file: multi-threaded",
                 paste0("(",nThread," threads)"),v=verbose)  
        register_cores(workers = nThread,
                       progressbar = verbose)
        ## Check which chromosome are available. 
        xy <- if(isTRUE(include_xy)) c("X","Y") else NULL
        possible_chr <- c(
            c(as.character(seq_len(22)),xy),
            paste0("chr",c(as.character(seq_len(22)),xy))
        )
        used_chr <- possible_chr[possible_chr %in% header@reference]
        ## Tile ranges across the genome 
        # tilewidth = 1e7L
        tiles <-
            GenomicRanges::seqinfo(vcf_file) |>
            GenomeInfoDb::keepSeqlevels(used_chr)
        #### Determine tile size by tilewidth ####
        if(!is.null(tilewidth)){
            tiles <- tiles |> 
                GenomicRanges::tileGenome(cut.last.tile.in.chrom = FALSE,
                                          tilewidth = tilewidth)
        #### Determine tile size by number of threads ####
        } else {
            tiles <- tiles |> 
                GenomicRanges::tileGenome(cut.last.tile.in.chrom = FALSE,
                                          ntile = ntile)
        } 
        # Create mapping function
        MAP <- function(range,
                        file,
                        param,
                        genome="HG19/GRCh37",
                        as_datatable=TRUE,
                        ...) {
            # param <- get(x = "param1", envir = parent.frame(3L))
            param2 <- VariantAnnotation::ScanVcfParam(which = range,
                                                      fixed = param@fixed,
                                                      info = param@info,
                                                      geno = param@geno,
                                                      samples = param@samples)
            vcf <- VariantAnnotation::readVcf(file = file,
                                              genome = genome,
                                              param = param2)
            if(as_datatable){
                return(vcf2df(vcf = vcf,
                              add_sample_names = FALSE,
                              verbose = FALSE))
            } else {return(vcf)}
        }
        ## Parallelised query
        #### reduceByRange ####
        REDUCE <- if(isTRUE(as_datatable)){
            function(x){data.table::rbindlist(l = x, fill=TRUE)}
            
        } else {
            function(x){do.call(VariantAnnotation::rbind, x)}
        }
        system.time({
            vcf <- GenomicFiles::reduceByRange(ranges = tiles,
                                               files = vcf_file$path,
                                               MAP = MAP,
                                               REDUCE = REDUCE,
                                               iterate = TRUE,
                                               ### Args passed to MAP
                                               param = param,
                                               as_datatable = as_datatable,
                                               genome = genome)
        }) 
        vcf <- REDUCE(vcf)
        #### Set back to 1 to avoid errors in later steps ####
        register_cores(workers = 1,
                       progressbar = verbose)
    }   
    if(verbose) methods::show(round(difftime(Sys.time(),t1),1))
    return(vcf)
}

check_info_score_log <- function(sumstats_dt,
                                 log_files,
                                 INFO_filter,
                                 check_save_out,
                                 tabix_index,
                                 nThread){
    INFO <- NULL
    name <- "info_filter"
    name <- get_unique_name_log_file(
        name = name,
        log_files = log_files
    )
    write_sumstats(
        sumstats_dt = sumstats_dt[INFO < INFO_filter, ],
        save_path =
            paste0(
                check_save_out$log_folder,
                "/", name,
                check_save_out$extension
            ),
        sep = check_save_out$sep,
        #don't tab indx as could be miss values & cause err
        #tabix_index = tabix_index,
        nThread = nThread
    )
    log_files[[name]] <-
        paste0(
            check_save_out$log_folder, "/", name,
            check_save_out$extension
        )
    return(list(log_files=log_files,
                sumstats_dt=sumstats_dt))
}

#' Ensure that the input parameters are logical
#'
#' @inheritParams format_sumstats
#' @return No return
#' @keywords internal
validate_parameters <- function(path,
                                ref_genome,
                                convert_ref_genome,
                                convert_small_p,
                                es_is_beta,
                                compute_z,
                                compute_n,
                                convert_n_int,
                                analysis_trait,
                                INFO_filter,
                                FRQ_filter,
                                pos_se,
                                effect_columns_nonzero,
                                N_std,
                                N_dropNA,
                                chr_style,
                                rmv_chr,
                                on_ref_genome,
                                infer_eff_direction,
                                eff_on_minor_alleles,
                                strand_ambig_filter,
                                allele_flip_check,
                                allele_flip_drop,
                                allele_flip_z,
                                allele_flip_frq,
                                bi_allelic_filter,
                                flip_frq_as_biallelic,
                                snp_ids_are_rs_ids,
                                remove_multi_rs_snp,
                                frq_is_maf,
                                indels,
                                drop_indels,
                                check_dups,
                                dbSNP,
                                dbSNP_tarball,
                                write_vcf,
                                return_format,
                                ldsc_format,
                                save_format,
                                imputation_ind,
                                log_folder_ind,
                                log_mungesumstats_msgs,
                                mapping_file,
                                tabix_index,
                                chain_source,
                                local_chain,
                                drop_na_cols,
                                #deprecated parameters
                                rmv_chrPrefix) {
    # Checking if the file exists should happen first -
    # can pass dt/df of sumstats
    pth_msg <- paste0(
        "Path to GWAS sumstats is not valid, pass a file path or a ",
        "dataframe/data.table object to the path parameter"
    )
    if (!is.data.frame(path) && !file.exists(path) &&
        !startsWith(path, "https://gwas.mrcieu.ac.uk") &&
        !startsWith(path, "https://")) {
        stop(pth_msg)
    }

    gen_msg <- paste0(
        "The chosen genome build must be one of GRCh37 or GRCh38 ",
        "or left as null so the genome build will be inferred ",
        "from the data."
    )
    # Check genome build is valid option
    if (!is.null(ref_genome) && !(toupper(ref_genome) %in%
        c("GRCH37", "GRCH38"))) {
        stop(gen_msg)
    }
    gen_msg2 <- paste0(
        "The chosen genome build to convert to must be one of ",
        "GRCh37 or GRCh38 ",
        "or left as null so the genome build will be inferred ",
        "from the data."
    )
    if (!is.null(convert_ref_genome) && !(toupper(convert_ref_genome) %in%
        c("GRCH37", "GRCH38"))) {
        stop(gen_msg2)
    }
    #check chain file source
    chain_msg <- paste0(
      "The chosen chain file source to convert to must be one of ",
      "Ensembl or UCSC ('ensembl','ucsc')"
    )
    if(length(chain_source)>1 || !tolower(chain_source) %in% c("ucsc",
                                                               "ensembl")){
      stop(chain_msg)
    }
    #check local chain file
    if (!is.null(local_chain) && !file.exists(local_chain)){
      lcl_chain_msg <- paste0(
        "The local_chain parameter is invalid, please chose a valid path to a ",
        "local chain file or leave as NULL to download a chain file."
      )
      stop(lcl_chain_msg)
    }
    # if no tarball, we require that the matching SNPlocs pkg is installed
    if (is.null(dbSNP_tarball)) {
          if (!is.numeric(dbSNP) || dbSNP <= 0){
            stp_msg <- paste0(
              "`dbSNP` must be a positive integer (e.g. 144, 155...",
              ") or provide `dbSNP_tarball`.")
            stop(stp_msg)
          }
          pkg_name <- sprintf(
                "SNPlocs.Hsapiens.dbSNP%d.GRCh%s",
                as.integer(dbSNP),
                ifelse(toupper(ref_genome)=="GRCH37","37","38")
            )
          if (!requireNamespace(pkg_name, quietly=TRUE)) {
                stop("To use dbSNP=", dbSNP, " on ", ref_genome,
                     ", please install the Bioconductor package '", 
                     pkg_name, "'.", call. = FALSE)
            }
    } else{
      if(!file.exists(dbSNP_tarball)){
        tarball_msg <- paste0(
          "The dbSNP_tarball parameter is invalid, please chose a valid path ",
          "to a local dbSNP release in tarball format or leave as NULL to use ",
          "the dbSNP parameter"
        )
        stop(tarball_msg)
      }
    }
    # checks for installed packages
    GRCH37_msg1 <- paste0(
        "Install 'SNPlocs.Hsapiens.dbSNP144.GRCh37' to use ",
        "'GRCh37' as 'ref_genome' and 144 as dbSNP version"
    )
    GRCH37_msg2 <- paste0(
        "Install 'BSgenome.Hsapiens.1000genomes.hs37d5' to ",
        "use 'GRCh37' as 'ref_genome'"
    )
    GRCH37_msg3 <- paste0(
      "Install 'SNPlocs.Hsapiens.dbSNP155.GRCh37' to ",
      "use 'GRCh37' as 'ref_genome' and 155 as dbSNP version"
    )
    #dbsnp 144 grch37
    if (any(toupper(ref_genome) == "GRCH37") && as.integer(dbSNP)==144 &&
        !requireNamespace("SNPlocs.Hsapiens.dbSNP144.GRCh37",
            quietly = TRUE
        )) {
        stop(GRCH37_msg1)
    }
    #dbsnp 155 grch37
    if (any(toupper(ref_genome) == "GRCH37") && as.integer(dbSNP)==155 &&
        !requireNamespace("SNPlocs.Hsapiens.dbSNP155.GRCh37",
                          quietly = TRUE
        )) {
      stop(GRCH37_msg3)
    }
    #grch37 ref genome
    if (any(toupper(ref_genome) == "GRCH37") &&
        !requireNamespace("BSgenome.Hsapiens.1000genomes.hs37d5",
            quietly = TRUE
        )) {
        stop(GRCH37_msg2)
    }
    GRCH38_msg1 <- paste0(
        "Install 'SNPlocs.Hsapiens.dbSNP144.GRCh38' to use ",
        "'GRCh38' as 'ref_genome' and 144 as dbSNP version"
    )
    GRCH38_msg2 <- paste0(
        "Install 'BSgenome.Hsapiens.NCBI.GRCh38' to ",
        "use 'GRCh38' as 'ref_genome'"
    )
    GRCH38_msg3 <- paste0(
      "Install 'SNPlocs.Hsapiens.dbSNP155.GRCh38' to ",
      "use 'GRCh38' as 'ref_genome' and 155 as dbSNP version"
    )
    #grch38 and dbsnp 144
    if (any(toupper(ref_genome) == "GRCH38") && as.integer(dbSNP)==144 &&
        !requireNamespace("SNPlocs.Hsapiens.dbSNP144.GRCh38",
            quietly = TRUE
        )) {
        stop(GRCH38_msg1)
    }
    #grch38 and dbsnp 155
    if (any(toupper(ref_genome) == "GRCH38") && as.integer(dbSNP)==155 &&
        !requireNamespace("SNPlocs.Hsapiens.dbSNP155.GRCh38",
                          quietly = TRUE
        )) {
      stop(GRCH38_msg3)
    }
    #ref genome
    if (any(toupper(ref_genome) == "GRCH38") &&
        !requireNamespace("BSgenome.Hsapiens.NCBI.GRCh38",
            quietly = TRUE
        )) {
        stop(GRCH38_msg2)
    }
    #if ref genome not specified, have to install both
    if (is.null(ref_genome)) {
        #ref genomes
        if (!requireNamespace("BSgenome.Hsapiens.1000genomes.hs37d5",
                            quietly = TRUE
        )) {
          stop(GRCH37_msg2)
        }
        if (!requireNamespace("BSgenome.Hsapiens.NCBI.GRCh38",
                            quietly = TRUE
        )) {
          stop(GRCH38_msg2)
        }
        #dbSNP
        if (as.integer(dbSNP)==144 &&
            !requireNamespace("SNPlocs.Hsapiens.dbSNP144.GRCh37",
            quietly = TRUE
        )) {
            stop(GRCH37_msg1)
        }
        if (as.integer(dbSNP)==155 &&
            !requireNamespace("SNPlocs.Hsapiens.dbSNP155.GRCh37",
                            quietly = TRUE
        )) {
            stop(GRCH37_msg3)
        }
        if (as.integer(dbSNP)==144 &&
            !requireNamespace("SNPlocs.Hsapiens.dbSNP144.GRCh38",
            quietly = TRUE
            )) {
            stop(GRCH38_msg1)
        }
        if (as.integer(dbSNP)==155 &&
            !requireNamespace("SNPlocs.Hsapiens.dbSNP155.GRCh38",
                            quietly = TRUE
            )) {
            stop(GRCH38_msg3)
        }
    }


    # Check binary values
    if (!is.logical(N_dropNA)) {
        stop("N_dropNA must be either TRUE or FALSE")
    }
    if (!is.logical(convert_small_p)) {
        stop("convert_small_p must be either TRUE or FALSE")
    }
    if (!is.logical(es_is_beta)){
      stop("es_is_beta must be either TRUE or FALSE")
    }
    if (!is.logical(compute_z)) {
        if(!toupper(compute_z) %in% c('P','BETA'))
          stop("compute_z must be either TRUE or FALSE")
    }
    if (!is.logical(convert_n_int)) {
        stop("convert_n_int must be either TRUE or FALSE")
    }
    if (!is.logical(on_ref_genome)) {
        stop("on_ref_genome must be either TRUE or FALSE")
    }
    if(!is.logical(infer_eff_direction)){
      stop("infer_eff_direction must be either TRUE or FALSE")
    }
    if(!is.logical(eff_on_minor_alleles)){
      stop("eff_on_minor_alleles must be either TRUE or FALSE")
    }
    if (!is.logical(strand_ambig_filter)) {
        stop("strand_ambig_filter must be either TRUE or FALSE")
    }
    if (!is.logical(allele_flip_check)) {
        stop("allele_flip_check must be either TRUE or FALSE")
    }
    if (!is.logical(allele_flip_drop)) {
        stop("allele_flip_drop must be either TRUE or FALSE")
    }
    if (!is.logical(allele_flip_z)) {
        stop("allele_flip_z must be either TRUE or FALSE")
    }
    if (!is.logical(allele_flip_frq)) {
        stop("allele_flip_frq must be either TRUE or FALSE")
    }
    if (!is.logical(bi_allelic_filter)) {
        stop("bi_allelic_filter must be either TRUE or FALSE")
    }
    if (!is.logical(flip_frq_as_biallelic)) {
      stop("flip_frq_as_biallelic must be either TRUE or FALSE")
    }
    if (!is.logical(snp_ids_are_rs_ids)) {
        stop("snp_ids_are_rs_ids must be either TRUE or FALSE")
    }
    if (!is.logical(remove_multi_rs_snp)) {
        stop("remove_multi_rs_snp must be either TRUE or FALSE")
    }
    if (!is.logical(frq_is_maf)) {
        stop("frq_is_maf must be either TRUE or FALSE")
    }
    if (!is.logical(indels)) {
        stop("indels must be either TRUE or FALSE")
    }
    if (!is.logical(drop_indels)) {
      stop("drop_indels must be either TRUE or FALSE")
    }
    if (!is.logical(check_dups)) {
      stop("check_dups must be either TRUE or FALSE")
    }
    if (!is.logical(write_vcf)) {
        stop("write_vcf must be either TRUE or FALSE")
    }
    #LDSC format has been deprecated - use save_format
    if (!isFALSE(ldsc_format)) {
        stop("`ldsc_format` has been deprecated. Use `save_format='LDSC'`.")
    }
    #save_format
    if(!is.null(save_format) &&
       !tolower(save_format) %in% c("ldsc","opengwas")){
      stop("save_format must be NULL or one of LDSC or openGWAS")
    }
    opengws_err <- paste0("IEU OpenGWAS format only available when saving as ",
                          "VCF. Set `write_vcf=True` and rerun ",
                          "`format_sumstats()`")
    if(!is.null(save_format) &&
        tolower(save_format)=="opengwas" & isFALSE(write_vcf))
      stop(opengws_err)
    if (!is.logical(pos_se)) {
        stop("pos_se must be either TRUE or FALSE")
    }
    if (!is.logical(effect_columns_nonzero)) {
        stop("effect_columns_nonzero must be either TRUE or FALSE")
    }
    if (!is.logical(imputation_ind)) {
        stop("imputation_ind must be either TRUE or FALSE")
    }
    if (!is.logical(log_folder_ind)) {
        stop("log_folder_ind must be either TRUE or FALSE")
    }
    if (!is.logical(log_mungesumstats_msgs)) {
        stop("log_mungesumstats_msgs must be either TRUE or FALSE")
    }

    # Check numeric
    if (!is.numeric(INFO_filter)) {
        stop("INFO_filter must be numeric")
    }
    if (!is.numeric(FRQ_filter)) {
        stop("FRQ_filter must be numeric")
    }
    if (!is.numeric(N_std)) {
        stop("N_std must be numeric")
    }
    #SNP level compute_n value - not allowed
    if(length(compute_n)>1 && is.numeric(compute_n)){
      compute_n_msg <- paste0("Multiple integer values for compute_n not ",
                              "supported.\nAdd SNP specific N values before ",
                              "passing to MungeSumstats.")
      stop(compute_n_msg)
    }

    if (!is.numeric(compute_n) || compute_n < 0) {
        if (is.character(compute_n)) {
            methods <- c("ldsc", "giant", "metal", "sum")
            msg_methods <- paste0(
                "Valid methods to compute N are: ",
                paste(methods, collapse = ", "),
                ". Please update compute_n."
            )
            if (!all(tolower(compute_n) %in% methods)) {
                  stop(msg_methods)
              }
        } else {
            stop("compute_n must be 0 or an integer value")
        }
    }

    # Check that chr_style is a valid choice
    styles <- c("NCBI", "UCSC", "dbSNP", "Ensembl")
    if (!(chr_style %in% styles)) {
      stop("chr_style must be one of ", paste(styles, collapse = ", "))
    }
    # Check that rmv_chr choices are all valid chromosomes
    # according to the Ensembl/NCBI naming style
    chrs <- c(as.character(seq_len(22)), "X", "Y", "MT")
    if (!is.null(rmv_chr)) {
      if (!all(rmv_chr %in% chrs)) {
        stop("rmv_chr choices must be one or more of: \n",
             paste(chrs, collapse = ", "))
      }
    }
    # check return_format
    rf_msg <- paste0(
        "MungeSumstats can only output as data.table, GRanges or ",
        "VRanges objects, not ", return_format,
        ". Check return_format"
    )
    if (!(tolower(return_format) %in% c(
        "vr", "vranges", "gr", "granges",
        "genomicranges", "data.table"
    ))) {
        stop(rf_msg)
    }

    # check if mapping file correct - in case user defined
    essential_cols <- c("SNP", "CHR", "BP", "P", "A1", "A2")
    signed_cols <- c("Z", "OR", "BETA", "LOG_ODDS", "SIGNED_SUMSTAT")
    mapping_file_msg <- paste0(
        "User supplied mapping file should be a 2 column ",
        "dataframe with columns Corrected and Uncorrected",
        ".\nMappings for at least  all essential and one ",
        "signed column must be included.\nThe essential ",
        "columns are: ",
        paste(essential_cols, collapse = ","), ".\n",
        "The signed columns are: ",
        paste(signed_cols, collapse = ","), ".\n",
        "If your inputted column headers ",
        "already have these headers correctly, make sure ",
        "to include a mapping for these too.\nFor example",
        ", SNP -> SNP. See data(sumstatsColHeaders) for ",
        "format."
    )
    if (!is.data.frame(mapping_file) || ncol(mapping_file) != 2 ||
        !all(
            toupper(
                colnames(mapping_file)
            ) %in% c("UNCORRECTED", "CORRECTED")
        ) ||
        !all(essential_cols %in%
            mapping_file[, toupper(colnames(mapping_file)) == "CORRECTED"]) ||
        !any(signed_cols %in%
            mapping_file[, toupper(colnames(mapping_file)) == "CORRECTED"])) {
        stop(mapping_file_msg)
    }

    if(tabix_index &&
       any(!requireNamespace("Rsamtools", quietly = TRUE),
           !requireNamespace("MatrixGenerics", quietly = TRUE)) ){
        pkgs <- c("Rsamtools","MatrixGenerics")
        missing_pkgs <- pkgs[!pkgs %in% rownames(utils::installed.packages())]
        tbx_msg <- paste0(
            "The following packages must be installed when tabix_index=TRUE:\n",
            paste(" -",missing_pkgs,
                  collapse = "\n"))
        stop(tbx_msg)
    }
    
    # validate drop_na_cols
    if (!is.character(drop_na_cols)) {
      if (!is.null(drop_na_cols)) {
        stop(
          "Parameter `drop_na_cols` should be either a character vector of column names, or `NULL`"
        )
      }
    } 
    
    #deprecated parameters
    if (!is.null(rmv_chrPrefix)) { 
      dep_msg <- paste0(
        "The parameter rmv_chrPrefix is now deprecated, please use chr_style ",
        "instead.\nThe default of rmv_chrPrefix = True will give the same ",
        "result as using chr_style = 'Ensembl'."
        )
      stop(dep_msg)
    }
    rmv_chrPrefix = rmv_chrPrefix
}

#' Drop duplicate columns
#' 
#' Drop columns with identical names (if any exist) within a data.table.
#' @param dt data.table
#' @keywords internal
#' @return Null output
drop_duplicate_cols <- function(dt){
    dups <- which(duplicated(names(dt)))
    if(length(dups)>0){
        messager("Dropping",length(dups),"duplicate column(s).")
        dt[,  which(duplicated(names(dt))):= NULL] 
    } 
}

#' Write sum stats file to disk
#'
#' @param sumstats_dt data table obj of the summary statistics
#' file for the GWAS.
#' @param return_path Return \code{save_path}.
#'  This will have been modified in some cases
#'   (e.g. after compressing and tabix-indexing a
#'    previously un-compressed file).
#' @param save_path_check Ensure path name is valid (given the other arguments)
#' before writing (default: FALSE).
#' @inheritParams data.table::fread
#' @inheritParams format_sumstats
#'
#' @source \href{https://github.com/Bioconductor/VariantAnnotation/issues/35}{
#' VariantAnnotation::writeVcf has some unexpected/silent
#' file renaming behavior}
#'
#' @returns If \code{return_path=TRUE}, returns \code{save_path}.
#'  Else returns \code{NULL}.
#'
#' @export
#' @importFrom GenomicRanges makeGRangesFromDataFrame
#' @importFrom VariantAnnotation makeVRangesFromGRanges
#' @examples
#' path <- system.file("extdata", "eduAttainOkbay.txt",
#'     package = "MungeSumstats"
#' )
#' eduAttainOkbay <- read_sumstats(path = path)
#' write_sumstats(
#'     sumstats_dt = eduAttainOkbay,
#'     save_path = tempfile(fileext = ".tsv.gz")
#' )
write_sumstats <- function(sumstats_dt,
                           save_path,
                           ref_genome=NULL,
                           sep = "\t",
                           write_vcf = FALSE,
                           save_format = NULL,
                           tabix_index = FALSE,
                           nThread = 1,
                           return_path = FALSE,
                           save_path_check = FALSE) {
    #### Check save_path ####
    if (isTRUE(save_path_check)) {
        check <- check_save_path(save_path = save_path,
                                 log_folder = tempdir(),
                                 log_folder_ind = FALSE,
                                 tabix_index = tabix_index,
                                 write_vcf = write_vcf,
                                 verbose = TRUE)
        save_path <- check$save_path
    } 
    #### Sort again just to be sure when tabix-indexing ####
    if (isTRUE(tabix_index) ||
        isTRUE(write_vcf)) {
      sumstats_dt <- sort_coords(sumstats_dt = sumstats_dt)
    }
    #### Select write format ####
    if (isTRUE(write_vcf)) { 
        tmp_save_path <- gsub("\\.bgz|\\.gz", "", save_path)
        #convert to IEU OpenGWAS VCF format (column naming and RSID position)
        if (!is.null(save_format) &&
            tolower(save_format) == "opengwas") {
            #### Check ref genome ####
            if(missing(ref_genome) || 
               is.null(ref_genome)){
                stp <- "ref_genome must be provided when write_vcf=TRUE."
                stop(stp)
            }
          #first check genome build - all of openGWAS is GRCh37 currently so
          #warn user if their data isn't
          gen_build_err <- paste0("Your sumstats has been built on the ",
                                  ref_genome, " reference genome. However, ",
                                  "OpenGWAS is all\n",
                                  "currently built on GRCh37. Use the ",
                                  "convert_ref_genome parameter to liftover to",
                                  " GRCh37 by rerunning format_sumstats.")
          if (toupper(ref_genome) != "GRCH37")
            warning(gen_build_err)
          #necessary cols (https://github.com/MRCIEU/gwas-vcf-specification):
          #NS:NC:ES:SE:LP:AF:AC
          #p-val needs to be -log10 p
          #SNP -> RSID in INFO col
          if ("SNP" %in% colnames(sumstats_dt)) {
            setnames(sumstats_dt, "SNP", "RSID")
          } else{
            stop("SNP/RSID is required for IEU OpenGWAS format VCFs")
          }
          #remove any extra columns
          opengwas_cols <- c("RSID", "CHR", "BP", "A1", "A2", "P",
                             "FRQ", "BETA", "SE", "N", "N_CAS")
          if (any(!(colnames(sumstats_dt) %in% opengwas_cols)))
            sumstats_dt[, colnames(sumstats_dt)[!(colnames(sumstats_dt) %in%
                                                  opengwas_cols)] := NULL]
          #### Convert to VRanges and save ####
          vr <- to_vranges(sumstats_dt = sumstats_dt)
          if ("P" %in% names(mcols(vr))) {
            #P -> LP
            vr$LP <- -log(vr$P, base = 10)
            vr$P <- NULL
          } else {
            stop("P-value is required for IEU OpenGWAS format VCFs")
          }
          #FRQ -> AF
          if ("FRQ" %in% names(mcols(vr))) {
            vr$AF <- vr$FRQ
            vr$FRQ <- NULL
          }
          #BETA -> ES
          if ("BETA" %in% names(mcols(vr))) {
            vr$ES <- vr$BETA
            vr$BETA <- NULL
          } else {
            stop("BETA (Effect Size) is required for IEU OpenGWAS format VCFs")
          }
          #SE -> SE
          if (!"SE" %in% names(mcols(vr))) {
            se_msg <- paste0("Standard Error (of effect size) is required for",
                              " IEU OpenGWAS format VCFs")
            stop(se_msg)
          }
          #N -> NS
          if ("N" %in% names(mcols(vr))) {
            vr$NS <- vr$N
            vr$N <- NULL
          }
          #N_CAS -> NC
          if ("N_CAS" %in% names(mcols(vr))) {
            vr$NC <- vr$N_CAS
            vr$N_CAS <- NULL
          }
          #reorder cols and drop any unnecessary
          all_poss_cols <- c("RSID", "NS", "NC", "ES", "SE", "LP", "AF", "AC")
          vr <- vr[, all_poss_cols[all_poss_cols %in% names(mcols(vr))]]

          messager("Writing in IEU OpenGWAS VCF format ==> ", save_path)
          VariantAnnotation::writeVcf(
            obj = VariantAnnotation::asVCF(vr, info = "RSID"),
            ### Must supply filename without compression suffix
            filename = tmp_save_path,
            index = tabix_index
          )

        } else {
          #### Convert to VRanges and save ####
          vr <- to_vranges(sumstats_dt = sumstats_dt)
          messager("Writing in VCF format ==> ", save_path)
          VariantAnnotation::writeVcf(
              obj = vr,
              ### Must supply filename without compression suffix
              filename = tmp_save_path,
              index = tabix_index
          )
        }
        #### Compress ####
        ## only compress if this was not already handled by writeVcf(index=T)
        if (isFALSE(tabix_index)) {
            if (endsWith(save_path,".bgz")) {
                save_path <- Rsamtools::bgzip(tmp_save_path, overwrite = TRUE)
            } else if (endsWith(save_path,".gz")) {
                #save_path <- R.utils::gzip(tmp_save_path, overwrite = TRUE)
                # IMPORTANT: use bgzip, not gzip, for VCF compatibility
                save_path <- Rsamtools::bgzip(tmp_save_path, overwrite = TRUE)
            } else {
                save_path <- tmp_save_path
            }
        }
    } else {
        if (isTRUE(tabix_index)) {
            tmp_save_path <- gsub(".bgz|.gz", "", save_path)
            messager("Writing in tabular format ==>", tmp_save_path)
            if (tmp_save_path != save_path) {
              messager("Writing uncompressed instead of gzipped",
                       "to enable tabix indexing.")
            }
        } else {
            tmp_save_path <- save_path
            messager("Writing in tabular format ==>", save_path)

        }
        #### Write to disk ####
        if (sep == "\t") {
          quotation <- FALSE
          narep <- "NA"
        } else {
          quotation <- "auto"
          narep <- ""
        }

        data.table::fwrite(
            x = sumstats_dt,
            ### Must be uncompressed so ####
            file = tmp_save_path,
            sep = sep,
            nThread = nThread,
            na = narep,
            quote = quotation
        )

        if (isTRUE(tabix_index)) {
            save_path <- index_tabular(path = tmp_save_path,
                                       chrom_col = "CHR",
                                       start_col = "BP",
                                       verbose = TRUE)
        }
    }
    if (isTRUE(return_path)) return(save_path)
}

test_that("index_tabular works", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
  
    #### Don't run on Windows at all for now, since tabix-
    is_32bit_windows <-
      .Platform$OS.type == "windows"## && .Platform$r_arch == "i386"
    if (!is_32bit_windows) { 
        
      sumstats_dt <- MungeSumstats::formatted_example() 
      path <- tempfile(fileext = ".tsv")
      MungeSumstats::write_sumstats(sumstats_dt = sumstats_dt,
                                    save_path = path)
      #### Index file ####
      tbx_file <- MungeSumstats::index_tabular(path = path) 
      
      #### Test that file exists ####
      testthat::expect_true(endsWith(tbx_file,".bgz")) 
      testthat::expect_true(file.exists(tbx_file)) 
      
      #### Test that header exists ###
      header <- MungeSumstats::read_header(path = tbx_file)
      testthat::expect_equal(ncol(header), 9)
      #### Test that all chr1 SNPs are present ####
      tabixRange <- paste0(1,":",
                           min(sumstats_dt$BP),"-",
                           max(sumstats_dt$BP))
      query <-  MungeSumstats::read_header(path = tbx_file, 
                                           n = NULL)
      query[,CHR:=as.character(CHR)] 
      testthat::expect_equal(query,sumstats_dt) 
      
      #### --- Test sorting --- ####
      #### GenomicRanges ####
      query_unsorted <- data.table::copy(query)
      data.table::setorderv(x = query_unsorted, 
                            cols = c("BETA"))
      query_resorted <- MungeSumstats:::sort_coords(
          sumstats_dt = data.table::copy(query_unsorted), 
          sort_method = "GenomicRanges")
      testthat::expect_equal(all.equal(query,query_resorted,
                                       ignore.col.order = TRUE),TRUE)
      testthat::expect_failure(
          testthat::expect_equal(query$SNP,query_unsorted$SNP)
      )
      #### data.table ####
      query_unsorted <- data.table::copy(query)
      data.table::setorderv(x = query_unsorted, 
                            cols = c("BETA"))
      query_resorted <- MungeSumstats:::sort_coords(
          sumstats_dt = data.table::copy(query_unsorted), 
          sort_method = "data.table")
      testthat::expect_equal(query,query_resorted)
      testthat::expect_failure(
          testthat::expect_equal(query$SNP,query_unsorted$SNP)
      )
    }    
    else{
      expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("Test that different kinds of files can be read in.", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        ### read data
        path <- system.file("extdata", "eduAttainOkbay.txt", 
                            package = "MungeSumstats")
        sumstats_dt <- data.table::fread(path, nThread = 1)
        sumstats_dt <- standardise_header(
            sumstats_dt = sumstats_dt,
            return_list = FALSE,
        )
        col_order <- colnames(sumstats_dt)
        ### Test tsv
        tsv_ss <- sumstats_dt
        ### Test csv
        path_csv <- tempfile()
        data.table::fwrite(sumstats_dt, path_csv, sep = ",")
        csv_ss <- MungeSumstats::read_sumstats(path = path_csv, 
                                               standardise_headers = TRUE)
        #### Test space-separated
        path_space <- tempfile()
        data.table::fwrite(sumstats_dt, path_space, sep = " ")
        space_ss <- MungeSumstats::read_sumstats(path = path_space,
                                                 standardise_headers = TRUE)
        ### Test VCF
        vcf_tmp <- tempfile(fileext = ".vcf.gz")
        vcf_tmp <- write_sumstats(
            sumstats_dt = sumstats_dt,
            save_path = vcf_tmp,
            write_vcf = TRUE,
            return_path = TRUE,
            save_path_check = TRUE
        )
        vcf_ss <- MungeSumstats::read_sumstats(path = vcf_tmp,
                                               standardise_headers = TRUE) 
        for (x in c("FRQ", "BETA", "SE", "P")) {
            vcf_ss[, (x) := as.numeric(get(x))]
        }
        vcf_ss[,c("ID","END"):=NULL]
        data.table::setcolorder(vcf_ss, col_order) 
        
        #### Test that all dts are the same
        objs <- mget(c("tsv_ss", "csv_ss", "space_ss", "vcf_ss"))
        #### Ensure all keys are the same ####
        for(obj in objs){
            data.table::setkey(obj,SNP)
        }
        iterative_tests <- outer(objs, objs, Vectorize(all.equal))
        if (any(is(unlist(iterative_tests[1, ]), "character"))) {
            all_same <- FALSE
        } else {
            all_same <- all(colSums(iterative_tests) == nrow(iterative_tests))
        } 
        testthat::expect_equal(all_same, TRUE)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("write_sumstats works", {
    ## The following test uses more than 2GB of memory, which is more
    ## than what 32-bit Windows can handle:
    is_32bit_windows <- .Platform$OS.type == "windows" ##&&
    ##.Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        sumstats_dt <- MungeSumstats::formatted_example() 
        
        run_tests <- function(sumstats_dt,
                              fileext,
                              tabix_index=FALSE,
                              write_vcf=FALSE,
                              standardise_headers=FALSE,
                              save_path_check=FALSE){
            message(fileext) 
            #### Check paths #### 
            message("=== write tests ===")
            path_out <- MungeSumstats::write_sumstats(
                sumstats_dt = sumstats_dt,
                save_path = tempfile(fileext = fileext),
                write_vcf = write_vcf,
                tabix_index = tabix_index,
                return_path = TRUE, 
                save_path_check = save_path_check
            )
            testthat::expect_true(file.exists(path_out)) 
            
            message("\n=== read tests ===")
            dat <- MungeSumstats::read_sumstats(
                path = path_out, 
                standardise_headers = standardise_headers)
            testthat::expect_equal(nrow(dat), nrow(sumstats_dt)) 
            return(dat)
        }
        
        #### Tabular formats ####
        dat <- run_tests(sumstats_dt = sumstats_dt, 
                         fileext = ".tsv")
        dat <- run_tests(sumstats_dt = sumstats_dt, 
                         fileext = ".tsv.gz") 
        dat <- run_tests(sumstats_dt = sumstats_dt, 
                         fileext = ".tsv.bgz")
        dat <- run_tests(sumstats_dt = sumstats_dt, 
                         fileext = ".tsv.gz", 
                         tabix_index = TRUE)
        dat <- run_tests(sumstats_dt = sumstats_dt, 
                         fileext = ".tsv.bgz", 
                         tabix_index = TRUE)
        dat <- run_tests(sumstats_dt = sumstats_dt, 
                         fileext = ".csv")
        dat <- run_tests(sumstats_dt = sumstats_dt, 
                         fileext = ".csv.gz")
        # write_vcf=F
        ### Will write as tsv even though specified vcf suffix
        dat <- run_tests(sumstats_dt = sumstats_dt, 
                         fileext = ".vcf", 
                         save_path_check = TRUE) 
        dat <- run_tests(sumstats_dt = sumstats_dt, 
                         fileext = ".vcf.gz",
                         save_path_check = TRUE) 
        
        #### VCF formats ####
        # write_vcf=T
        dat <- run_tests(sumstats_dt = sumstats_dt, 
                         write_vcf = TRUE,
                         fileext = ".vcf") 
        dat <- run_tests(sumstats_dt = sumstats_dt, 
                         write_vcf = TRUE,
                         fileext = ".vcf.gz") 
        ## with indexing
        # providing the correct suffix is important
        #testthat::expect_failure(
        #    dat <- run_tests(sumstats_dt = sumstats_dt, 
        #                     write_vcf = TRUE,
        #                     tabix_index = TRUE,
        #                     fileext = ".vcf", 
        #                     save_path_check = FALSE) 
        #)
        dat <- run_tests(sumstats_dt = sumstats_dt, 
                         write_vcf = TRUE,
                         tabix_index = TRUE,
                         fileext = ".vcf", 
                         save_path_check = TRUE) 
        dat <- run_tests(sumstats_dt = sumstats_dt, 
                         tabix_index = TRUE,
                         write_vcf = TRUE,
                         fileext = ".vcf.bgz") 
    }
})

test_that("Test that VCFs can be properly read in.", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        # write the ALS GWAS, VCF file to a temp file for testing
        vcf_path <- system.file("extdata", "ALSvcf.vcf", 
                                package = "MungeSumstats")
        ### Read in original VCF
        sumstats_dt <- read_vcf(path = vcf_path)
        sumstats_dt <- standardise_header(
            sumstats_dt = sumstats_dt,
            return_list = FALSE
        )
        ### Write this VCF and then read it in again
        tmp_vcf <- tempfile(fileext = ".vcf.gz")
        tmp_vcf <- write_sumstats(
            sumstats_dt = sumstats_dt,
            save_path = tmp_vcf,
            write_vcf = TRUE,
            return_path = TRUE, 
            save_path_check = TRUE
        )
        sumstats_dt2 <- read_vcf(path = tmp_vcf)
        sumstats_dt2 <- standardise_header(
            sumstats_dt = sumstats_dt2,
            return_list = FALSE
        )
        ## Reading in the VCF again adds some new cols and changes their order
        common_cols <- intersect(names(sumstats_dt), names(sumstats_dt2))
        testthat::expect_equal(
            sumstats_dt[,common_cols,with=FALSE], 
            sumstats_dt2[,common_cols,with=FALSE]
        )
    }    
    else{
        testthat::expect_equal(is_32bit_windows, TRUE)
    }
})

#' Standardise the column headers in the Summary Statistics files
#'
#' Use a reference data table of common column header names (stored in
#' \code{sumstatsColHeaders} or user inputted mapping file) to convert them to a
#' standard set, i.e. chromosome -> CHR. This function does not check that all
#' the required column headers are present. The amended header is written
#' directly back into the file
#'
#' @param uppercase_unmapped For columns that could not be identified in 
#' the \code{mapping_file}, return them in the same format they were input as
#'  (without forcing them to uppercase). 
#' @param convert_A0 Whether to convert A* (representing A0) to A1/A2. This 
#' should be done unless checking if A0 was present in the input as if you do 
#' it you can't infer this. Default is TRUE   
#' @inheritParams format_sumstats 
#' @inheritParams compute_nsize
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object
#' @export
#' @importFrom data.table setnames rbindlist setDF
#' @examples
#' sumstats_dt <- data.table::fread(system.file("extdata", "eduAttainOkbay.txt",
#'                                              package = "MungeSumstats"))
#' sumstats_dt2 <- standardise_header(sumstats_dt=sumstats_dt)
standardise_header <- standardise_sumstats_column_headers_crossplatform <-
    function(sumstats_dt,
             mapping_file = sumstatsColHeaders,
             uppercase_unmapped=TRUE,
             convert_A0 = TRUE,
             return_list=TRUE) {
        message("Standardising column headers.")
        message("First line of summary statistics file: ")
        msg <- paste0(names(sumstats_dt), split = "\t")
        message(msg)
        #### Store original colnames #####
        ## In case we want to use the original casing 
        ## IMPORTANT! Must use copy() function or else this vector will get 
        ## changed when the data.table it comes from gets changed.
        names_og <- data.table::copy(names(sumstats_dt))
        #### first make all column headers upper case ####
        data.table::setnames(sumstats_dt, toupper(names(sumstats_dt))) 
        column_headers <- names(sumstats_dt) 
        # load synonym mapping - internal data no loading
        # Go through each and get correct spelling
        # allow for differing cases column names
        colnames(mapping_file) <- toupper(colnames(mapping_file))
        #get names for allele mared eff/frq columns
        eff_frq_allele_matches <- get_eff_frq_allele_combns()
        mapping_file <- rbind(mapping_file,
                              as.data.frame(eff_frq_allele_matches))
        for (headerI in seq_len(nrow(mapping_file))) {
            un <- mapping_file[headerI, "UNCORRECTED"]
            cr <- mapping_file[headerI, "CORRECTED"]
            if (un %in% column_headers & (!cr %in% column_headers)) {
                data.table::setnames(sumstats_dt, un, cr)
            }
        }
        # Special case!! A0/A1 -> ref/alt so A1 flips meaning,
        # A0 is A* in mapping
        # but usually A1/A2 -> ref/alt so if A* found,
        # swap A1 to A2 and make A* -> A1
        new_headers <- colnames(sumstats_dt)
        if ("A*" %in% new_headers && isTRUE(convert_A0)) {
            # if A1 and A2 also present need to rename A2
            if ("A1" %in% new_headers && "A2" %in% new_headers) {
                data.table::setnames(sumstats_dt, "A2", "A2_from_input")
            }
            # if A1 present change to A2, doesn't have to be, can be imputted
            data.table::setnames(sumstats_dt, "A1", "A2", skip_absent = TRUE)
            data.table::setnames(sumstats_dt, "A*", "A1")
        }
        #### Return mapped columns to original casing if requested ####
        if(!uppercase_unmapped){
            unmapped <- colnames(sumstats_dt)[
                !colnames(sumstats_dt) %in% mapping_file$CORRECTED
            ]
            unmapped_og <- names_og[toupper(names_og) %in% unmapped]
            if(length(unmapped_og)>0){
                msg <- paste("Returning unmapped column names",
                             "without making them uppercase.")
                message(msg)
                data.table::setnames(sumstats_dt, unmapped, unmapped_og)
            } 
        }
        #### Return format ####
        if(return_list){
            return(list("sumstats_dt" = sumstats_dt))
        }else {
            return(sumstats_dt)
        } 
    }

#' Read VCF: INFO column
#' 
#' Parse INFO column in VCF file.
#' 
#' @param sumstats_dt Summary stats data.table. 
#' @keywords internal
#' @returns Null output.
#' @importFrom data.table setnames
read_vcf_info <- function(sumstats_dt){
    INFO <- NULL;
    
    if((!"INFO" %in% names(sumstats_dt)) && 
       ("SI" %in% names(sumstats_dt))){
        messager("Renaming SI column as INFO.")
        data.table::setnames(sumstats_dt, "SI","INFO")
    } 
    if("INFO" %in% names(sumstats_dt)){
        messager("Formatting INFO column.")
        sumstats_dt[INFO == ".", INFO := 0]
        sumstats_dt[, INFO := as.numeric(INFO)]
    } else {
        messager("No INFO (SI) column detected.")
    }
}

.onLoad <- function(libname, pkgname) {
    
    #### Ensure functions recognise you're using data.table #####
    # https://rdatatable.gitlab.io/data.table/articles/datatable-importing.html
    .datatable.aware<-TRUE;
    
    #op <- options()
    #op.googleAuthR <- list(
    #    gargle_oauth_cache = "ieugwasr_oauth",
    #    googleAuthR.verbose = 3,
    #    googleAuthR.webapp.client_id = "906514199468-1jpkqgngur8emoqfg9j460s47fdo2euo.apps.googleusercontent.com",
    #    googleAuthR.webapp.client_secret = "I7Gqp83Ku4KJxL9zHWYxG_gD",
    #    googleAuthR.client_id = "906514199468-m9thhcept50gu26ng494376iipt125d6.apps.googleusercontent.com",
    #    googleAuthR.client_secret = "zkihPnJnNRlHTinpzI0NUs4R",
    #    googleAuthR.webapp.port = 4018,
    #    googleAuthR.jsonlite.simplifyVector = TRUE,
    #    googleAuthR.scopes.selected = c(
    #        "https://www.googleapis.com/auth/userinfo.profile",
    #        "https://www.googleapis.com/auth/userinfo.email"
    #    ),
    #    googleAuthR.ok_content_types = c("application/json; charset=UTF-8",
    #                                     ("text/html; charset=UTF-8")),
    #    googleAuthR.securitycode =
    #        paste0(base::sample(c(seq(1, 9), LETTERS, letters),
    #                            20, replace = TRUE), collapse = ""),
    #    googleAuthR.tryAttempts = 5
    #)
    
    #options(op.googleAuthR)
    #select_api(where = "public", 
    #           verbose = FALSE) 
    invisible()
}

#' Ensure all SNPs are on the reference genome
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return A list containing two data tables:
#' \itemize{
#'   \item \code{sumstats_dt}{
#'   : the modified summary statistics data table object}
#'   \item \code{rsids}{
#'   : snpsById, filtered to SNPs of interest if loaded already. Or else NULL}
#'   \item \code{log_files}{
#'   : log file list}
#' }
#' @keywords internal
#' @importFrom data.table setDT
#' @importFrom data.table setkey
#' @importFrom data.table :=
#' @importFrom data.table copy
#' @importFrom data.table rbindlist
#' @importFrom data.table setcolorder
check_on_ref_genome <-function(sumstats_dt, 
                               path, 
                               ref_genome, 
                               on_ref_genome, 
                               indels=indels,
                               rsids, 
                               imputation_ind,
                               log_folder_ind, 
                               check_save_out, 
                               tabix_index, 
                               nThread, 
                               log_files,
                               dbSNP,
                               dbSNP_tarball) {
        CHR <- SNP <- IMPUTATION_SNP <- miss_rs_chr_bp <- A1 <- A2 <- NULL
        # If CHR present and user specified chromosome to have SNPs removed
        col_headers <- names(sumstats_dt)
        if ("SNP" %in% col_headers && !isFALSE(on_ref_genome)) {
            message("Ensuring all SNPs are on the reference genome.")
            if (is.null(rsids)) {
                rsids <- load_ref_genome_data(
                    snps = data.table::copy(sumstats_dt$SNP),
                    ref_genome = ref_genome,
                    dbSNP = dbSNP,
                    dbSNP_tarball = dbSNP_tarball
                )
            }
            # ensure rsids is up-to-date with filtered sumstats_dt
            rsids <- rsids[sumstats_dt, ,nomatch = NULL,on="SNP"]
            #remove dups caused by indels non bi-alllelic SNPs
            rsids <-unique(rsids,by="SNP")
            data.table::setkey(rsids, SNP)
            #if indels in dataset, don't check they are present on the ref 
            # genome as they won't be there
            if(indels){
                data.table::setkey(sumstats_dt, SNP)
                #make copy, check if not pres in ref first
                indel_dt <-
                        data.table::copy(sumstats_dt[!unique(rsids$SNP),])
                #also check >1 character in A1 A2, use this to define indel
                indel_dt <- indel_dt[(nchar(A1)>1 | nchar(A2)>1),]
                if(nrow(indel_dt)>0){
                        #remove indels from sumstats for now
                        sumstats_dt <- sumstats_dt[!indel_dt$SNP, ]
                        msg <- paste0("Found ",
                                        formatC(nrow(indel_dt),big.mark = ","),
                                        " Indels. These won't",
                                        " be checked against the reference ",
                                        "genome as it does not contain ",
                                        "Indels.\nWARNING If your sumstat ",
                                        "doesn't contain Indels, set the ",
                                        "indel param to FALSE & rerun ",
                                        "MungeSumstats::format_sumstats()")
                        message(msg)
                }
            }else{
                    # join using SNP
                    data.table::setkey(sumstats_dt, SNP)
                    indel_dt <- data.table::data.table()
            }
            num_bad_ids <- 
                    length(sumstats_dt$SNP)-length(rsids$SNP)-nrow(indel_dt)
            # check for SNPs not on ref genome
            if (num_bad_ids > 0) {
                msg <- paste0(
                    formatC(num_bad_ids, big.mark = ","),
                    " SNPs are not on the reference genome.",
                    " These will be corrected from the reference genome."
                )
                message(msg)
                # if the dataset has CHR & BP, try impute the correct ones
                if (sum(c("CHR", "BP") %in% col_headers) == 2) {
                    bad_snp <- sumstats_dt[!rsids$SNP, ]
                    # remove snp column and pass to function to impute snp
                    bad_snp <- bad_snp[, SNP := NULL]
                    corrected_snp <-
                        check_no_snp(
                            sumstats_dt = bad_snp, 
                            path = tempfile(),
                            ref_genome = ref_genome, 
                            indels=indels,
                            imputation_ind = imputation_ind,
                            log_folder_ind = log_folder_ind,
                            check_save_out = check_save_out, 
                            tabix_index = tabix_index,
                            nThread = nThread, 
                            log_files = log_files,
                            dbSNP = dbSNP,
                            dbSNP_tarball = dbSNP_tarball,
                            verbose = FALSE
                        )
                    log_files <- corrected_snp$log_files
                    corrected_snp <- corrected_snp$sumstats_dt
                    # make sure columns in correct order
                    data.table::setcolorder(corrected_snp, names(sumstats_dt))
                    # remove rows missing from the reference genome and combine
                    # If IMPUTATION column added add it to other DT
                    if (imputation_ind && 
                        !"IMPUTATION_SNP" %in% names(sumstats_dt)) {
                        sumstats_dt[, IMPUTATION_SNP := NA]
                        # update for indels so can rbind later
                        if(indels){
                            indel_dt[, IMPUTATION_SNP := NA]
                        }
                    }
                    sumstats_dt <-
                        data.table::rbindlist(
                            list(sumstats_dt[rsids$SNP, ], corrected_snp))
                } else {
                    msg <- paste0(
                        formatC(num_bad_ids, big.mark = ","),
                        " SNPs are not on the reference genome. ",
                        "These will be removed"
                    )
                    message(msg)

                    # remove rows missing from the reference genome
                    # If user wants log, save it to there
                    if (log_folder_ind) {
                        name <- "snp_not_on_ref_gen"
                        name <- get_unique_name_log_file(name = name,
                                                         log_files = log_files)
                        write_sumstats(
                            sumstats_dt = sumstats_dt[!rsids$SNP, ],
                            save_path =
                                paste0(
                                    check_save_out$log_folder,
                                    "/", name,
                                    check_save_out$extension
                                ),
                            sep = check_save_out$sep,
                            #don't tab indx as could be miss values & cause err
                            #tabix_index = tabix_index,
                            nThread = nThread
                        )
                        log_files[[name]] <-
                            paste0(check_save_out$log_folder, "/",
                                   name, check_save_out$extension)
                    }
                    sumstats_dt <- sumstats_dt[rsids$SNP, ,on="SNP"]
                    #join back indels
                    sumstats_dt <-
                            data.table::rbindlist(
                                    list(sumstats_dt, indel_dt))
                }
                #update rsid again since new SNP IDs
                rsids <- load_ref_genome_data(
                        snps = data.table::copy(sumstats_dt$SNP),
                        ref_genome = ref_genome,
                        dbSNP=dbSNP,
                        dbSNP_tarball = dbSNP_tarball
                )
            }
            #join back indels
            sumstats_dt <-
                    data.table::rbindlist(
                            list(sumstats_dt, indel_dt))
        }
        return(list("sumstats_dt" = sumstats_dt,
                    "rsids" = rsids, 
                    "log_files" = log_files))
}

#' Parse number of SNPs not correctly formatted
#' 
#' Support function for \link[MungeSumstats]{parse_logs}.
#' 
#' @param l Lines of text from log file.
#' 
#' @return Numeric
#' @keywords internal
parse_snps_not_formatted <- function(l){
    line <- grep("SNP IDs are not correctly formatted.",l,
                 value = TRUE)[1]
    if(is.na(line)) return(NA)
    as.integer(gsub(",","",strsplit(line," ")[[1]][1]))
}

#' Check if the inputted file is in VCF format
#'
#' @param header Header of the GWAS summary statistics file.
#' @return Whether the file is vcf or not
#' @keywords internal
#' @importFrom methods is
check_vcf <- function(header) {
    if (is(header, "VCFHeader")) {
        return(TRUE)
    }
    P <- LP <- INFO <- NULL
    # if the file is a VCF, first line will look like: ##fileformat=VCFv4.2
    first_line <- header[[1]]
    file_type <- gsub("^##fileformat=", "", first_line)
    is_vcf <- length(grep("^vcf", tolower(file_type))) == 1
    if (is_vcf) {
        message(
            "VCF format detected.",
            "This will be converted to a standardised table format."
        )
    }
    return(is_vcf)
}

test_that("Checking whether a file is works", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # write the ALS GWAS, VCF file to a temp file for testing
        vcf_head <- read_header(path = system.file("extdata", "ALSvcf.vcf",
            package = "MungeSumstats"
        ))
        is_vcf <- check_vcf(header = vcf_head)
        expect_equal(is_vcf, TRUE)
    }    
    else{
        expect_equal(TRUE, TRUE)
    }
})

#' Register cores
#' 
#' Register a multi-threaded instances using \pkg{BiocParallel}.
#' @inheritParams BiocParallel::SnowParam
#' @returns Null output.
register_cores <- function(workers=1,
                           progressbar=TRUE){
    requireNamespace("BiocParallel")
    BPPARAM <- if(.Platform$OS.type=="windows"){
        BiocParallel::SnowParam(workers = workers, 
                                progressbar = progressbar)
    } else {
        BiocParallel::MulticoreParam(workers = workers, 
                                     progressbar = progressbar)
    }
    BiocParallel::register(BPPARAM = BPPARAM)
}

#' Ensure all rows have SNPs beginning with rs or SNP, drop those that don't
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and log file list
#' @keywords internal
#' @importFrom data.table fread
#' @importFrom data.table fwrite
check_row_snp <- function(sumstats_dt, path, log_folder_ind, check_save_out,
                          tabix_index, nThread, log_files) {
    SNP <- NULL
    # All rows should start with either SNP or rs... if they don't drop them
    # use data table for speed
    num_bad_ids <- nrow(sumstats_dt[!grep("^rs", SNP), ])
    if (num_bad_ids > 0) {
        stop_msg <- paste0(
            "No SNPs (inferred as RSIDs) in the dataset start with",
            "'rs'. If these IDs are just some arbitrary value ",
            "rather than RSIDs, set `snp_ids_are_rs_ids=FALSE`"
        )
        if (num_bad_ids == nrow(sumstats_dt)) {
            stop(stop_msg)
        }
        msg <- paste0(
            formatC(num_bad_ids, big.mark = ","), " SNPs (inferred as ",
            "RSIDs) don't start with 'rs' and will be removed"
        )
        message(msg)
        # If user wants log, save it to there
        if (log_folder_ind) {
            name <- "snp_missing_rs"
            name <- get_unique_name_log_file(name = name,
                                             log_files = log_files)
            write_sumstats(
                sumstats_dt = sumstats_dt[!grep("^rs", SNP), ],
                save_path =
                    paste0(
                        check_save_out$log_folder,
                        "/", name,
                        check_save_out$extension
                    ),
                sep = check_save_out$sep,
                #don't tab indx as could be miss values & cause err
                #tabix_index = tabix_index,
                nThread = nThread
            )
            log_files[[name]] <-
                paste0(check_save_out$log_folder, "/",
                       name, check_save_out$extension)
        }
        sumstats_dt <- sumstats_dt[grep("^rs", SNP), ]

        return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
    } else {
        return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
    }
}

#' Parse the total time taken the munge the file
#' 
#' Support function for \link[MungeSumstats]{parse_logs}.
#' 
#' @param l Lines of text from log file.
#' 
#' @return Character
#' @keywords internal
parse_time <- function(l){
    line <- grep("Done munging in",l,
                 value = TRUE)[1]
    if(is.na(line)) return(NA)
    as.numeric(trimws(strsplit(line," ")[[1]][4], whitespace = "'|[ ]"))
}

#' Report info on current state of the summary statistics
#'
#' Prints report.
#'
#' @return No return
#'
#' @param sumstats_dt data table obj of the summary
#'  statistics file for the GWAS.
#' @keywords internal
report_summary <- function(sumstats_dt,
                           orig_dims = NULL) {
    ### Add this to avoid confusing BiocCheck
    P <- NULL

    orig_dims_report <- if (!is.null(orig_dims)) {
        paste0(" (", round(nrow(sumstats_dt) / orig_dims[1] * 100, 1),
               "% of original ", 
               formatC(orig_dims[1], big.mark = ",", format = "fg"),
               " rows)")
    } else {
        NULL
    }

    rows_msg <- paste0("\n   - ",
                       formatC(nrow(sumstats_dt), 
                               big.mark = ",", format = "fg"),
                       " rows", orig_dims_report)
    SNP_msg <- if ("SNP" %in% colnames(sumstats_dt)) {
        paste0("\n   - ", 
               formatC(length(unique(sumstats_dt$SNP)),
                       big.mark = ",", format = "fg"),
               " unique variants")
    } else {
        NULL
    }
    P_msg <- if ("P" %in% colnames(sumstats_dt)) {
        if (!is.numeric(sumstats_dt$P)){
          sumstats_dt[,P:=as.numeric(P)]
        }
        paste0("\n   - ", 
               formatC(nrow(subset(sumstats_dt, P < 5e-8)),
                       big.mark = ",", format = "fg"),
               " genome-wide significant variants (P<5e-8)")
    } else {
        NULL
    }
    CHR_msg <- if ("CHR" %in% colnames(sumstats_dt)) {
        paste0("\n   - ", 
               formatC(length(unique(sumstats_dt$CHR)),
                       big.mark = ","), 
               " chromosomes")
    } else {
        NULL
    }

    message(
        "Summary statistics report:",
        rows_msg,
        SNP_msg,
        P_msg,
        CHR_msg
    )
}

#' Read in VCF file
#'
#' Read in a VCF file as a \link[VariantAnnotation]{VCF} or a
#' \link[data.table]{data.table}.
#' Can optionally save the VCF/data.table as well.
#'
#' @param path Path to local or remote VCF file.
#' @param as_datatable Return the data as a
#'  \link[data.table]{data.table} (default: \code{TRUE})
#'  or a \link[VariantAnnotation]{VCF} (\code{FALSE}).
#' @param samples Which samples to use:
#' \itemize{
#' \item{1 : }{Only the first sample will be used (\emph{DEFAULT}).}
#' \item{NULL : }{All samples will be used.}
#' \item{c("<sample_id1>","<sample_id2>",...) : }{
#' Only user-selected samples will be used (case-insensitive).}
#' }
#' @param which Genomic ranges to be added if supplied. Default is NULL.
#' @param use_params
#' When \code{TRUE} (default), increases the speed of reading in the VCF by
#' omitting columns that are empty based on the head of the VCF (NAs only).
#' NOTE that that this requires the VCF to be sorted, bgzip-compressed,
#' tabix-indexed, which \link[MungeSumstats]{read_vcf} will attempt to do.
#' @param download Download the VCF (and its index file)
#' to a temp folder before reading it into R.
#' This is important to keep \code{TRUE} when \code{nThread>1} to avoid
#' making too many queries to remote file.
#' @param mt_thresh When the number of rows (variants) in the VCF is
#' \code{< mt_thresh}, only use single-threading for reading in the VCF.
#' This is because the overhead of parallelisation outweighs the speed benefits
#' when VCFs are small.
#' @param verbose Print messages.
#' @inheritParams check_empty_cols
#' @inheritParams format_sumstats
#' @inheritParams downloader
#' @inheritParams download_vcf
#' @inheritParams import_sumstats
#' @inheritParams VariantAnnotation::ScanVcfParam
#'
#' @return The VCF file in data.table format.
#' @export
#' @importFrom VariantAnnotation writeVcf
#' @importFrom data.table as.data.table setnames fwrite
#' @source
#' \code{
#' #### Benchmarking ####
#' library(VCFWrenchR)
#' library(VariantAnnotation)
#' path <- "https://gwas.mrcieu.ac.uk/files/ubm-a-2929/ubm-a-2929.vcf.gz"
#' vcf <- VariantAnnotation::readVcf(file = path)
#' N <- 1e5
#' vcf_sub <- vcf[1:N,]
#' res <- microbenchmark::microbenchmark(
#'     "vcf2df"={dat1 <- MungeSumstats:::vcf2df(vcf = vcf_sub)},
#'     "VCFWrenchR"= {dat2 <- as.data.frame(x = vcf_sub)},
#'     "VRanges"={dat3 <- data.table::as.data.table(
#'         methods::as(vcf_sub, "VRanges"))},
#'     times=1
#' )
#' }
#' @source \href{https://github.com/Bioconductor/VariantAnnotation/issues/57}{
#' Discussion on VariantAnnotation GitHub}
#' @source \href{https://github.com/Bioconductor/VariantAnnotation/issues/59}{
#' Discussion on VariantAnnotation GitHub}
#' @examples
#' #### Local file ####
#' path <- system.file("extdata","ALSvcf.vcf", package="MungeSumstats")
#' sumstats_dt <- read_vcf(path = path)
#'
#' #### Remote file ####
#' ## Small GWAS (0.2Mb)
#' # path <- "https://gwas.mrcieu.ac.uk/files/ieu-a-298/ieu-a-298.vcf.gz"
#' # sumstats_dt2 <- read_vcf(path = path)
#'
#' ## Large GWAS (250Mb)
#' # path <- "https://gwas.mrcieu.ac.uk/files/ubm-a-2929/ubm-a-2929.vcf.gz"
#' # sumstats_dt3 <- read_vcf(path = path, nThread=11)
#'
#' ### Very large GWAS (500Mb)
#' # path <- "https://gwas.mrcieu.ac.uk/files/ieu-a-1124/ieu-a-1124.vcf.gz"
#' # sumstats_dt4 <- read_vcf(path = path, nThread=11)
read_vcf <- function(path,
                     as_datatable = TRUE,
                     save_path = NULL,
                     tabix_index = FALSE,
                     samples = 1,
                     which = NULL,
                     use_params = TRUE,
                     sampled_rows = 1e4L,
                     download = TRUE,
                     vcf_dir = tempdir(),
                     download_method = "download.file",
                     force_new = FALSE,
                     mt_thresh = 1e5L,
                     nThread = 1,
                     verbose = TRUE) {
    #### Read VCF ####
    ## Returns either a VCF or a data.table, depending on as_datatable arg.
    vcf_dt <- read_vcf_parallel(path = path,
                                samples = samples,
                                which = which,
                                use_params = use_params,
                                as_datatable = as_datatable,
                                sampled_rows = sampled_rows,

                                download = download,
                                vcf_dir = vcf_dir,
                                download_method = download_method,
                                force_new = force_new,
                                nThread = nThread,
                                verbose = verbose)
    #### Check save path ####
    if (!is.null(save_path)) {
        check_save_path_out <- check_save_path(
            ### dummy arg, not used here
            log_folder = "NULL",
            ### dummy arg, not used here
            log_folder_ind = FALSE,
            save_path = save_path,
            write_vcf = !as_datatable,
            tabix_index = tabix_index)
        save_path <- check_save_path_out$save_path
    }
    #### Save as VCF ####
    if (isFALSE(as_datatable)) {
        if (!is.null(save_path)) {
            VariantAnnotation::writeVcf(
                obj = vcf_dt,
                filename = check_save_path_out$save_path,
                index = tabix_index
            )
        }
        messager("Returning as VCF.")
        return(vcf_dt)
    }
    #### Prepare SNP column ####
    read_vcf_markername(sumstats_dt = vcf_dt)
    #### Prepare/un-log P col ####
    sumstats_dt <- read_log_pval(sumstats_dt = vcf_dt,
                                 return_list=FALSE)
    #### Prepare INFO col ####
    read_vcf_info(sumstats_dt = vcf_dt)
    #### Rename start col #####
    data.table::setnames(vcf_dt, "start", "BP")
    #### Write new data ####
    if (!is.null(save_path)) {
        messager("Storing intermediate file before proceeding ==>", save_path,
                 v = verbose)
        data.table::fwrite(
            x = vcf_dt,
            file = save_path,
            sep = "\t",
            nThread = nThread,
            na = "NA",
            quote = FALSE
        )
    }
    return(vcf_dt)
}

test_that("Check that imputation columns added correctly", {
    ## The following test uses more than 2GB of memory, which is more
    ## than what 32-bit Windows can handle:
    is_32bit_windows <- .Platform$OS.type == "windows" #&&
    #.Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        #Our VCF file contains a BETA and SE column, let's impute these and 
        #compare the difference
        # write the ALS GWAS, VCF file to a temp file for testing
        vcf_path <- system.file("extdata", "ALSvcf.vcf", 
                                package = "MungeSumstats")
        sumstats_dt <- MungeSumstats:::read_vcf(path = vcf_path)
        #add in known sample size of study
        sumstats_dt[,N:=293723]
        # write to temp dir
        file <- tempfile()
        data.table::fwrite(sumstats_dt, file)
        #run control through
        control <- MungeSumstats::format_sumstats(file,
                                                  ref_genome = "GRCh37",
                                                  on_ref_genome = FALSE,
                                                  strand_ambig_filter = FALSE,
                                                  bi_allelic_filter = FALSE,
                                                  allele_flip_check = FALSE,
                                                  imputation_ind = TRUE,
                                                  log_folder_ind = TRUE,
                                                  INFO_filter = 0,
                                                  dbSNP=144
        )
        control_dt <- data.table::fread(control$sumstats)
        #rerun control through with ES not equal to beta
        a<- data.table::fread(file)
        a[,Beta:=ES]
        control_es <- MungeSumstats::format_sumstats(a,
                                                  ref_genome = "GRCh37",
                                                  on_ref_genome = FALSE,
                                                  strand_ambig_filter = FALSE,
                                                  bi_allelic_filter = FALSE,
                                                  allele_flip_check = FALSE,
                                                  imputation_ind = TRUE,
                                                  log_folder_ind = TRUE,
                                                  INFO_filter = 0,
                                                  dbSNP=144,
                                                  es_is_beta = FALSE
        )
        control_dt_es <- data.table::fread(control_es$sumstats)
        control_dt_es[,ES:=NULL]
        testthat::expect_equal(all.equal(control_dt,control_dt_es,
                                         ignore.col.order = TRUE),TRUE)
        #now impute SE
        sumstats_dt_org <- copy(sumstats_dt)
        sumstats_dt[,SE:=NULL]
        data.table::fwrite(sumstats_dt, file)
        reformatted <- MungeSumstats::format_sumstats(file,
                                                      ref_genome = "GRCh37",
                                                      impute_se = TRUE,
                                                      on_ref_genome = FALSE,
                                                      strand_ambig_filter =
                                                          FALSE,
                                                      bi_allelic_filter = FALSE,
                                                      allele_flip_check = FALSE,
                                                      imputation_ind = TRUE,
                                                      log_folder_ind = TRUE,
                                                      INFO_filter = 0,
                                                      dbSNP=144
        )
        #first check it was imputed
        imp_se_dt <- data.table::fread(reformatted$sumstats)
        expect_equal("SE" %in% colnames(imp_se_dt), TRUE)
        expect_equal("IMPUTATION_SE" %in% colnames(imp_se_dt), TRUE)
        #check how close it is to actual
        setkey(imp_se_dt,SNP)
        setkey(control_dt,SNP)
        control_dt[imp_se_dt,imp_se:=i.SE]
        #check diff as percentage of value
        control_dt[,diff_se:=abs((SE-imp_se)/SE)]
        #expect a mean difference below 0.1%
        testthat::expect_equal(mean(control_dt$diff_se)<0.001, TRUE)
        
        
        #-----------
        # Now let's impute beta
        # use sumstats with Z and beta:
        # Genome-wide association meta-analysis (N=269,867) identifies new 
        # genetic and functional links to intelligence.
        # https://www.ncbi.nlm.nih.gov/pmc/articles/PMC6411041/
        # PMID: 29942086 PMCID: PMC6411041 DOI: 10.1038/s41588-018-0152-6
        #manually writing 25 rows because of package size limits
        sumstats_dt_org <-
            data.table::data.table(SNP=c('rs12184267','rs12184277','rs12184279',
                                         'rs116801199','rs12565286','rs2977670',
                                         'rs28454925','rs116720794','rs4951859',
                                         'rs146277091','rs3094315','rs3131972',
                                         'rs3115860','rs2073813','rs12184312',
                                         'rs12184325','rs3131969','rs3131968',
                                         'rs12184313','rs3131967','rs3115859',
                                         'rs10454459','rs3131966','rs3131965',
                                         'rs3115858'),
                                   CHR=c(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                                         1,1,1,1,1,1),
                                   BP=c(715265,715367,717485,720381,721290,
                                        723891,
                                        726794,729632,729679,752478,752566,
                                        752721,
                                        753405,753541,754063,754105,754182,
                                        754192,
                                        754211,754334,754503,754629,754964,
                                        755775,
                                        755890),
                                   A1=c('C','A','C','G','G','G','C','C','C',
                                        'G','G',
                                        'A','C','G','G','C','A','A','G','T',
                                        'G','A','C','A','A'),
                                   A2=c('T','G','A','T','C','C','G','T','G','A',
                                        'A',
                                        'G','A','A','T','T','G','G','A','C','A',
                                        'G','T','G','T'),
                                   FRQ=c(0.9591931,0.9589313,0.9594241,0.957838,
                                         0.9576224,0.06312,0.9590545,0.9589005,
                                         0.183523,0.9592701,0.180135,0.186495,
                                         0.147228,0.848645,0.9590545,0.9590083,
                                         0.154419,0.154389,0.9587773,0.153927,
                                         0.185618,0.9585925,0.184909,0.177333,
                                         0.147844),
                                   Z=c(-0.916,-0.656,-1.05,-0.3,-0.566,0.253,
                                       -0.539,
                                       -0.27,0.208,-0.263,0.351,0.61,0.48,
                                       -0.441,
                                       -0.181,-0.217,0.344,0.434,-0.212,0.509,
                                       0.823,-0.351,0.828,0.808,0.414),
                                   BETA=c(-0.0068872979,-0.0049144905,
                                          -0.0079116035,
                                          -0.0022174032,-0.0041742154,
                                          0.0015498434,
                                          -0.0040387267,-0.0020185581,
                                          0.0008058415,
                                          -0.0019709245,0.0013480759,
                                          0.0023117892,
                                          0.0019985366,-0.0018164389,
                                          -0.0013546785,
                                          -0.0016223525,0.0013769675,
                                          0.001760705,
                                          -0.0015823145,0.0020819201,
                                          0.003133556,
                                          -0.0026146926,0.003159564,
                                          0.0032010789,0.0017171769),
                                   SE=c(0.007518884,0.007491601,0.00753486,
                                        0.007391344,0.007374939,0.006125863,
                                        0.007492999,0.007476141,0.003874238,
                                        0.007494009,0.003840672,0.003789818,
                                        0.004163618,0.004118909,0.007484411,
                                        0.007476279,0.004002812,0.004056924,
                                        0.007463748,0.004090216,0.00380748,
                                        0.007449267,0.003815899,0.003961731,
                                        0.00414777),
                                   P=c(0.3598,0.5116,0.2938,0.7644,0.5711,
                                       0.8006,
                                       0.5896,0.7872,0.835,0.7924,0.7257,0.5421,
                                       0.631,0.6592,0.8567,0.8281,0.7309,0.6646,
                                       0.8322,0.6105,0.4103,0.7257,0.4074,0.419,
                                       0.6787),
                                   N=c(225955,226215,226224,226626,226528,
                                       225312,226782,226989,222312,227870,
                                       229517,229459,229723,229447,227303,
                                       227552,238992,232696,227092,229485,
                                       228163,227002,227830,218366,230684))
        
        sumstats_dt <- copy(sumstats_dt_org)
        sumstats_dt[,BETA:=NULL]
        data.table::fwrite(sumstats_dt, file)
        reformatted <- MungeSumstats::format_sumstats(file,
                                                      ref_genome = "GRCh37",
                                                      impute_beta = TRUE,
                                                      on_ref_genome = FALSE,
                                                      strand_ambig_filter = 
                                                          FALSE,
                                                      bi_allelic_filter = FALSE,
                                                      allele_flip_check = FALSE,
                                                      imputation_ind = TRUE,
                                                      log_folder_ind = TRUE,
                                                      dbSNP=144
        )
        imp_beta_dt <- data.table::fread(reformatted$sumstats)
        #first check it was imputed
        testthat::expect_equal("BETA" %in% colnames(imp_beta_dt), TRUE)
        #check imputation column created
        testthat::expect_equal("IMPUTATION_BETA" %in% colnames(imp_beta_dt), 
                               TRUE)
        #check how close it is to actual
        setkey(imp_beta_dt,SNP)
        setkey(sumstats_dt_org,SNP)
        sumstats_dt_org[imp_beta_dt,imp_beta:=i.BETA]
        #check diff as percentage of value
        sumstats_dt_org[,diff_beta:=abs((BETA-imp_beta)/BETA)]
        #expect a mean difference below 0.1%
        testthat::expect_equal(mean(sumstats_dt_org$diff_beta,na.rm = TRUE)<0.001, 
                               TRUE)
    } else {
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("VCF is correctly formatted", {
    # Run MungeSumstats code
    ## The following test uses more than 2GB of memory, which is more
    ## than what 32-bit Windows can handle:
    is_32bit_windows <- .Platform$OS.type == "windows" ##&&
    ##.Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        ## IMPORTANT: Must have .vcf file extension, 
        # or else MungeSumstats won't know it's a VCF.
        file <- tempfile(fileext = ".vcf")
        # write the ALS GWAS, VCF file to a temp file for testing
        ALSvcf <- readLines(system.file("extdata", "ALSvcf.vcf",
                                        package = "MungeSumstats"
        ))
        # dat <- data.table::fread(text = ALSvcf, skip = "#CHR")
        writeLines(ALSvcf, con = file)
        # vcf <- MungeSumstats:::read_vcf(path = file)
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(
            path = file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )  
        reformatted_lines <- readLines(reformatted)
        # check manually against first five SNPs
        corr_res <- c(
            "SNP\tCHR\tBP\tA1\tA2\tEND\tFILTER\tFRQ\tBETA\tLP\tSE\tP",
            "rs58108140\t1\t10583\tG\tA\t10583\tPASS\t0.1589\t0.0312\t0.369267\t0.0393\t0.427300105456596",
            "rs806731\t1\t30923\tG\tT\t30923\tPASS\t0.7843\t-0.0114\t0.126854\t0.0353\t0.746699739815279",
            "rs116400033\t1\t51479\tT\tA\t51479\tPASS\t0.1829\t0.0711\t1.26241\t0.037\t0.0546499790752282",
            "rs146477069\t1\t54421\tA\tG\t54421\tPASS\t0.0352\t-0.024\t0.112102\t0.083\t0.772499131799648"
        )
        testthat::expect_equal(reformatted_lines[1:5], corr_res)
        
        # check allelic flipping with VCF
        file2 <- tempfile(fileext = ".vcf")
        # write the ALS GWAS, VCF file to a temp file for testing
        ALSvcf <- readLines(system.file("extdata", "ALSvcf.vcf",
                                        package = "MungeSumstats"
        ))
        # update last SNP, flipping allelic direction: A/G --> G/A
        snp_of_interest <- "rs146477069"
        rsid_index <- grep(snp_of_interest, ALSvcf, ignore.case = TRUE)
        ALSvcf[rsid_index] <-
            ## Original
            # "1\t54421\trs146477069\tG\tA\t.\tPASS\tAF=0.0352\tES:SE:LP:AF:ID\t+0.024:0.083:0.112102:0.0352:rs146477069"
            ## flip FRQ
            "1\t54421\trs146477069\tG\tA\t.\tPASS\tAF=0.9648\tES:SE:LP:AF:ID\t+0.024:0.083:0.112102:0.9648:rs146477069"
        writeLines(ALSvcf, con = file2)
        reformatted_allelic_flip <-
            MungeSumstats::format_sumstats(
                path = file2,
                ref_genome = "GRCh37",
                on_ref_genome = FALSE,
                strand_ambig_filter = FALSE,
                bi_allelic_filter = TRUE,
                allele_flip_check = TRUE,
                allele_flip_drop = FALSE,
                INFO_filter = 0.01,
                dbSNP=144
            )
        reformatted_lines_af <- readLines(reformatted_allelic_flip)
        testthat::expect_equal(sort(reformatted_lines), 
                               sort(reformatted_lines_af))
        # also check outputting as different types
        pth <- system.file("extdata", "ALSvcf.vcf", package = "MungeSumstats")
        rtrn_dt <- MungeSumstats::format_sumstats(
            path = pth,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            allele_flip_drop = FALSE,
            INFO_filter = 0.01,
            return_data = TRUE,
            return_format = "data.table",
            dbSNP=144
        )
        rtrn_grng <- MungeSumstats::format_sumstats(
            path = pth,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            allele_flip_drop = FALSE,
            INFO_filter = 0.01,
            return_data = TRUE,
            return_format = "GRanges",
            dbSNP=144
        )
        rtrn_vrng <- MungeSumstats::format_sumstats(
            path = pth,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            allele_flip_drop = FALSE,
            INFO_filter = 0.01,
            return_data = TRUE,
            return_format = "VRanges",
            dbSNP=144
        )
        testthat::expect_true(is(rtrn_grng,"GRanges"))
        testthat::expect_true(is(rtrn_vrng,"VRanges"))
        testthat::expect_true(is(rtrn_dt,"data.table"))
        
        # also test inferring the genome build
        #### Failing atm? duplicate SNPs?
        # rtrn_dt_infer <- MungeSumstats::format_sumstats(
        #     path = pth,
        #     on_ref_genome = FALSE,
        #     strand_ambig_filter = FALSE,
        #     bi_allelic_filter = FALSE,
        #     allele_flip_check = FALSE,
        #     allele_flip_drop = FALSE,
        #     INFO_filter = 0.01,
        #     return_data = TRUE,
        #     return_format = "data.table"
        # )
        # testthat::expect_true(all.equal(rtrn_dt, rtrn_dt_infer))
        
        # also test outputting ldsc_format ready format
        rtrn_ldsc <- MungeSumstats::format_sumstats(
            path = pth,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            allele_flip_drop = FALSE,
            INFO_filter = 0.01,
            save_format='LDSC',
            compute_n = 1001,
            dbSNP=144
        )
        res <- data.table::fread(rtrn_ldsc, nThread = 1)
        # check for necessary columns - 
        # https://github.com/bulik/ldsc/wiki/Summary-Statistics-File-Format
        ldsc_cols <- c("SNP", "N", "A1", "A2", "Z")
        testthat::expect_true(all(ldsc_cols %in% names(res)))
        
        #also ensure A1 and A2 have been renamed
        #For LDSC format, rename A1 and A2 as LDSC expects A1 to be the effect 
        #column rather than A2 (the opposite to MSS's default) - see more 
        #[here](https://groups.google.com/g/ldsc_users/c/S7FZK743w68).Although, 
        #this didn't seem to make any difference to results in tests, see more
        #[here](https://github.com/neurogenomics/MungeSumstats/issues/160#issuecomment-1891899253).
        data.table::setnames(res,c("A1","A2"),c("A2","A1"))
        res[,CHR:=as.character(CHR)]
        testthat::expect_true(all.equal(res[,c("SNP","CHR","BP","A1","A2","END",
                                               "FILTER","FRQ","BETA","LP","SE",
                                               "P")],rtrn_dt))
        
                              
        testthat::expect_equal(reformatted_lines[1:5], corr_res)
    } else {
        testthat::expect_true((is_32bit_windows||!Sys.info()["sysname"]=="Linux"))
        testthat::expect_true((is_32bit_windows||!Sys.info()["sysname"]=="Linux"))
        testthat::expect_true((is_32bit_windows||!Sys.info()["sysname"]=="Linux"))
        testthat::expect_true((is_32bit_windows||!Sys.info()["sysname"]=="Linux"))
        testthat::expect_true((is_32bit_windows||!Sys.info()["sysname"]=="Linux"))
        testthat::expect_true((is_32bit_windows||!Sys.info()["sysname"]=="Linux"))
    }
})

#' Parse data from log files
#' 
#' Parses data from the log files generated by 
#' \link[MungeSumstats]{format_sumstats} or 
#' \link[MungeSumstats]{import_sumstats} when the argument
#' \code{log_mungesumstats_msgs} is set to \code{TRUE}.
#' 
#' @param save_dir Top-level directory to recursively search 
#' for log files within.
#' @param pattern Regex pattern to search for files with.
#' @param verbose Print messages.
#' 
#' @returns \link[data.table]{data.table} of parsed log data.
#'  
#' @export
#' @importFrom data.table data.table rbindlist
#' @examples 
#' save_dir <- system.file("extdata",package = "MungeSumstats")
#' log_data <- MungeSumstats::parse_logs(save_dir = save_dir)
parse_logs <- function(save_dir = getwd(),
                       pattern = "MungeSumstats_log_msg.txt$",
                       verbose = TRUE){
    log_files <- list.files(path = save_dir,
                            pattern = pattern,
                            full.names = TRUE,
                            recursive = TRUE)
    messager("Parsing info from",length(log_files),"log file(s).",
             v=verbose)
    #### Iterate over each log file ####
    log_data <- lapply(seq_len(length(log_files)), function(i){
        f <- log_files[i]
        # messager(i,":",f)
        l <- readLines(f)
        data.table::data.table(
            #### Infer ID from directory names ####
            id = basename(dirname(dirname(f))),
            id_standard = parse_idStandard(l = l),
            time = parse_time(l = l),
            #### Get metrics before munging ####
            rows_start = parse_report(l = l, entry = 1, line = 1),
            snps_start = parse_report(l = l, entry = 1, line = 2),
            sig_snps_start = parse_report(l = l, entry = 1, line = 3),
            chroms_start = parse_report(l = l, entry = 1, line = 4),
            #### Get metrics after munging ####
            rows_end = parse_report(l = l, entry = -1, line = 1),
            snps_end = parse_report(l = l, entry = -1, line = 2),
            sig_snps_end = parse_report(l = l, entry = -1, line = 3),
            chroms_end = parse_report(l = l, entry = -1, line = 4),
            #### Genome build ####
            build_inferred = parse_genome_build(l = l),
            #### Flipped ####
            snps_flipped = parse_flipped(l = l),
            snps_notFormatted = parse_snps_not_formatted(l = l),
            snps_frq05 = parse_snps_freq_05(l = l),
            snps_frq05Percent = parse_snps_freq_05(l = l, percent = TRUE),
            #### Dropped ####
            snps_dropped_INFO = parse_dropped_INFO(l = l),
            snps_dropped_nonRef = parse_dropped_nonRef(l = l),
            snps_dropped_nonA1A2 = parse_dropped_nonA1A2(l = l),
            snps_dropped_duplicates = parse_dropped_duplicates(l = l),
            snps_dropped_chrom = parse_dropped_chrom(l = l),
            snps_dropped_nonBiallelic = parse_dropped_nonBiallelic(l = l),
            #### Problematic p-values ####
            snps_pval_small = parse_pval_small(l = l),
            snps_pval_large = parse_pval_large(l = l),
            snps_pval_neg = parse_pval_neg(l = l),
            #### Path info ####
            log_path = f
        )  
    }) %>% data.table::rbindlist()
    return(log_data)
}

test_that("list_sumstats and parse_logs work", {
  
    #### Make some fake sums stats files ####
    # Let's pretend this is a different dataset each time.
    sumstats_path <- system.file(
        "extdata/ieu-a-298.tsv.gz",
        package = "MungeSumstats")
    #### Create fake log files ####
    # Let's pretend this is a different dataset each time.
    logs_path <- sumstats_path <- system.file(
        "extdata/MungeSumstats_log_msg.txt",
        package = "MungeSumstats")  
    #### iterate 10 files ####
    save_dir <- file.path(tempdir(),"data")
    n_files <- 10
    for(i in seq_len(n_files)){
        tmpdir <- file.path(save_dir,paste0("file",i))
        dir.create(tmpdir, showWarnings = FALSE, recursive = TRUE)
        tmpfile <- tempfile(tmpdir = tmpdir,
                            fileext = ".tsv.gz")
        print(tmpfile)
        #### sumstats ####
        file.copy(sumstats_path,
                  tmpfile)
        #### logs ####
        logs_path2 <- file.path(tmpdir,"logs")
        dir.create(logs_path2,showWarnings = FALSE)
        file.copy(logs_path,logs_path2)
    }
    #### List summary stats files ###
    munged_files <- MungeSumstats::list_sumstats(save_dir = save_dir)
    testthat::expect_length(munged_files,n_files)
    testthat::expect_length(unique(names(munged_files)), n_files)
    
    #### Parse log files ####
    log_data <- MungeSumstats::parse_logs(save_dir = save_dir)
    testthat::expect_true(methods::is(log_data,"data.frame"))
    testthat::expect_equal(nrow(log_data), n_files)
    testthat::expect_gte(ncol(log_data), 26)
})

#' Convert summary statistics to desired object type
#'
#' @return Summary statistics in the converted format
#'
#' @inheritParams format_sumstats
#' @param return_format Object type to convert to;
#'  \code{"data.table"}, \code{"GenomicRanges"} or
#'  \code{"VRanges"}(default is \code{"data.table"}).
#' @keywords internal
convert_sumstats <- function(sumstats_dt,
                             return_format = c("data.table", 
                                               "vranges", 
                                               "granges")) {
    return_format <- return_format[1]
    if (tolower(return_format) %in% c("vr", "vranges")) {
        out <- to_vranges(sumstats_dt = sumstats_dt)
        return(out)
    } else if (tolower(return_format) %in% c("gr",
                                             "granges",
                                             "genomicranges")) {
        out <- to_granges(sumstats_dt = sumstats_dt)
        return(out)
    } else {
        return(sumstats_dt)
    }
}

## ----setup--------------------------------------------------------------------
library(MungeSumstats)

## ----eval=FALSE, message=TRUE-------------------------------------------------
# eduAttainOkbayPth <- system.file("extdata","eduAttainOkbay.txt",
#                                   package="MungeSumstats")
# reformatted <-
#   MungeSumstats::format_sumstats(path=eduAttainOkbayPth,
#                                  ref_genome="GRCh37")

## ----echo=FALSE---------------------------------------------------------------
#don't run time intensive checks
eduAttainOkbayPth <- system.file("extdata","eduAttainOkbay.txt",
                                  package="MungeSumstats")
reformatted <- 
  MungeSumstats::format_sumstats(path=eduAttainOkbayPth,
                                 on_ref_genome = FALSE,
                                 strand_ambig_filter = FALSE,
                                 bi_allelic_filter = FALSE,
                                 allele_flip_check = FALSE,
                                 ref_genome="GRCh37")

## ----message=TRUE-------------------------------------------------------------
#save ALS GWAS from the ieu open GWAS project to a temp directory
ALSvcfPth <- system.file("extdata","ALSvcf.vcf", package="MungeSumstats")

## ----eval=FALSE---------------------------------------------------------------
# reformatted_vcf <-
#   MungeSumstats::format_sumstats(path=ALSvcfPth,
#                                  ref_genome="GRCh37")

## ----eval=FALSE, message=FALSE------------------------------------------------
# #set
# reformatted_vcf_2 <-
#   MungeSumstats::format_sumstats(path=ALSvcfPth,
#                                  ref_genome="GRCh37",
#                                  log_folder_ind=TRUE,
#                                  imputation_ind=TRUE,
#                                  log_mungesumstats_msgs=TRUE)

## ----echo=FALSE,message=FALSE-------------------------------------------------
#don't run time intensive checks
reformatted_vcf_2 <- 
  MungeSumstats::format_sumstats(path=ALSvcfPth,
                                 ref_genome="GRCh37",
                                 log_folder_ind=TRUE,
                                 imputation_ind=TRUE,
                                 log_mungesumstats_msgs=TRUE,
                                 on_ref_genome = FALSE,
                                 strand_ambig_filter = FALSE,
                                 bi_allelic_filter = FALSE,
                                 allele_flip_check = FALSE)

## ----message=TRUE-------------------------------------------------------------
names(reformatted_vcf_2)

## ----message=TRUE-------------------------------------------------------------
print(reformatted_vcf_2$log_files$snp_bi_allelic)

## ----message=FALSE,eval=FALSE-------------------------------------------------
# #set
# reformatted_vcf_2 <-
#   MungeSumstats::format_sumstats(path=ALSvcfPth,
#                                  ref_genome="GRCh37",
#                                  log_folder_ind=TRUE,
#                                  imputation_ind=TRUE,
#                                  log_mungesumstats_msgs=TRUE,
#                                  return_data=TRUE,
#                                  return_format="GRanges")

## ----message=FALSE,eval=FALSE-------------------------------------------------
# #set
# reformatted_vcf_2 <-
#   MungeSumstats::format_sumstats(path=ALSvcfPth,
#                                  ref_genome="GRCh37",
#                                  write_vcf=TRUE,
#                                  save_format ="openGWAS")

## ----message=FALSE,eval=FALSE-------------------------------------------------
# # Pass path to Educational Attainment Okbay sumstat file to a temp directory
# eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
#                                   package = "MungeSumstats")
# ALSvcfPth <- system.file("extdata","ALSvcf.vcf", package="MungeSumstats")
# sumstats_list <- list(ss1 = eduAttainOkbayPth, ss2 = ALSvcfPth)
# 
# ref_genomes <- MungeSumstats::get_genome_builds(sumstats_list = sumstats_list)
# 

## -----------------------------------------------------------------------------
sumstats_dt <- MungeSumstats::formatted_example()
sumstats_dt_hg38 <- MungeSumstats::liftover(sumstats_dt = sumstats_dt, 
                                            ref_genome = "hg19",
                                            convert_ref_genome = "hg38")
knitr::kable(head(sumstats_dt_hg38))

## -----------------------------------------------------------------------------
eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
                                  package = "MungeSumstats")
formatted_path <- tempfile(fileext = "_eduAttainOkbay_standardised.tsv.gz")


#### 1. Read in the data and standardise header names ####
dat <- MungeSumstats::read_sumstats(path = eduAttainOkbayPth, 
                                    standardise_headers = TRUE)
knitr::kable(head(dat))
#### 2. Write to disk as a compressed, tab-delimited, tabix-indexed file ####
formatted_path <- MungeSumstats::write_sumstats(sumstats_dt = dat,
                                                save_path = formatted_path,
                                                tabix_index = TRUE,
                                                write_vcf = FALSE,
                                                return_path = TRUE)   

## -----------------------------------------------------------------------------
#### Mess up some column names ####
dat_raw <- data.table::copy(dat)
data.table::setnames(dat_raw, c("SNP","CHR"), c("rsID","Seqnames"))
#### Add a non-standard column that I want to keep the casing for ####
dat_raw$Support <- runif(nrow(dat_raw))

dat2 <- MungeSumstats::standardise_header(sumstats_dt = dat_raw,
                                          uppercase_unmapped = FALSE, 
                                          return_list = FALSE )
knitr::kable(head(dat2))

## ----message=TRUE, echo=FALSE-------------------------------------------------
utils::sessionInfo()

#' Check that summary statistics from GWAS are in a homogeneous format
#'
#' @return The address for the modified sumstats file or the actual data
#' dependent on user choice. Also, if log files wanted by the user, the return
#' in both above instances are a list.
#'
#' @examples
#' # Pass path to Educational Attainment Okbay sumstat file to a temp directory
#'
#' eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
#'     package = "MungeSumstats"
#' )
#'
#' ## Call uses reference genome as default with more than 2GB of memory,
#' ## which is more than what 32-bit Windows can handle so remove certain checks
#' ## Using dbSNP = 144 for speed as it's smaller but you should use 155 unless
#' ## you know what you are doing and need 144
#'
#' is_32bit_windows <-
#'     .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
#' if (!is_32bit_windows) {
#'     reformatted <- format_sumstats(
#'         path = eduAttainOkbayPth,
#'         ref_genome = "GRCh37",
#'         dbSNP = 144
#'     )
#' } else {
#'     reformatted <- format_sumstats(
#'         path = eduAttainOkbayPth,
#'         ref_genome = "GRCh37",
#'         on_ref_genome = FALSE,
#'         strand_ambig_filter = FALSE,
#'         bi_allelic_filter = FALSE,
#'         allele_flip_check = FALSE,
#'         dbSNP=144
#'     )
#' }
#' # returned location has the updated summary statistics file
#' @param path Filepath for the summary statistics file to be formatted. A
#' dataframe or datatable of the summary statistics file can also be passed
#' directly to MungeSumstats using the path parameter.
#' @param ref_genome name of the reference genome used for the GWAS ("GRCh37" or
#' "GRCh38"). Argument is case-insensitive. Default is NULL which infers the
#' reference genome from the data.
#' @param convert_ref_genome name of the reference genome to convert to
#' ("GRCh37" or "GRCh38"). This will only occur if the current genome build does
#' not match. Default is not to convert the genome build (NULL).
#' @param chain_source source of the chain file to use in liftover, if converting
#' genome build ("ucsc" or "ensembl"). Note that the UCSC chain files require a
#' license for commercial use. The Ensembl chain is used by default ("ensembl").
#' @param local_chain Path to local chain file to use instead of downlaoding.
#' Default of NULL i.e. no local file to use. NOTE if passing a local chain file
#' make sure to specify the path to convert from and to the correct build like 
#' GRCh37 to GRCh38. We can not sense check this for local files. The chain file
#' can be submitted as a gz file (as downloaed from source) or unzipped.
#' @param convert_small_p Binary, should non-negative
#' p-values <= 5e-324 be converted to 0?
#' Small p-values pass the R limit and can cause errors with LDSC/MAGMA and
#' should be converted. Default is TRUE.
#' @param convert_large_p Binary, should p-values >1 be converted to 1?
#' P-values >1 should not be possible and can cause errors with LDSC/MAGMA and
#' should be converted. Default is TRUE.
#' @param convert_neg_p Binary, should p-values <0 be converted to 0?
#' Negative p-values should not be possible and can cause errors
#' with LDSC/MAGMA and should be converted. Default is TRUE.
#' @param compute_z Whether to compute Z-score column. Default is FALSE. This
#' can be computed from Beta and SE with (Beta/SE) or P
#' (Z:=sign(BETA)*sqrt(stats::qchisq(P,1,lower=FALSE))).
#' **Note** that imputing the Z-score from P for every SNP will not be
#' perfectly correct and may result in a loss of power. This should only be done
#' as a last resort. Use 'BETA' to impute by BETA/SE and 'P' to impute by SNP
#' p-value.
#' @param force_new_z When a "Z" column already exists, it will be used by
#' default. To override and compute a new Z-score column from P set
#' \code{force_new_z=TRUE}.
#' @param compute_n Whether to impute N. Default of 0 won't impute, any other
#' integer will be imputed as the N (sample size) for every SNP in the dataset.
#' **Note** that imputing the sample size for every SNP is not correct and
#' should only be done as a last resort. N can also be inputted with "ldsc",
#' "sum", "giant" or "metal" by passing one of these for this field or a vector
#' of multiple. Sum and an integer value creates an N column in the output
#' whereas giant, metal or ldsc create an Neff or effective sample size. If
#' multiples are passed, the formula used to derive it will be indicated.
#' @param convert_n_int Binary, if N (the number of samples) is not an integer,
#' should this be rounded? Default is TRUE.
#' @param impute_beta Binary, whether BETA should be imputed using other effect
#' data if it isn't present in the sumstats. Note that this imputation is an
#' approximation (for Z & SE approach) so could have an effect on downstream
#' analysis. Use with caution. The different methods MungeSumstats will try and
#' impute beta (in this order or priority) are:
#' 1. log(OR)  2. Z x SE
#' Default value is FALSE.
#' @param es_is_beta Binary, whether to map ES to BETA. We take BETA to be any
#' BETA-like value (including Effect Size). If this is not the case for your
#' sumstats, change this to FALSE. Default is TRUE.
#' @param impute_se Binary, whether the standard error should be imputed using
#' other effect data if it isn't present in the sumstats. Note that this
#' imputation is an approximation so could have an effect on downstream
#' analysis. Use with caution. The different methods MungeSumstats will try and
#' impute se (in this order or priority) are:
#' 1. BETA / Z  2. abs(BETA/ qnorm(P/2))
#' Default is FALSE.
#' @param analysis_trait If multiple traits were studied, name of the trait for
#' analysis from the GWAS. Default is NULL.
#' @param ignore_multi_trait If you have multiple traits (p-values) in the study
#' but you want to ignorwe these and instead use a standard named p-value, set
#' to TRUE. By default is FALSE which will check for multi-traits.
#' @param INFO_filter numeric The minimum value permissible of the imputation
#' information score (if present in sumstats file). Default 0.9.
#' @param FRQ_filter numeric The minimum value permissible of the frequency(FRQ)
#' of the SNP (i.e. Allele Frequency (AF)) (if present in sumstats file). By
#' default no filtering is done, i.e. value of 0.
#' @param pos_se Binary Should the standard Error (SE) column be checked to
#' ensure it is greater than 0? Those that are, are removed (if present in
#' sumstats file). Default TRUE.
#' @param effect_columns_nonzero Binary should the effect columns in the data
#' BETA,OR (odds ratio),LOG_ODDS,SIGNED_SUMSTAT be checked to ensure no SNP=0.
#' Those that do are removed(if present in sumstats file). Default FALSE.
#' @param N_std numeric The number of standard deviations above the mean a SNP's
#' N is needed to be removed. Default is 5.
#' @param N_dropNA Drop rows where N is missing.Default is TRUE.
#' @param chr_style Chromosome naming style to use in the formatted summary
#'   statistics file ("NCBI", "UCSC", "dbSNP", or "Ensembl"). The NCBI and
#'   Ensembl styles both code chromosomes as `1-22, X, Y, MT`; the UCSC style is
#'   `chr1-chr22, chrX, chrY, chrM`; and the dbSNP style is
#'   `ch1-ch22, chX, chY, chMT`. Default is Ensembl.
#' @param rmv_chrPrefix Is now deprecated, do. not use. Use chr_style instead -
#' chr_style = 'Ensembl' will give the same result as rmv_chrPrefix=TRUE used to
#' give.
#' @param rmv_chr Chromosomes to exclude from the formatted summary statistics
#'   file. Use NULL if no filtering is necessary. Default is `c("X", "Y", "MT")`
#'   which removes all non-autosomal SNPs.
#' @param on_ref_genome Binary Should a check take place that all SNPs are on
#' the reference genome by SNP ID. Default is TRUE.
#' @param infer_eff_direction Binary Should a check take place to ensure the 
#' alleles match the effect direction? Default is TRUE.
#' @param eff_on_minor_alleles Binary Should MungeSumstats assume that the 
#' effects are majoritively measured on the minor alleles? Default is FALSE as
#' this is an assumption that won't be appropriate in all cases. However, the 
#' benefit is that if we know the majority of SNPs have their effects based on 
#' the minor alleles, we can catch cases where the allele columns have been 
#' mislabelled.
#' @param strand_ambig_filter Binary Should SNPs with strand-ambiguous alleles
#' be removed. Default is FALSE.
#' @param allele_flip_check Binary Should the allele columns be checked against
#' reference genome to infer if flipping is necessary. Default is TRUE.
#' @param allele_flip_drop Binary Should the SNPs for which neither their A1 or
#' A2 base pair values match a reference genome be dropped. Default is TRUE.
#' @param allele_flip_z Binary should the Z-score be flipped along with effect
#' and FRQ columns like Beta? It is assumed to be calculated off the effect size
#' not the P-value and so will be flipped i.e. default TRUE.
#' @param allele_flip_frq Binary should the frequency (FRQ) column be flipped
#' along with effect and z-score columns like Beta? Default TRUE.
#' @param bi_allelic_filter Binary Should non-bi-allelic SNPs be removed.
#' Default is TRUE.
#' @param flip_frq_as_biallelic Binary Should non-bi-allelic SNPs frequency 
#' values be flipped as 1-p despite there being other alternative alleles? 
#' Default is FALSE but if set to TRUE, this allows non-bi-allelic SNPs to be 
#' kept despite needing flipping.
#' @param snp_ids_are_rs_ids Binary Should the supplied SNP ID's be assumed to
#' be RSIDs. If not, imputation using the SNP ID for other columns like
#' base-pair position or chromosome will not be possible. If set to FALSE, the
#' SNP RS ID will be imputed from the reference genome if possible. Default is
#' TRUE.
#' @param remove_multi_rs_snp Binary Sometimes summary statistics can have
#' multiple RSIDs on one row (i.e. related to one SNP), for example
#' "rs5772025_rs397784053". This can cause an error so by default, the first
#' RS ID will be kept and the rest removed e.g."rs5772025". If you want to just
#' remove these SNPs entirely, set it to TRUE. Default is FALSE.
#' @param frq_is_maf Conventionally the FRQ column is intended to show the
#' minor/effect allele frequency (MAF) but sometimes the major allele frequency
#' can be inferred as the FRQ column. This logical variable indicates that the
#' FRQ column should be renamed to MAJOR_ALLELE_FRQ if the frequency values
#' appear to relate to the major allele i.e. >0.5. By default this mapping won't
#' occur i.e. is TRUE.
#' @param indels Binary does your Sumstats file contain Indels? These don't
#' exist in our reference file so they will be excluded from checks if this
#' value is TRUE. Default is TRUE.
#' @param drop_indels Binary, should any indels found in the sumstats be
#' dropped? These can not be checked against a reference dataset and will have
#' the same RS ID and position as SNPs which can affect downstream analysis.
#' Default is False.
#' @param drop_na_cols A character vector of column names to be checked for 
#' missing values. Rows with missing values in any of these columns (if present 
#' in the dataset) will be dropped. If `NULL`, all columns will be checked for 
#' missing values. Default columns are SNP, chromosome, position, allele 1, 
#' allele2, effect columns (frequency, beta, Z-score, standard error, log odds,
#' signed sumstats, odds ratio), p value and N columns. 
#' @param dbSNP version of dbSNP to be used for imputation (144 or 155). See 
#' `dbSNP_tarball` for different versions of dbSNP (including newer releases).
#' @param dbSNP_tarball Pass local versions of dbSNP in tarball format. Default 
#' of NULL uses the dbSNP version passed in `dbSNP` parmeter. `dbSNP_tarball` 
#' was enabled to help with dbSNP versions >=156, after the decision to no 
#' longer provide dbSNP releases as bioconductor packages. dbSNP 156 tarball is 
#' available here: http://149.165.171.124/SNPlocs/.
#' @param check_dups whether to check for duplicates - if formatting QTL
#' datasets this should be set to FALSE otherwise keep as TRUE. Default is TRUE.
#' @param sort_coordinates Whether to sort by coordinates of resulting sumstats
#' @param nThread Number of threads to use for parallel processes.
#' @param save_path File path to save formatted data. Defaults to
#' \code{tempfile(fileext=".tsv.gz")}.
#' @param write_vcf Whether to write as VCF (TRUE) or tabular file (FALSE).
#' @param tabix_index Index the formatted summary statistics with
#' \href{http://www.htslib.org/doc/tabix.html}{tabix} for fast querying.
#' @param return_data Return \code{data.table}, \code{GRanges} or \code{VRanges}
#' directly to user. Otherwise, return the path to the save data. Default is
#' FALSE.
#' @param return_format If return_data is TRUE. Object type to be returned
#' ("data.table","vranges","granges").
#' @param ldsc_format DEPRECATED, do not use. Use save_format="LDSC" instead.
#' @param save_format Output format of sumstats. Options are NULL - standardised
#' output format from MungeSumstats, LDSC - output format compatible with LDSC
#' and openGWAS - output compatible with openGWAS VCFs. Default is NULL. 
#' **NOTE** - If LDSC format is used, the naming convention of A1 as the 
#' reference (genome build) allele and A2 as the effect allele will be reversed
#' to match LDSC (A1 will now be the effect allele). See more info on this 
#' [here](https://groups.google.com/g/ldsc_users/c/S7FZK743w68). Note that any 
#' effect columns (e.g. Z) will be inrelation to A1 now instead of A2.
#' @param log_folder_ind Binary Should log files be stored containing all
#' filtered out SNPs (separate file per filter). The data is outputted in the
#' same format specified for the resulting sumstats file. The only exception to
#' this rule is if output is vcf, then log file saved as .tsv.gz. Default is
#' FALSE.
#' @param log_mungesumstats_msgs Binary Should a log be stored containing all
#' messages and errors printed by MungeSumstats in a run. Default is FALSE
#' @param log_folder Filepath to the directory for the log files and the log of
#' MungeSumstats messages to be stored. Default is a temporary directory. Note
#' the name of the log files (log messages and log outputs) are now the same as
#' the name of the file specified in the save path parameter with the extension
#' '_log_msg.txt' and '_log_output.txt' respectively.
#' @param imputation_ind Binary Should a column be added for each imputation
#' step to show what SNPs have imputed values for differing fields. This
#' includes a field denoting SNP allele flipping (flipped). On the flipped
#' value, this denoted whether the alelles where switched based on
#' MungeSumstats initial choice of A1, A2 from the input column headers and thus
#' may not align with what the creator intended.**Note** these columns will be
#' in the formatted summary statistics returned. Default is FALSE.
#' @param force_new If a formatted file of the same names as \code{save_path}
#' exists, formatting will be skipped and this file will be imported instead
#' (default). Set \code{force_new=TRUE} to override this.
#' @param mapping_file MungeSumstats has a pre-defined column-name mapping file
#' which should cover the most common column headers and their interpretations.
#' However, if a column header that is in youf file is missing of the mapping we
#' give is incorrect you can supply your own mapping file. Must be a 2 column
#' dataframe with column names "Uncorrected" and "Corrected". See
#' data(sumstatsColHeaders) for default mapping and necessary format.
#'
#' @importFrom data.table fread
#' @importFrom data.table fwrite
#' @importFrom data.table setcolorder
#' @importFrom data.table as.data.table
#' @importFrom utils read.table
#' @importFrom utils data
#' @export
format_sumstats <- function(path,
                            ref_genome = NULL,
                            convert_ref_genome = NULL,
                            chain_source = "ensembl",
                            local_chain = NULL,
                            convert_small_p = TRUE,
                            convert_large_p = TRUE,
                            convert_neg_p = TRUE,
                            compute_z = FALSE,
                            force_new_z = FALSE,
                            compute_n = 0L,
                            convert_n_int = TRUE,
                            impute_beta = FALSE,
                            es_is_beta = TRUE,
                            impute_se = FALSE,
                            analysis_trait = NULL,
                            ignore_multi_trait = FALSE,
                            INFO_filter = 0.9,
                            FRQ_filter = 0,
                            pos_se = TRUE,
                            effect_columns_nonzero = FALSE,
                            N_std = 5,
                            N_dropNA = TRUE,
                            chr_style = "Ensembl",
                            rmv_chr = c("X", "Y", "MT"),
                            on_ref_genome = TRUE,
                            infer_eff_direction = TRUE,
                            eff_on_minor_alleles = FALSE,
                            strand_ambig_filter = FALSE,
                            allele_flip_check = TRUE,
                            allele_flip_drop = TRUE,
                            allele_flip_z = TRUE,
                            allele_flip_frq = TRUE,
                            bi_allelic_filter = TRUE,
                            flip_frq_as_biallelic = FALSE,
                            snp_ids_are_rs_ids = TRUE,
                            remove_multi_rs_snp = FALSE,
                            frq_is_maf = TRUE,
                            indels = TRUE,
                            drop_indels  = FALSE,
                            drop_na_cols = c("SNP", "CHR", "BP", "A1", "A2", 
                                             "FRQ", "BETA", "Z", "OR", 
                                             "LOG_ODDS", "SIGNED_SUMSTAT", "SE", 
                                             "P", "N"),
                            dbSNP = 155,
                            dbSNP_tarball = NULL,
                            check_dups = TRUE,
                            sort_coordinates = TRUE,
                            nThread = 1,
                            save_path = tempfile(fileext = ".tsv.gz"),
                            write_vcf = FALSE,
                            tabix_index = FALSE,
                            return_data = FALSE,
                            return_format = "data.table",
                            ldsc_format = FALSE,
                            save_format = NULL,
                            log_folder_ind = FALSE,
                            log_mungesumstats_msgs = FALSE,
                            log_folder = tempdir(),
                            imputation_ind = FALSE,
                            force_new = FALSE,
                            mapping_file = sumstatsColHeaders,
                            #deprecated parameters
                            rmv_chrPrefix = NULL
                            ) {
    #### Setup multi-threading ####
    data.table::setDTthreads(threads = nThread)
    #### Setup empty variables ####
    rsids <- orig_dims <- A1_n <- A2 <- A1 <- NULL
    log_files <- vector(mode = "list")
    t1 <- Sys.time()

    #### Check 1: Ensure save_path is correct.   ####
    check_save_out <- check_save_path(
        save_path = save_path,
        log_folder = log_folder,
        log_folder_ind = log_folder_ind,
        tabix_index = tabix_index,
        write_vcf = write_vcf
    )
    if (isTRUE(tabix_index) && (sort_coordinates == FALSE)) {
        message(
            "Setting `sort_coordinates=TRUE` in ",
            "order to tabix-index results."
        )
        sort_coordinates <- TRUE
    }

    #### Recognize previously formatted files ####
    if (file.exists(check_save_out$save_path) && (force_new == FALSE)) {
        message(
            "Importing previously formatted file.",
            "Set `force_new=TRUE` to override this."
        )
        message("    ", check_save_out$save_path)
    } else {
        # Avoid reloading ref genome every time,
        # save it to this parent environment
        # after being made once - speed up code

        # Check input parameters
        validate_parameters(
            path = path,
            ref_genome = ref_genome,
            convert_ref_genome = convert_ref_genome,
            convert_small_p = convert_small_p,
            es_is_beta = es_is_beta,
            compute_z = compute_z,
            compute_n = compute_n,
            convert_n_int = convert_n_int,
            analysis_trait = analysis_trait,
            INFO_filter = INFO_filter,
            FRQ_filter = FRQ_filter,
            pos_se = pos_se,
            effect_columns_nonzero = effect_columns_nonzero,
            N_std = N_std,
            N_dropNA = N_dropNA,
            chr_style = chr_style,
            rmv_chr = rmv_chr,
            on_ref_genome = on_ref_genome,
            infer_eff_direction = infer_eff_direction,
            eff_on_minor_alleles = eff_on_minor_alleles,
            strand_ambig_filter = strand_ambig_filter,
            allele_flip_check = allele_flip_check,
            allele_flip_drop = allele_flip_drop,
            allele_flip_z = allele_flip_z,
            allele_flip_frq = allele_flip_frq,
            bi_allelic_filter = bi_allelic_filter,
            flip_frq_as_biallelic = flip_frq_as_biallelic,
            snp_ids_are_rs_ids = snp_ids_are_rs_ids,
            remove_multi_rs_snp = remove_multi_rs_snp,
            frq_is_maf = frq_is_maf,
            indels = indels,
            drop_indels = drop_indels,
            dbSNP = dbSNP,
            dbSNP_tarball = dbSNP_tarball,
            check_dups = check_dups,
            write_vcf = write_vcf,
            return_format = return_format,
            ldsc_format = ldsc_format,
            save_format = save_format,
            imputation_ind = imputation_ind,
            log_folder_ind = log_folder_ind,
            log_mungesumstats_msgs = log_mungesumstats_msgs,
            mapping_file = mapping_file,
            tabix_index = tabix_index,
            chain_source = chain_source,
            local_chain = local_chain,
            drop_na_cols = drop_na_cols,
            #deprecated parameters
            rmv_chrPrefix = rmv_chrPrefix
        )

        # save messages to file if user specified
        if (log_mungesumstats_msgs) {
            #get name of file from save_path
            nme <- strsplit(basename(check_save_out$save_path),
                            split="[.]")[[1]][1]
            msg <- paste0("Saving output messages to:\n",
                          paste0(check_save_out$log_folder,"/",
                                 nme,"_log_msg.txt"),"\n",
                          "Any runtime errors will be saved to:\n",
                          paste0(check_save_out$log_folder,"/",
                                 nme,"_log_output.txt"),"\n",
                          "Messages will not be printed to terminal.")
            message(msg)
            msgcon <-
                file(paste0(
                  check_save_out$log_folder,"/",
                  nme,"_log_msg.txt"),
                open = "a"
                )
            sink(
                file = paste0(
                  check_save_out$log_folder,"/",
                  nme,"_log_output.txt"
                ),
                split = TRUE, append = TRUE
            )
            sink(msgcon, type = "message") # does not support split
            on.exit(
              {
                sink(NULL, type = "message")
                sink(NULL, type = "output")
              },
              add = TRUE
            )
            # add name to log_file list
            log_files[["MungeSumstats_log_msg"]] <-
                paste0(
                  check_save_out$log_folder,"/",
                  nme,"_log_msg.txt"
                )
            log_files[["MungeSumstats_log_output"]] <-
                paste0(
                  check_save_out$log_folder,"/",
                  nme,"_log_output.txt"
                )
        }
        # This almost surely modifies the file (since most sumstats
        # from different studies are differently formatted),
        # so it makes more sense to just make a
        # temporary file <tmp>, and return the address of the temp

        #Ensure dbSNP is a integer (make using it later easier)
        #already validated in validate param function
        dbSNP <- as.integer(dbSNP)

        ####  Check 2: Check input format and import ####
        sumstats_return <- list()
        # if data.frame/data.table read it in directly, otherwise read from path
        if (is.data.frame(path)) {
            sumstats_return[["sumstats_dt"]] <- data.table::as.data.table(path)
            # update path in case it causes issue later and for space
            path <- ""
        } else {
            sumstats_return[["sumstats_dt"]] <- read_sumstats(
                path = path,
                samples = if(is.null(analysis_trait)) 1 else analysis_trait,
                nThread = nThread
            )
        }
        
        #If user inputted mapping file, validate
        if(!identical(mapping_file, sumstatsColHeaders)) {
            message("Non-standard mapping file detected.",
                    "Making sure all entries in `Uncorrected`",
                    " are in upper case.")
            data.table::setDF(mapping_file)
            #check again
            if(!identical(mapping_file, sumstatsColHeaders)) {
              mapping_file$Uncorrected <- toupper(mapping_file$Uncorrected)
            }  
        }
        
        #If es_is_beta remove from mapping file if present
        if (!es_is_beta & nrow(mapping_file[mapping_file$Uncorrected=="ES" &
                                           mapping_file$Corrected=="BETA",])>=1)
          {
          mapping_file <- mapping_file[!(mapping_file$Uncorrected=="ES" &
                                         mapping_file$Corrected=="BETA"),]
          #Add ES mapping
          es_cols <- data.frame("Uncorrected"=c("ES","EFFECT_SIZE",
                                                "EFFECT.SIZE","EFFECT-SIZE",
                                                "EFFECT SIZE",
                                                "EFFECT_SIZE_ESTIMATE",
                                                "EFFECT SIZE ESTIMATE",
                                                "EFFECT.SIZE.ESTIMATE",
                                                "ES.A1","ES.A2","ES-A1","ES-A2",
                                                "ES_A1","ES_A2"),
                                "Corrected"=rep("ES",14))
          mapping_file <- rbind(mapping_file,es_cols)
        }
        
        #### Check 40:Check for log10 p instead of p ####
        sumstats_return <-
          read_log_pval(sumstats_dt = sumstats_return$sumstats_dt)
 
        #### Check 2:Check for effect direction ####
        sumstats_return <-
          infer_effect_column(
            sumstats_dt = sumstats_return$sumstats_dt,
            mapping_file = mapping_file,
            dbSNP = dbSNP,
            dbSNP_tarball = dbSNP_tarball,
            nThread = nThread,
            ref_genome = ref_genome,
            on_ref_genome = on_ref_genome,
            infer_eff_direction = infer_eff_direction,
            eff_on_minor_alleles = eff_on_minor_alleles
          )
        
        #### Check 3:Standardise headers for all OS ####
        sumstats_return <-
            standardise_sumstats_column_headers_crossplatform(
                sumstats_dt = sumstats_return$sumstats_dt,
                mapping_file = mapping_file
            )

        #### If save_format=LDSC, make sure all arguments comply with with.
        check_ldsc <- check_ldsc_format(
            sumstats_dt = sumstats_return$sumstats_dt,
            save_format = save_format,
            convert_n_int = convert_n_int,
            allele_flip_check = allele_flip_check,
            compute_z = compute_z,
            compute_n = compute_n
        )
        convert_n_int <- check_ldsc$convert_n_int
        allele_flip_check <- check_ldsc$allele_flip_check
        compute_z <- check_ldsc$compute_z

        ### Report the number of SNP/CHR/etc. before any filtering
        ### (but after header formatting)
        report_summary(sumstats_dt = sumstats_return$sumstats_dt)
        orig_dims <- dim(sumstats_return$sumstats_dt)

        #### Check 4: Check if multi models used
        # or multi traits tested in GWAS ####
        sumstats_return <-
            check_multi_gwas(
                sumstats_dt = sumstats_return$sumstats_dt,
                path = path,
                analysis_trait = analysis_trait,
                ignore_multi_trait = ignore_multi_trait,
                mapping_file = mapping_file
            )

        #### Check 33: Check if multi RS ID SNPs in one line ####
        sumstats_return <-
            check_multi_rs_snp(
                sumstats_dt = sumstats_return$sumstats_dt,
                path = path,
                remove_multi_rs_snp = remove_multi_rs_snp,
                imputation_ind = imputation_ind,
                log_folder_ind = log_folder_ind,
                check_save_out = check_save_out,
                tabix_index = tabix_index,
                nThread = nThread,
                log_files = log_files
            )
        # update values
        log_files <- sumstats_return$log_files

        #before running inference of genome build, do any formatting
        #not using the reference sets

        #### Infer reference genome if necessary ####
        if (is.null(ref_genome)) {
            ref_genome <- get_genome_build(
                sumstats = sumstats_return$sumstats_dt,
                standardise_headers = FALSE, ## done prev
                sampled_snps = 10000,
                mapping_file = mapping_file,
                dbSNP=dbSNP
            )
        }

        #### Check 5: Check for uniformity in SNP col - ####
        #### no mix of rs/missing rs/chr:bp ####
        sumstats_return <-
            check_no_rs_snp(
                sumstats_dt = sumstats_return$sumstats_dt,
                path = path,
                ref_genome = ref_genome,
                snp_ids_are_rs_ids = snp_ids_are_rs_ids,
                indels=indels,
                imputation_ind = imputation_ind,
                log_folder_ind = log_folder_ind,
                check_save_out = check_save_out,
                tabix_index = tabix_index,
                nThread = nThread,
                log_files = log_files,
                dbSNP = dbSNP,
                dbSNP_tarball = dbSNP_tarball
            )
        # update values
        log_files <- sumstats_return$log_files
        #### Check 6: Check for combined allele column (A1 and A2) ####
        sumstats_return <-
            check_allele_merge(
                sumstats_dt = sumstats_return$sumstats_dt,
                path = path
            )
        col_headers <- names(sumstats_return$sumstats_dt)

        #Ensure A1 and A2 are upper case
        sumstats_return <-
            make_allele_upper(sumstats_dt = sumstats_return$sumstats_dt,
                              log_files = log_files)
        # update values
        log_files <- sumstats_return$log_files

        # Series of checks if CHR or BP columns aren't present
        if (sum(c("CHR", "BP") %in% col_headers) != 2) {
            msg <-
                paste0(
                    "Summary statistics file does not have",
                    " obvious CHR/BP columns. ",
                    "Checking to see if they are joined in another column."
                )
            message(msg)

            #### Check 6: check if CHR:BP:A2:A1 merged to 1 column
            sumstats_return <- check_four_step_col(
                sumstats_dt =
                    sumstats_return$sumstats_dt,
                path = path
            )

            #### Check 7: check if there is a column of
            # data with CHR:BP format ####
            sumstats_return <- check_two_step_col(
                sumstats_dt =
                    sumstats_return$sumstats_dt,
                path = path
            )
            #### Re-standardise in case the joined column
            # headers were unusual ####
            sumstats_return <-
                standardise_sumstats_column_headers_crossplatform(
                    sumstats_dt = sumstats_return$sumstats_dt,
                    mapping_file = mapping_file
                )
        }

        #### Check 38: validate BP
        sumstats_return <- check_bp_range(
          sumstats_dt = sumstats_return$sumstats_dt,
          path = path,
          ref_genome = ref_genome,
          imputation_ind = imputation_ind,
          log_folder_ind = log_folder_ind,
          check_save_out = check_save_out,
          tabix_index = tabix_index,
          nThread = nThread,
          log_files = log_files
        )
        # update values
        log_files <- sumstats_return$log_files

        #### Check 8: check if CHR and BP are missing but SNP is present ####
        sumstats_return <-
            check_no_chr_bp(
                sumstats_dt = sumstats_return$sumstats_dt,
                path = path,
                ref_genome = ref_genome,
                rsids = rsids,
                imputation_ind = imputation_ind,
                log_folder_ind = log_folder_ind,
                check_save_out = check_save_out,
                tabix_index = tabix_index,
                nThread = nThread,
                log_files = log_files,
                dbSNP = dbSNP,
                dbSNP_tarball=dbSNP_tarball
            )
        # update values
        log_files <- sumstats_return$log_files
        rsids <- sumstats_return$rsids # update rsids
        sumstats_return$rsids <- NULL

        #### Check 9: check if CHR and BP are present but SNP is missing ####
        sumstats_return <- check_no_snp(
            sumstats_dt = sumstats_return$sumstats_dt,
            path = path,
            ref_genome = ref_genome,
            indels = indels,
            imputation_ind = imputation_ind,
            log_folder_ind = log_folder_ind,
            check_save_out = check_save_out,
            tabix_index = tabix_index,
            nThread = nThread,
            log_files = log_files,
            dbSNP = dbSNP,
            dbSNP_tarball = dbSNP_tarball
        )
        # update values
        log_files <- sumstats_return$log_files

        #### Check 25: check that all snps are present on reference genome ####
        sumstats_return <- check_on_ref_genome(
            sumstats_dt =
                sumstats_return$sumstats_dt,
            path = path,
            ref_genome = ref_genome,
            on_ref_genome = on_ref_genome,
            indels=indels,
            rsids = rsids,
            imputation_ind = imputation_ind,
            log_folder_ind = log_folder_ind,
            check_save_out = check_save_out,
            tabix_index = tabix_index,
            nThread = nThread,
            log_files = log_files,
            dbSNP = dbSNP,
            dbSNP_tarball = dbSNP_tarball
        )
        # update values
        log_files <- sumstats_return$log_files
        rsids <- sumstats_return$rsids # update rsids
        sumstats_return$rsids <- NULL

        #### Check 10: check if SNP is present but A1 and/or A2 is missing ####
        sumstats_return <-
            check_no_allele(
                sumstats_dt = sumstats_return$sumstats_dt, path = path,
                ref_genome = ref_genome, rsids = rsids,
                imputation_ind = imputation_ind,
                allele_flip_check = allele_flip_check,
                log_folder_ind = log_folder_ind,
                check_save_out = check_save_out,
                tabix_index = tabix_index,
                nThread = nThread,
                log_files = log_files,
                bi_allelic_filter = bi_allelic_filter,
                dbSNP = dbSNP,
                dbSNP_tarball = dbSNP_tarball
            )
        # update values
        log_files <- sumstats_return$log_files
        bi_allelic_filter <- sumstats_return$bi_allelic_filter
        rsids <- sumstats_return$rsids # update rsids
        sumstats_return$rsids <- NULL
        # get updated flip
        allele_flip_check <- sumstats_return$allele_flip_check

        #### Check 11: check that all the vital columns are present ###
        check_vital_col(sumstats_dt = sumstats_return$sumstats_dt)

        #### Check 12: check there is at least one signed sumstats column ###
        sumstats_return <-
            check_signed_col(
                sumstats_dt = sumstats_return$sumstats_dt,
                impute_beta = impute_beta,
                log_folder_ind = log_folder_ind,
                rsids = rsids,
                imputation_ind = imputation_ind,
                check_save_out = check_save_out,
                tabix_index = tabix_index,
                nThread = nThread,
                log_files = log_files
            )
        # update values
        log_files <- sumstats_return$log_files
        rsids <- sumstats_return$rsids # update rsids
        sumstats_return$rsids <- NULL

        #### Check 13: check for allele flipping ####
        sumstats_return <-
            check_allele_flip(
                sumstats_dt = sumstats_return$sumstats_dt,
                path = path,
                ref_genome = ref_genome,
                rsids = rsids,
                allele_flip_check = allele_flip_check,
                allele_flip_drop = allele_flip_drop,
                allele_flip_z = allele_flip_z,
                allele_flip_frq = allele_flip_frq,
                bi_allelic_filter = bi_allelic_filter,
                flip_frq_as_biallelic = flip_frq_as_biallelic,
                imputation_ind = imputation_ind,
                log_folder_ind = log_folder_ind,
                check_save_out = check_save_out,
                tabix_index = tabix_index,
                nThread = nThread,
                log_files = log_files,
                mapping_file = mapping_file,
                dbSNP = dbSNP,
                dbSNP_tarball = dbSNP_tarball
            )
        # update values
        log_files <- sumstats_return$log_files
        rsids <- sumstats_return$rsids # update rsids
        sumstats_return$rsids <- NULL

        #### Check 14: check first three column headers are SNP, CHR, BP ###
        ### (in that order) and also check A1 and A2 are fourth and fifth####
        sumstats_return <-
            check_col_order(
                sumstats_dt = sumstats_return$sumstats_dt,
                path = path
            )
        
        #### Check 15: Keep only rows which have the number
        # of columns expected ####
        sumstats_return <-
            check_miss_data(
                sumstats_dt = sumstats_return$sumstats_dt,
                path = path,
                log_folder_ind = log_folder_ind,
                check_save_out = check_save_out,
                tabix_index = tabix_index,
                nThread = nThread,
                log_files = log_files,
                drop_na_cols = drop_na_cols
            )
        # update values
        log_files <- sumstats_return$log_files

        #### Check 16: check for duplicated columns ####
        # The formatting process can (rarely) result in duplicated columns,
        # i.e. CHR, if CHR:BP is expanded and
        # one already exists...delete duplicates
        sumstats_return <- check_dup_col(
            sumstats_dt = sumstats_return$sumstats_dt,
            path = path
        )

        #### Check 17: check for small P-values (<=5e-324) ####
        sumstats_return <-
            check_small_p_val(
                sumstats_dt = sumstats_return$sumstats_dt,
                convert_small_p = convert_small_p,
                imputation_ind = imputation_ind
            )

        #### Check 17.5: check for large (>1) and neg (<0)  p-values ####
        sumstats_return <-
            check_range_p_val(
                sumstats_dt = sumstats_return$sumstats_dt,
                convert_large_p = convert_large_p,
                convert_neg_p = convert_neg_p,
                imputation_ind = imputation_ind
            )

        #### Check 18: check is N column not all integers,
        # if so round it up ####
        sumstats_return <-
            check_n_int(
                sumstats_dt = sumstats_return$sumstats_dt,
                path = path,
                convert_n_int = convert_n_int,
                imputation_ind = imputation_ind
            )

        #### Check 19: check all rows have SNPs starting with SNP or rs, ####
        #### drop those that don't ####.
        sumstats_return <- check_row_snp(
            sumstats_dt = sumstats_return$sumstats_dt,
            path = path,
            log_folder_ind = log_folder_ind,
            check_save_out = check_save_out,
            tabix_index = tabix_index,
            nThread = nThread,
            log_files = log_files
        )
        # update values
        log_files <- sumstats_return$log_files

        ### Check 37: Drop Indels ###
        sumstats_return <- check_drop_indels(
          sumstats_dt = sumstats_return$sumstats_dt,
          drop_indels=drop_indels,
          path = path,
          log_folder_ind = log_folder_ind,
          check_save_out = check_save_out,
          tabix_index = tabix_index,
          nThread = nThread,
          log_files = log_files)

        # update values
        log_files <- sumstats_return$log_files

        #### Check 20: check all rows for duplicated SNPs,
        # remove any that are ####
        sumstats_return <- check_dup_snp(
            sumstats_dt = sumstats_return$sumstats_dt,
            indels=indels,
            path = path,
            log_folder_ind = log_folder_ind,
            check_save_out = check_save_out,
            tabix_index = tabix_index,
            nThread = nThread,
            log_files = log_files,
            bi_allelic_filter = bi_allelic_filter,
            check_dups = check_dups
        )
        # update values
        log_files <- sumstats_return$log_files

        #### Check 21: check all rows for duplicated BPs,
        # remove any that are ####
        sumstats_return <- check_dup_bp(
            sumstats_dt = sumstats_return$sumstats_dt,
            bi_allelic_filter=bi_allelic_filter,
            check_dups = check_dups,
            indels=indels,
            path = path,
            log_folder_ind = log_folder_ind,
            check_save_out = check_save_out,
            tabix_index = tabix_index,
            nThread = nThread,
            log_files = log_files
        )
        # update values
        log_files <- sumstats_return$log_files

        #### Check 22: check for low INFO scores ####
        sumstats_return <-
            check_info_score(
                sumstats_dt = sumstats_return$sumstats_dt,
                INFO_filter = INFO_filter,
                log_folder_ind = log_folder_ind,
                check_save_out = check_save_out,
                tabix_index = tabix_index,
                nThread = nThread,
                log_files = log_files
            )
        # update values
        log_files <- sumstats_return$log_files

        #### Check 35: check for low FRQ scores ####
        sumstats_return <-
            check_frq(
                sumstats_dt = sumstats_return$sumstats_dt,
                path = path,
                FRQ_filter = FRQ_filter,
                log_folder_ind = log_folder_ind,
                check_save_out = check_save_out,
                tabix_index = tabix_index,
                nThread = nThread,
                log_files = log_files
            )
        # update values
        log_files <- sumstats_return$log_files

        #### Check 30: check standard error is positive ####
        sumstats_return <-
            check_pos_se(
                sumstats_dt = sumstats_return$sumstats_dt,
                path = path,
                pos_se = pos_se,
                impute_se = impute_se,
                imputation_ind = imputation_ind,
                log_folder_ind = log_folder_ind,
                check_save_out = check_save_out,
                tabix_index = tabix_index,
                nThread = nThread,
                log_files = log_files
            )
        # update values
        log_files <- sumstats_return$log_files

        #### Check 31: check effect columns are not 0 ####
        sumstats_return <-
            check_effect_columns_nonzero(
                sumstats_dt = sumstats_return$sumstats_dt,
                path = path,
                effect_columns_nonzero = effect_columns_nonzero,
                log_folder_ind = log_folder_ind,
                check_save_out = check_save_out,
                tabix_index = tabix_index,
                nThread = nThread,
                log_files = log_files
            )
        # update values
        log_files <- sumstats_return$log_files

        #### Check 23: check for N > X std dev above mean ####
        sumstats_return <- check_n_num(
            sumstats_dt = sumstats_return$sumstats_dt,
            path = path,
            N_std = N_std,
            N_dropNA = N_dropNA,
            log_folder_ind = log_folder_ind,
            check_save_out = check_save_out,
            tabix_index = tabix_index,
            nThread = nThread,
            log_files = log_files
        )
        # update values
        log_files <- sumstats_return$log_files

        #### Check 24: standardize the CHR column ####
        sumstats_return <- check_chr(
          sumstats_dt = sumstats_return$sumstats_dt,
          log_files = log_files,
          check_save_out = check_save_out,
          rmv_chr = rmv_chr,
          nThread = nThread,
          log_folder_ind = log_folder_ind
        )
        # update values
        log_files <- sumstats_return$log_files

        #### Check 26: check that all snps are not strand ambiguous ####
        sumstats_return <- check_strand_ambiguous(
            sumstats_dt =
                sumstats_return$sumstats_dt,
            path = path,
            ref_genome = ref_genome,
            strand_ambig_filter =
                strand_ambig_filter,
            log_folder_ind = log_folder_ind,
            check_save_out = check_save_out,
            tabix_index = tabix_index,
            nThread = nThread,
            log_files = log_files
        )
        # update values
        log_files <- sumstats_return$log_files

        #### Check 27: check for non-biallelic SNPS ####
        sumstats_return <- check_bi_allelic(
            sumstats_dt =
                sumstats_return$sumstats_dt,
            path = path,
            ref_genome = ref_genome,
            bi_allelic_filter = bi_allelic_filter,
            rsids = rsids,
            log_folder_ind = log_folder_ind,
            check_save_out = check_save_out,
            tabix_index = tabix_index,
            nThread = nThread,
            log_files = log_files,
            dbSNP = dbSNP,
            dbSNP_tarball = dbSNP_tarball
        )
        # update values
        log_files <- sumstats_return$log_files
        rsids <- sumstats_return$rsids # update rsids
        sumstats_return$rsids <- NULL

        #### Check 28: Compute Z-score ####
        sumstats_return <- check_zscore(
            sumstats_dt =
                sumstats_return$sumstats_dt,
            compute_z = compute_z,
            force_new_z = force_new_z,
            imputation_ind = imputation_ind,
            mapping_file = mapping_file
        )

        #### Check 32: Compute N ####
        sumstats_return <- compute_nsize(
            sumstats_dt =
                sumstats_return$sumstats_dt,
            compute_n = compute_n,
            imputation_ind = imputation_ind
        )

        #### Check 36: Ensure FRQ is MAF ####
        sumstats_return$sumstats_dt <- check_frq_maf(
            sumstats_dt =
                sumstats_return$sumstats_dt,
            frq_is_maf = frq_is_maf
        )


        #### Check 34: Perform liftover ####
        sumstats_return$sumstats_dt <- liftover(
            sumstats_dt =
                sumstats_return$sumstats_dt,
            convert_ref_genome = convert_ref_genome,
            ref_genome = ref_genome,
            imputation_ind = imputation_ind,
            chain_source = chain_source,
            local_chain = local_chain
        )
        #update ref genome of data
        if(!is.null(convert_ref_genome))
          ref_genome <- convert_ref_genome

        #### Check 29: Sort rows by genomic coordinates ####
        sumstats_return$sumstats_dt <- sort_coords(
            sumstats_dt =
                sumstats_return$sumstats_dt,
            sort_coordinates =
                sort_coordinates
        )

        ### Check 39: Ensure CHR follows the requested style ###
        CHR <- NULL
        sumstats_return$sumstats_dt[, 
                                    CHR := GenomeInfoDb::mapSeqlevels(as.character(CHR), 
                                                                      style = chr_style)]
        
        ### IF LDSC, rename A1 and A2, effect columns are fine
        if (!is.null(save_format) && 
            tolower(save_format)=="ldsc") {
          message("Renaming A1,A2 to match LDSC format.")
          #For LDSC format, rename A1 and A2 as LDSC expects A1 to be the effect 
          #column rather than A2 (the opposite to MSS's default) - see more 
          #[here](https://groups.google.com/g/ldsc_users/c/S7FZK743w68).Although, 
          #this didn't seem to make any difference to results in tests, see more
          #https://github.com/neurogenomics/MungeSumstats/issues/160#issuecomment-1891899253
          sumstats_return$sumstats_dt[,A1_n:=A2]
          sumstats_return$sumstats_dt[,A2:=A1]
          sumstats_return$sumstats_dt[,A1:=A1_n]
          sumstats_return$sumstats_dt[,A1_n:=NULL]
        }

        #### WRITE data.table TO PATH ####
        check_save_out$save_path <- write_sumstats(
            sumstats_dt = sumstats_return$sumstats_dt,
            save_path = check_save_out$save_path,
            ref_genome = ref_genome,
            sep = check_save_out$sep,
            write_vcf = write_vcf,
            save_format = save_format,
            tabix_index = tabix_index,
            nThread = nThread,
            return_path = TRUE
        )
        rm(rsids) # free up memory

        #### Report summary ####
        report_summary(
            sumstats_dt = sumstats_return$sumstats_dt,
            orig_dims = orig_dims
        )
    }
    #### Record time taken ####
    t2 <- Sys.time()
    message(
        "Done munging in ",
        round(difftime(t2, t1, units = "mins"), 3), " minutes."
    )

    #### Preview sumstats ####
    preview_sumstats(
        save_path = check_save_out$save_path,
        nrows = 5L
    )

    # if user wanted log of messages remember to unsink at end
    if (log_mungesumstats_msgs) {
        sink(NULL, type = "message")
        sink(NULL, type = "output")
    }

    if (return_data) {
        message("Returning data directly.")
        #### Load data into memory when a pre-existing file is being used
        if (!exists("sumstats_return")) {
            sumstats_return <- list()
            sumstats_return[["sumstats_dt"]] <-
                read_sumstats(
                    path = check_save_out$save_path,
                    nThread = nThread
                )
        }
        out <- convert_sumstats(
            sumstats_dt = sumstats_return$sumstats_dt,
            return_format = return_format
        )
        # if user wants log files return a list
        if (log_folder_ind || log_mungesumstats_msgs) {
            return(list("sumstats" = out,
                        "log_files" = log_files))
        }
        return(out)
    } else {
        message("Returning path to saved data.")
        if (log_folder_ind || log_mungesumstats_msgs) {
            return(list(
                "sumstats" = check_save_out$save_path,
                "log_files" = log_files
            ))
        }
        return(check_save_out$save_path) # Returns address of modified file
    }
}

test_that("Filter SNPs where INFO<0.9", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # write the Educational Attainment GWAS to a temp file for testing
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
            package = "MungeSumstats"
        ))
        writeLines(eduAttainOkbay, con = file)
        # read it in and make N
        sumstats_dt <- data.table::fread(file, nThread = 1)
        # Add N column and make it not an integer
        set.seed(101)
        sumstats_dt[, INFO := runif(nrow(sumstats_dt)) * 2]
        # get SNPs with INFO<0.9
        rmv_snps <- sumstats_dt[INFO < 0.9, ]$MarkerName
        data.table::fwrite(x = sumstats_dt, file = file, sep = "\t")
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            INFO_filter = 0.9,
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            log_folder_ind = TRUE,
            imputation_ind = TRUE,
            dbSNP=144
        )
        res_dt <- data.table::fread(reformatted$sumstats, nThread = 1)
        testthat::expect_equal(all(!rmv_snps %in% res_dt$SNP), TRUE)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("Handle dup cols", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # write the Educational Attainment GWAS to a temp file for testing
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
            package = "MungeSumstats"
        ))
        writeLines(eduAttainOkbay, con = file)
        # read it in and make N
        sumstats_dt <- data.table::fread(file)
        # Add dup column and make it not an integer
        sumstats_dt[, P := Pval]
        data.table::fwrite(x = sumstats_dt, file = file, sep = "\t")
        # rename Pval to p
        sumstats_txt <- readLines(file)
        sumstats_txt[1] <-
            "MarkerName\tCHR\tPOS\tA1\tA2\tEAF\tBeta\tSE\tP\tP"
        writeLines(sumstats_txt, file)
        # Run MungeSumstats code
        # Don't convert n to integers as this may round down
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            N_std = 5, convert_n_int = FALSE,
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            log_folder_ind = TRUE,
            imputation_ind = TRUE,
            log_mungesumstats_msgs = TRUE,
            dbSNP=144
        )
    
        # first check log file
        expect_equal(file.exists(reformatted$log_files$MungeSumstats_log_msg), 
                        TRUE)
        expect_equal(
            file.exists(reformatted$log_files$MungeSumstats_log_output),
            TRUE
        )
    
        res_dt <- data.table::fread(reformatted$sumstats)
    
        # should equal org
        writeLines(eduAttainOkbay, con = file)
        org_before_dup <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            N_std = 5, convert_n_int = FALSE,
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            log_folder_ind = TRUE,
            imputation_ind = TRUE,
            dbSNP=144
        )
        org_dt <- data.table::fread(org_before_dup$sumstats)
        expect_equal(all.equal(org_dt, res_dt), TRUE)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("Handle duplicate rows based on rs ID", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # Duplicate rows and check output is the same
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
            package = "MungeSumstats"
        ))
        eduAttainOkbay_missing <- eduAttainOkbay
        len <- length(eduAttainOkbay_missing)
        eduAttainOkbay_missing <- c(
            eduAttainOkbay_missing,
            eduAttainOkbay_missing[2:len]
        )
        # write the Educational Attainment GWAS to a temp file for testing
        writeLines(eduAttainOkbay_missing, con = file)
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        reformatted_lines <- readLines(reformatted)
        # Should equal org
        writeLines(eduAttainOkbay, con = file)
        org <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        org_lines <- readLines(org)
        # check equal regardless of order
        expect_equal(setequal(reformatted_lines, org_lines), TRUE)
    
        #---------------
        # Duplicate base-pair position and check output is the same
        eduAttainOkbay_missing <- eduAttainOkbay
        # add in one row again and change rs id so position removes it
        # row 77
        eduAttainOkbay_missing <-
            c(
                eduAttainOkbay_missing,
                "rs9556959\t13\t99100046\tT\tC\t0.5019\t-0.014\t0.003\t6.617e-08"
            )
        # write the Educational Attainment GWAS to a temp file for testing
        writeLines(eduAttainOkbay_missing, con = file)
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = TRUE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        reformatted_lines <- readLines(reformatted)
        # check equal regardless of order
        expect_equal(setequal(reformatted_lines, org_lines), TRUE)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("Can pass in R objects of summary statistics", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # write the Educational Attainment GWAS to a temp file for testing
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
            package = "MungeSumstats"
        ))
        writeLines(eduAttainOkbay, con = file)
        # read it in and combine CHR BP columns
        sumstats_dt <- data.table::fread(file, nThread = 1)
        # Run MungeSumstats code
        path_return <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        dt_return <- MungeSumstats::format_sumstats(sumstats_dt,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        sumstats_rtrn_path <- data.table::fread(path_return, nThread = 1)
        sumstats_rtrn_dt <- data.table::fread(dt_return, nThread = 1)
        expect_equal(all.equal(sumstats_rtrn_dt, sumstats_rtrn_path), TRUE)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("SNPs not on reference genome are removed", {
  ## The following test uses more than 2GB of memory, which is more
  ## than what 32-bit Windows can handle:
  is_32bit_windows <- .Platform$OS.type == "windows" #&&
  #.Platform$r_arch == "i386"
  if (!is_32bit_windows) {
    file <- tempfile()
    # Update ID from line 3 to check it is deleted -
    # "rs79925071" is not on ref genome GRCh37
    eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
                                            package = "MungeSumstats"
    ))
    eduAttainOkbay_missing <- eduAttainOkbay
    eduAttainOkbay_missing[3] <-
      "rs79925071\t6\t98584733\tA\tC\t0.5019\t0.024\t0.003\t2.457e-19"
    # write the Educational Attainment GWAS to a temp file for testing
    writeLines(eduAttainOkbay_missing, con = file)
    # Run MungeSumstats code
    reformatted <- MungeSumstats::format_sumstats(file,
                                                  ref_genome = "GRCh37",
                                                  on_ref_genome = TRUE,
                                                  strand_ambig_filter = FALSE,
                                                  bi_allelic_filter = FALSE,
                                                  allele_flip_check = FALSE,
                                                  log_folder_ind = TRUE,
                                                  infer_eff_direction = FALSE,
                                                  dbSNP=144
    )
    reformatted_lines <- data.table::fread(reformatted$sumstats)
    # Should equal org apart from this one line
    writeLines(eduAttainOkbay, con = file)
    org <- MungeSumstats::format_sumstats(file,
                                          ref_genome = "GRCh37",
                                          on_ref_genome = FALSE,#TRUE, for speed
                                          strand_ambig_filter = FALSE,
                                          bi_allelic_filter = FALSE,
                                          allele_flip_check = FALSE,
                                          infer_eff_direction = FALSE,
                                          dbSNP=144
    )
    org_lines <- data.table::fread(org)
    #test
    expect_equal(all.equal(reformatted_lines, org_lines), TRUE)
    # also check get genome builds works
    eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
                                     package = "MungeSumstats"
    )
    sumstats_list <- list(ss1 = eduAttainOkbayPth)
    ref_genomes <- get_genome_builds(
      sumstats_list = sumstats_list,
      sampled_snps = 19,
      dbSNP = 144,
      chr_filt = c("1","2","3","4") #filtering to reduce computational burden
    )
    expect_equal(all.equal(ref_genomes, list("ss1" = "GRCH37")), TRUE)
  } else {
    expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
    expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
  }
})

test_that("Can correctly separate CHR:BP:A2:A1", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # write the Educational Attainment GWAS to a temp file for testing
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
            package = "MungeSumstats"
        ))
        writeLines(eduAttainOkbay, con = file)
        # read it in and combine CHR BP columns
        sumstats_dt <- data.table::fread(file)
        # Keep Org to validate values
        sumstats_dt_missing <- data.table::copy(sumstats_dt)
        sumstats_dt_missing[, CHR_BP_A2_A1 := paste0(CHR, ":", POS, ":", 
                                                        A2, ":", A1)]
        sumstats_dt_missing[, CHR := NULL]
        sumstats_dt_missing[, POS := NULL]
        sumstats_dt_missing[, A1 := NULL]
        sumstats_dt_missing[, A2 := NULL]
        data.table::fwrite(x = sumstats_dt_missing, file = file, sep = "\t")
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        res_dt <- data.table::fread(reformatted)
        # Should give same result as separated
        data.table::fwrite(x = sumstats_dt, file = file, sep = "\t")
        org <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        org_dt <- data.table::fread(org)
        expect_equal(all.equal(org_dt, res_dt, ignore.row.order = TRUE), TRUE)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("Test that user inputted mapping file is appropriate", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
            package = "MungeSumstats"
        ))
        # write the Educational Attainment GWAS to a temp file for testing
        writeLines(eduAttainOkbay, con = file)
    
        # define mapping file - leave out some essential columns - A2
        data("sumstatsColHeaders")
        essential_cols <- c("SNP", "CHR", "BP", "P", "A1", "A2")
        signed_cols <- c("Z", "OR", "BETA", "LOG_ODDS", "SIGNED_SUMSTAT")
        user_map <- sumstatsColHeaders[sumstatsColHeaders$Corrected %in%
            essential_cols[-6] |
            sumstatsColHeaders$Corrected %in%
                signed_cols, ]
        # Run MungeSumstats code
        fail_return <-
            tryCatch(MungeSumstats::format_sumstats(file,
                ref_genome = "GRCh37",
                mapping_file = user_map
            ),
            error = function(e) e,
            warning = function(w) w
            )
        catch <- is(fail_return, "error")||
          !is.character(fail_return)||!file.exists(fail_return)
        expect_equal(catch, TRUE)
        # update user map to contain all essential columns
        user_map2 <- sumstatsColHeaders[sumstatsColHeaders$Corrected %in%
            essential_cols |
            sumstatsColHeaders$Corrected %in%
                signed_cols, ]
        # This time should run
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            mapping_file = user_map2,
            return_data = TRUE,
            return_format = "GRanges",
            dbSNP=144
        )
    
    
        expect_equal(is(reformatted, "GRanges"), TRUE)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("Handle n when its 5 std dev > mean", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
    file <- tempfile()
    # write the Educational Attainment GWAS to a temp file for testing
    eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
        package = "MungeSumstats"
    ))
    writeLines(eduAttainOkbay, con = file)
    # read it in and make N
    sumstats_dt <- data.table::fread(file)
    # Add N column and make it not an integer
    sumstats_dt[, N := round(10 * runif(nrow(sumstats_dt)), 0)]
    # Ensure 1 value is > 5std dev above the mean
    # Remember creating and adding in this value will increase the mean and sd
    mean_N <- mean(sumstats_dt$N)
    sd_N <- stats::sd(sumstats_dt$N)
    bigger_value <- mean_N + (6 * sd_N)
    data.table::set(sumstats_dt, i = 1L, j = "N", value = bigger_value)
    data.table::fwrite(x = sumstats_dt, file = file, sep = "\t")
    # ensure this SNP is removed
    rmv_snp <- sumstats_dt$MarkerName[1]
    # Run MungeSumstats code
    # Don't convert n to integers as this may round down
    reformatted <- MungeSumstats::format_sumstats(file,
        ref_genome = "GRCh37",
        N_std = 5, convert_n_int = FALSE,
        on_ref_genome = FALSE,
        strand_ambig_filter = FALSE,
        bi_allelic_filter = FALSE,
        allele_flip_check = FALSE,
        log_folder_ind = TRUE,
        dbSNP=144
    )
    res_dt <- data.table::fread(reformatted$sumstats)
    expect_equal(!(rmv_snp %in% res_dt$SNP), TRUE)

    # Run MungeSumstats code
    # Don't convert n to integers as this may round down
    # set N_dropNA to TRUE
    reformatted <- MungeSumstats::format_sumstats(file,
        ref_genome = "GRCh37",
        N_std = 5, convert_n_int = FALSE,
        on_ref_genome = FALSE,
        strand_ambig_filter = FALSE,
        bi_allelic_filter = FALSE,
        allele_flip_check = FALSE,
        log_folder_ind = TRUE,
        N_dropNA = TRUE,
        dbSNP=144
    )
    res_dt <- data.table::fread(reformatted$sumstats)

    # set N_dropNA to FALSE
    reformatted2 <- MungeSumstats::format_sumstats(file,
        ref_genome = "GRCh37",
        N_std = 5, convert_n_int = FALSE,
        on_ref_genome = FALSE,
        strand_ambig_filter = FALSE,
        bi_allelic_filter = FALSE,
        allele_flip_check = FALSE,
        log_folder_ind = TRUE,
        N_dropNA = FALSE,
        dbSNP=144
    )
    res_dt2 <- data.table::fread(reformatted2$sumstats)
    expect_equal(!(rmv_snp %in% res_dt$SNP), TRUE)
    # should be no na's
    expect_equal(all.equal(res_dt, res_dt2), TRUE)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("Test that allele columns and effect columns flipped correctly", {
    ## The following test uses more than 2GB of memory, which is more
    ## than what 32-bit Windows can handle:
    is_32bit_windows <- .Platform$OS.type == "windows" ##&&
        ##.Platform$r_arch == "i386"
    if (!is_32bit_windows && Sys.info()["sysname"]=="Linux") {
        file <- tempfile()
        # The dataset's alleles need to be flipped to test
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
                                                package = "MungeSumstats"
        ))
        eduAttainOkbay_missing <- eduAttainOkbay
        eduAttainOkbay_missing[1] <-
            "MarkerName\tCHR\tPOS\tA2\tA1\tEAF\tBeta\tSE\tPval"
        # write the Educational Attainment GWAS to a temp file for testing
        writeLines(eduAttainOkbay_missing, con = file)
        # read in and manually change effect columns
        eduAttainOkbay_missing_dt <- data.table::fread(file)
        eduAttainOkbay_missing_dt[, Beta := Beta * -1]
        eduAttainOkbay_missing_dt[, EAF := 1 - EAF]
        data.table::fwrite(eduAttainOkbay_missing_dt,
                           file = file, sep = "\t"
        )
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = TRUE,
            allele_flip_check = TRUE,
            dbSNP=144
        )
        reformatted_lines <- readLines(reformatted)
        # Should equal org since the effect should be corrected
        writeLines(eduAttainOkbay, con = file)
        org <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = TRUE,
            infer_eff_direction = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = TRUE,
            allele_flip_check = TRUE,
            dbSNP=144
        )
        org_lines <- readLines(org)
        # reordering in function
        expect_equal(setequal(reformatted_lines, org_lines), TRUE)
    } else {
        expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
    }
})

test_that("validate parameters", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # write the Educational Attainment GWAS to a temp file for testing
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
            package = "MungeSumstats"
        ))
        writeLines(eduAttainOkbay, con = file)
    
        # Check that submitting incorrect parameters gives errors
        # Run MungeSumstats code
        # passing incorrect path
        not_file <- tempfile()
        error_return <-
            tryCatch(MungeSumstats::format_sumstats(not_file,
                ref_genome = "GRCh37",
                on_ref_genome = FALSE,
                strand_ambig_filter = FALSE,
                bi_allelic_filter = FALSE,
                allele_flip_check = FALSE,
                dbSNP=144
            ),
            error = function(e) e,
            warning = function(w) w
            )
        # incorrect ref genome
        error_return2 <-
            tryCatch(MungeSumstats::format_sumstats(file,
                ref_genome = "fake",
                on_ref_genome = FALSE,
                strand_ambig_filter = FALSE,
                bi_allelic_filter = FALSE,
                allele_flip_check = FALSE,
                dbSNP=144
            ),
            error = function(e) e,
            warning = function(w) w
            )
        # incorrect convert_small_p value
        error_return3 <-
            tryCatch(MungeSumstats::format_sumstats(file,
                ref_genome = "GRCh37",
                convert_small_p = "fake",
                on_ref_genome = FALSE,
                strand_ambig_filter = FALSE,
                bi_allelic_filter = FALSE,
                allele_flip_check = FALSE,
                dbSNP=144
            ),
            error = function(e) e,
            warning = function(w) w
            )
        # incorrect convert_n_int value
        error_return4 <-
            tryCatch(MungeSumstats::format_sumstats(file,
                ref_genome = "GRCh37",
                convert_n_int = "fake",
                on_ref_genome = FALSE,
                strand_ambig_filter = FALSE,
                bi_allelic_filter = FALSE,
                allele_flip_check = FALSE,
                dbSNP=144
            ),
            error = function(e) e,
            warning = function(w) w
            )
    
        # incorrect on_ref_genome value
        error_return5 <-
            tryCatch(MungeSumstats::format_sumstats(file,
                ref_genome = "GRCh37",
                on_ref_genome = "YES",
                strand_ambig_filter = FALSE,
                bi_allelic_filter = FALSE,
                allele_flip_check = FALSE,
                dbSNP=144
            ),
            error = function(e) e,
            warning = function(w) w
            )
    
        # incorrect strand_ambig_filter value
        error_return6 <-
            tryCatch(MungeSumstats::format_sumstats(file,
                ref_genome = "GRCh37",
                on_ref_genome = FALSE,
                strand_ambig_filter = "YES",
                bi_allelic_filter = FALSE,
                allele_flip_check = FALSE,
                dbSNP=144
            ),
            error = function(e) e,
            warning = function(w) w
            )
    
        # incorrect INFO_filter value
        error_return7 <-
            tryCatch(MungeSumstats::format_sumstats(file,
                ref_genome = "GRCh37",
                INFO_filter = TRUE,
                on_ref_genome = FALSE,
                strand_ambig_filter = FALSE,
                bi_allelic_filter = FALSE,
                allele_flip_check = FALSE,
                dbSNP=144
            ),
            error = function(e) e,
            warning = function(w) w
            )
    
        # incorrect N_std value
        error_return8 <-
            tryCatch(MungeSumstats::format_sumstats(file,
                ref_genome = "GRCh37",
                N_std = FALSE,
                on_ref_genome = FALSE,
                strand_ambig_filter = FALSE,
                bi_allelic_filter = FALSE,
                allele_flip_check = FALSE,
                dbSNP=144
            ),
            error = function(e) e,
            warning = function(w) w
            )
    
        # incorrect rmv_chr value
        error_return9 <-
            tryCatch(MungeSumstats::format_sumstats(file,
                ref_genome = "GRCh37",
                rmv_chr = c("X", "FAKE"),
                on_ref_genome = FALSE,
                strand_ambig_filter = FALSE,
                bi_allelic_filter = FALSE,
                allele_flip_check = FALSE,
                dbSNP=144
            ),
            error = function(e) e,
            warning = function(w) w
            )
    
        # incorrect bi_allelic value
        error_return10 <-
            tryCatch(MungeSumstats::format_sumstats(file,
                ref_genome = "GRCh37",
                on_ref_genome = FALSE,
                strand_ambig_filter = FALSE,
                bi_allelic_filter = "FAKE",
                allele_flip_check = FALSE,
                dbSNP=144
            ),
            error = function(e) e,
            warning = function(w) w
            )
    
        # incorrect allele_flip_check value
        error_return11 <-
            tryCatch(MungeSumstats::format_sumstats(file,
                ref_genome = "GRCh37",
                on_ref_genome = FALSE,
                strand_ambig_filter = FALSE,
                allele_flip_check = "FAKE",
                dbSNP=144
            ),
            error = function(e) e,
            warning = function(w) w
            )
    
        # Make sure ref_genome=NULL works
        ## Call uses reference genome as default with more than 2GB of memory,
        ## which is more than what 32-bit Windows can handle so
        # remove certain checks
        ## Removing for now, too time-intensive and is covered by other tests.
        # is_32bit_windows <-
        #     .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
        # if (!is_32bit_windows) {
        #     pass_return1 <-
        #         tryCatch(MungeSumstats::format_sumstats(
        #             path = file,
        #             ref_genome = NULL
        #         ),
        #         error = function(e) e,
        #         warning = function(w) w
        #         )
        #     expect_true(file.exists(pass_return1))
        # }
    
    
        expect_true(is(error_return, "error"))
        expect_true(is(error_return2, "error"))
        expect_true(is(error_return3, "error"))
        expect_true(is(error_return4, "error"))
        expect_true(is(error_return5, "error"))
        expect_true(is(error_return6, "error"))
        expect_true(is(error_return7, "error"))
        expect_true(is(error_return8, "error"))
        expect_true(is(error_return9, "error"))
        expect_true(is(error_return10, "error"))
        expect_true(is(error_return11, "error"))
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("liftover works", {
    ## The following test uses more than 2GB of memory, which is more
    ## than what 32-bit Windows can handle:
    is_32bit_windows <- .Platform$OS.type == "windows" #&&
        #.Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        ##### Test exported function directly ####
        sumstats_dt <- MungeSumstats::formatted_example()
        
        ## as data.table  
        sumstats_dt_hg38 <- MungeSumstats::liftover(
            sumstats_dt=sumstats_dt,
            ref_genome = "hg19",
            convert_ref_genome="hg38")
        testthat::expect_true("IMPUTATION_gen_build" %in% colnames(sumstats_dt_hg38))
        testthat::expect_equal(nrow(sumstats_dt_hg38), nrow(sumstats_dt))
        proportion_positions_changed <- sum(sumstats_dt_hg38$BP!=sumstats_dt$BP)/
            nrow(sumstats_dt)
        testthat::expect_equal(proportion_positions_changed,1)   
        proportion_snps_changed <- sum(sumstats_dt_hg38$SNP!=sumstats_dt$SNP)/
            nrow(sumstats_dt)
        testthat::expect_equal(proportion_snps_changed,0)     
        
        ## as GRAnges  
        granges_hg38 <- MungeSumstats::liftover(
            sumstats_dt=sumstats_dt,
            ref_genome = "hg19",
            convert_ref_genome="hg38", 
            as_granges = TRUE)
        testthat::expect_true("IMPUTATION_gen_build" %in% colnames(sumstats_dt_hg38))
        testthat::expect_equal(nrow(sumstats_dt_hg38), nrow(sumstats_dt))
        proportion_positions_changed <- sum(GenomicRanges::start(granges_hg38)!=sumstats_dt$BP)/
            nrow(sumstats_dt)
        testthat::expect_equal(proportion_positions_changed,1)   
        proportion_snps_changed <- sum(granges_hg38$SNP!=sumstats_dt$SNP)/
            nrow(sumstats_dt)
        testthat::expect_equal(proportion_snps_changed,0)     
        
        
        
        
        #### Test liftover functionality within format_sumstats ####
        
        file <- tempfile()
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
                                                package = "MungeSumstats"
        ))
        # write the Educational Attainment GWAS to a temp file for testing
        writeLines(eduAttainOkbay, con = file)
        #use stashed versions of chain files to speed up test
        #move them to temp dir so found and avoid download
        save_dir <- tempdir()
        build_conversion <- c("GRCh38_to_GRCh37", "GRCh37_to_GRCh38")
        chain_file <- paste0(build_conversion[1],".chain.gz")
        chain_file2 <- paste0(build_conversion[2],".chain.gz")
        
        
        local_path <- paste0(save_dir,"/",chain_file)
        local_path2 <- paste0(save_dir,"/",chain_file2)
        local_path_gunzip <- gsub(".gz", "", local_path)
        local_path_gunzip2 <- gsub(".gz", "", local_path2)
        
        if(!file.exists(local_path_gunzip)){
            if(!file.exists(local_path))
                copied <- R.utils::copyFile(srcPathname = 
                                       system.file("extdata",chain_file,
                                                   package="MungeSumstats"), 
                                   save_dir)
            R.utils::gunzip(local_path,overwrite=TRUE)
        }
        if(!file.exists(local_path_gunzip2)){
            if(!file.exists(local_path2))    
                copied2 <- R.utils::copyFile(srcPathname = 
                                       system.file("extdata",chain_file2,
                                                   package="MungeSumstats"), 
                                   save_dir)
            R.utils::gunzip(local_path2,overwrite=TRUE)
        }
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(
            path = file,
            ref_genome = "GRCh37",
            on_ref_genome = TRUE,
            convert_ref_genome = "GRCh38",
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            log_folder_ind = TRUE,
            imputation_ind = TRUE,
            dbSNP=144
        )
        # now rerun and convert back, should then equal original
        reformatted2 <- MungeSumstats::format_sumstats(
            path = reformatted$sumstats,
            ref_genome = "GRCh38",
            on_ref_genome = TRUE,
            convert_ref_genome = "GRCh37",
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            log_folder_ind = TRUE,
            imputation_ind = TRUE,
            dbSNP=144
        )

        # run org through
        reformatted3 <- MungeSumstats::format_sumstats(
            path = file,
            ref_genome = "GRCh37",
            on_ref_genome = TRUE,
            convert_ref_genome = NULL,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            log_folder_ind = TRUE,
            dbSNP=144
        )

        ref_37_org <- data.table::fread(reformatted3$sumstats, nThread = 1)
        ref_37 <- data.table::fread(reformatted2$sumstats, nThread = 1)
        ref_37[, IMPUTATION_gen_build := NULL]
        ref_37[, IMPUTATION_GEN_BUILD := NULL]
        # drop 1 row from org not in chain files
        ref_37_org <- ref_37_org[SNP %in% ref_37$SNP, ]
        expect_equal(all.equal(ref_37_org, ref_37), TRUE)
        
        #test local chain file
        save_dir <- tempdir()
        lcl_chain <- system.file("extdata",'GRCh37_to_GRCh38.chain.gz',
                                 package="MungeSumstats")
        copied <- R.utils::copyFile(
          srcPathname = lcl_chain,
          overwrite=TRUE,
          save_dir)
        reformatted4 <- MungeSumstats::format_sumstats(
          path = file,
          ref_genome = "GRCh37",
          on_ref_genome = TRUE,
          convert_ref_genome = "GRCh38",
          strand_ambig_filter = FALSE,
          bi_allelic_filter = FALSE,
          allele_flip_check = FALSE,
          log_folder_ind = TRUE,
          imputation_ind = TRUE,
          dbSNP=144,
          local_chain = paste0(save_dir,'/GRCh37_to_GRCh38.chain.gz')
        )
        lcl_ss <- data.table::fread(reformatted$sumstats)
        remote_ss <- data.table::fread(reformatted4$sumstats)
        expect_equal(all.equal(lcl_ss,remote_ss),TRUE)
        
        
    } else {
       expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
    }
})

test_that("Handle missing data", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # Remove data from line 3 to check it is deleted
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
            package = "MungeSumstats"
        ))
        eduAttainOkbay_missing <- eduAttainOkbay
        eduAttainOkbay_missing[3] <-
            "rs12987662\t2\t100821548\tA\tC\t0.3787\t0.027\t0.003\t"
        problem_snp <- "rs9320913"
        # write the Educational Attainment GWAS to a temp file for testing
        writeLines(eduAttainOkbay_missing, con = file)
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            sort_coordinates = FALSE,
            dbSNP=144
        )
        reformatted_lines <- readLines(reformatted)
        # Should equal org apart from this one line
        writeLines(eduAttainOkbay, con = file)
        org <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            sort_coordinates = FALSE,
            dbSNP=144
        )
        org_lines <- readLines(org)
        rsid_index <- grep(problem_snp, org_lines, ignore.case = TRUE)
        # reordering in function, line 3 is now 58
        expect_equal(reformatted_lines, org_lines[-rsid_index])
        # test imputing CHR BP from SNP when they are na but cols exist
        miss <- fread(system.file("extdata", "eduAttainOkbay.txt",
                                  package = "MungeSumstats"
        ))
        #add NA's
        miss[MarkerName=='rs9320913',CHR:=NA]
        miss[MarkerName=='rs9320913',POS:=NA]
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(miss,
                                            ref_genome = "GRCh37",
                                            on_ref_genome = FALSE,
                                            strand_ambig_filter = FALSE,
                                            bi_allelic_filter = FALSE,
                                            allele_flip_check = FALSE,
                                            sort_coordinates = FALSE,
                                            dbSNP=144
        )
        reformatted_lines <- readLines(reformatted)
        expect_equal(reformatted_lines, org_lines)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("log10 p-value", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
      # read it in and make N
      sumstats_dt <- data.table::fread(system.file("extdata", "eduAttainOkbay.txt",
                                                   package = "MungeSumstats"), 
                                       nThread = 1)
      #test -log10
      sumstats_dt[,LP:=-1*log(Pval,base=10)]
      data.table::setnames(sumstats_dt,"Pval","Pval_org")
      reformatted <- MungeSumstats::format_sumstats(sumstats_dt,
                                                    ref_genome = "GRCh37",
                                                    INFO_filter = 0.9,
                                                    on_ref_genome = FALSE,
                                                    strand_ambig_filter = FALSE,
                                                    bi_allelic_filter = FALSE,
                                                    allele_flip_check = FALSE,
                                                    log_folder_ind = FALSE,
                                                    imputation_ind = FALSE,
                                                    dbSNP=144,
                                                    ignore_multi_trait=TRUE,
                                                    return_data = TRUE)
      testthat::expect_equal(reformatted$PVAL_ORG,reformatted$P)
      #test log10
      sumstats_dt <- data.table::fread(system.file("extdata", "eduAttainOkbay.txt",
                                                   package = "MungeSumstats"), 
                                       nThread = 1)
      sumstats_dt[,LP:=log(Pval,base=10)]
      data.table::setnames(sumstats_dt,"Pval","Pval_org")
      reformatted <- MungeSumstats::format_sumstats(sumstats_dt,
                                                    ref_genome = "GRCh37",
                                                    INFO_filter = 0.9,
                                                    on_ref_genome = FALSE,
                                                    strand_ambig_filter = FALSE,
                                                    bi_allelic_filter = FALSE,
                                                    allele_flip_check = FALSE,
                                                    log_folder_ind = FALSE,
                                                    imputation_ind = FALSE,
                                                    dbSNP=144,
                                                    ignore_multi_trait=TRUE,
                                                    return_data = TRUE)
      testthat::expect_equal(reformatted$PVAL_ORG,reformatted$P)
    }    
    else{
      testthat::expect_equal(is_32bit_windows, TRUE)
      testthat::expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("non-biallelic SNPs are removed", {
  ## The following test uses more than 2GB of memory, which is more
  ## than what 32-bit Windows can handle:
  is_32bit_windows <- .Platform$OS.type == "windows" #&&
  #.Platform$r_arch == "i386"
  if (!is_32bit_windows) {
    #test to ensure indels aren't removed
    # also test indel missing RS ID removed rather than imputing wrong RS ID
    ss_indel <- data.table::data.table("SNP"=c("rs34589910","rs12987662",
                                               "4:6364621"),
                                       "CHR"=c(4,2,4),
                                       "BP"=c(6364621,100821548,6364621),
                                       "A1"=c("C","A","C"),
                                       "A2"=c("CG","C","CG"),
                                       "Uniq.a1a2"=c("4:6364621_C_CG","aa",
                                                     "4:6364621_C_CG"),
                                       "EAF"=c(0.0945334,0.3787,0.0945334),
                                       "BETA"=c(-0.00625732297153778,0.027,
                                                -0.00625732297153778),
                                       "P"=c(0.4883341,2.693e-24,0.4883341))
    
    reformatted_ss_ad <-
      MungeSumstats::format_sumstats(ss_indel,ref_genome="GRCh37",
                                     convert_small_p=TRUE,
                                     allele_flip_check=TRUE,
                                     snp_ids_are_rs_ids=TRUE,
                                     return_data=TRUE,
                                     nThread=2,
                                     on_ref_genome = TRUE,
                                     indels = TRUE,
                                     log_folder_ind = TRUE,
                                     dbSNP=144)
    #SNP ID is an indel so won't exist in our SNP reference dataset
    testthat::expect_equal("rs34589910" %in% 
                             reformatted_ss_ad$sumstats$SNP,TRUE)
    #check that indel missing RS ID is removed rather than imputing 
    testthat::expect_equal(nrow(fread(
      reformatted_ss_ad$log_files$snp_missing_rs)),1)
    
  } else {
    testthat::expect_equal((is_32bit_windows||
                              !Sys.info()["sysname"]=="Linux"), TRUE)
    testthat::expect_equal((is_32bit_windows||
                              !Sys.info()["sysname"]=="Linux"), TRUE)
  }
})

test_that("Test infer effect column function works", {
  ## Call uses reference genome as default with more than 2GB of memory,
  ## which is more than what 32-bit Windows can handle so remove tests
  is_32bit_windows <-
    .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
  if (!is_32bit_windows) {
    a <- MungeSumstats::formatted_example()
    b <- copy(a)
    
    #check if inferring effect direction is working
    
    #make A1 the effect col not A2
    #change FRQ and BETA to reflect this change
    data.table::setnames(b,"A2","A3")
    data.table::setnames(b,"A1","A2")
    data.table::setnames(b,"A3","A1")
    c <- copy(b)
    data.table::setnames(b,"BETA","BETA1")
    data.table::setnames(c,"FRQ","A1FRQ")
    
    # if the allele columns are named unambiguously, formatting will be performed 
    # correctly - use this to test against as eff will be flipped compared to org
    b_renamed <- copy(b)
    data.table::setnames(b_renamed, "A1", "effect_allele")
    data.table::setnames(b_renamed, "A2", "non_effect_allele")
    b_renamed_for <- MungeSumstats::format_sumstats(b_renamed, return_data = TRUE,
                                                    #all just make MSS run faster
                                                    ref_genome = 'GRCh37',
                                                    on_ref_genome = FALSE,
                                                    strand_ambig_filter = FALSE,
                                                    bi_allelic_filter = FALSE,
                                                    allele_flip_check = FALSE,
                                                    dbSNP=144)
    
    # what if BETA gives the direction
    b_for <- MungeSumstats::format_sumstats(b, return_data = TRUE, 
                                            #all just make MSS run faster
                                            ref_genome = 'GRCh37',
                                            on_ref_genome = FALSE,
                                            strand_ambig_filter = FALSE,
                                            bi_allelic_filter = FALSE,
                                            allele_flip_check = FALSE,
                                            dbSNP=144)
    
    # what if FRQ gives the direction
    c_for <- MungeSumstats::format_sumstats(c, return_data = TRUE, 
                                            #all just make MSS run faster
                                            ref_genome = 'GRCh37',
                                            on_ref_genome = FALSE,
                                            strand_ambig_filter = FALSE,
                                            bi_allelic_filter = FALSE,
                                            allele_flip_check = FALSE,
                                            dbSNP=144)
    
    testthat::expect_equal(
      all.equal(b_renamed_for, b_for,ignore.col.order = TRUE),
      TRUE
    )
    
    testthat::expect_equal(
      all.equal(b_renamed_for, c_for,ignore.col.order = TRUE),
      TRUE
    )
    
    
    #finally check if the ref genome can be used to infer rather than being 
    #told in eff/frq cols - just subset for speed
    snps <- c("rs11210860","rs34305371","rs1008078","rs11588857","rs1777827",
              "rs76076331","rs2457660","rs10496091","rs4851251","rs12987662",
              "rs10930008","rs301800","rs2568955","rs61787263","rs2992632",
              "rs11689269","rs11690172")
    d <- copy(b)
    data.table::setnames(d,"BETA1","BETA")
    d_for <- MungeSumstats::format_sumstats(d[!SNP %in% snps,], return_data = TRUE, 
                                            on_ref_genome = TRUE,
                                            #all just make MSS run faster
                                            ref_genome = 'GRCh37',
                                            strand_ambig_filter = FALSE,
                                            bi_allelic_filter = FALSE,
                                            allele_flip_check = FALSE,
                                            dbSNP=144)
    data.table::setkey(b_renamed_for,"SNP")
    data.table::setkey(d_for,"SNP")
    testthat::expect_equal(
      all.equal(b_renamed_for[!SNP %in% snps], d_for,
                ignore.col.order = TRUE),
      TRUE
    )
  }    
  else{
    testthat::expect_equal(is_32bit_windows, TRUE)
    testthat::expect_equal(is_32bit_windows, TRUE)
    testthat::expect_equal(is_32bit_windows, TRUE)
  }
})

test_that("Imputation of A1/A2 correctly", {
    ## The following test uses more than 2GB of memory, which is more
    ## than what 32-bit Windows can handle:
    is_32bit_windows <- .Platform$OS.type == "windows" ##&&
        ##.Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # write the Educational Attainment GWAS to a temp file for testing
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
                                                package = "MungeSumstats"
        ))
        writeLines(eduAttainOkbay, con = file)
        # read it in and drop CHR BP columns
        sumstats_dt <- data.table::fread(file, nThread = 1)
        # Keep Org to validate values
        sumstats_dt_missing <- data.table::copy(sumstats_dt)
        sumstats_dt_missing[, A1 := NULL]
        sumstats_dt_missing[, A2 := NULL]
        data.table::fwrite(
            x = sumstats_dt_missing,
            file = file,
            sep = "\t",
            nThread = 1
        )
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            imputation_ind = TRUE,
            log_folder_ind = TRUE,
            dbSNP=144
        )
        res_dt <- data.table::fread(reformatted$sumstats, 
                                    nThread = 1)
        # imputation cols - check they are there, then drop 
        testthat::expect_equal(
            sum(c("IMPUTATION_A1", "IMPUTATION_A2") %in% names(res_dt)), 2)
        res_dt[, IMPUTATION_A1 := NULL]
        res_dt[, IMPUTATION_A2 := NULL]
        # Check with just one of A1 A2
        # write the Educational Attainment GWAS to a temp file for testing
        writeLines(eduAttainOkbay, con = file)
        # read it in and drop A1 columns
        sumstats_dt <- data.table::fread(file,
                                         nThread = 1)
        # Keep Org to validate values
        sumstats_dt_missing <- data.table::copy(sumstats_dt)
        sumstats_dt_missing[, A1 := NULL]
        data.table::fwrite(x = sumstats_dt_missing,
                           file = file,
                           sep = "\t",
                           nThread = 1)
        # Run MungeSumstats code
        reformatted2 <- MungeSumstats::format_sumstats(
            path = file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            imputation_ind = TRUE,
            log_folder_ind = TRUE,
            allele_flip_frq = FALSE,
            dbSNP=144
        )
        res_dt2 <- data.table::fread(reformatted2$sumstats,
                                     nThread = 1)
        # imputation cols - check they are there, then drop
        testthat::expect_equal(
            sum(c("IMPUTATION_A1", "flipped") %in% names(res_dt2)), 2)
        res_dt2[, IMPUTATION_A1 := NULL]
        res_dt2[, flipped := NULL]
        # Check with just one of A1 A2
        # write the Educational Attainment GWAS to a temp file for testing
        writeLines(eduAttainOkbay, con = file)
        # read it in and drop A2 columns
        sumstats_dt <- data.table::fread(file,
                                         nThread = 1)
        # Keep Org to validate values
        sumstats_dt_missing <- data.table::copy(sumstats_dt)
        sumstats_dt_missing[, A2 := NULL]
        data.table::fwrite(x = sumstats_dt_missing,
                           file = file,
                           sep = "\t",
                           nThread = 1)
        # Run MungeSumstats code
        reformatted3 <- MungeSumstats::format_sumstats(
            path = file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            allele_flip_drop = FALSE,
            imputation_ind = TRUE,
            log_folder_ind = TRUE,
            dbSNP=144
        )
        res_dt3 <- data.table::fread(reformatted3$sumstats,
                                     nThread = 1)
        # imputation cols - check they are there, then drop
        testthat::expect_equal("IMPUTATION_A2" %in% names(res_dt3), TRUE)
        res_dt3[, IMPUTATION_A2 := NULL]

        # correct names of MungeSumstats::eduAttainOkbay
        names(sumstats_dt) <- c("SNP", "CHR", "BP", "A1", "A2",
                                "FRQ", "Beta", "SE", "P")
        # get order same
        data.table::setkey(res_dt, SNP)
        data.table::setkey(res_dt2, SNP)
        data.table::setkey(sumstats_dt, SNP)
        # add A1 to org
        sumstats_dt[res_dt, A1_der := i.A1]
        # add A2 to org
        sumstats_dt[res_dt, A2_der := i.A2]

        # add second A1 to org
        sumstats_dt[res_dt2, A1_der2 := i.A1]
        # add second A2 to org
        sumstats_dt[res_dt3, A2_der2 := i.A2]

        # remove any that weren't found in reference
        sumstats_dt <- sumstats_dt[complete.cases(sumstats_dt), ]
        # random chance would be 25% - so this is significantly greater than that
        A1_valid <- mean(sumstats_dt$A1 == sumstats_dt$A1_der) > 0.5 # 50% threshold
        # expect A1s to be equal, won't be always right
        testthat::expect_equal(A1_valid, TRUE)
        A2_valid <- mean(sumstats_dt$A2 == sumstats_dt$A2_der) > 0.45 # 45% threshold
        # expect A2s to be equal, all won't be since can be multiple A2s
        testthat::expect_equal(A2_valid, TRUE)

        A1_valid2 <- mean(sumstats_dt$A1 == sumstats_dt$A1_der2) > 0.5 # 50% threshold
        # expect A1s to be equal, all won't be since can be multiple A1s
        testthat::expect_equal(A1_valid2, TRUE)

        A2_valid2 <- mean(sumstats_dt$A2 == sumstats_dt$A2_der2) > 0.45 # 45% threshold
        # expect A2s to be equal, all won't be since can be multiple A2s
        testthat::expect_equal(A2_valid2, TRUE)

        # now check if ran org through allele flip check
        writeLines(eduAttainOkbay, con = file)
        org_rtrn <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = TRUE,
            allele_flip_frq = FALSE,
            dbSNP=144
        )
        res_org <- data.table::fread(org_rtrn, nThread = 1)
        data.table::setkey(res_org, SNP)
        # add A1 to org from one allele missing run
        res_org[res_dt2, A1_der := i.A1]
        # add A2 to org from one allele missing run
        res_org[res_dt3, A2_der := i.A2]

        testthat::expect_equal(
            all(res_org$A1 == res_org$A1_der) &&
            all(res_org$A2 == res_org$A2_der), TRUE)
    } else {
        expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
        expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
        expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
        expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
        expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
        expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
        expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
        expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
    }
})

test_that("strand-ambiguous SNPs are removed", {
    ## The following test uses more than 2GB of memory, which is more
    ## than what 32-bit Windows can handle:
    is_32bit_windows <- .Platform$OS.type == "windows" ##&&
        ##.Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # Remove all known strand ambiguous SNPs from dataset
        # "rs7131944"  "rs12682297" "rs55830725" "rs2992632"  "rs11689269"
        # "rs4493682"  "rs34106693" "rs6799130"  are strand-ambiguous
        SA_snps <- c(
            "rs7131944", "rs12682297", "rs55830725", "rs2992632", "rs11689269",
            "rs4493682", "rs34106693", "rs6799130"
        )
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
                                                package = "MungeSumstats"
        ))
        eduAttainOkbay_missing <- eduAttainOkbay
        for (SA_snp in SA_snps) {
            eduAttainOkbay_missing <-
                eduAttainOkbay_missing[!grepl(SA_snp, eduAttainOkbay_missing)]
        }
        # write the Educational Attainment GWAS to a temp file for testing
        writeLines(eduAttainOkbay_missing, con = file)
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = TRUE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        reformatted_lines <- readLines(reformatted)
        # Should equal org as strand ambig can be removed
        writeLines(eduAttainOkbay, con = file)
        org <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = TRUE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        org_lines <- readLines(org)
        # reordering in function, line 3 rs9320913 is now 58
        expect_equal(setequal(reformatted_lines, org_lines), TRUE)
    } else {
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("Test that if a0/a1 passed, formatted correctly", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # The dataset's alleles need to be flipped to test
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
            package = "MungeSumstats"
        ))
        eduAttainOkbay_missing <- eduAttainOkbay
        # A0/A1 go to ref/alt whereas A1/A2 goes to ref/alt
        eduAttainOkbay_missing[1] <-
            "MarkerName\tCHR\tPOS\tA0\tA1\tEAF\tBeta\tSE\tPval"
        # write the Educational Attainment GWAS to a temp file for testing
        writeLines(eduAttainOkbay_missing, con = file)
    
    
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        reformatted_lines <- readLines(reformatted)
        # Should equal org since the effect should be corrected
        writeLines(eduAttainOkbay, con = file)
        org <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        org_lines <- readLines(org)
        # reordering in function
        expect_equal(setequal(reformatted_lines, org_lines), TRUE)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("Imputation of SNP correctly", {
    ## The following test uses more than 2GB of memory, which is more
    ## than what 32-bit Windows can handle:
    is_32bit_windows <- .Platform$OS.type == "windows" ##&&
        ##.Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # write the Educational Attainment GWAS to a temp file for testing
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
                                                package = "MungeSumstats"
        ))
        writeLines(eduAttainOkbay, con = file)
        # read it in and drop CHR BP columns
        sumstats_dt <- data.table::fread(file)
        # Keep Org to validate values
        sumstats_dt_missing <- data.table::copy(sumstats_dt)
        sumstats_dt_missing[, MarkerName := NULL]
        data.table::fwrite(x = sumstats_dt_missing, file = file, sep = "\t")
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        res_dt <- data.table::fread(reformatted)
        # correct names of MungeSumstats::eduAttainOkbay
        names(sumstats_dt) <- c("SNP", "CHR", "BP", "A1", "A2", "FRQ", 
                                    "Beta", "SE", "P")
        # get order same
        setkey(res_dt, SNP)
        setkey(sumstats_dt, SNP)
        # add SNP to org
        sumstats_dt[res_dt, SNP_der := i.SNP]
        # remove any that weren't found in reference
        sumstats_dt <- sumstats_dt[complete.cases(sumstats_dt), ]
        expect_equal(sumstats_dt$SNP, sumstats_dt$SNP_der)
    } else {
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("compute_nsize works", {
  
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        sumstats_dt <- MungeSumstats::formatted_example(formatted = FALSE)
        ## pass mulitple N's - SNP level N not supported
        n_err <- 
          tryCatch(MungeSumstats::format_sumstats(sumstats_dt,
                                         ref_genome = "GRCh37",
                                         on_ref_genome = FALSE,
                                         strand_ambig_filter = FALSE,
                                         bi_allelic_filter = FALSE,
                                         allele_flip_check = FALSE,
                                         dbSNP=144,
                                         compute_n = c(5,5,7,8,10,12,12)
                                         ),
                   error = function(e) e,
                   warning = function(w) w
          )
        expect_true(is(n_err, "error"))
        
        #### Add N: numeric mode####
        sumstats_dt2 <- MungeSumstats::compute_nsize(sumstats_dt=sumstats_dt,
                                                     standardise_headers = TRUE, 
                                                     return_list = TRUE,
                                                     compute_n = 1000
                                                     )$sumstats_dt
        
        testthat::expect_false("N" %in% colnames(sumstats_dt))
        testthat::expect_true("N" %in% colnames(sumstats_dt2))
        
        #### Use existing N ####
        sumstats_dt3 <- compute_nsize(sumstats_dt = sumstats_dt2,
                                      compute_n = 500,
                                      return_list = FALSE)
        testthat::expect_equal(sumstats_dt3$N[1],1000)
        
        #### N_CAS/N_CON methods ####
        #### LDSC ####
        set.seed(1234)
        sumstats_dt$N_CAS <- as.integer(rnorm(nrow(sumstats_dt), mean = 500))
        sumstats_dt$N_CON <- as.integer(rnorm(nrow(sumstats_dt), mean = 1000))
        opts <- eval(as.list(args(compute_nsize))$compute_n)
        for(o in opts){
            print(paste0("Testing: compute_n='",o,"'"))
            sumstats_dt4 <- compute_nsize(sumstats_dt = sumstats_dt,
                                          compute_n = o,
                                          return_list = FALSE)
            if(o=="sum"){
                testthat::expect_true("N" %in% colnames(sumstats_dt4))
            } else {
                testthat::expect_true("Neff" %in% colnames(sumstats_dt4))
            } 
            remove(sumstats_dt4)
        } 
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("SNPs on X,Y,MT chromosome are removed", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # Update CHR from line 3,4,5 to X,Y,MT to check it is deleted -
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
            package = "MungeSumstats"
        ))
        eduAttainOkbay_missing <- eduAttainOkbay
        eduAttainOkbay_missing[3] <-
            "rs9320913\tX\t98584733\tA\tC\t0.5019\t0.024\t0.003\t2.457e-19"
        eduAttainOkbay_missing[4] <-
            "rs11712056\tY\t49914397\tT\tC\t0.5504\t0.024\t0.003\t3.304e-19"
        eduAttainOkbay_missing[5] <-
            "rs148734725\tMT\t49406708\tA\tG\t0.3078\t0.025\t0.003\t1.363e-18"
    
        problem_snp <- c("rs9320913", "rs11712056", "rs148734725")
        # write the Educational Attainment GWAS to a temp file for testing
        writeLines(eduAttainOkbay_missing, con = file)
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            log_folder_ind = TRUE,
            dbSNP=144
        )
        reformatted_lines <- readLines(reformatted$sumstats)
        # Should equal org apart from this one line
        writeLines(eduAttainOkbay, con = file)
        org <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        org_lines <- readLines(org)
        rsid_index <- grep(paste(problem_snp, collapse = "|"), org_lines,
            ignore.case = TRUE
        )
        # reordering in function, line 3,4,5 is now 28,58
        expect_equal(setequal(
            reformatted_lines,
            org_lines[-rsid_index]
        ), TRUE)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("Input has correct format", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # write the Educational Attainment GWAS to a temp file for testing
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
            package = "MungeSumstats"
        ))
        writeLines(eduAttainOkbay, con = file)
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        reformatted_lines <- readLines(reformatted)
        # Only issue with eduAttainOkbay is the SNP ID name so update before check
        len_eduAttainOkbay <- length(eduAttainOkbay)
        # setequal ignores order - SNP rows are reordered
        expect_equal(setequal(
            reformatted_lines[2:length(reformatted_lines)],
            eduAttainOkbay[2:len_eduAttainOkbay]
        ), TRUE)
        headers_eduAttainOkbay <- "SNP\tCHR\tBP\tA1\tA2\tFRQ\tBETA\tSE\tP"
        expect_equal(reformatted_lines[1], headers_eduAttainOkbay)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("Handle extra info in rs id column", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # create dataset to test
        set.seed(101)
        a <- data.table::data.table(
            SNP = c(
                "rs140052487:C:A", "rs558796213:G:T",
                "rs561234294:A:G", "rs2462492:C:T",
                "rs548455890:T:G"
            ),
            "P" = (runif(5) / 10),
            "FRQ" = runif(5), "BETA" = runif(5), "CHR" = rep(1, 5),
            "BP" = c(54353, 54564, 54591, 54676, 54763)
        )
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(a,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            log_folder_ind = TRUE,
            imputation_ind = FALSE,
            return_data = TRUE,
            dbSNP=144
        )
    
        # Should equal separated version
        set.seed(101)
        b <- data.table::data.table(
            SNP = c(
                "rs140052487", "rs558796213", "rs561234294",
                "rs2462492", "rs548455890"
            ), "P" = (runif(5) / 10),
            "FRQ" = runif(5), "BETA" = runif(5), "CHR" = rep(1, 5),
            "BP" = c(54353, 54564, 54591, 54676, 54763),
            "A1" = c("C", "G", "A", "C", "T"), "A2" = c("A", "T", "G", "T", "G")
        )
        reformatted2 <- MungeSumstats::format_sumstats(b,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            log_folder_ind = TRUE,
            imputation_ind = TRUE,
            return_data = TRUE,
            dbSNP=144
        )
        # should be the same
        expect_equal(setequal(reformatted$sumstats, reformatted2$sumstats), TRUE)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("Handle more than 1 rs IDs in one row", {
  ## The following test uses more than 2GB of memory, which is more
  ## than what 32-bit Windows can handle:
  is_32bit_windows <- .Platform$OS.type == "windows" #&&
  #.Platform$r_arch == "i386"
  if (!is_32bit_windows  && Sys.info()["sysname"]=="Linux") {
    file <- tempfile()
    # Remove data from line 3 to check it is deleted
    eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
                                            package = "MungeSumstats"
    ))
    eduAttainOkbay_missing <- eduAttainOkbay
    eduAttainOkbay_missing[3] <-
      "rs9320913_rs1234_rs_45678\t6\t98584733\tA\tC\t0.5019\t0.024\t0.003\t2.457e-19"
    # write the Educational Attainment GWAS to a temp file for testing
    writeLines(eduAttainOkbay_missing, con = file)
    
    
    # make changes for log check
    file2 <- tempfile()
    # multiple rs id already there
    # data already has 8 strand ambiguous snps, 1 snp A1 A2 doesn't match ref gen
    # add missing data(EAF)
    eduAttainOkbay_missing[2] <-
      "rs12987662\t2\t100821548\tA\tC\t\t0.027\t0.003\t2.693e-24"
    # make beta 0
    eduAttainOkbay_missing[4] <-
      "rs11712056\t3\t49914397\tT\tC\t0.5504\t0\t0.003\t3.304e-19"
    # make se negative
    eduAttainOkbay_missing[9] <-
      "rs2456973\t12\t56416928\tA\tC\t0.6791\t-0.02\t-0.003\t1.064e-12"
    # make duplicate SNP IDs
    eduAttainOkbay_missing[10] <-
      "rs165633\t12\t123767929\tA\tG\t0.2257\t0.023\t0.003\t1.258e-12"
    # make duplicate base pair positions - bp from row 14
    eduAttainOkbay_missing[13] <-
      "rs11191193\t4\t140764124\tA\tG\t0.6511\t0.018\t0.003\t5.444e-11"
    # make snp missing rs but change chr and bp to not real ones so then removed
    eduAttainOkbay_missing[15] <-
      "11210860\t1\t-1\tA\tG\t0.3694\t0.017\t0.003\t2.359e-10"
    # write the Educational Attainment GWAS to a temp file for testing
    writeLines(eduAttainOkbay_missing, con = file2)
    # Run MungeSumstats code
    reformatted <-
      MungeSumstats::format_sumstats(file,
                                     ref_genome = "GRCh37",
                                     on_ref_genome = FALSE,
                                     strand_ambig_filter = FALSE,
                                     bi_allelic_filter = FALSE,
                                     allele_flip_check = FALSE,
                                     imputation_ind = TRUE,
                                     remove_multi_rs_snp = FALSE,
                                     dbSNP=144
      )
    reformatted_lines <- data.table::fread(reformatted)
    # Should equal org apart from this one line
    writeLines(eduAttainOkbay, con = file)
    org <- MungeSumstats::format_sumstats(file,
                                          ref_genome = "GRCh37",
                                          on_ref_genome = FALSE,
                                          strand_ambig_filter = FALSE,
                                          bi_allelic_filter = FALSE,
                                          allele_flip_check = FALSE,
                                          imputation_ind = TRUE,
                                          remove_multi_rs_snp = FALSE,
                                          dbSNP=144
    )
    org_lines <- data.table::fread(org)
    
    # remove imputation column
    reformatted_lines[, convert_multi_rs_SNP := NULL]
    # reordering makes line 3 got to 58
    testthat::expect_equal(reformatted_lines, org_lines)
    
    # check log files
    # Run MungeSumstats code
    reformatted_log <-
      MungeSumstats::format_sumstats(file2,
                                     ref_genome = "GRCh37",
                                     on_ref_genome = FALSE,#TRUE,
                                     strand_ambig_filter = TRUE,
                                     bi_allelic_filter = FALSE,#TRUE,
                                     allele_flip_check = FALSE,#TRUE,
                                     imputation_ind = TRUE,
                                     remove_multi_rs_snp = TRUE,
                                     log_folder_ind = TRUE,
                                     dbSNP=144
      )
    
    # expect 5 log files
    testthat::expect_equal(length(reformatted_log$log_files), 5)
    # next check number of rows in each
    results <- c()
    for (log_i in reformatted_log$log_files) {
      data_log_i <- data.table::fread(log_i)
      if (grepl("snp_strand_ambiguous", log_i)) {
        results <- c(results, nrow(data_log_i) == 8)
      } else {
        results <- c(results, nrow(data_log_i) == 1|
                       nrow(data_log_i) == 0)
      }
    }
    expect_equal(all(results), TRUE)
  } else {
    expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
    expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
    expect_equal((is_32bit_windows||!Sys.info()["sysname"]=="Linux"), TRUE)
  }
})

test_that("Check SNP ID formatting", {
    ## The following test uses more than 2GB of memory, which is more
    ## than what 32-bit Windows can handle:
    is_32bit_windows <- .Platform$OS.type == "windows" ##&&
        ##.Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # write the Educational Attainment GWAS to a temp file for testing
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
                                                package = "MungeSumstats"
        ))
        writeLines(eduAttainOkbay, con = file)
        # read it in and drop CHR BP columns
        sumstats_dt <- data.table::fread(file)
        # Keep Org to validate values
        sumstats_dt_missing <- data.table::copy(sumstats_dt)
        # impute CHR:BP for SNP for first row to ensure MungeSumstats gets SNP
        sumstats_dt_missing[
            MarkerName == "rs12987662",
            MarkerName := paste0(CHR, ":", POS)
        ]
        # have copy where CHR & POS not removed
        sumstats_dt_missing2 <- data.table::copy(sumstats_dt_missing)
        # Now remove CHR POS
        sumstats_dt_missing[, CHR := NULL]
        sumstats_dt_missing[, POS := NULL]
        # Also add row with incorrect format for SNP ID which should be removed
        sumstats_dt_missing[
            MarkerName == "rs9320913",
            MarkerName := "9320913"
        ]
        sumstats_dt_missing2[
            MarkerName == "rs9320913",
            MarkerName := "9320913"
        ]
        
        # try third with check_row_snp and snp_ids_are_rs_ids=TRUE
        sumstats_dt_missing3 <- data.table::copy(sumstats_dt)
        sumstats_dt_missing3[, MarkerName := substr(MarkerName, 3, 
                                                    nchar(MarkerName))]
        
        data.table::fwrite(x = sumstats_dt_missing, file = file, sep = "\t")
        file2 <- tempfile()
        data.table::fwrite(x = sumstats_dt_missing2, file = file2, sep = "\t")
        file3 <- tempfile()
        data.table::fwrite(x = sumstats_dt_missing3, file = file3, sep = "\t")
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        res_dt <- data.table::fread(reformatted)

        reformatted2 <- MungeSumstats::format_sumstats(file2,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        res_dt2 <- data.table::fread(reformatted2)

        # will give error as all ID's don't have rs and 
        # snp_ids_are_rs_ids=TRUE set
        fail_return <-
            tryCatch(MungeSumstats::format_sumstats(file3,
                ref_genome = "GRCh37",
                on_ref_genome = FALSE,
                strand_ambig_filter = FALSE,
                bi_allelic_filter = FALSE,
                allele_flip_check = FALSE,
                dbSNP=144
            ),
            error = function(e) e,
            warning = function(w) w
            )

        # run org
        writeLines(eduAttainOkbay, con = file)
        org <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            dbSNP=144
        )
        org_dt <- data.table::fread(org)
        data.table::setkey(org_dt, SNP)
        data.table::setkey(res_dt, SNP)
        data.table::setkey(res_dt2, SNP)
        # check equal with corrupted SNP ID removed
        expect_equal(all.equal(org_dt[SNP != "rs9320913", ], res_dt,
            ignore.row.order = TRUE
        ), TRUE)
        expect_equal(all.equal(org_dt, res_dt2,
            ignore.row.order = TRUE
        ), TRUE)
        expect_equal(is(fail_return, "error"), TRUE)
    } else {
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("will fail without a vital column", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # write the Educational Attainment GWAS to a temp file for testing
        eduAttainOkbay <- readLines(system.file("extdata", "eduAttainOkbay.txt",
            package = "MungeSumstats"
        ))
        writeLines(eduAttainOkbay, con = file)
        # read it in and combine CHR BP columns
        sumstats_dt <- data.table::fread(file, nThread = 1)
        # Remove vital column - P
        sumstats_dt[, Pval := NULL]
        data.table::fwrite(
            x = sumstats_dt,
            file = file,
            sep = "\t",
            nThread = 1
        )
        # Run MungeSumstats code
        error_return <-
            tryCatch(MungeSumstats::format_sumstats(file,
                ref_genome = "GRCh37",
                on_ref_genome = FALSE,
                strand_ambig_filter = FALSE,
                bi_allelic_filter = FALSE,
                allele_flip_check = FALSE,
                dbSNP=144
            ),
            error = function(e) e,
            warning = function(w) w
            )
        expect_equal(is(error_return, "error"), TRUE)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("Multi-trait GWAS handled correctly", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        file <- tempfile()
        # write an example of a multi-trait GWAS in
        multi_trait <- c(
            "chromosome\trs_id\tmarkername\tposition_hg18\tEffect_allele\tOther_allele\tEAF_HapMapCEU\tN_SMK\tEffect_SMK\tStdErr_SMK\tP_value_SMK\tN_NONSMK\tEffect_NonSMK\tStdErr_NonSMK\tP_value_NonSMK",
            "1\t\tchr1:240307304\t240307304\tT\tG\t\t31366.8\t-0.0528\t0.0142\t0.0002004\t121792\t-0.0026\t0.0075\t0.7274",
            "1\trs1000050\tchr1:161003087\t161003087\tT\tC\t0.9\t36256.6\t0.0001\t0.0109\t0.9931\t127514\t0.0058\t0.0059\t0.3307",
            "1\trs1000073\tchr1:155522020\t155522020\tA\tG\t0.3136\t36335\t0.0046\t0.0083\t0.5812\t126780\t0.0038\t0.0045\t0.3979",
            "1\trs1000075\tchr1:94939420\t94939420\tT\tC\t0.3583\t38959.3\t-0.0013\t0.0082\t0.8687\t147567\t-0.0043\t0.0044\t0.3259",
            "1\trs1000085\tchr1:66630503\t66630503\tC\tG\t0.1667\t38761\t0.0053\t0.0095\t0.5746\t147259\t-0.0034\t0.0052\t0.5157"
        )
        writeLines(multi_trait, con = file)
        # Run MungeSumstats code
        reformatted <- MungeSumstats::format_sumstats(file,
            ref_genome = "GRCh37",
            analysis_trait = "smk",
            on_ref_genome = FALSE,
            strand_ambig_filter = FALSE,
            bi_allelic_filter = FALSE,
            allele_flip_check = FALSE,
            sort_coordinates = FALSE,
            chr_style = "UCSC",
            dbSNP=144
        )
        reformatted_res <- readLines(reformatted)
        # check manually
        multi_trait_res_smk <- c(
            "SNP\tCHR\tBP\tA1\tA2\tPOSITION_HG18\tEAF_HAPMAPCEU\tN\tBETA\tSE\tP\tN_NONSMK\tEFFECT_NONSMK\tSTDERR_NONSMK\tP_VALUE_NONSMK",
            "rs1000073\tchr1\t155522020\tG\tA\t155522020\t0.3136\t36335\t0.0046\t0.0083\t0.5812\t126780\t0.0038\t0.0045\t0.3979",
            "rs1000050\tchr1\t161003087\tC\tT\t161003087\t0.9\t36257\t1e-04\t0.0109\t0.9931\t127514\t0.0058\t0.0059\t0.3307",
            "rs1000085\tchr1\t66630503\tG\tC\t66630503\t0.1667\t38761\t0.0053\t0.0095\t0.5746\t147259\t-0.0034\t0.0052\t0.5157",
            "rs1000075\tchr1\t94939420\tC\tT\t94939420\t0.3583\t38959\t-0.0013\t0.0082\t0.8687\t147567\t-0.0043\t0.0044\t0.3259"
        )
        expect_equal(setequal(multi_trait_res_smk, reformatted_res), TRUE)
    }
    else{
        expect_equal(is_32bit_windows, TRUE)
    }
})

test_that("Check that imputation columns added correctly", {
  ## The following test uses more than 2GB of memory, which is more
  ## than what 32-bit Windows can handle:
  is_32bit_windows <- .Platform$OS.type == "windows" #&&
  #.Platform$r_arch == "i386"
  if (!is_32bit_windows) {
    pth <- system.file("extdata", "eduAttainOkbay.txt",
                       package = "MungeSumstats"
    )
    #only run not on linux to speed up linux bioc checks
    eduAttainOkbay <- data.table::fread(pth)
    # edit to make an rs id be imputed
    eduAttainOkbay[1, "MarkerName"] <-
      substring(
        eduAttainOkbay[1, "MarkerName"], 3,
        nchar(eduAttainOkbay[1, "MarkerName"])
      )
    # write to temp dir
    file <- tempfile()
    data.table::fwrite(eduAttainOkbay, file)
    # run
    reformatted <- MungeSumstats::format_sumstats(file,
                                                  ref_genome = "GRCh37",
                                                  compute_z = TRUE,
                                                  compute_n = 1001,
                                                  save_format='LDSC',
                                                  imputation_ind = TRUE,
                                                  allele_flip_check = TRUE,
                                                  dbSNP=144
    )
    res <- data.table::fread(reformatted)
    col_headers <- names(res)
    imputat_cols <- c(
      col_headers[grepl("^IMPUTATION_", col_headers)],
      "flipped"["flipped" %in% col_headers],
      col_headers[grepl("^convert_", col_headers)]
    )
    # just check imputation columns exist
    expect_equal(length(imputat_cols) > 0, TRUE)
    # also check all have at least 1 value present
    have_value <- TRUE
    for (col_i in imputat_cols) {
      col_i_val <- res[[col_i]]
      if (length(col_i_val[!is.na(col_i_val)]) == 0) {
        have_value <- FALSE
      }
    }
    expect_equal(have_value, TRUE)
    # check other compute_n values
    eduAttainOkbay <- data.table::fread(pth)
    eduAttainOkbay[, N_CON := 100]
    eduAttainOkbay[, N_CAS := 120]
    # write to temp dir
    file <- tempfile()
    data.table::fwrite(eduAttainOkbay, file)
    methods <- c("ldsc", "sum", "giant", "metal")
    reformatted <- MungeSumstats::format_sumstats(file,
                                                  ref_genome = "GRCh37",
                                                  compute_n = methods,
                                                  on_ref_genome = FALSE,
                                                  strand_ambig_filter = FALSE,
                                                  bi_allelic_filter = FALSE,
                                                  allele_flip_check = FALSE,
                                                  dbSNP=144
    )
    res <- data.table::fread(reformatted)
    expect_equal(all(paste0("Neff_", c("ldsc", "giant", "metal")) %in%
                       colnames(res)), TRUE)
  } else {
    expect_equal(is_32bit_windows, TRUE)
    expect_equal(is_32bit_windows, TRUE)
    expect_equal(is_32bit_windows, TRUE)
  }
})

#' Map column names to positions.
#'
#' Useful in situations where you need to specify columns by
#' index instead of name (e.g. awk queries).
#'
#' @source Borrowed function from
#' \href{https://github.com/RajLabMSSM/echotabix/blob/main/R/convert.R}{
#' echotabix}.
#' 
#' @source 
#' \code{
#' eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
#'     package = "MungeSumstats"
#' )
#' tmp <- tempfile(fileext = ".tsv")
#' file.copy(eduAttainOkbayPth, tmp)
#' cdict <- MungeSumstats:::column_dictionary(file_path = tmp)
#' }
#' 
#' @param file_path Path to full summary stats file
#' (or any really file you want to make a column dictionary for).
#' 
#' @return Named list of column positions.
#' 
#' @keywords internal
#' @importFrom stats setNames
column_dictionary <- function(file_path) {
    # Get the index of each column name
    header <- read_header(path = file_path, 
                          # n must be 2 or else 
                          # fread won't be able to parse text
                          n = 2, 
                          skip_vcf_metadata = TRUE) 
    cNames <- colnames(header)
    colDict <- stats::setNames(seq(1, length(cNames)), cNames)
    return(colDict)
}

#' Genome build liftover
#'
#' Transfer genomic coordinates from one genome build to another.
#'
#' @source \href{https://doi.org/doi:10.18129/B9.bioc.liftOver}{liftOver}
#' @source \href{https://hgdownload.cse.ucsc.edu/goldenpath/hg19/liftOver/}{
#' UCSC chain files}
#' @source \href{https://ftp.ensembl.org/pub/assembly_mapping/homo_sapiens/}{
#' Ensembl chain files}
#'
#' @param sumstats_dt data table obj of the summary statistics
#'  file for the GWAS.
#' @param chain_source chain file source used ("ucsc" as default, or "ensembl")
#' @param chrom_col Name of the chromosome column in 
#' \code{sumstats_dt} (e.g. "CHR").
#' @param start_col Name of the starting genomic position
#'  column in \code{sumstats_dt} (e.g. "POS","start").
#' @param end_col Name of the ending genomic position
#'  column in \code{sumstats_dt} (e.g. "POS","end"). 
#'  Can be the same as \code{start_col} when \code{sumstats_dt} 
#'  only contains SNPs that span 1 base pair (bp) each.
#' @param as_granges Return results as \link[GenomicRanges]{GRanges} 
#' instead of a \link[data.table]{data.table} (default: \code{FALSE}).
#' @param style Style to return \link[GenomicRanges]{GRanges} object in
#' (e.g.  "NCBI" = 4; "UCSC" = "chr4";) (default: \code{"NCBI"}).
#' @param local_chain Path to local chain file to use instead of downlaoding.
#' Default of NULL i.e. no local file to use. NOTE if passing a local chain file
#' make sure to specify the path to convert from and to the correct build like 
#' GRCh37 to GRCh38. We can not sense check this for local files. The chain file
#' can be submitted as a gz file (as downloaed from source) or unzipped.
#' @param rmv_chr Chromosomes to exclude from the formatted summary statistics
#'   file. Use NULL if no filtering is necessary. Default is `c("X", "Y", "MT")`
#'   which removes all non-autosomal SNPs.
#' @param verbose Print messages.
#' @inheritParams format_sumstats
#' 
#' @returns Lifted summary stats in \code{data.table} 
#' or \link[GenomicRanges]{GRanges} format.
#' 
#' @export
#' @importFrom rtracklayer liftOver width strand end
#' @importFrom GenomeInfoDb seqnames mapGenomeBuilds
#' @importFrom GenomicRanges mcols
#' @importFrom data.table as.data.table setnames :=
#' @examples 
#' sumstats_dt <- MungeSumstats::formatted_example()
#'
#' sumstats_dt_hg38 <- liftover(sumstats_dt=sumstats_dt, 
#'                              ref_genome = "hg19",
#'                              convert_ref_genome="hg38")
liftover <- function(sumstats_dt, 
                     convert_ref_genome, 
                     ref_genome,
                     chain_source = "ensembl",
                     imputation_ind = TRUE,
                     chrom_col = "CHR",
                     start_col = "BP",
                     end_col = start_col, 
                     as_granges = FALSE,
                     style = "NCBI",
                     local_chain = NULL,
                     rmv_chr = c(),
                     verbose = TRUE) {
    
    IMPUTATION_gen_build <- width <- strand <- end <- seqnames <- NULL;
    chain_source <- tolower(chain_source)
    #check chain file source
    chain_msg <- paste0(
      "The chosen chain file source to convert to must be one of ",
      "Ensembl or UCSC ('ensembl','ucsc')"
    )
    if(length(chain_source)>1 || !tolower(chain_source) %in% c("ucsc", 
                                                               "ensembl")){
      stop(chain_msg)
    }
    #check local chain file
    if (!is.null(local_chain) && !file.exists(local_chain)){
      lcl_chain_msg <- paste0(
        "The local_chain parameter is invalid, please chose a valid path to a ",
        "local chain file or leave as NULL to download a chain file."
      )
      stop(lcl_chain_msg)
    }
    #Only continue with checks if user specifies a genome to convert to
    if (!is.null(convert_ref_genome)){
      #### Map genome build synonyms ####
      query_ucsc <- if(!is.null(ref_genome)){
          GenomeInfoDb::mapGenomeBuilds(genome = ref_genome)$ucscID[1]
      } else {ref_genome}
      target_ucsc <- if(!is.null(convert_ref_genome)){
          GenomeInfoDb::mapGenomeBuilds(genome = convert_ref_genome)$ucscID[1]
      } else {convert_ref_genome}
       
      #### Check if one or more of the genomes couldn't be mapped ####
      null_builds <- c("query_genome", "target_genome")[
          c(is.null(query_ucsc), is.null(target_ucsc))
      ] 
      if(length(null_builds)>0){
          msg <- paste0("Could not recognize genome build of:\n",
                        paste(" -",null_builds,collapse = "\n"),
                        "\nThese will be inferred from the data.")
          message(msg)
      } 
      
      #### Check if liftover is necessary ####
      ## i.e. the desired genome build isn't the current one
      if ((!is.null(query_ucsc) & !is.null(target_ucsc)) &&
          (query_ucsc != target_ucsc)) {
          msg <- paste0(
              "Performing data liftover from ", query_ucsc, " to ",
              target_ucsc, "."
          )
          message(msg)
  
          #### Check that liftover is available ####
          ## If one or more builds are NULL, this won't be evaluated bc
          ## the builds will be inferred instead.
          if(any(!c(query_ucsc, target_ucsc) %in% c("hg38", "hg19")) ||
                 query_ucsc == target_ucsc) {
              stop("Can only perform liftover between hg19 <---> hg38")
          } 
          
          #FIRST ensure chr formatting is correct to avoid issues with chain 
          #files
          msg <- paste0(
            "First - Checking CHR format to avoid liftover issues with chain ",
            "file."
          )
          message(msg)
          sumstats_return <- check_chr(
            sumstats_dt = sumstats_dt,
            rmv_chr = rmv_chr
          )
          
          #### Convert to GRanges #### 
          gr <- to_granges(
              sumstats_dt = sumstats_dt,
              style = "UCSC", 
              seqnames.field = chrom_col,
              start.field = start_col,
              end.field = end_col
          )
          #### Specify chain file ####
          if (is.null(local_chain)) {
            if (verbose) {message("Downloading chain file...")}
            chain <- get_chain_file(
              from = query_ucsc,
              to = target_ucsc,
              chain_source = chain_source,
              verbose = verbose
            )
          }
          else {
            if (verbose) {message("Using local chain file...")}
            #unzip if necessary
            filetype = summary(file(local_chain))$class
            if(filetype=='gzfile'){
              local_chain <- R.utils::gunzip(local_chain, overwrite=TRUE)
            }
            chain <- rtracklayer::import.chain(local_chain)
          }
          #### Liftover ####
          gr_lifted <- unlist(rtracklayer::liftOver(
              x = gr,
              chain = chain
          ))
          #### Chrom style ####
          gr_lifted <- granges_style(
              gr = gr_lifted,
              style = style
          )
          #### Return format ####
          if (as_granges) {
              if(imputation_ind){
                  GenomicRanges::mcols(gr_lifted)[["IMPUTATION_gen_build"]] <-
                      TRUE
              }
              return(gr_lifted)
          } else {
              sumstats_dt <- data.table::as.data.table(gr_lifted)
              #### rename columns back to original #### 
              void_cols <- c("width","strand")
              void_cols <- void_cols[void_cols %in% names(sumstats_dt)] 
              if(length(void_cols)>0) sumstats_dt[,(void_cols):=NULL]
              data.table::setnames(sumstats_dt,"seqnames","CHR")
              #### Remove end_col if it was the same as start_col ####
              if (start_col == end_col) {
                  sumstats_dt[, end := NULL]
                  data.table::setnames(sumstats_dt, "start", start_col)
              } else {
                  data.table::setnames(sumstats_dt, c("start","end"),
                                       c(start_col, end_col) 
                  )
              }
              #### lastly rearrange the order again ####
              sumstats_dt <- check_col_order(
                  sumstats_dt = sumstats_dt,
                  path = NULL
              )$sumstats_dt
              if (imputation_ind) {
                  sumstats_dt[, IMPUTATION_gen_build := TRUE]
              }
          } 
      }
    }
    return(sumstats_dt)
}

#' Compute (effective) sample size
#'
#' Computes sample sum (as new column "N") or
#' effective sample size (ESS) (as new column "Neff").
#' Computing ESS is important as it takes into account
#' the proportion of cases to controls (i.e. class imbalance) so as not to
#' overestimate your statistical power.
#'
#' There are many different formulas for calculating ESS,
#' but LDSC is probably the best method available here, as it
#'  doesn't assume that the proportion of controls:cases
#'  is 2:1 (as in GIANT) or 4:1 (as in METAL).
#'
#' @param sumstats_dt Summary statistics data.table.
#' @param method Method for computing (effective) sample size.
#'
#' \itemize{
#'
#' \item{"ldsc" : \cr}{
#' \eqn{Neff = (N_CAS+N_CON) * (N_CAS/(N_CAS+N_CON)) /
#'  mean((N_CAS/(N_CAS+N_CON))[(N_CAS+N_CON)==max(N_CAS+N_CON)]))}\cr
#' \href{https://github.com/bulik/ldsc/issues/95}{
#' bulik/ldsc GitHub Issue}
#' \href{https://github.com/bulik/ldsc/blob/aa33296abac9569a6422ee6ba7eb4b902422cc74/munge_sumstats.py#L321}{
#' bulik/ldsc GitHub code}
#' }
#'
#' \item{"giant" : \cr}{
#' \eqn{Neff = 2 / (1/N_CAS + 1/N_CON)}\cr
#' \href{https://www.nature.com/articles/nprot.2014.071}{
#' Winkler et al. 2014, Nature}
#' }
#'
#' \item{"metal" : \cr}{
#' \eqn{Neff = 4 / (1/N_CAS + 1/N_CON)}\cr
#' \href{https://pubmed.ncbi.nlm.nih.gov/20616382/}{
#' Willer et al. 2010, Bioinformatics}
#' }
#'
#' \item{"sum" : \cr}{
#' \eqn{N = N_CAS + N_CON}\cr
#' Simple summation of cases and controls
#'  that does not account for class imbalance.
#'  }
#'
#' \item{"\\<integer\\>" : \cr}{
#' \code{N = \\<integer\\>}\cr
#' If method is a positive integer, it will be used as N
#' for every row.
#' }
#'
#' }
#'
#' @param force_new If "Neff" (or "N") already exists in \code{sumstats_dt},
#' replace it with the recomputed version.
#' @param append_method_name should Neff column have an indicator to explain the
#' method that makes it., Default is FALSE unless multiple methods are passed
#'
#' @return A data.table with a new column "Neff" or "N"
#' @keywords internal
compute_sample_size <- function(sumstats_dt,
                                method = c("ldsc", "giant", "metal", "sum"),
                                force_new = FALSE,
                                append_method_name = FALSE) {
    if (is.character(method)) {
        #### Compute Neff/N ###
        compute_sample_size_neff(
            sumstats_dt = sumstats_dt,
            method = method,
            force_new = force_new,
            append_method_name = append_method_name
        )
    } else if (is.numeric(method)) {
        #### Add user-supplied N ###
        compute_sample_size_n(
            sumstats_dt = sumstats_dt,
            method = method,
            force_new = force_new
        )
    } else {
        all_method <- c("ldsc", "giant", "metal", "sum", "<integer>")
        msg <- paste0(
            "Warning: method must be one of:\n",
            paste0(" - ", all_method, collapse = "\n")
        )
        message(msg)
    }
}

## ----style, echo=FALSE--------------------------------------------------------
knitr::opts_chunk$set(tidy = FALSE,
                      message = FALSE)

## -----------------------------------------------------------------------------
library(MungeSumstats)

## ----eval=FALSE---------------------------------------------------------------
# #### Search for datasets ####
# metagwas <- MungeSumstats::find_sumstats(traits = c("parkinson","alzheimer"),
#                                          min_sample_size = 1000)
# head(metagwas,3)
# ids <- (dplyr::arrange(metagwas, nsnp))$id

## ----echo=FALSE---------------------------------------------------------------
#### Search for datasets ####
#error_dwnld <-
#            tryCatch(
#              metagwas <- MungeSumstats::find_sumstats(traits = c("parkinson",
#                                                                  "alzheimer"), 
#                                         min_sample_size = 1000),
#            error = function(e) e,
#            warning = function(w) w
#            )
#if(exists("metagwas")&&is.data.frame(metagwas)){#if exists downloaded fine
#  head(metagwas,3)
#  ids <- (dplyr::arrange(metagwas, nsnp))$id  
#}

#to speed up build just create results
metagwas2 <- 
    data.frame(
        id=c("ieu-a-298","ieu-b-2","ieu-a-297"),
        trait = rep("Alzheimer's disease",3),
        group_name = rep("public",3),
        year=c(2013, 2019, 2013),
        author=c("Lambert","Kunkle BW","Lambert"),
        consortium=c("IGAP",
                     "Alzheimer Disease Genetics Consortium (ADGC), European Alzheimer's Disease Initiative (EADI), Cohorts for Heart and Aging Research in Genomic Epidemiology Consortium (CHARGE), Genetic and Environmental Risk in AD/Defining Genetic, Polygenic and Environmental Risk for Alzheimer's Disease Consortium (GERAD/PERADES),",
                     "IGAP" ),
        sex=rep("Males and Females",3),
        population=rep("European",3),
        unit=c("log odds","NA","log odds"),
        nsnp=c(11633,10528610,7055882),
        sample_size=c(74046,63926,54162),
        build=rep("HG19/GRCh37",3),
        category=c("Disease","Binary","Disease"),
        subcategory=rep("Psychiatric / neurological",3),
        ontology=rep("NA",3),
        mr=rep(1,3),
        priority=c(1,0,2),
        pmid=c(24162737,30820047,24162737),
        sd=rep(NA,3),
        note=c("Exposure only; Effect allele frequencies are missing; forward(+) strand",
               "NA","Effect allele frequencies are missing; forward(+) strand"),
        ncase=c(25580,21982,17008),
        ncontrol=c(48466,41944,37154),
        N=c(74046,63926,54162)
    )
print(head(metagwas2,3))

## ----eval=FALSE---------------------------------------------------------------
# ### By ID and sample size
# metagwas <- find_sumstats(
#   ids = c("ieu-b-4760", "prot-a-1725", "prot-a-664"),
#   min_sample_size = 5000
# )

## ----eval=FALSE---------------------------------------------------------------
# datasets <- MungeSumstats::import_sumstats(ids = "ieu-a-298",
#                                            ref_genome = "GRCH37")

## ----echo=FALSE---------------------------------------------------------------
#don't actually run as this takes some time, use stashed version
datasets <- list("ieu-a-298"=paste0(tempdir(),"/ieu-a-298.tsv.gz"))
#stashed value
datasets_data <- list("ieu-a-298"=system.file("extdata","ieu-a-298.tsv.gz",
                                                package="MungeSumstats"))


## -----------------------------------------------------------------------------
print(datasets)

## -----------------------------------------------------------------------------
results_df <- data.frame(id=names(datasets), 
                         path=unlist(datasets))
print(results_df)

## ----eval=FALSE---------------------------------------------------------------
# datasets <- MungeSumstats::import_sumstats(ids = ids,
#                                            vcf_download = TRUE,
#                                            download_method = "axel",
#                                            nThread = max(2,future::availableCores()-2))

## -----------------------------------------------------------------------------
utils::sessionInfo()

#' Ensure that SNP ids don't have multiple rs ids on one line
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and the log file list.
#' @keywords internal
#' @importFrom data.table :=
check_multi_rs_snp <- function(sumstats_dt, path, remove_multi_rs_snp,
                               imputation_ind, log_folder_ind, check_save_out,
                               tabix_index, nThread, log_files) {
    SNP <- convert_multi_rs_SNP <- NULL
    message("Checking for multiple RSIDs on one row.")
    col_headers <- names(sumstats_dt)
    # check for "rs1234;rs5678","rs1234,rs5678","rs1234_rs5678","rs1234-rs5678"
    # "rs1234-rs5678" should also deal with a space in each of the above
    if (sum("SNP" %in% col_headers) == 1 &&
        (sum(grepl("[[:punct:]]rs", sumstats_dt$SNP)) > 0) ||
        (sum(grepl("[[:punct:]] rs", sumstats_dt$SNP)) > 0)) {
        if (!remove_multi_rs_snp) { # take first
            msg <- paste0(
                formatC((sum(grepl("[[:punct:]]rs", sumstats_dt$SNP)) +
                    sum(grepl("[[:punct:]] rs", sumstats_dt$SNP))),
                big.mark = ","
                ),
                " SNPs found with ",
                "multiple RSIDs on one row, the first will be ",
                "taken. If you would rather remove these SNPs set\n",
                "`remove_multi_rs_snp=TRUE`."
            )
            message(msg)
            # if user specifies add a column to notify of the imputation
            if (imputation_ind) {
                sumstats_dt[
                    grepl("[[:punct:]]rs", SNP),
                    convert_multi_rs_SNP := TRUE
                ]
                sumstats_dt[
                    grepl("[[:punct:]] rs", SNP),
                    convert_multi_rs_SNP := TRUE
                ]
            }
            sumstats_dt[
                grepl("[[:punct:]]rs", SNP),
                SNP := gsub("([[:punct:]])rs.*", "", SNP)
            ]
            sumstats_dt[
                grepl("[[:punct:]] rs", SNP),
                SNP := gsub("([[:punct:]]) rs.*", "", SNP)
            ]
        } else { # remove rows
            msg <- paste0(
                sum(grepl("_rs", sumstats_dt$SNP)), " SNPs found with",
                " multiple RSIDs on one row, these will be ",
                "removed. If you would rather take the first RS ID ",
                "set\n`remove_multi_rs_snp`=FALSE"
            )
            # If user wants log, save it to there
            if (log_folder_ind) {
                name <- "snp_multi_rs_one_row"
                name <- get_unique_name_log_file(
                    name = name,
                    log_files = log_files
                )
                write_sumstats(
                    sumstats_dt =
                        sumstats_dt[grepl("[[:punct:]]rs", SNP) |
                            grepl("[[:punct:]] rs", SNP), ],
                    save_path =
                        paste0(
                            check_save_out$log_folder,
                            "/", name,
                            check_save_out$extension
                        ),
                    sep = check_save_out$sep,
                    #don't tab indx as could be miss values & cause err
                    #tabix_index = tabix_index,
                    nThread = nThread
                )
                log_files[[name]] <-
                    paste0(
                        check_save_out$log_folder, "/", name,
                        check_save_out$extension
                    )
            }
            message(msg)
            sumstats_dt <- sumstats_dt[!(grepl("[[:punct:]]rs", SNP) |
                grepl("[[:punct:]] rs", SNP)), ]
        }

        return(list(
            "sumstats_dt" = sumstats_dt,
            "log_files" = log_files
        ))
    } else {
        return(list(
            "sumstats_dt" = sumstats_dt,
            "log_files" = log_files
        ))
    }
}

#' Ensure that no columns are duplicated
#'
#' @param sumstats_dt data table obj of the summary statistics file for the GWAS
#' @param path Filepath for the summary statistics file to be formatted
#' @return list containing sumstats_dt, the modified
#' summary statistics data table object
#' @keywords internal
check_dup_col <- function(sumstats_dt, path) {
    message("Checking for duplicate columns.")
    col_headers <- names(sumstats_dt)
    if (sum(duplicated(col_headers)) > 0) {
        msg <- paste0(
            "There are ", sum(duplicated(col_headers)),
            " duplicated columns which will be removed."
        )
        message(msg)
        notDup <- which(!duplicated(col_headers))
        sumstats_dt <- sumstats_dt[, notDup, with = FALSE]
        return(list("sumstats_dt" = sumstats_dt))
    } else {
        return(list("sumstats_dt" = sumstats_dt))
    }
}

#' Remove non-biallelic SNPs
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return A list containing two data tables:
#' \itemize{
#'   \item \code{sumstats_dt}: the modified summary statistics data table object
#'   \item \code{rsids}: snpsById, filtered to SNPs of interest
#'   if loaded already. Or else \code{NULL}.
#'   \item \code{log_files}: log file list
#' }
#' @keywords internal
#' @importFrom data.table setDT
#' @importFrom data.table setkey
#' @importFrom data.table :=
#' @importFrom data.table copy
#' @importFrom Biostrings IUPAC_CODE_MAP
check_bi_allelic <-
    function(sumstats_dt, path, ref_genome, bi_allelic_filter, rsids,
             log_folder_ind, check_save_out, tabix_index, nThread, log_files,
             dbSNP,dbSNP_tarball) {
        CHR <- alleles_as_ambig <- SNP <- NULL
        # If SNP present and user specified to remove
        col_headers <- names(sumstats_dt)
        if ("SNP" %in% col_headers && !isFALSE(bi_allelic_filter)) {
            message("Checking for bi-allelic SNPs.")
            if (is.null(rsids)) {
                rsids <- load_ref_genome_data(
                    data.table::copy(sumstats_dt$SNP),
                    ref_genome,
                    dbSNP = dbSNP,
                    dbSNP_tarball = dbSNP_tarball
                )
            }
            # get chars for SNPs not bi/tri allelic
            # or strand ambig from IUPAC_CODE_MAP
            nonambig_IUPAC_CODE_MAP <-
                names(Biostrings::IUPAC_CODE_MAP[nchar(
                    Biostrings::IUPAC_CODE_MAP
                ) < 3])
            # ensure rsids is up-to-date with filtered sumstats_dt
            rsids <- rsids[unique(sumstats_dt$SNP), , nomatch = NULL]
            data.table::setkey(rsids, SNP)
            num_bad_ids <- nrow(
                rsids[!alleles_as_ambig %in% nonambig_IUPAC_CODE_MAP]
            )
            # check for SNPs not on ref genome
            if (num_bad_ids > 0) {
                msg <- paste0(
                    formatC(num_bad_ids, big.mark = ","),
                    " SNPs are non-biallelic.",
                    " These will be removed."
                )
                message(msg)
                # join using SNP
                data.table::setkey(sumstats_dt, SNP)
                keep_snps <- rsids[
                    alleles_as_ambig %in% nonambig_IUPAC_CODE_MAP
                ]$SNP
                # remove rows not bi-allelic
                # If user wants log, save it to there
                if (log_folder_ind) {
                    name <- "snp_bi_allelic"
                    name <- get_unique_name_log_file(
                        name = name,
                        log_files = log_files
                    )
                    write_sumstats(
                        sumstats_dt = sumstats_dt[!keep_snps, ],
                        save_path =
                            paste0(
                                check_save_out$log_folder,
                                "/", name,
                                check_save_out$extension
                            ),
                        sep = check_save_out$sep,
                        #don't tab indx as could be miss values & cause err
                        #tabix_index = tabix_index,
                        nThread = nThread
                    )
                    log_files[[name]] <-
                        paste0(
                            check_save_out$log_folder, "/", name,
                            check_save_out$extension
                        )
                }
                sumstats_dt <- sumstats_dt[keep_snps, ]
            }
            return(list(
                "sumstats_dt" = sumstats_dt, "rsids" = rsids,
                "log_files" = log_files
            ))
        } else {
            return(list(
                "sumstats_dt" = sumstats_dt, "rsids" = rsids,
                "log_files" = log_files
            ))
        }
    }

#' Ensure that the p values are not >1 and if so set to 1
#'
#' @param sumstats_dt data table obj of the summary statistics file for the GWAS
#' @inheritParams format_sumstats
#' @source 
#' \code{
#' sumstats_dt <- MungeSumstats:::formatted_example()
#' sumstats_dt$P[1:3] <- 5
#' sumstats_dt$P[6:10] <- -5
#' sumstats <- check_range_p_val(sumstats_dt = sumstats_dt, 
#'                               convert_large_p = TRUE,
#'                               convert_neg_p = TRUE, 
#'                               imputation_ind = TRUE)

#' }
#' @returns list containing sumstats_dt, 
#' the modified summary statistics data table object
#' @keywords internal
#' @importFrom data.table :=
check_range_p_val <- function(sumstats_dt, 
                              convert_large_p,
                              convert_neg_p,
                              imputation_ind) {
    
    P <- convert_large_p_1 <- convert_neg_p_0 <- NULL
    # Sometimes the N column is not all integers... so round it up
    col_headers <- names(sumstats_dt)
    if ("P" %in% col_headers) {
        #### Ensure column is numeric ####
        sumstats_dt[,P:=as.numeric(P)] 
        
        #### Check for p-vals >1 ####
        large_bool <- sumstats_dt$P > 1
        large_n <- sum(large_bool, na.rm = TRUE)
        if (large_n > 0) {
            msg <- paste0(
                formatC(large_n, big.mark = ","),
                " p-values are >1 which ",
                "LDSC/MAGMA may not be able to handle. "
            ) 
            #### Convert p-values >1 to 1 ####
            if(convert_large_p){
                msg2 <- paste0(msg, "These will be converted to 1.")
                message(msg2) 
                # if users want edited snps, return information
                if (imputation_ind) {
                    sumstats_dt[large_bool, convert_large_p_1 := TRUE]
                }
                sumstats_dt[large_bool, P := 1]
            } else {
                msg2 <- paste0(msg, "These will NOT be converted.")
                message(msg2)
            } 
        }
        
        
        #### Check for p-vals <1 ####
        neg_bool <- sumstats_dt$P < 0
        neg_n <- sum(neg_bool, na.rm = TRUE)
        if (neg_n > 0) {
            msg3 <- paste0(
                formatC(neg_n, big.mark = ","),
                " p-values are <0 which ",
                "LDSC/MAGMA may not be able to handle. "
            ) 
            #### Convert p-values <0 to 0 ####
            if(convert_neg_p){
                msg4 <- paste0(msg3, "These will be converted to 0.")
                message(msg4) 
                # if users want edited snps, return information
                if (imputation_ind) {
                    sumstats_dt[neg_bool, convert_neg_p_0 := TRUE]
                }
                sumstats_dt[neg_bool, P := 0]
            } else {
                msg2 <- paste0(msg3, "These will NOT be converted.")
                message(msg2)
            } 
        }
    } 
    return(list("sumstats_dt" = sumstats_dt))
}

test_that("check_range_p_val works", {
    
    sumstats_dt <- MungeSumstats:::formatted_example()
    range1 <- 1:3
    range2 <- 6:10
    sumstats_dt$P[range1] <- 5
    sumstats_dt$P[range2] <- -5
    range_n <- length(range1) + length(range2)
    sumstats <- check_range_p_val(sumstats_dt = sumstats_dt,
                                  convert_large_p = TRUE,
                                  convert_neg_p = TRUE,
                                  imputation_ind = TRUE)
    testthat::expect_true(
        "convert_large_p_1" %in% colnames(sumstats$sumstats_dt))
    testthat::expect_equal(
        sum(sumstats$sumstats_dt$convert_large_p_1,na.rm = TRUE),
        length(range1))
    
    testthat::expect_true(
        "convert_neg_p_0" %in% colnames(sumstats$sumstats_dt))
    testthat::expect_equal(
        sum(sumstats$sumstats_dt$convert_neg_p_0,na.rm = TRUE),
        length(range2))
})

#' downloader wrapper
#'
#' R wrapper for 
#' \href{https://github.com/axel-download-accelerator/axel}{axel} 
#' (multi-threaded) and
#'  \link[utils]{download.file} (single-threaded) 
#'  download functions.
#' @source \href{https://stackoverflow.com/a/66602496/13214824}{
#' Suggestion to avoid 'proc$get_built_file() : Build process failed'}
#'
#' @return Local path to downloaded file.
#'
#' @param input_url input_url.
#' @param output_path output_path.
#' @param download_method \code{"axel"} (multi-threaded) or
#' \code{"download.file"} (single-threaded) .
#' @param background Run in background
#' @param force_overwrite Overwrite existing file.
#' @param quiet Run quietly.
#' @param show_progress show_progress.
#' @param continue continue.
#' @param nThread Number of threads to parallelize over.
#' @param alternate alternate,
#' @param check_certificates check_certificates
#' @param timeout How many seconds before giving up on download.
#' Passed to \code{download.file}. Default: \code{10*60} (10min).
#' @family downloaders
#' @keywords internal
downloader <- function(input_url,
                       output_path,
                       download_method = "axel",
                       background = FALSE,
                       force_overwrite = FALSE,
                       quiet = TRUE,
                       show_progress = TRUE,
                       continue = TRUE,
                       nThread = 1,
                       alternate = TRUE,
                       check_certificates = TRUE,
                       # conda_env=NULL,
                       timeout = 10*60) {
    if (download_method == "axel") {
        axel_avail <- length(system("which axel", intern = TRUE)) != 0
        if (axel_avail) {
            out_file <- axel(
                input_url = input_url,
                output_path = output_path,
                background = background,
                nThread = nThread,
                force_overwrite = force_overwrite,
                quiet = quiet, # output is hella long otherwise...
                alternate = alternate,
                # conda_env=conda_env,
                check_certificates = check_certificates
            )
            if (!file.exists(out_file)) {
                message("axel download failed. Trying with download.file.")
                download_method <- "download.file"
            }
        } else {
            messager(
                "Please install axel first.\n",
                "- MacOS: brew install axel",
                "- Linux: sudo apt-get update && sudo apt-get install axel"
            )
            messager("Defaulting to download.file")
            download_method <- "download.file"
        }
    }
    if (download_method == "download.file") {
        messager("Downloading with download.file.")
        options(timeout = timeout)
        out_file <- file.path(output_path, basename(input_url))
        catch_fail <- tryCatch({
                utils::download.file(url = input_url, 
                                     destfile = out_file)
        },
            error = function(e) {message(e);e}
        )
        msg <- paste(
            "Failed to download:", input_url,
            "\nThis is likely due to either an incorrect ID/URL,",
            "or an issue with your internet connection."
        )
        #### 2nd attempt ###
        if (methods::is(catch_fail, "error") | 
            methods::is(catch_fail, "warning")) { 
            messager("Trying download.file again with different parameters.")
            catch_fail2 <- tryCatch({
                utils::download.file(url = input_url, 
                                     destfile = out_file,
                                     mode = 'wb',
                                     method = 'curl',
                                     extra = '-k')
            },
            error = function(e) {message(e);e}
            )
            
            if (methods::is(catch_fail2, "error") | 
                methods::is(catch_fail2, "warning")) {
                stop(msg)
            }
        }
        
    }
    return(out_file)
}

#' Ensure valid tabular format
#'
#' @param header The summary statistics file for the GWAS
#' @return Whether the file is tabular
#' @keywords internal
check_tabular <- function(header) {
    ### If data.table can read in the header properly, 
    # it can read in the rest of the file.
    if(is(header,"data.frame")){
        row_of_data <- colnames(header)
    } else {
        row_of_data <- colnames(data.table::fread(text = header))
    } 
    # check if readLines picked up headers as single char
    is_tabular <- length(row_of_data) != 1
    if (is_tabular) message("Tabular format detected.")
    return(is_tabular)
}

test_that("Check that a file is in tabular format", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        ### read data
        path <- 
            system.file("extdata", "eduAttainOkbay.txt", 
                            package = "MungeSumstats")
        sumstats_dt <- data.table::fread(path, nThread = 1)
        ### Test tsv
        header <- read_header(path = path)
        is_tabular_tsv <- check_tabular(header = header)
        ### Test csv
        path_csv <- tempfile()
        data.table::fwrite(sumstats_dt, path_csv, sep = ",")
        header <- read_header(path = path_csv)
        is_tabular_csv <- check_tabular(header = header)
        #### Test space-separated
        path_space <- tempfile()
        data.table::fwrite(sumstats_dt, path_space, sep = " ")
        header <- read_header(path = path_space)
        is_tabular_space <- check_tabular(header = header)
        expect_equal(all.equal(is_tabular_tsv, is_tabular_csv, 
                                is_tabular_space), TRUE)
    }    
    else{
        expect_equal(TRUE, TRUE)
    }
})

#' List munged summary statistics
#' 
#' Searches for and lists local GWAS summary statistics files munged by 
#' \link[MungeSumstats]{format_sumstats} or 
#' \link[MungeSumstats]{import_sumstats}.
#' 
#' @param save_dir Top-level directory to recursively search 
#' for summary statistics files within.
#' @param pattern Regex pattern to search for files with.
#' @param ids_from_file Try to extract dataset IDs from file names.
#' If \code{FALSE}, will infer IDs from the directory names instead.
#' @param verbose Print messages.
#' 
#' @returns Named vector of summary stats paths.
#' 
#' @examples
#' save_dir <- system.file("extdata",package = "MungeSumstats")
#' munged_files <- MungeSumstats::list_sumstats(save_dir = save_dir)
#' 
#' @export
#' @importFrom stats setNames
list_sumstats <- function(save_dir = getwd(),
                          pattern = "*.tsv.gz$",
                          ids_from_file = TRUE,
                          verbose = TRUE){ 
    munged_files <- list.files(path = save_dir,
                               pattern = pattern,
                               full.names = TRUE, 
                               recursive = TRUE)
    #### Exclude log files ####
    munged_files <- munged_files[basename(dirname(munged_files))!="logs"] 
    #### infer IDs ####
    if(ids_from_file){
        ids <- gsub(paste(supported_suffixes(),collapse = "|"), "",
                    basename(munged_files))
    }else {
        ids <- basename(dirname(munged_files))
    }
    #### Report ####
    messager(length(munged_files),"file(s) found.",v=verbose)
    return(stats::setNames(munged_files,ids))
}

#' Ensure all SNPs have frq score above threshold
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and the log file list
#' @keywords internal
check_frq <- function(sumstats_dt, path, FRQ_filter, log_folder_ind,
                      check_save_out, tabix_index, nThread, log_files) {
    FRQ <- NULL
    col_headers <- names(sumstats_dt)
    if ("FRQ" %in% col_headers && FRQ_filter > 0) {
        message("Filtering SNPs based on FRQ.")
        # use data table for speed
        num_bad_ids <- nrow(sumstats_dt[FRQ < FRQ_filter, ])
        if (num_bad_ids > 0) {
            msg <- paste0(
                formatC(num_bad_ids, big.mark = ","), " SNPs",
                " are below the FRQ threshold of ", FRQ_filter,
                " and will be removed."
            )
            message(msg)
            # If user wants log, save it to there
            if (log_folder_ind) {
                name <- "frq_filter"
                name <- get_unique_name_log_file(
                    name = name,
                    log_files = log_files
                )
                write_sumstats(
                    sumstats_dt = sumstats_dt[FRQ < FRQ_filter, ],
                    save_path =
                        paste0(
                            check_save_out$log_folder,
                            "/", name,
                            check_save_out$extension
                        ),
                    sep = check_save_out$sep,
                    #don't tab indx as could be miss values & cause err
                    #tabix_index = tabix_index,
                    nThread = nThread
                )
                log_files[[name]] <-
                    paste0(
                        check_save_out$log_folder, "/", name,
                        check_save_out$extension
                    )
            }
            sumstats_dt <- sumstats_dt[FRQ >= FRQ_filter, ]
        }
        return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
    } else {
        return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
    }
}

#' Sort sum stats
#' 
#' Sort summary statistics table by genomic coordinates.
#' @param sumstats_dt \link[data.table]{data.table} obj of the
#'  summary statistics file for the GWAS.
#' @param sort_coords Whether to sort by coordinates.
#' @param sort_method Method to sort coordinates by: 
#' \itemize{
#' \item{"data.table" (default)}{Uses \link[data.table]{setorderv},
#'  which is must faster than "GenomicRanges" 
#'  but less robust to variations in some sum stats files.}
#' \item{"GenomicRanges"}{Uses \link[GenomicRanges]{sort.GenomicRanges},
#'  which is more robust to variations in sum stats files
#'   but much slower than the "data.table" method.}
#' }
#' @returns Sorted sumstats_dt
#' 
#' @keywords internal
#' @importFrom data.table :=
sort_coords <- function(sumstats_dt,
                        sort_coordinates = TRUE, 
                        sort_method=c("data.table","GenomicRanges")) {
  ### Add this to avoid confusing BiocCheck
  CHR <- NULL
  if (isTRUE(sort_coordinates)) {
    #### Report ####
    sort_method <- sort_method[1]
    messager("Sorting coordinates with",paste0(shQuote(sort_method),".")) 
    ### Double check that X and Y are uppercase
    sumstats_dt[, CHR := gsub("x|23", "X", CHR)]
    sumstats_dt[, CHR := gsub("y", "Y", CHR)]
    sumstats_dt[, CHR := gsub("mt", "MT", CHR)]
    #### Sort ####
    if(sort_method=="data.table"){
      sumstats_dt <- sort_coords_datatable(sumstats_dt = sumstats_dt)   
    } else if (sort_method=="GenomicRanges"){
      sumstats_dt <- sort_coord_genomicranges(sumstats_dt = sumstats_dt)   
    }
    ### Now set CHR back to character to avoid issues 
    # when merging with other dts
    sumstats_dt[,CHR:=as.character(CHR)]
  }
  return(sumstats_dt)
}

#' Ensure all rows are unique based on SNP,CHR,BP,A1,A2, drop those that aren't
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and log files list
#' @keywords internal
#' @importFrom data.table key
#' @importFrom data.table setkey
check_dup_row <- function(sumstats_dt,
                          check_dups,
                          path,
                          log_folder_ind,
                          check_save_out,
                          tabix_index,
                          nThread,
                          log_files) {
  BP <- CHR <- A1 <- A2 <- SNP <- NULL
  col_headers <- names(sumstats_dt)
  #just check for duplicates across all columns or those would need to be 
  #unique
  #This check is fine for Indels and non-bi-allelic SNPs
  dup_cols <- col_headers
  if(sum(c("SNP","CHR","BP","A1","A2") %in% col_headers) == 5)
    dup_cols <- c("SNP","CHR","BP","A1","A2")
  message("Checking for duplicated rows.")
  # Try to remove duplicated Positions
  data.table::setkeyv(sumstats_dt, dup_cols)
  dups <- duplicated(sumstats_dt, by = data.table::key(sumstats_dt))
  if (sum(dups) > 0 & check_dups) {
    msg <- paste0(
      formatC(sum(dups), big.mark = ","),
      " sumstat rows are",
      " duplicated. These duplicates will",
      " be removed."
    )
    message(msg)
    # If user wants log, save it to there
    if (log_folder_ind) {
      name <- "dup_row"
      name <- get_unique_name_log_file(
        name = name,
        log_files = log_files
      )
      write_sumstats(
        sumstats_dt = sumstats_dt[dups, ],
        save_path =
          paste0(
            check_save_out$log_folder,
            "/", name,
            check_save_out$extension
          ),
        sep = check_save_out$sep,
        #don't tab indx as could be miss values & cause err
        #tabix_index = tabix_index,
        nThread = nThread
      )
      log_files[[name]] <-
        paste0(
          check_save_out$log_folder, "/",
          name, check_save_out$extension
        )
    }
    sumstats_dt <- unique(sumstats_dt,
                          by = data.table::key(sumstats_dt)
    )
    
    return(list(
      "sumstats_dt" = sumstats_dt,
      "log_files" = log_files
    ))
  }
  else{
    return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
  }
}

#' Send messages to console even from within parallel processes
#' @return A message
#' @keywords internal
message_parallel <- function(...) {
    system(sprintf('echo "%s"', paste0(..., collapse = "")))
}

#' Ensure that the Base-pair column values are all within the range for the 
#' chromosome
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and the log file list
#' @keywords internal
#' @importFrom GenomeInfoDb seqinfo
check_bp_range <- function(sumstats_dt, path, ref_genome,log_folder_ind, 
                         imputation_ind,check_save_out, tabix_index, nThread, 
                         log_files) {
    BP<- chr_max<- CHR <- seqlengths <- .SD <- NULL
    col_headers <- names(sumstats_dt)
    #need CHR to get chrom lengths
    if ("BP" %in% col_headers && "CHR" %in% col_headers) {
        message("Checking for incorrect base-pair positions")
        #load chromosome lengths
        if (toupper(ref_genome) == "GRCH37") {
          genome_info <- 
            seqinfo(BSgenome.Hsapiens.1000genomes.hs37d5::BSgenome.Hsapiens.1000genomes.hs37d5)
        } else { # =="GRCH38"
          genome_info <- 
            seqinfo(BSgenome.Hsapiens.NCBI.GRCh38::BSgenome.Hsapiens.NCBI.GRCh38)
        }
        #mke data.table
        genome_info <-
          cbind(data.table::data.table("CHR"=seqnames(genome_info)),
                data.table::as.data.table(genome_info))
        #convert CHR to char in sumstats (if it is an int)
        sumstats_dt[,CHR:=as.character(CHR)]
        #add chr len to sumstats
        sumstats_dt[genome_info,chr_max:=seqlengths,on="CHR"]
        #ensure BP numeric
        if(!is.integer(sumstats_dt$BP)){
          message("Coercing BP column to numeric.")
          sumstats_dt[,BP:=as.numeric(BP)]
        }  
        #now check if BP value is too large/less than 0
        #s.na(chr_max) in case chr formatting not found
        bad_bp <- sumstats_dt[!is.na(chr_max) & (is.na(BP)|BP<=0 |BP>chr_max),]
        if (nrow(bad_bp)>0){
          message(nrow(bad_bp)," SNPs have been removed as their BP column is ",
                  "not in the range of 1 to the length of the chromosome")
          if (log_folder_ind){
            name <- "bad_bp"
            name <- get_unique_name_log_file(name = name,
                                             log_files = log_files)
            write_sumstats(
              sumstats_dt =
                bad_bp,
              save_path =
                paste0(
                  check_save_out$log_folder,
                  "/", name,
                  check_save_out$extension
                ),
              sep = check_save_out$sep,
              #don't tab indx as could be miss values & cause err
              #tabix_index = tabix_index,
              nThread = nThread
            )
            log_files[[name]] <-
              paste0(check_save_out$log_folder, "/",
                     name, check_save_out$extension)
          }
          
          # update actual
          sumstats_dt <- sumstats_dt[!is.na(BP) & BP>0 & 
                                       (BP<=chr_max | is.na(chr_max)),]
        }
        #check is doen remove column
        sumstats_dt[,chr_max:=NULL]
    }
    
    return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
}

#' Example logs file
#' 
#' Example logs file produced by \link[MungeSumstats]{format_sumstats}.
#' 
#' @param read Whether to read the logs file into memory. 
#' @source 
#' \code{
#' eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
#'                                  package = "MungeSumstats")
#' sumstats_dt <- data.table::fread(eduAttainOkbayPth)
#' #### Introduce values that need to be fixed ####
#' sumstats_dt$Pval[10:15] <- 5
#' sumstats_dt$Pval[20:22] <- -5
#' sumstats_dt$Pval[23:25] <- "5e-324"
#' ss_path <- tempfile()
#' data.table::fwrite(sumstats_dt, ss_path)
#' log_folder <- tempdir()
#' reformatted <- MungeSumstats::format_sumstats(
#'     path = ss_path,
#'     ref_genome = "GRCh37",
#'     log_folder = log_folder,
#'     log_mungesumstats_msgs = TRUE,
#'     log_folder_ind = TRUE,
#' )
#' file.copy(reformatted$log_files$MungeSumstats_log_msg,
#'           "inst/extdata",overwrite = TRUE)
#' }
#' @returns Path to logs file.
#' @keywords internal
logs_example <- function(read = FALSE){ 
    logs_path <- system.file("extdata/MungeSumstats_log_msg.txt",
                             package = "MungeSumstats")
    if(read){
        l <- readLines(logs_path)
        return(l)
    } else {
        return(logs_path)
    } 
}

#' Ensure A1 and A2 are upper case
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and the log file list
#' @keywords internal
make_allele_upper <- function(sumstats_dt, log_files) {
    A1 <- A2 <- NULL
    col_headers <- names(sumstats_dt)
    
    if ("A1" %in% col_headers) {
        message("Checking A1 is uppercase")
        sumstats_dt[, A1:=toupper(A1)]
    }
    if ("A2" %in% col_headers) {
        message("Checking A2 is uppercase")
        sumstats_dt[, A2:=toupper(A2)]
    }
    
    return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
}

#' Parse "Summary statistics report" metrics 
#' 
#' Support function for \link[MungeSumstats]{parse_logs}.
#' 
#' @param l Lines of text from log file.
#' 
#' @return Numeric
#' @keywords internal
parse_report <- function(l, 
                         entry = 1,
                         line = 1){
    report_lines <- grep("Summary statistics report:",l)
    if(length(report_lines)<2 && entry!=1) return(NA)
    as.integer(
        gsub(",","",
             strsplit(
                 trimws(
                     l[report_lines+line][entry]
                 ),
                 " ")[[1]][2]
        )
    )
}

#' Print messages
#'
#' Print messages with option to silence.
#'
#' @param ... Message input.
#' @param v Whether to print messages.
#' 
#' @return Null output.
#'
#' @keywords internal
messager <- function(..., v = TRUE) {
    if (v) {
        msg <- paste(...)
        message(msg)
    }
}

#' GenomicRanges to data.table
#' 
#' Convert a \link[GenomicRanges]{GRanges} into a \link[data.table]{data.table}.
#' @param gr A \link[GenomicRanges]{GRanges} object.
#' 
#' @return A data.table object.
#' @source 
#' \href{https://rdrr.io/github/databio/GenomicDistributions/src/R/utility.R}{
#' Code adapted from GenomicDistributions.}
#' @keywords internal
#' @importFrom GenomicRanges seqnames start end elementMetadata
#' @importFrom data.table data.table
granges_to_dt  <- function(gr) {
    if(is.null(gr)) return(gr)
    #### Convert metadata ####
    DF <- GenomicRanges::elementMetadata(gr)
    #### Combine metadata with ranges data ####
    if( ncol(DF) > 0) { 
        meta <- DF_to_dt(DF = DF)
        DT <- data.table::data.table(
            chr=as.vector(GenomicRanges::seqnames(gr)), 
            start=GenomicRanges::start(gr),
            end=GenomicRanges::end(gr), 
            meta)
    } else {
        DT <- data.table::data.table(
            chr=as.vector(GenomicRanges::seqnames(gr)),
            start=GenomicRanges::start(gr),
            end=GenomicRanges::end(gr))
    }
    DT <- check_numeric(DT)
    return(DT)
}

#' Ensure all SNPs have info score above threshold
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations. 
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and the log file list
#' @keywords internal
check_info_score <- function(sumstats_dt,
                             INFO_filter, 
                             log_folder_ind,
                             check_save_out, 
                             tabix_index, 
                             nThread, 
                             log_files) {
    INFO <- NULL
    col_headers <- names(sumstats_dt)
    if ("INFO" %in% col_headers && INFO_filter > 0) {
        msg1 <- "Filtering SNPs based on INFO score."
        message(msg1)
        # use data table for speed
        num_bad_ids <- nrow(sumstats_dt[INFO < INFO_filter, ])
        if (num_bad_ids > 0) {
            msg2 <- paste0(
                formatC(num_bad_ids, big.mark = ","), " SNPs",
                " are below the INFO threshold of ", INFO_filter,
                " and will be removed."
            )
            message(msg2)
            #### If user wants log, save it to there ####
            if (log_folder_ind) {
                log_out <- check_info_score_log(sumstats_dt=sumstats_dt,
                                                log_files=log_files,
                                                INFO_filter=INFO_filter,
                                                check_save_out=check_save_out,
                                                tabix_index=tabix_index,
                                                nThread=nThread)
                sumstats_dt <- log_out$sumstats_dt
                log_files <- log_out$log_files
            }
            sumstats_dt <- sumstats_dt[INFO >= INFO_filter, ]
        } else {
            msg2b <- paste0("All rows have INFO>=",INFO_filter)
            message(msg2b)
        }
    } else {
        if(!"INFO" %in% col_headers){
            msg3 <- "INFO column not available. Skipping INFO score filtering step."
            message(msg3)
        } else if (INFO_filter == 0){
            msg3 <- "INFO_filter==0. Skipping INFO score filtering step."
            message(msg3)
        }  
    }
    return(list("sumstats_dt" = sumstats_dt,
                "log_files" = log_files))
}

test_that("check_info_score works", {
    
    sumstats_dt <- MungeSumstats::formatted_example()  
    ### Make fake INFO score ####
    sumstats_dt$INFO <- rep(c(1,.95,.8,0), ceiling(nrow(sumstats_dt)/4))[
        seq_len(nrow(sumstats_dt))
    ]
    #### Make fake check_save_out list ####
    check_save_out <- list(sep="\t",
                           extension=".tsv.gz",
                           log_folder=tempdir())
    log_files <- list(
        MungeSumstats_log_msg=file.path(tempdir(),
                                        "MungeSumstats_log_msg.txt"),
        MungeSumstats_log_output=file.path(tempdir(),
                                           "MungeSumstats_log_output.txt"))
    
    #### INFO_filter=.9  ####
    sumstats <- MungeSumstats:::check_info_score(sumstats_dt=sumstats_dt, 
                                                 INFO_filter=.9,
                                                 log_folder_ind=TRUE,
                                                 check_save_out=check_save_out, 
                                                 tabix_index=FALSE, 
                                                 nThread=1, 
                                                 log_files=log_files) 
    testthat::expect_equal(names(sumstats),c( "sumstats_dt","log_files" )) 
    testthat::expect_equal(nrow(sumstats$sumstats_dt),47)
    testthat::expect_lt(nrow(sumstats$sumstats_dt), nrow(sumstats_dt))
    dropped_snps <- data.table::fread(sumstats$log_files$info_filter)
    testthat::expect_equal(nrow(sumstats_dt) - nrow(dropped_snps), 
                           nrow(sumstats$sumstats_dt))
    
    
    #### INFO_filter=0  ####
    sumstats <- MungeSumstats:::check_info_score(sumstats_dt=sumstats_dt, 
                                                 INFO_filter=0,
                                                 log_folder_ind=TRUE,
                                                 check_save_out=check_save_out, 
                                                 tabix_index=FALSE, 
                                                 nThread=1, 
                                                 log_files=log_files) 
    testthat::expect_equal(names(sumstats),c( "sumstats_dt","log_files" )) 
    testthat::expect_equal(sumstats$sumstats_dt,sumstats_dt)  
    
    #### All INFO==1  ####
    sumstats_dt$INFO <- 1
    sumstats <- MungeSumstats::: check_info_score(sumstats_dt=sumstats_dt, 
                                                  INFO_filter=.9,
                                                  log_folder_ind=TRUE,
                                                  check_save_out=check_save_out, 
                                                  tabix_index=FALSE, 
                                                  nThread=1, 
                                                  log_files=log_files) 
    testthat::expect_equal(names(sumstats),c( "sumstats_dt","log_files" )) 
    testthat::expect_equal(sumstats$sumstats_dt,sumstats_dt)  
})

#' VCF to DF
#' 
#' Function to convert a \pkg{VariantAnnotation}
#'  \code{CollapsedVCF}/\code{ExpandedVCF}
#'  object to a \code{data.frame}. 
#' @param vcf Variant Call Format (VCF) file imported into R 
#' as a \pkg{VariantAnnotation} 
#' \link[VariantAnnotation]{CollapsedVCF}/
#' \link[VariantAnnotation]{ExpandedVCF} object. 
#' @param add_sample_names Append sample names to column names 
#' (e.g. "EZ" --> "EZ_ubm-a-2929").
#' @param add_rowranges Include \code{rowRanges} from VCF as well.
#' @param drop_empty_cols Drop columns that are filled entirely with: 
#' \code{NA}, \code{"."}, or \code{""}. 
#' @param unique_cols Only keep uniquely named columns.
#' @param unique_rows Only keep unique rows.
#' @param unlist_cols If any columns are lists instead of vectors, unlist them.
#' Required to be \code{TRUE} when \code{unique_rows=TRUE}.
#' @param verbose Print messages.
#' @inheritParams check_empty_cols
#' 
#' @source 
#' \href{https://gist.github.com/zhujack/849b75f5a8305edaeca1001dfb9c3fe9}{
#' Original code source}
#' @source {
#' #### vcfR ####
#' if(!require("pinfsc50")) install.packages("pinfsc50")
#' vcf_file <- system.file("extdata", "pinf_sc50.vcf.gz", package = "pinfsc50")
#' vcf <- read.vcfR( vcf_file, verbose = FALSE )
#' vcf_df_list <- vcfR::vcfR2tidy(vcf, single_frame=TRUE)
#' vcf_df <- data.table::data.table(vcf_df_list$dat)
#' }
#' @return data.frame version of VCF 
#' 
#' @export
#' @importFrom utils type.convert 
#' @importFrom data.table as.data.table
#' @importFrom methods slotNames is show
#' @examples   
#' #### VariantAnnotation ####
#' # path <- "https://github.com/brentp/vcfanno/raw/master/example/exac.vcf.gz"
#' path <- system.file("extdata", "ALSvcf.vcf",
#'                     package = "MungeSumstats")
#'                     
#' vcf <- VariantAnnotation::readVcf(file = path)
#' vcf_df <- MungeSumstats:::vcf2df(vcf = vcf)
vcf2df <- function(vcf, 
                   add_sample_names=TRUE,
                   add_rowranges=TRUE,
                   drop_empty_cols=TRUE,
                   unique_cols=TRUE,
                   unique_rows=TRUE,
                   unlist_cols=TRUE,
                   sampled_rows=NULL,
                   verbose=TRUE) {
    requireNamespace("VariantAnnotation")
    requireNamespace("MatrixGenerics")
  
    messager("Converting VCF to data.table.",v=verbose) 
    #### Expand VCF ####
    if (methods::is(vcf,"CollapsedVCF")) {
        messager('Expanding VCF first, so number of rows may increase.',
                 v=verbose)
        ## Not all VCFs work with this function
        vcf <- tryCatch({
            VariantAnnotation::expand(x = vcf)
        }, error = function(e){message(e); vcf})
    }  
    #### Automatically determine whether to add sample names ####
    if(is.null(add_sample_names)){
        header <- VariantAnnotation::header(x = vcf)
        samples <- VariantAnnotation::samples(header)
        add_sample_names <- length(samples)!=1
    } 
    #### .anncols function ####
    .anncols = function(anncol,headerstring) {
        anncols <- strsplit(sub("Functional annotations: '",'',
                               headerstring),' \\| ')[[1]]
        dfannempty <- data.frame(matrix(vector(), 0, length(anncols),
                                       dimnames=list(c(), anncols)),
                                stringsAsFactors=FALSE)
        yy <- data.frame(
            suppressWarnings(
                do.call(
                    rbind,
                    c(dfannempty,lapply(lapply(anncol,`[`,1),
                                        function(x){strsplit(x,'\\|')[[1]]})
                      )
                    )
                ),
            stringsAsFactors=FALSE)
        yy <- data.frame(lapply(yy,type.convert))
        colnames(yy) <- paste("ANN",anncols,sep="_")
        return(yy)
    }
    #### convert to data.table #### 
    t1 <- Sys.time()
    #### Get rowranges only if available ####
    if("rowRanges" %in% methods::slotNames(vcf)){
        gr <- MatrixGenerics::rowRanges(vcf)
    } else {
        gr <- NULL
    }
    df <- data.table::data.table(
        ID = names(gr),
        if(add_rowranges) granges_to_dt(gr = gr) else NULL,
        DF_to_dt(DF = VariantAnnotation::info(vcf)) 
    )
    remove(gr)
    #### Parse ANN column ####
    if('ANN' %in% colnames(df)) {
        dfann <- .anncols(
            anncol = df$ANN,
            headerstring = VariantAnnotation::info(
                VariantAnnotation::header(vcf)
                )['ANN',]$Description
        )
        df <- df[,colnames(df)!="ANN"]
        df <- cbind(df,dfann)
    }
    ##### Convert geno data ##### 
    ## Works better for VCFHeader
    if(methods::is(vcf,"VCFHeader")){
        tmp <- data.table::as.data.table(VariantAnnotation::geno(vcf), 
                                         keep.rownames = "name")
        # tmp <- DF_to_dt(DF = VariantAnnotation::geno(x))    
    } else {
        ## Works better for VCF
        n <- names(VariantAnnotation::geno(vcf))
        #### Avoid parsing redundant columns ####
        if("ID" %in% colnames(df)) n <- n[n!="ID"]
        tmp <- lapply(n,function(col) {
            coldat <- VariantAnnotation::geno(vcf)[[col]]  
            #### Convert 3D matrix --> 2D ####
            ## This sometimes happens by accident with 
            ## VariantAnnotation::writeVcf
            if(length(dim(coldat))==3){
                rn <- rownames(coldat)
                cn <- rep(colnames(coldat), dim(coldat)[3])
                if(length(unique(colnames(coldat)))==1){
                    coldat <- matrix(data = coldat[,,1, drop=FALSE])
                    rownames(coldat) <- rn
                    colnames(coldat) <- cn[1]
                } else {
                    coldat <- matrix(data = coldat,
                           nrow = dim(coldat)[1], 
                           ncol = dim(coldat)[2] * dim(coldat)[3])
                    rownames(coldat) <- rn
                    colnames(coldat) <- cn
                }  
            }
            #### Drop empty columns within each matrix ####
            if(isTRUE(drop_empty_cols)){
                for(i in ncol(coldat)){
                    if(all(is.na(coldat[,i])) || 
                       all(coldat[,i]==".") ||
                       all(coldat[,i]=="")){
                        coldat <- coldat[,-i]
                    }
                }
            } 
            #### Check if empty ####
            if(ncol(coldat)==0 | nrow(coldat)==0){
                return(NULL)
            } else {
                ## keeps colnames unchanged
                data.table::as.data.table(coldat)
            } 
        }) ## end lapply
        
        #### Remove NULL entries ####
        nulls <- unname(unlist(lapply(tmp,is.null)))
        tmp <- tmp[!nulls]
        n <- n[!nulls]
        ## Each element can potentially have >1 column 
        ncols <- unlist(lapply(tmp,ncol))
        tmp <- do.call(cbind, tmp)
        #### Add column names ####
        if(!is.null(tmp)){
            if(isTRUE(add_sample_names)){
                colnames(tmp) = paste(rep(n, times = ncols), 
                                      colnames(tmp),sep = "_") 
            } else {
                colnames(tmp) <- rep(n, times = ncols)
            } 
        }
    } 
    df <- cbind(df, tmp) 
    remove(tmp)
    
    ## ----- Post-processing ----- ####
    #### Only keep unique rows ####
    #### Remove duplicated columns ####
    if(isTRUE(unique_cols)){
        drop_duplicate_cols(dt = df)
    } 
    #### Remove any remaining empty columns #####
    if(isTRUE(drop_empty_cols)){
        remove_empty_cols(sumstats_dt = df,
                          sampled_rows = sampled_rows,
                          verbose = verbose)
    }
    #### Unlist columns inplace ####
    if(isTRUE(unique_rows) && isFALSE(unlist_cols)){
        messager("Must set unlist_cols=TRUE to use unique_rows=TRUE.",
                 "Setting unlist_cols=TRUE.",v=verbose)
        unlist_cols <- TRUE
    }
    if(isTRUE(unlist_cols)){ 
        unlist_dt(dt = df,
                  verbose = verbose)
    } 
    #### Remove duplicated rows #### 
    if(isTRUE(unique_rows)){
        df <- drop_duplicate_rows(dt = df, 
                                  verbose = verbose)
    }  
    #### Report ####
    if(verbose) methods::show(round(difftime(Sys.time(),t1),1))
    messager("VCF data.table contains:",
             formatC(nrow(df),big.mark = ","),"rows x",
             formatC(ncol(df),big.mark = ","),"columns.",
             v=verbose)
    return(df)
}

#' Ensure that CHR:BP aren't merged into 1 column
#'
#' @param sumstats_dt data table obj of the summary statistics
#'  file for the GWAS
#' @param path Filepath for the summary statistics file to be formatted
#' @returns list containing sumstats_dt, the modified summary
#'  statistics data table object
#' @keywords internal
#' @importFrom data.table tstrsplit
#' @importFrom data.table :=
check_two_step_col <- function(sumstats_dt, path) {
    # get col headers
    col_headers <- names(sumstats_dt)
    # Obtain a row of the actual data
    row_of_data <- as.character(sumstats_dt[1, ])
    twoStepCol <- grep(".*:.*", row_of_data)
    # in case there are more than one column with ":", just take first one
    if (length(twoStepCol) > 1) {
        # sort to get most recent genome build by 
        # default (cols: SNP_hg19, SNP_hg18)
        keep_col <- sort(col_headers[twoStepCol], decreasing = TRUE)[1]
        drop_cols <- sort(col_headers[twoStepCol], decreasing = TRUE)[-1]
        msg <- paste0(
            "Warning: Multiple columns in the sumstats file seem to ",
            "relate to Chromosome:Base Pair position.\nThe column ",
            keep_col, " will be kept whereas the column(s) ",
            drop_cols, " will be removed.\nIf this is not the correct ",
            "column to keep, please remove all incorrect columns from ",
            "those listed here before \nrunning `format_sumstats()`."
        )
        message(msg)
        # Get data without dropped
        sumstats_dt[, (drop_cols) := NULL]
        twoStepCol <- which(col_headers == keep_col)
    }
    if (length(twoStepCol)) {
        keep_col <- col_headers[twoStepCol]
        # split out col into separate values, keep names
        format <- strsplit(keep_col, ":")[[1]]
        if (length(format) != 2) { # check : and underscore in name
            format <- strsplit(keep_col, "_")[[1]]
        }
        if (length(format) != 2) { # If neither found assign name
            format <- c("CHR", "BP")
        }
        # keep ensures that even if certain rows have 3 values
        # e.g.16:23609681:ID
        # only first two taken
        sumstats_dt[, (format) := data.table::tstrsplit(get(keep_col),
            split = ":", fixed = TRUE,
            keep = c(1, 2),
            type.convert = TRUE
        )]
        # remove combined column
        sumstats_dt[, (keep_col) := NULL]
        msg <- paste0(
            "Column ", keep_col, " has been separated into the columns ",
            paste(format, collapse = ", ")
        )
        message(msg)

        return(list("sumstats_dt" = sumstats_dt))
    } else {
        return(list("sumstats_dt" = sumstats_dt))
    }
}

#' Ensure that only one model in GWAS sumstats or only one trait tested
#'
#' @param sumstats_dt data table obj of the summary statistics file for the GWAS
#' @param path Filepath for the summary statistics file to be formatted
#' @param analysis_trait If multiple traits were studied, name of the trait for
#' analysis from the GWAS. Default is NULL
#' @param mapping_file MungeSumstats has a pre-defined column-name mapping file
#' which should cover the most common column headers and their interpretations.
#' However, if a column header that is in youf file is missing of the mapping we
#' give is incorrect you can supply your own mapping file. Must be a 2 column
#' dataframe with column names "Uncorrected" and "Corrected". See
#' data(sumstatsColHeaders) for default mapping and necessary format.
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object
#' @keywords internal
check_multi_gwas <- function(sumstats_dt, path, analysis_trait, 
                             ignore_multi_trait,mapping_file) {
    if(isFALSE(ignore_multi_trait)){
      message("Checking for multi-GWAS.")
      col_headers <- names(sumstats_dt)
      # load synonym mapping - internal data no loading
      # Check for multiple p values and other columns,
      # if found choose 1 to continue
      # Use P value to find - first load all p-value synonyms
      p_syn <- sumstatsColHeaders[sumstatsColHeaders$Corrected == "P", 1]
      # So P_value columns found have already been corrected to "P" so if you find
      # any in p_syn in colheaders then we found multiple
      # NOTE THIS ASSUMES AN '_' or '.' SEPARATES P VALUE SYN FROM TRAIT/MODEL
      # NAME AND COLUMN NAME STARTS WITH P VAULE SYM
      # Sort p_syn so longest ones checked first, once 1 found stop
      # so don't get wrong subset with shorter ones
      p_syn <- p_syn[order(nchar(p_syn), p_syn, decreasing = TRUE)]
      for (pattern_i in p_syn) {
          p_val_multi <- grepl(paste0(
              "^", pattern_i, "_", "|",
              "^", pattern_i, "[.]"
          ), col_headers)
          if (any(p_val_multi)) {
              break
          }
      }
      # So note we could have 0 (do nothing), 1 (just update names),
      # 2+ (remove all but one) traits
      if (any(p_val_multi)) { # multiple traits
          # first get trait name by removing specific p_syn
          traits <- gsub(paste0(
              "^", pattern_i, "_", "|",
              "^", pattern_i, "[.]"
          ), "", col_headers[p_val_multi])
          if (length(traits) > 1) {
              if (!is.null(analysis_trait)) {
                  analysis_trait <- as.character(analysis_trait)
              } # ensure character
              msg2 <- paste0(
                  "WARNING: Multiple traits found in sumstats file only one",
                  " of which can be analysed: \n",
                  paste(traits, collapse = ", ")
              )
              message(msg2)
              stp_msg <- paste0(
                  "Inputted analysis_trait not one of these traits. Pleas",
                  "e input one of the traits above.\n  Or set",
                  "`ignore_multi_trait=TRUE` to ignore these multi-trait ",
                  "p-values and rerun `format_sumstats()`."
              )
              if (is.null(analysis_trait) ||
                  !toupper(analysis_trait) %in% toupper(traits)) {
                  stop(stp_msg)
              }
              # get right case for choice
              chosen_trait <- traits[toupper(traits) %in% toupper(analysis_trait)]
          } else { # just one trait
              msg <- paste0(
                "WARNING: A single multi-trait was found in sumstats file: \n",
                paste(traits, collapse = ", "),"\n",
                "If you don't want to use this value for P, set ",
                "`ignore_multi_trait=TRUE` and rerun `format_sumstats()`"
              )
              message(msg)
              chosen_trait <- traits
          }
          # just 1 trait from start or 1 chosen by user,
          # remove the trait from col name
          # then get the correct synonyms
          # NOTE ASSUMES TRAIT NAME STARTS WITH '_' or '.' &
          # IS AT THE END OF COLUMN
          chnge_header_names <- col_headers[grepl(
              paste0(
                  "_", chosen_trait, "$", "|",
                  "[.]", chosen_trait, "$"
              ),
              col_headers
          )]
  
          new_names <- gsub(paste0(
              "_", chosen_trait, "$", "|",
              ".", chosen_trait, "$"
          ), "", chnge_header_names)
          #if names present already, rename
          for(new_i in new_names){
              if(new_i %in% colnames(sumstats_dt)){
                  data.table::setnames(sumstats_dt, new_i, paste0(new_i,"_input"))
              }
          }
          data.table::setnames(sumstats_dt, chnge_header_names, new_names)
          # RE-standardise headers for all OS
          sumstats_return <-
              standardise_sumstats_column_headers_crossplatform(
                  sumstats_dt = sumstats_dt,
                  mapping_file = mapping_file
              )
          return(sumstats_return)
      } else {
          return(list("sumstats_dt" = sumstats_dt))
      }
    } else {
      return(list("sumstats_dt" = sumstats_dt))
    }
}

#' Parse number of SNPs dropped due to not being bi-allelic
#' 
#' Support function for \link[MungeSumstats]{parse_logs}.
#' 
#' @param l Lines of text from log file.
#' 
#' @return Numeric
#' @keywords internal
parse_dropped_nonBiallelic <- function(l){
    line <- grep("SNPs are non-biallelic",l,
                 value = TRUE)[1]
    as.integer(trimws(gsub(",","",strsplit(line," ")[[1]][1])))
}

#' Sort sum stats: GenomicRanges
#' 
#' Sort summary statistics table by genomic coordinates using a slower 
#' (but in some cases more robust) \code{GenomicRanges} strategy 
#' @inheritParams sort_coords
#' @returns Sorted sumstats_dt
#' 
#' @keywords internal
#' @importFrom GenomicRanges sort.GenomicRanges
#' @importFrom data.table setnames :=
sort_coord_genomicranges <- function(sumstats_dt){
    end <- NULL;
    ### sort.GenomicRanges is less efficient than setorderv,
    ### but more consistently reliable for tabix-indexing.
    keep_end <- "end" %in% tolower(names(sumstats_dt))
    gr <- to_granges(sumstats_dt)
    gr <- GenomicRanges::sort.GenomicRanges(gr)
    sumstats_dt <- granges_to_dt(gr)
    remove(gr)
    if(isFALSE(keep_end)) sumstats_dt[,end:=NULL]
    data.table::setnames(sumstats_dt, c("chr","start"), c("CHR","BP"))
    return(sumstats_dt)
}

#' Load the reference genome data for SNPs of interest
#'
#' @param snps Character vector SNPs by rs_id from sumstats file of interest.
#' @param ref_genome Name of the reference genome used for the GWAS
#'  (GRCh37 or GRCh38)
#' @param dbSNP version of dbSNP to be used (144 or 155)
#' @param dbSNP_tarball Pass local versions of dbSNP in tarball format. Default 
#' of NULL uses the dbSNP version passed in `dbSNP` parmeter. `dbSNP_tarball` 
#' was enabled to help with dbSNP versions >=156, after the decision to no 
#' longer provide dbSNP releases as bioconductor packages. dbSNP 156 tarball is 
#' available here: http://149.165.171.124/SNPlocs/.
#' @param msg Optional name of the column missing from the dataset in question.
#'  Default is NULL
#' @param chr_filt Internal for testing - filter reference genomes and sumstats
#' to specific chromosomes for testing. Pass a list of chroms in format: 
#' c("1","2"). Default is NULL i.e. no filtering.
#' @return data table of snpsById, filtered to SNPs of interest.
#' @importFrom data.table setDT setkey := setnames setorder
#' @importFrom BSgenome snpsById
#' @importFrom stringr str_sub
#' @source 
#' \code{
#' sumstats_dt <- formatted_example()
#' rsids <- MungeSumstats:::load_ref_genome_data(snps = sumstats_dt$SNP,
#'                                               ref_genome = "GRCH37",
#'                                               dbSNP=144)
#' }
load_ref_genome_data <- function(snps, 
                                 ref_genome,
                                 dbSNP=c(144,155),
                                 dbSNP_tarball = NULL,
                                 msg = NULL,
                                 chr_filt = NULL) {
    
    SNP <- NULL
    SNP_LOC_DATA <- load_snp_loc_data(
      ref_genome = ref_genome,
      dbSNP = dbSNP,
      dbSNP_tarball = dbSNP_tarball,
      msg = NULL
    )
    # Get correct ref genome
    message("Loading reference genome data.")
    if (toupper(ref_genome) == "GRCH37") {
        genome <-
            BSgenome.Hsapiens.1000genomes.hs37d5::BSgenome.Hsapiens.1000genomes.hs37d5
    } else { # =="GRCH38"
        genome <- BSgenome.Hsapiens.NCBI.GRCh38::BSgenome.Hsapiens.NCBI.GRCh38
    }

    #snps can contain odd characters, need to sort these
    #so the snp should be all numeric or should start with rs and then be 
    #numeric. Find any that aren't and exclude these. The rs id can be inferred
    #in a later function
    messager("Preprocessing RSIDs.") 
    snp_check <- suppressMessages(as.numeric(
        stringr::str_sub(string = snps, start = 3, end = -1L) 
    ))
    snps <- snps[!is.na(snp_check)]
    #need to make snps unique for cases where non bi-allelic or indels
    snps <- unique(snps)
    
    messager("Validating RSIDs of",formatC(length(snps),big.mark = ","),
             "SNPs using BSgenome::snpsById...")
    #this is memory intensive
    #if user specifies for testing, filt to a specific chr 
    #chr should be in format "1", "2" etc
    if(!is.null(chr_filt)){
      #from here: https://support.bioconductor.org/p/83588/
      keepBSgenomeSequences <- function(genome, seqnames)
      {
        stopifnot(all(seqnames %in% seqnames(genome)))
        genome@user_seqnames <- setNames(seqnames, seqnames)
        genome@seqinfo <- genome@seqinfo[seqnames]
        genome
      }
      genome <- keepBSgenomeSequences(genome, chr_filt)
      #can't find a method to filter ODLT_SNPlocs object ....
      #SNP_LOC_DATA <- SNP_LOC_DATA[[chr_filt]]
    }
    tm <- system.time({
        gr_rsids <- BSgenome::snpsById(
            x = SNP_LOC_DATA,
            id = snps,
            genome = genome,
            ifnotfound = "drop"
        )
    }) 
    messager("BSgenome::snpsById done in",round(tm[[3]]),"seconds.")
     
    rsids <- data.table::setDT(data.frame(gr_rsids))
    data.table::setnames(rsids, "RefSNP_id", "SNP")
    data.table::setorder(rsids, SNP)
    data.table::setkey(rsids, SNP)
    return(rsids)
}

#' Infer genome builds
#'
#' Infers the genome build of  summary statistics files (GRCh37 or GRCh38)
#' from the data. Uses SNP (RSID) & CHR & BP to get genome build.
#'
#' Iterative version of \code{get_genome_build}.
#'
#' @param sumstats_list A named list of paths to summary statistics,
#' or a named list of \code{data.table} objects.
#' @param header_only Instead of reading in the entire \code{sumstats} file,
#' only read in the first N rows where N=\code{sampled_snps}.
#' This should help speed up cases where you have to read in \code{sumstats}
#' from disk each time.
#' @param sampled_snps Downsample the number of SNPs used when inferring genome
#' build to save time.
#' @param names_from_paths Infer the name of each item in \code{sumstats_list}
#' from its respective file path.
#' Only works if \code{sumstats_list} is a list of paths.
#' @param dbSNP version of dbSNP to be used (144 or 155). Default is 155.
#' @param dbSNP_tarball Pass local versions of dbSNP in tarball format. Default 
#' of NULL uses the dbSNP version passed in `dbSNP` parmeter. `dbSNP_tarball` 
#' was enabled to help with dbSNP versions >=156, after the decision to no 
#' longer provide dbSNP releases as bioconductor packages. dbSNP 156 tarball is 
#' available here: http://149.165.171.124/SNPlocs/.
#' @param nThread Number of threads to use for parallel processes.
#' @param chr_filt Internal for testing - filter reference genomes and sumstats
#' to specific chromosomes for testing. Pass a list of chroms in format: 
#' c("1","2"). Default is NULL i.e. no filtering
#'
#' @return ref_genome the genome build of the data
#'
#' @examples
#' # Pass path to Educational Attainment Okbay sumstat file to a temp directory
#'
#' eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
#'     package = "MungeSumstats"
#' )
#' sumstats_list <- list(ss1 = eduAttainOkbayPth, ss2 = eduAttainOkbayPth)
#'
#' ## Call uses reference genome as default with more than 2GB of memory,
#' ## which is more than what 32-bit Windows can handle so remove certain checks
#' is_32bit_windows <-
#'     .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
#' if (!is_32bit_windows) {
#'     
#'     #multiple sumstats can be passed at once to get all their genome builds:
#'     #ref_genomes <- get_genome_builds(sumstats_list = sumstats_list)
#'     #just passing first here for speed
#'     sumstats_list_quick <- list(ss1 = eduAttainOkbayPth)
#'     ref_genomes <- get_genome_builds(sumstats_list = sumstats_list_quick,
#'                                      dbSNP=144)
#' }
#' @export
#' @importFrom parallel mclapply
#' @importFrom utils capture.output
#' @importFrom dplyr %>%
#' @importFrom methods is
get_genome_builds <- function(sumstats_list,
                              header_only = TRUE,
                              sampled_snps = 10000,
                              names_from_paths = FALSE,
                              dbSNP=155,
                              dbSNP_tarball=NULL,
                              nThread = 1,
                              chr_filt = NULL) {
    start <- Sys.time()
    #### Convert to list if it isn't already ####
    if (!methods::is(sumstats_list, "list")) {
        sumstats_list <- list(sumstats_list)
    }
    message(
        "Inferring genome build of ", length(sumstats_list),
        " sumstats file(s)."
    )
    #### Infer names from path ####
    if (names_from_paths &
        (methods::is(sumstats_list[[1]], "character"))) {
        message("Inferring names of sumstats_list items from paths.")
        names(sumstats_list) <- gsub(
            paste(supported_suffixes(), collapse = "|"),
            "", basename(unlist(sumstats_list))
        )
    }
    #### Make sure names are unique ###
    names(sumstats_list) <- make.unique(names(sumstats_list))
    #### Assign new name ####
    if (is.null(names(sumstats_list))) {
        message(
            "sumstats_list has no names. ",
            "Assigning names using ss# format."
        )
        names(sumstats_list) <- paste0("ss", seq(1, length(sumstats_list)))
    }
    #### Infer builds ####
    #Weirdly more efficient to not use parallel::mcapply() if only one
    if(length(names(sumstats_list))==1){
      build_ <- get_genome_build(
        sumstats = sumstats_list[[1]],
        sampled_snps = sampled_snps,
        dbSNP = dbSNP, 
        dbSNP_tarball = dbSNP_tarball,
        header_only = header_only,
        nThread = nThread,
        chr_filt = chr_filt
      )
      builds <- list(build_)
      names(builds) <- c(names(sumstats_list))
    }else{
      builds <- parallel::mclapply(names(sumstats_list),
                                   function(x,
                                            .sampled_snps = sampled_snps,
                                            .dbSNP=dbSNP,
                                            .dbSNP_tarball = dbSNP_tarball,
                                            .header_only = header_only) {
                                     message_parallel(x)
                                     get_genome_build(
                                       sumstats = sumstats_list[[x]],
                                       sampled_snps = .sampled_snps,
                                       dbSNP = .dbSNP, 
                                       dbSNP_tarball = .dbSNP_tarball,
                                       header_only = .header_only,
                                       nThread = 1,
                                       chr_filt = chr_filt
                                     )
                                   },
                                   mc.cores = nThread) %>%
        `names<-`(names(sumstats_list)) 
    }
    #### Report time ####
    message(utils::capture.output(difftime(Sys.time(), start)))
    #### Report build counts ####
    build_counts <- table(unlist(builds))
    for (i in seq(1, length(build_counts))) {
        message(names(build_counts)[i], ": ", build_counts[i], " file(s)")
    }
    return(builds)
}

# test_that("get_genome_builds works", {
# 
#     # Had to remove bc they took too long and put the overall build over 15m
# 
# 
#     eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
#         package = "MungeSumstats"
#     )
#     sumstats_list <- list(ss1 = eduAttainOkbayPth,
#                           ss2 = eduAttainOkbayPth)
# 
#     ## Call uses reference genome as default with more than 2GB of memory,
#     ## which is more than what 32-bit Windows can handle so
#     # remove certain checks
#     is_32bit_windows <-
#         .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
#     if (!is_32bit_windows) {
#         ref_genomes <- MungeSumstats::get_genome_builds(
#             sumstats_list = sumstats_list)
#         testthat::expect_true(all(ref_genomes=="GRCH37"))
#         testthat::expect_length(ref_genomes,2)
#     } else {
#         testthat::expect_true(is_32bit_windows)
#     }
# })

#' Simple function to ensure the new entry name to a list doesn't have the same
#' name as another entry
#'
#' @param name proposed name for the entry
#' @param log_files list of log file locations
#' @return a unique name (character)
#' @keywords internal
get_unique_name_log_file <- function(name, log_files) {
    used_names <- names(log_files)
    if (!name %in% used_names) { # if it isn't present return to be used
        return(name)
    }
    # else append number to end of name
    i <- 2
    need_unique_name <- TRUE
    while (need_unique_name) {
        proposed_name <- paste0(name, "_", i)
        if (!proposed_name %in% used_names) {
            name <- proposed_name
            need_unique_name <- FALSE
        }
        i <- i + 1
    }
    return(name)
}

#' axel downloader
#'
#' R wrapper for axel, which enables multi-threaded download
#'  of a single large file.
#'
#' @return Path where the file has been downloaded
#'
#' @inheritParams downloader
#' @family downloaders
#' @seealso \url{https://github.com/axel-download-accelerator/axel/}
#' @keywords internal
axel <- function(input_url,
                 output_path,
                 background = FALSE,
                 nThread = 1,
                 force_overwrite = FALSE,
                 quiet = TRUE,
                 alternate = TRUE,
                 check_certificates = FALSE) {
    message("Downloading with axel.")
    dir.create(output_path, showWarnings = FALSE, recursive = TRUE)
    out_file <- file.path(output_path, basename(input_url))
    if (force_overwrite) {
        message("Overwriting pre-existing file.")
        if(file.exists(out_file)) file.remove(out_file, showWarnings = FALSE)
    }
    axel <- "axel"
    cmd <- paste(
        axel,
        input_url,
        "-n", nThread,
        ## Checking certificates can sometimes cause issues
        if (check_certificates) "" else "--insecure",
        if (force_overwrite) "" else "--no-clobber",
        "-o", out_file,
        if (quiet) "-q" else "",
        # ifelse(alternate,"-a",""),
        if (background) "& bg" else ""
    )
    # print(cmd)
    system(cmd)
    return(out_file)
}

#' Read VCF genome
#' 
#' Get the genome build of a remote or local VCF file.
#' @param header Header extracted by \link[VariantAnnotation]{scanVcfHeader}.
#' @param validate Validate genome name using 
#' \link[GenomeInfoDb]{mapGenomeBuilds}.
#' @param default_genome When no genome can be extracted,
#'  default to this genome build. 
#' @param verbose Print messages. 
#' 
#' @keywords internal
#' @importFrom GenomeInfoDb mapGenomeBuilds
#' @importFrom VariantAnnotation genome
#' @returns genome 
read_vcf_genome <- function(header=NULL,
                            validate=FALSE,
                            default_genome="HG19/GRCh37",
                            verbose=TRUE){
    
    msg <- paste("No known genome build matches.",
                 "Defaulting to:",default_genome)
    genome <- tryCatch({
        #### Try 1 ###
        genome <- as.character(VariantAnnotation::genome(header)[[1]])
        #### Try 2 ###
        if(length(genome)==0){
            genome <- as.character(header@header$contig$assembly[[1]])
        } 
        if(isTRUE(validate)){
            genome_matches <- GenomeInfoDb::mapGenomeBuilds(genome=genome)
            if(nrow(genome_matches)==0) {
                messager(msg, v=verbose)
                genome <- default_genome
            }
        } 
        genome
    }, error = function(e){messager(msg, v=verbose); default_genome})
    return(genome)
}

#' Ensure that A1 & A2 are present, if not can find it with SNP and other allele
#'
#' More care needs to be taken if one of A1/A2 is present, before imputing the
#' other allele flipping needs to be checked
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return A list containing two data tables:
#' \itemize{
#'   \item \code{sumstats_dt}: the modified summary statistics data table object
#'   \item \code{rsids}: snpsById, filtered to SNPs of interest 
#'   if loaded already. Or else NULL.
#'   \item \code{allele_flip_check}: does the dataset require allele flip check
#'   \item \code{log_files}: log file list
#'   \item \code{bi_allelic_filter}: should multi-allelic SNPs be filtered out
#' }
#' @keywords internal
#' @importFrom data.table setDT
#' @importFrom data.table setkey
#' @importFrom data.table :=
#' @importFrom data.table setnames
#' @importFrom data.table setcolorder
#' @importFrom data.table setorder
#' @importFrom data.table copy
#' @importFrom Biostrings IUPAC_CODE_MAP
check_no_allele <- function(sumstats_dt, 
                            path, 
                            ref_genome, 
                            rsids,
                            imputation_ind, 
                            allele_flip_check, 
                            log_folder_ind,
                            check_save_out, 
                            tabix_index, 
                            nThread, 
                            log_files,
                            bi_allelic_filter,
                            dbSNP,
                            dbSNP_tarball) {
    SNP <- i.seqnames <- CHR <- BP <- i.pos <- LP <- P <- A1 <- A2 <-
        i.ref_allele <- i.alt_alleles <- alt_alleles <- ss_A <-
        alleles_as_ambig <- IMPUTATION_A2 <- IMPUTATION_A1 <- NULL
    # If SNP present but no A1/A2 then need to find them
    col_headers <- names(sumstats_dt)
    if (sum(c("A1", "A2") %in% col_headers) <= 1 &
        sum("SNP" %in% col_headers) == 1) {
        # if A2 is missing need to remove multi-allelic SNPs 
        # as we don't know which is the one the author is thinking of
        msg_a2 <- paste0(
            "WARNING: No A2 column found in the data, multi-allelic ",
            "can't not be accurately chosen (as any\nof the choices ",
            "could be valid). bi_allelic_filter has been forced to ",
            "TRUE."
        )
        if (!"A2" %in% col_headers && !bi_allelic_filter) {
            bi_allelic_filter <- TRUE
            message(msg_a2)
        }
        # check if rsids loaded if not do so
        if (is.null(rsids)) {
            rsids <- load_ref_genome_data(
                data.table::copy(sumstats_dt$SNP),
                ref_genome = ref_genome,
                dbSNP = dbSNP,
                dbSNP_tarball = dbSNP_tarball,
                msg = "A1 or A2 allele information"
            )
        } else {
            print_msg <- paste0(
                "There is no A1 or A2 allele information column",
                " found within the data. It must be inferred from ",
                " other column information."
            )
            message(print_msg)
        }
        # ensure rsids is up-to-date with filtered sumstats_dt
        rsids <- rsids[unique(sumstats_dt$SNP), , nomatch = NULL]
        data.table::setkey(rsids, SNP)

        # join based on SNP as key
        data.table::setkey(sumstats_dt, SNP)
        # if one allele in dataset join other
        if (sum(c("A1", "A2") %in% col_headers) == 1) { # one allele missing
            # NOTE: This is the old flipping code but doesn't matter since the
            # flipping check will correct
            message("One of A1/A2 are missing, allele flipping will be tested")
            allele_flip_check <- TRUE
            msg_a <- paste0(
                "WARNING: One of A1/A2 are missing, bi_allelic_filter ",
                "has been forced to TRUE to test imputation."
            )
            if (!allele_flip_check) {
                allele_flip_check <- TRUE
                message(msg_a)
            }
            # First get col name in data for allele we have
            ssA <- c("A1", "A2")[c("A1", "A2") %in% col_headers]
            # join based on SNP as key
            data.table::setorder(sumstats_dt, SNP)
            data.table::setkey(sumstats_dt, SNP)
            # different rules for each
            if ("A1" == ssA) {
                message("Deriving A2 from reference genome")
                msg <- paste0(
                    "WARNING: Inferring the alternative allele (A2) from the",
                    " reference genome. In some instances, there are more ",
                    "than one\nalternative allele. Arbitrarily, only the ",
                    "first will be kept. See column `alt_alleles` in your ",
                    "returned sumstats file\nfor all alternative alleles."
                )
                message(msg)
                sumstats_dt[rsids, alt_alleles := i.alt_alleles]
                # just take first A2 value arbitrarily
                sumstats_dt[, A2 := as.character(
                    lapply(alt_alleles,function(x) x[1]))]
                # collapse alt_alleles into character type sep by columns
                sumstats_dt[, alt_alleles :=
                    as.character(lapply(
                        alt_alleles,
                        function(x) {
                            paste0(x,
                                collapse = ","
                            )
                        }
                    ))]
                # if user specifies add a column to notify of the imputation
                if (imputation_ind) {
                    sumstats_dt[, IMPUTATION_A2 := TRUE]
                }
            } else { # A2 == ssA
                message("Deriving A1 from reference genome")
                sumstats_dt[rsids, A1 := i.ref_allele]
                # if user specifies add a column to notify of the imputation
                if (imputation_ind) {
                    sumstats_dt[, IMPUTATION_A1 := TRUE]
                }
            }
        } else {
            # get both A1, A2 from ref genome - 
            # choose an A2 value where multiple
            message("Deriving both A1 and A2 from reference genome")
            sumstats_dt[rsids, A1 := i.ref_allele]
            msg <- paste0(
                "WARNING: Inferring the alternative allele (A2) from the ",
                "reference genome. In some instances, there are more ",
                "than one\nalternative allele. Arbitrarily, only the ",
                "first will be kept. See column `alt_alleles` in your ",
                "returned sumstats file\nfor all alternative alleles."
            )
            message(msg)
            sumstats_dt[rsids, alt_alleles := i.alt_alleles]
            # just take first A2 value arbitrarily
            sumstats_dt[, A2 := as.character(
                lapply(alt_alleles, function(x) x[1]))]
            # collapse alt_alleles into character type sep by columns
            sumstats_dt[, alt_alleles :=
                as.character(lapply(
                    alt_alleles,
                    function(x) {
                        paste0(x,
                            collapse = ","
                        )
                    }
                ))]
            # if user specifies add a column to notify of the imputation
            if (imputation_ind) {
                sumstats_dt[, IMPUTATION_A1 := TRUE]
                sumstats_dt[, IMPUTATION_A2 := TRUE]
            }
        }
        # remove rows where A1/A2 couldn't be found
        # If user wants log, save it to there
        if (log_folder_ind) {
            name <- "alleles_not_found_from_snp"
            name <- get_unique_name_log_file(name = name,
                                             log_files = log_files)
            write_sumstats(
                sumstats_dt =
                    sumstats_dt[!complete.cases(sumstats_dt[, c(
                        "A1",
                        "A2"
                    )]), ],
                save_path =
                    paste0(
                        check_save_out$log_folder,
                        "/", name,
                        check_save_out$extension
                    ),
                sep = check_save_out$sep,
                #don't tab indx as could be miss values & cause err
                #tabix_index = tabix_index,
                nThread = nThread
            )
            log_files[[name]] <-
                paste0(check_save_out$log_folder, "/",
                       name, check_save_out$extension)
        }
        sumstats_dt <- sumstats_dt[complete.cases(
            sumstats_dt[, c("A1", "A2")]), ]
        # move SNP, CHR, BP, A1 and A2 to start
        other_cols <-
            names(sumstats_dt)[!names(sumstats_dt) %in%
                c("SNP", "CHR", "BP", "A1", "A2")]
        data.table::setcolorder(
            sumstats_dt,
            c("SNP", "CHR", "BP", "A1", "A2", other_cols)
        )

        return(list(
            "sumstats_dt" = sumstats_dt,
            "rsids" = rsids,
            "allele_flip_check" = allele_flip_check,
            "log_files" = log_files,
            "bi_allelic_filter" = bi_allelic_filter
        ))
    } else {
        return(list(
            "sumstats_dt" = sumstats_dt, 
            "rsids" = rsids,
            "allele_flip_check" = allele_flip_check,
            "log_files" = log_files,
            "bi_allelic_filter" = bi_allelic_filter
        ))
    }
}

#' Drop duplicate rows
#' 
#' Drop rows with duplicate values across all columns. 
#' @param dt data.table
#' @param verbose Print messages.
#' @keywords internal
#' @return Filtered \code{dt}. 
drop_duplicate_rows <- function(dt,
                                verbose=TRUE){
    nrows_old <- nrow(dt)
    dt <- unique(dt)
    nrows_new <- nrow(dt)
    dropped <-  nrows_old-nrows_new
    if(dropped>0){
        messager("Dropped",formatC(dropped,big.mark = ","),
                 "duplicate rows.",v=verbose)
    }
    return(dt)
}

#' Ensure that all necessary columns are in the summary statistics file
#'
#' @param sumstats_dt data table obj of the summary statistics file for the GWAS
#' @return null
#' @keywords internal
check_vital_col <- function(sumstats_dt) {
    col_headers <- names(sumstats_dt)
    err_msg <-
        paste("Cannot find a %s column in GWAS sumstats.",
              "\nUse code such as '%s' to fix")
    for (key_column in c("SNP", "CHR", "BP", "P", "A1", "A2")) {
        code_example <- "sed -i '' '1s/p_value/P/' IQ.Sniekers.2017.txt"
        if (!key_column %in% col_headers) {
            stop(sprintf(err_msg, key_column, code_example))
        }
    }
}

#' Genome build inferred from the summary statistics
#' 
#' Support function for \link[MungeSumstats]{parse_logs}.
#' 
#' @param l Lines of text from log file.
#' 
#' @return Character
#' @keywords internal
parse_genome_build <- function(l){
  line <- grep("Inferred genome build:",l,value = TRUE)[1]
  if(is.na(line)) return(NA)
  trimws(strsplit(line,":")[[1]][-1])
}

#' Parse number of SNPs dropped due to not matching the ref genome A1 or A2
#' 
#' Support function for \link[MungeSumstats]{parse_logs}.
#' 
#' @param l Lines of text from log file.
#' 
#' @return Numeric
#' @keywords internal
parse_dropped_nonA1A2 <- function(l){
  line <- grep("neither A1 nor A2 match the reference genome",l,
               value = TRUE)[1]
  if(is.na(line)) return(NA)
  as.integer(trimws(gsub("There are|,","",strsplit(line," SNPs")[[1]][1])))
}

#' Read in file header
#'
#' @return First \code{n} lines of the VCF header
#'
#' @inheritParams format_sumstats
#' @param n integer. The (maximal) number of lines to read. Negative values
#' indicate that one should read up to the end of input on the connection.
#' @param skip_vcf_metadata logical, should VCF metadata be ignored 
#' @inheritParams format_sumstats
#' 
#' @importFrom VariantAnnotation scanVcfHeader
#' @export
#' @examples
#' path <- system.file("extdata", "eduAttainOkbay.txt", 
#'                     package = "MungeSumstats") 
#' header <- read_header(path = path)                    
read_header <- function(path,
                        n = 2L,
                        skip_vcf_metadata = FALSE,
                        nThread = 1) {
    if(is.null(n)) {
        message("Reading entire file.")
        n <- -2L
    } else {
        message("Reading header.")
    } 
    vcf_suffixes <- supported_suffixes(tabular = FALSE,
                                       tabular_compressed = FALSE)
    if (startsWith(path, "https://gwas.mrcieu.ac.uk") | 
        any(endsWith(path, vcf_suffixes))) {
        #### Read VCFs ####
        if (isTRUE(skip_vcf_metadata)) {  
            if(endsWith(path,".bgz")){
                header <- data.table::fread(text = readLines(path,
                                                              n = n+1000),
                                            nrows = n,
                                            skip = "#CHR",
                                            nThread = nThread)
            } else {
                header <- data.table::fread(input = path,
                                            nrows = n,
                                            skip = "#CHR",
                                            nThread = nThread)
            } 
        } else {
            #### Attempt to read in VCF header as well
            header <- readLines(path, n = 1000)
        }
    } else if (endsWith(path,".bgz")){
        #### Read tabix-indexed tabular ####  
        header <- data.table::fread(text=readLines(con = path,
                                                   n = n+1L)) 
    } else if(any(startsWith(path, c("https:","http:")))){
        #### Read generic remote sumstats ####
        header <- data.table::fread(path,nrows = n) 
    } else {
        #### Read tabular #### 
        header <- readLines(con = path,
                            n = n)
        # Deal with strange, not recognised characters in header
        # like '\' e.g 'xa6\xc2'
        header[[1]] <- iconv(enc2utf8(header[[1]]), sub = "byte")
        if(length(header)<2) header <- rep(header,2)
        header <- data.table::fread(text = header)
    }
    header <- check_numeric(header)
    return(header)
}

test_that("read_header works", {
    
    is_32bit_windows <-
        .Platform$OS.type == "windows" 
    if (!is_32bit_windows) { 
        #### txt ####
        path <- system.file("extdata", "eduAttainOkbay.txt",
                            package = "MungeSumstats")
        header <- read_header(path)
        testthat::expect_equal(dim(header),c(1,9))
        header2 <- read_header(path, n = NULL)
        testthat::expect_equal(dim(header2),c(93,9))
        
        #### vcf #### 
        path <- system.file("extdata","ALSvcf.vcf", package="MungeSumstats") 
        header3 <- read_header(path = path)
        testthat::expect_length(header3, 528)
        header4 <- read_header(path = path, 
                               skip_vcf_metadata = TRUE)
        testthat::expect_equal(dim(header4),c(2,10))
        
        #### vcf.gz ####
        if(file.exists(paste0(path,".gz"))){
          path_gz <- paste0(path,".gz")
        }else{
          path_gz <- R.utils::gzip(path, remove=FALSE) 
        }
        header5 <- read_header(path = path_gz)
        testthat::expect_length(header5, 528)
        
        #### vcf.bgz ####
        dest <- tempfile(fileext = ".vcf.bgz")
        path_bgz <- Rsamtools::bgzip(path, dest = dest)
        header6 <- read_header(path = path_bgz)
        testthat::expect_length(header6, 528)
        header7 <- read_header(path = path_bgz, 
                               skip_vcf_metadata = TRUE)
        testthat::expect_equal(dim(header7),c(2,10))
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
    }
})

#' Loads the SNP locations and alleles for Homo sapiens from dbSNP builds
#'
#' @param ref_genome   character, "GRCh37" or "GRCh38"
#' @param dbSNP        integer, dbSNP build number (144, 155, or any installed 
#' SNPlocs package)
#' @param dbSNP_tarball Optional path to a .tar.gz containing:
#'   one or more .rds files (Bioc SNPlocs package layout).
#' @param msg          optional character to message before loading
#' @return A data.table or OnDiskLongTable of SNP locations
#' @importFrom BSgenome OnDiskLongTable
#' @export
load_snp_loc_data <- function(ref_genome,
                              dbSNP,
                              dbSNP_tarball = NULL,
                              msg = NULL) {
  ## 1) Validate inputs
  ref <- toupper(ref_genome)
  if (!ref %in% c("GRCH37", "GRCH38")) {
    stop("`ref_genome` must be 'GRCh37' or 'GRCh38'.", call. = FALSE)
  }
  if (!is.null(msg)) {
    print_msg <- paste0(
      "There is no ", msg, " column found within the data. ",
      "It must be inferred from other column information."
    )
    message(print_msg)
  }
  
  ## 2) Custom‐tarball branch
  if (!is.null(dbSNP_tarball)) {
    #check ref genome matches file, else throw error
    if(!grepl(ref_genome, basename(dbSNP_tarball),ignore.case = TRUE)){
      stp_msg <- paste0(
        "The dbSNP_tarball file name does not appear to be from the specified",
        "genome build (`ref_genome`). This is based on the tarball file name.",
        "Check this is correct and update either the specified ref_genome or ",
        "the tarball file name")
      stop(stp_msg)
    }
    message("Loading SNPlocs data from tarball ", basename(dbSNP_tarball), 
            " on ", ref, ".")
    tmpdir <- tempfile("snp_loc_")
    #check if one already created - this is called multiple times per run
    tmpdirs <- list.dirs(dirname(tmpdir),recursive = FALSE)
    tmpdirs <- tmpdirs[grepl("\\bsnp_loc_",tmpdirs)]
    if(length(tmpdirs)==0){
      dir.create(tmpdir)
      utils::untar(dbSNP_tarball, exdir = tmpdir)
    }else{ #found already
      tmpdir <- tmpdirs[1] #can be multiple
    }
    # locate inst/extdata under the top‐level unpacked directory
    topdirs <- list.dirs(tmpdir, recursive = FALSE, full.names = TRUE)
    extdata <- NULL
    for (d in topdirs) {
      p <- file.path(d, "inst", "extdata")
      if (dir.exists(p)) {
        extdata <- p
      }
    }
    # fallback if unpacked flat
    if (is.null(extdata)) {
      extdata <- file.path(tmpdir, "inst", "extdata")
      if (!dir.exists(extdata)) {
        stop("Cannot locate inst/extdata in tarball", call. = FALSE)
      }
    }
    # construct and return the OnDiskLongTable
    return(BSgenome::OnDiskLongTable(extdata))
  }
  
  ## 3) Use installed SNPlocs pkg (144, 155, 156, 157, …)
  message("Loading SNPlocs data for build ", dbSNP, " on ", ref, ".")
  pkg_name <- sprintf("SNPlocs.Hsapiens.dbSNP%d.GRCh%s",
                      as.integer(dbSNP),
                      ifelse(ref == "GRCH37", "37", "38"))
  if (!requireNamespace(pkg_name, quietly = TRUE)) {
    stop("Please install Bioconductor package '", pkg_name, "'.", call. = FALSE)
  }
  snp_loc_data <- getExportedValue(pkg_name, pkg_name)
  return(snp_loc_data)
}

#' Parse number of SNPs with non-negative p-values <=5e-324
#' 
#' Support function for \link[MungeSumstats]{parse_logs}.
#' 
#' @param l Lines of text from log file.
#' 
#' @return Numeric
#' @keywords internal
parse_pval_small <- function(l){
  line <- grep(
    "p-values are <=5e-324 which LDSC/MAGMA may not be able to handle",l,
    value = TRUE)[1]
  if(is.na(line)) return(NA)
  as.integer(trimws(gsub(",","",strsplit(line," ")[[1]][1])))
}

#' Ensure A1 & A2 are correctly named, if GWAS SNP constructed as
#' Alternative/Reference or Risk/Nonrisk alleles these SNPs will need to be
#' converted to Reference/Alternative or Nonrisk/Risk. Here non-risk is defined
#' as what's on the reference genome (this may not always be the case).
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @param standardise_headers Run
#' \code{standardise_sumstats_column_headers_crossplatform} first.
#'
#' @return A list containing two data tables:
#' \itemize{
#'   \item \code{sumstats_dt}: the modified summary statistics
#'    \code{data.table} object.
#'   \item \code{rsids}: snpsById, filtered to SNPs of interest if
#'    loaded already. Or else NULL.
#'   \item \code{log_files}: log file list
#' }
#' @keywords internal
#' @import R.utils
#' @importFrom data.table setkey
#' @importFrom data.table :=
#' @importFrom data.table setnames
#' @importFrom data.table set
#' @importFrom data.table setorder
#' @importFrom data.table copy
check_allele_flip <- function(sumstats_dt, path,
                              ref_genome, rsids,
                              allele_flip_check,
                              allele_flip_drop,
                              allele_flip_z,
                              allele_flip_frq,
                              bi_allelic_filter,
                              flip_frq_as_biallelic,
                              imputation_ind,
                              log_folder_ind,
                              check_save_out,
                              tabix_index,
                              nThread,
                              log_files,
                              standardise_headers = FALSE,
                              mapping_file,
                              dbSNP,
                              dbSNP_tarball) {
    # # GenomicSEM' allele flipping strategy:
    # file.path("https://github.com/GenomicSEM/GenomicSEM/blob",
    #           "fc8f17a817a8022d6900acf41824d27b3676f9c4/R/munge.R#L151")

    # #example
    # path <- system.file("extdata","eduAttainOkbay.txt",
    # package="MungeSumstats")
    # sumstats_dt <- read_sumstats(path = path)
    # sumstats_return <- check_allele_flip(sumstats_dt = sumstats_dt,
    #                                      path=path,
    #                                      ref_genome="GRCh37",
    #                                      rsids=NULL,
    #                                      allele_flip_check=TRUE,
    #                                      standardise_headers=TRUE)
    ## Set variables to be used in in place data.table functions to NULL
    ## to avoid confusing BiocCheck.
    SNP <- i.seqnames <- CHR <- BP <- i.pos <- LP <- P <- A1 <- A2 <- eff_i <-
        i.A1 <- i.A2 <- ss_A1 <- ss_A2 <- i.ref_allele <-
        ref_gen_allele <- match_type <-
        tmp <- flipped <- NULL
    if (standardise_headers) {
        sumstats_dt <-
            standardise_sumstats_column_headers_crossplatform(
                sumstats_dt = sumstats_dt,
                mapping_file = mapping_file
            )[["sumstats_dt"]]
    }
    # If SNP present but no A1/A2 then need to find them
    col_headers <- names(sumstats_dt)
    if (sum(c("A1", "A2") %in% col_headers) == 2 && allele_flip_check) {
        message(
            "Checking for correct direction of A1 (reference) ",
            "and A2 (alternative allele)."
        )
        # check if rsids loaded if not do so
        if (is.null(rsids)) {
            rsids <-
                load_ref_genome_data(
                    data.table::copy(sumstats_dt$SNP),
                    ref_genome = ref_genome, 
                    dbSNP = dbSNP, dbSNP_tarball = dbSNP_tarball,
                    msg=NULL
                )
        }
        # ensure rsids is up-to-date with filtered sumstats_dt
        rsids <- rsids[unique(sumstats_dt$SNP), , nomatch = NULL]
        data.table::setkey(rsids, SNP)
        data.table::setkey(sumstats_dt, SNP)
        # Append reference genome to data and check matches to both A1 or A2
        # For each SNP, if ref genome matches A1, leave it (TRUE)
        # if ref genome matches A2, flip it (FALSE)
        # if ref genome doesn't match A1 or A2, leave it (TRUE)
        sumstats_dt[rsids, ref_gen_allele := i.ref_allele]
        sumstats_dt[is.na(ref_gen_allele), match_type := TRUE]
        sumstats_dt[A1 == ref_gen_allele, match_type := TRUE]
        sumstats_dt[A2 == ref_gen_allele, match_type := FALSE]
        # drop cases that don't match either
        if (allele_flip_drop &&
            nrow(sumstats_dt[A1 != ref_gen_allele &
                A2 != ref_gen_allele, ]) > 0) {
            print_msg0 <-
                paste0(
                    "There are ",
                    formatC(nrow(sumstats_dt[A1 != ref_gen_allele &
                        A2 != ref_gen_allele, ]), big.mark = ","),
                    " SNPs where neither A1 nor A2 match the reference genome.",
                    " These will be removed."
                )
            message(print_msg0)
            # If user wants log, save it to there
            if (log_folder_ind) {
                name <- "alleles_dont_match_ref_gen"
                name <- get_unique_name_log_file(
                    name = name,
                    log_files = log_files
                )
                write_sumstats(
                    sumstats_dt = sumstats_dt[(A1 != ref_gen_allele &
                        A2 != ref_gen_allele), ],
                    save_path =
                        paste0(
                            check_save_out$log_folder,
                            "/", name,
                            check_save_out$extension
                        ),
                    sep = check_save_out$sep,
                    #don't tab indx as could be miss values & cause err
                    #tabix_index = tabix_index,
                    nThread = nThread
                )
                log_files[[name]] <-
                    paste0(
                        check_save_out$log_folder, "/", name,
                        check_save_out$extension
                    )
            }
            sumstats_dt <- sumstats_dt[!(A1 != ref_gen_allele &
                A2 != ref_gen_allele), ]
        } else {
            sumstats_dt[
                A1 != ref_gen_allele & A2 != ref_gen_allele,
                match_type := TRUE
            ]
        }
        # continue if flipping necessary
        if (nrow(sumstats_dt[match_type == FALSE, ]) > 0) {
            print_msg <- paste0(
                "There are ", 
                formatC(nrow(sumstats_dt[match_type == FALSE, ]),
                        big.mark = ","),
                " SNPs where A1 doesn't match the reference genome.",
                "\nThese will be flipped with their effect columns."
            )
            message(print_msg)
            # swap A1 and A2 for those SNPs needing to be flipped
            sumstats_dt[match_type == FALSE, tmp := A2]
            sumstats_dt[match_type == FALSE, A2 := A1]
            sumstats_dt[match_type == FALSE, A1 := tmp]
            sumstats_dt[, tmp := NULL]

            # flip effect column(s) - BETA, OR, Z, log_odds, SIGNED_SUMSTAT, FRQ
            effect_columns <- c("BETA", "OR", "LOG_ODDS", "SIGNED_SUMSTAT")
            if (allele_flip_z) {
                effect_columns <- c(effect_columns, "Z")
            }
            if (allele_flip_frq) {
                effect_columns <- c(effect_columns, "FRQ")
            }
            effect_columns <-
                effect_columns[effect_columns %in% names(sumstats_dt)]
            # if FRQ present and needs to be flipped for SNPs ensure
            # bi_allelic_filter is TRUE
            stp_msg <- paste0(
                "Certain SNPs need to be flipped along with their ",
                "effect columns and frequency column. However to flip ",
                "the\nFRQ column, only bi-allelic SNPs can be ",
                "considered. It is recommended to set ",
                "bi_allelic_filter to TRUE so\nnon-bi-allelic SNPs are",
                " removed. Otherwise, set allele_flip_frq to FALSE to ",
                "not flip the FRQ column but note\nthis could lead to ",
                "incorrect FRQ values.\nA new option added is to flip ",
                "non-bi-allelic SNPs as if they were bi-allelic (1-FRQ), ",
                "to do this set\nflip_frq_as_biallelic to TRUE but note ",
                "these values will not be exact down to the missing ",
                "frequencies of the other\nalternative allele(s)."
            )
            if (nrow(sumstats_dt[match_type == FALSE, ]) > 0 &&
                "FRQ" %in% effect_columns &&
                !bi_allelic_filter && !flip_frq_as_biallelic) {
                stop(stp_msg)
            }
            #if set flip_frq_as_biallelic = TRUE, let them know
            if (nrow(sumstats_dt[match_type == FALSE, ]) > 0 &&
                "FRQ" %in% effect_columns &&
                !bi_allelic_filter && flip_frq_as_biallelic) {
              print_msg <- paste0(
                "Note: You have set flip_frq_as_biallelic to TRUE meaning of ",
                "the ",
                formatC(nrow(sumstats_dt[match_type == FALSE, ]),
                        big.mark = ","),
                " SNPs to be flipped, ",
                "any non-bi-allelic SNPs\nwill have their frequencies flipped ",
                "as (1-FRQ) essentially ignoring the frequencies of any other ",
                "alternative alleles."
              )
              message(print_msg)
            }
            for (eff_i in effect_columns) { # set updates quicker for DT
                # conversion done in case, VCF beta column may not be numeric
                if (eff_i == "FRQ") {
                    sumstats_dt[
                        match_type == FALSE,
                        (eff_i) := (1 - as.numeric(get(eff_i)))
                    ]
                } else if(eff_i == "OR"){
                    sumstats_dt[
                        match_type == FALSE,
                        (eff_i) := (1/as.numeric(get(eff_i)))
                    ]
                }
                else {
                    sumstats_dt[
                        match_type == FALSE,
                        (eff_i) := as.numeric(get(eff_i)) * -1
                    ]
                }
            }
            if (imputation_ind) {
                sumstats_dt[match_type == FALSE, flipped := TRUE]
            }
        }
        # remove extra created columns and return
        sumstats_dt[, ref_gen_allele := NULL]
        sumstats_dt[, match_type := NULL]

        return(list(
            "sumstats_dt" = sumstats_dt,
            "rsids" = rsids, "log_files" = log_files
        ))
    }
    return(list(
        "sumstats_dt" = sumstats_dt,
        "rsids" = rsids, "log_files" = log_files
    ))
}

#' Download chain file for liftover
#'
#' @source \href{https://hgdownload.cse.ucsc.edu/goldenpath/hg19/liftOver/}{
#' UCSC chain files}
#' @source \href{https://ftp.ensembl.org/pub/assembly_mapping/homo_sapiens/}{
#' Ensembl chain files}
#' @param from genome build converted from ("hg38", "hg19")
#' @param to genome build converted to ("hg19", "hg38")
#' @param chain_source chain file source used ("ucsc" as default, or "ensembl")
#' @param save_dir where is the chain file saved? Default is a temp directory
#' @param verbose extra messages printed? Default is TRUE
#' @return loaded chain file for liftover
#' @keywords internal
#' @importFrom utils download.file
#' @importFrom R.utils gunzip copyFile
#' @importFrom rtracklayer import.chain
get_chain_file <- function(from = c("hg38", "hg19"),
                           to = c("hg19", "hg38"),
                           chain_source = c("ucsc", "ensembl"),
                           save_dir = tempdir(),
                           verbose = TRUE) {
  #### Match args ####
  from <- match.arg(from)
  to <- match.arg(to)
  chain_source <- match.arg(chain_source)
  if(from == to){
    stop("Cannot get a chain file from one reference to the same.")
  }
  if(chain_source == "ucsc"){
    message("Note that you are fetching the UCSC chain file, ",
            "which requires a licence for commercial use.")
  }
  
  #### Define paths ####
  remote_path = switch(
    chain_source,
    "ensembl" = .get_ensembl_chain_remote(from, to),
    "ucsc" = .get_ucsc_chain_remote(from, to)
  )
  local_path <- file.path(save_dir, basename(remote_path))
  local_path_gunzip <- gsub(".gz", "", local_path)
  ### Download chain file ####
  if(file.exists(local_path_gunzip)){
    if(verbose)
      messager(sprintf("Using existing chain file from %s.", 
                       chain_source),v=verbose)
  }
  else{
    source_readable = ifelse(chain_source == "ensembl", "Ensembl", 
                             "UCSC Genome Browser")
    if(verbose)
      messager(sprintf("Downloading chain file from %s.", 
                       source_readable),
               v=verbose)
    error_dwnld <-
      tryCatch(utils::download.file(remote_path, local_path),
               error = function(e){e},
               warning = function(w){w}
      )
    #if download failed use file in package
    if(is(error_dwnld,"warning")||is(error_dwnld,"error")||
       ("message" %in% names(error_dwnld) &&
        (grepl("Couldn't connect to server",error_dwnld$message)||
         grepl("Couldn't resolve host name",error_dwnld$message)||
         grepl("cannot open URL",error_dwnld$message)))
    ){
      if(chain_source != "ensembl")
        chain_file <- basename(.get_ucsc_chain_remote(from, to))
      else
        chain_file <- basename(.get_ensembl_chain_remote(from, to))
      #download.file will create an empty file even if download fails
      if(file.exists(local_path)){
        rmvd <- file.remove(local_path)
        msg <- paste0(
          sprintf("Download of chain file from %s ", source_readable),
          "failed, use ensembl chain file (chain_source='ensembl') ",
          "\nfor an offline solution.")
        if(chain_source!='ensembl')
          stop(msg)
        copied <- R.utils::copyFile(
          srcPathname = system.file("extdata",chain_file,
                                    package="MungeSumstats"),
          save_dir)
        msg2 <- paste0(
          sprintf("Download of chain file from %s ", source_readable),
          "failed, using ensembl chain file downloaded on 2022-11-25 ",
          "instead.")
        if(chain_source=='ensembl'){
          messager(msg2)
          #local_path = 
        }  
      } 
    }
    messager(local_path,v=verbose)
    local_path <- R.utils::gunzip(local_path, overwrite=TRUE)
    local_path_gunzip <- local_path
  }
  #### Import ####
  #NOT NECESSARY WITH FIX TO rtracklayer - v1.59.1
  #(https://github.com/lawremi/rtracklayer/issues/23
  # Ensembl format is slightly different to UCSC, rtracklayer can't handle 
  # the spaces rather than tabs. Solution here as per RoelKluin
  # https://github.com/lawremi/rtracklayer/issues/23
  #if(chain_source == "ensembl"){
  #    new_path = gsub(".chain", "_tabs.chain", local_path_gunzip, fixed=TRUE)
  #    if(!file.exists(new_path)){
  #        system(sprintf(
  #            "sed -E 's/^([0-9]+) ([0-9]+) ([0-9]+)$/\\1\\t\\2\\t\\3/' %s > %s",
  #            local_path_gunzip, new_path)
  #        )
  #    }
  #    local_path_gunzip <- new_path
  #}
  chain <- rtracklayer::import.chain(local_path_gunzip)
  return(chain)
}

.get_ensembl_chain_remote <- function(from = c("hg38", "hg19"),
                                      to = c("hg19", "hg38")) {
  base <- "ftp://ftp.ensembl.org/pub/assembly_mapping/homo_sapiens/"
  ens_convert <- c("hg38" = "GRCh38", "hg19" = "GRCh37")
  ens_from <- ens_convert[from]
  ens_to <- ens_convert[to]
  return(
    paste0(base, ens_from, "_to_", ens_to, ".chain.gz")
  )
}

.get_ucsc_chain_remote <- function(from = c("hg38", "hg19"),
                                   to = c("hg19", "hg38")) {
  base <- "ftp://hgdownload.cse.ucsc.edu/goldenPath/"
  to_caps <- paste0(toupper(substr(to, 1, 1)),substr(to, 2, nchar(to)))
  return(
    paste0(base, from, "/liftOver/", from, "To", to_caps, ".over.chain.gz")
  )
}

#' Ensure that the first three columns are SNP, CHR, BP in that order and
#' then A1, A2 if present
#'
#' @param sumstats_dt data table obj of the summary statistics file for the GWAS
#' @param path Filepath for the summary statistics file to be formatted
#' @return list containing sumstats_dt, the modified summary statistics
#' data table object
#' @keywords internal
#' @importFrom data.table setcolorder
check_col_order <- function(sumstats_dt,
                            path) {
    col_headers <- names(sumstats_dt)
    # Use data tables for speed
    if (!sum(col_headers[seq_len(3)] == c("SNP", "CHR", "BP")) == 3 | (
        sum(c("A1", "A2") %in% col_headers) == 2 &
            !sum(col_headers[c(4, 5)] == c("A1", "A2")) == 2)) {
        msg <- paste0(
            "Reordering so first three column headers are SNP, CHR and",
            " BP in this order."
        )
        message(msg)
        whichSNP <- which(col_headers == "SNP")[1]
        whichCHR <- which(col_headers == "CHR")[1]
        whichBP <- which(col_headers == "BP")[1]
        # if A1 and A2 present, put them as four and five
        if (sum(c("A1", "A2") %in% col_headers) == 2) {
            message("Reordering so the fourth and fifth columns are A1 and A2.")
            whichA1 <- which(col_headers == "A1")[1]
            whichA2 <- which(col_headers == "A2")[1]
            otherCols <- setdiff(
                seq_len(length(col_headers)),
                c(whichSNP, whichCHR, whichBP, whichA1, whichA2)
            )
            data.table::setcolorder(sumstats_dt, c(
                whichSNP, whichCHR, whichBP, whichA1,
                whichA2, otherCols
            ))
        } else {
            otherCols <-
                setdiff(
                    seq_len(length(col_headers)),
                    c(whichSNP, whichCHR, whichBP)
                )
            data.table::setcolorder(
                sumstats_dt,
                c(whichSNP, whichCHR, whichBP, otherCols)
            )
        }
        return(list("sumstats_dt" = sumstats_dt))
    } else {
        return(list("sumstats_dt" = sumstats_dt))
    }
}

#' Ensure that the standard error (se) is positive for all SNPs
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and the log file list
#' @keywords internal
check_effect_columns_nonzero <- function(sumstats_dt, path,
                                         effect_columns_nonzero,
                                         log_folder_ind, check_save_out,
                                         tabix_index, nThread, log_files) {
    .SD <- NULL
    col_headers <- names(sumstats_dt)
    effect_columns <- c("BETA", "OR", "LOG_ODDS", "SIGNED_SUMSTAT")
    if (sum(effect_columns %in% col_headers) >= 1 && effect_columns_nonzero) {
        message("Filtering effect columns, ensuring none equal 0.")
        # filter to effect columns in the data
        effect_columns_dat <- effect_columns[effect_columns %in% col_headers]
        # ensure numeric
        sumstats_dt[, (effect_columns_dat) := lapply(.SD, as.numeric),
            .SDcols = effect_columns_dat
        ]
        # check if any equal 0 - use data table for speed
        bad_ids <- sumstats_dt[, Reduce(`|`, lapply(.SD, `==`, 0)),
            .SDcols = effect_columns_dat
        ]
        num_bad_ids <- sum(bad_ids)
        if (num_bad_ids > 0) {
            msg <- paste0(
                formatC(num_bad_ids, big.mark = ","), " SNPs",
                " have effect values = 0 and will be removed"
            )
            message(msg)
            # If user wants log, save it to there
            if (log_folder_ind) {
                name <- "effect_col_zero"
                name <- get_unique_name_log_file(
                    name = name,
                    log_files = log_files
                )
                write_sumstats(
                    sumstats_dt = sumstats_dt[bad_ids, ],
                    save_path =
                        paste0(
                            check_save_out$log_folder,
                            "/", name,
                            check_save_out$extension
                        ),
                    sep = check_save_out$sep,
                    #don't tab indx as could be miss values & cause err
                    #tabix_index = tabix_index,
                    nThread = nThread
                )
                log_files[[name]] <-
                    paste0(
                        check_save_out$log_folder, "/", name,
                        check_save_out$extension
                    )
            }
            sumstats_dt <- sumstats_dt[!bad_ids]
        }
        return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
    } else {
        return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
    }
}

#' Search Open GWAS for datasets matching criteria
#'
#' For each  argument, searches for any datasets matching
#' a case-insensitive substring search in the respective metadata column.
#' Users can supply a single character string or a
#' list/vector of character strings.
#' 
#' To authenticate, you need to generate a token from the OpenGWAS website. The 
#' token behaves like a password, and it will be used to authorise the requests 
#' you make to the OpenGWAS API. Here are the steps to generate the token and 
#' then have `ieugwasr` automatically use it for your queries:
#' 1. Login to https://api.opengwas.io/profile/
#' 2. Generate a new token
#' 3. Add `OPENGWAS_JWT=<token>` to your .Renviron file, thi can be edited in R
#' by running `usethis::edit_r_environ()`
#' 4. Restart your R session
#' 5. To check that your token is being recognised, run 
#' `ieugwasr::get_opengwas_jwt()`. If it returns a long random string then you 
#' are authenticated.
#' 6. To check that your token is working, run `ieugwasr::user()`. It will make a 
#' a request to the API for your user information using your token. It should 
#' return a list with your user information. If it returns an error, then your 
#' token is not working.
#' 7. Make sure you have submitted use
#'
#' By default, returns metadata for all studies currently in Open GWAS database.
#'
#' @return (Filtered) GWAS metadata table.
#'
#' @param ids List of Open GWAS study IDs
#' (e.g. \code{c("prot-a-664", "ieu-b-4760")}).
#' @param traits List of traits
#' (e.g. \code{c("parkinson", "Alzheimer")}).
#' @param years List of years
#' (e.g. \code{seq(2015,2021)} or \code{c(2010, 2012, 2021)}).
#' @param consortia List of consortia
#'  (e.g. \code{c("MRC-IEU","Neale Lab")}.
#' @param authors List of authors
#' (e.g. \code{c("Elsworth","Kunkle","Neale")}).
#' @param populations List of populations
#' (e.g. \code{c("European","Asian")}).
#' @param categories List of categories
#' (e.g. \code{c("Binary","Continuous","Disease","Risk factor"))}).
#' @param subcategories List of categories
#' (e.g. \code{c("neurological","Immune","cardio"))}).
#' @param builds List of genome builds
#' (e.g. \code{c("hg19","grch37")}).
#' @param pmids List of PubMed ID (exact matches only)
#' (e.g. \code{c(29875488, 30305740, 28240269)}).
#' @param min_sample_size Minimum total number of study participants
#' (e.g. \code{5000}).
#' @param min_ncase Minimum number of case participants
#' (e.g. \code{1000}).
#' @param min_ncontrol Minimum number of control participants
#' (e.g. \code{1000}).
#' @param min_nsnp Minimum number of SNPs
#' (e.g. \code{200000}).
#' @param include_NAs Include datasets with missing metadata for size criteria
#' (i.e. \code{min_sample_size}, \code{min_ncase}, or \code{min_ncontrol}).
#' 
#' @export
#' @importFrom dplyr %>% arrange desc mutate rowwise
#' @importFrom data.table setorderv
#' @importFrom ieugwasr gwasinfo
#' @examples
#' # Only run the examples if user has internet access
#' # and if access token has been added
#' if(try(is.character(getURL("www.google.com")))==TRUE && ieugwasr::get_opengwas_jwt()!=""){
#' ### By ID
#' metagwas <- find_sumstats(ids = c(
#'     "ieu-b-4760",
#'     "prot-a-1725",
#'     "prot-a-664"
#' ))
#' ### By ID and sample size
#' metagwas <- find_sumstats(
#'     ids = c("ieu-b-4760", "prot-a-1725", "prot-a-664"),
#'     min_sample_size = 5000
#' )
#' ### By criteria
#' metagwas <- find_sumstats(
#'     traits = c("alzheimer", "parkinson"),
#'     years = seq(2015, 2021)
#' )
#' }
find_sumstats <- function(ids = NULL,
                          traits = NULL,
                          years = NULL,
                          consortia = NULL,
                          authors = NULL,
                          populations = NULL,
                          categories = NULL,
                          subcategories = NULL,
                          builds = NULL,
                          pmids = NULL,
                          min_sample_size = NULL,
                          min_ncase = NULL,
                          min_ncontrol = NULL,
                          min_nsnp = NULL,
                          include_NAs = FALSE
                          ) {
    
    ## Set up fake empty variables to avoid confusing BiocCheck
    sample_size <- ncase <- ncontrol <- nsnp <- N <- NULL;
    
    message("Collecting metadata from Open GWAS.")
    if (!is.null(ids)) {
        metagwas <- ieugwasr::gwasinfo(
            id = ids
        )
        ## gwasinfo() doesn't always return all columns for some reason
        missing_cols <- c("ncase", "ncontrol")
        missing_cols <- missing_cols[!missing_cols %in% colnames(metagwas)]
        if (length(missing_cols) > 0) {
            for (x in missing_cols) {
                metagwas[[x]] <- NA
            }
        }
    } else {
        metagwas <- ieugwasr::gwasinfo()
    }
    message("Filtering metadata by substring criteria.")
    if (!is.null(traits)) {
        metagwas <- metagwas[grepl(paste(traits, collapse = "|"),
                                   metagwas$trait,
                                   ignore.case = TRUE
        ), ]
    }
    if (!is.null(years)) {
        metagwas <- metagwas[grepl(paste(years, collapse = "|"),
                                   metagwas$year,
                                   ignore.case = TRUE
        ), ]
    }
    if (!is.null(consortia)) {
        metagwas <- metagwas[grepl(paste(consortia, collapse = "|"),
                                   metagwas$consortium,
                                   ignore.case = TRUE
        ), ]
    }
    if (!is.null(authors)) {
        metagwas <- metagwas[grepl(paste(authors, collapse = "|"),
                                   metagwas$author,
                                   ignore.case = TRUE
        ), ]
    }
    if (!is.null(populations)) {
        metagwas <- metagwas[grepl(paste(populations, collapse = "|"),
                                   metagwas$population,
                                   ignore.case = TRUE
        ), ]
    }
    if (!is.null(categories)) {
        metagwas <- metagwas[grepl(paste(categories, collapse = "|"),
                                   metagwas$category,
                                   ignore.case = TRUE
        ), ]
    }
    if (!is.null(subcategories)) {
        metagwas <- metagwas[grepl(paste(subcategories, collapse = "|"),
                                   metagwas$subcategory,
                                   ignore.case = TRUE
        ), ]
    }
    if (!is.null(builds)) {
        metagwas <- metagwas[grepl(paste(builds, collapse = "|"),
                                   metagwas$build,
                                   ignore.case = TRUE
        ), ]
    }
    if (!is.null(pmids)) metagwas <- metagwas[metagwas$pmid %in% pmids, ]
    
    if (any(
        !is.null(min_sample_size),
        !is.null(min_ncase),
        !is.null(min_ncontrol),
        !is.null(min_nsnp)
    )) {
        message("Filtering metadata by sample/case/control/SNP size criteria.")
        if (include_NAs) {
            message("Including sample/case/control size with NAs.")
            if (!is.null(min_sample_size)) {
                metagwas <- subset(
                    metagwas,
                    sample_size >= min_sample_size |
                        is.na(sample_size) |
                        sample_size == "NA"
                )
            }
            if (!is.null(min_ncase)) {
                metagwas <- subset(
                    metagwas,
                    ncase >= min_ncase |
                        is.na(ncase) |
                        ncase == "NA"
                )
            }
            if (!is.null(min_ncontrol)) {
                metagwas <- subset(
                    metagwas,
                    ncontrol >= min_ncontrol |
                        is.na(ncontrol) |
                        ncontrol == "NA"
                )
            }
            if (!is.null(min_nsnp)) {
                metagwas <- subset(
                    metagwas,
                    nsnp >= min_nsnp |
                        is.na(nsnp) |
                        nsnp == "NA"
                )
            }
        } else {
            message("Excluding sample/case/control size with NAs.")
            if (!is.null(min_sample_size)) {
                metagwas <- subset(metagwas, sample_size >= min_sample_size)
            }
            if (!is.null(min_ncase)) {
                metagwas <- subset(metagwas, ncase >= min_ncase)
            }
            if (!is.null(min_ncontrol)) {
                metagwas <- subset(metagwas, ncontrol >= min_ncontrol)
            }
            if (!is.null(min_nsnp)) {
                metagwas <- subset(metagwas, nsnp >= min_nsnp)
            }
        }
    }
    #### Add N col #### 
    metagwas <- metagwas |>
        dplyr::rowwise() |>
        dplyr::mutate(N = ifelse(is.na(sample_size),
                                 sum(ncase, ncontrol, na.rm = TRUE),
                                 sample_size
        )) |>
        data.table::data.table()
    metagwas[N %in% c(NA,0,"","NA",NULL),]$N <- NA
    #### Ensure data.table format ####
    metagwas <- data.table::data.table(metagwas)
    #### Add query col to keep track of groups ####
    param_list <- as.list(match.call())  
    metagwas$query <- list(param_list[names(param_list)!=""] )
    #### Sort results  #### 
    data.table::setorderv(metagwas,
                          cols = c(
                              "trait", "N", "sample_size",
                              "ncase", "ncontrol", "year"
                          ),
                          order = c(1, -1, -1, -1, -1, -1)
    )
    message(
        "Found ", formatC(nrow(metagwas), big.mark = ","),
        " GWAS datasets matching search criteria across:",
        "\n   - ", formatC(length(unique(metagwas$trait)),
                           big.mark = ","
        ), " trait(s)",
        "\n   - ", formatC(length(unique(metagwas$population)),
                           big.mark = ","
        ), " population(s)",
        "\n   - ", formatC(length(unique(metagwas$category)),
                           big.mark = ","
        ), " category(ies)",
        "\n   - ", formatC(length(unique(metagwas$subcategory)),
                           big.mark = ","
        ), " subcategory(ies)",
        "\n   - ", formatC(length(unique(metagwas$pmid)),
                           big.mark = ","
        ), " publication(s)",
        "\n   - ", formatC(length(unique(metagwas$consortium)),
                           big.mark = ","
        ), " consortia(ium)",
        "\n   - ", formatC(length(unique(metagwas$build)),
                           big.mark = ","
        ), " genome build(s)"
    ) 
    return(metagwas)
}

test_that("Test connection to IEU GWAS - metadata, download", {
  ## The following test uses more than 2GB of memory, which is more
  ## than what 32-bit Windows can handle:
  is_32bit_windows <- .Platform$OS.type == "windows" ##&&
  ##.Platform$r_arch == "i386"
  #only run test if user has internet access
  #capture internet outage or server issues
  if(try(is.character(RCurl::getURL("www.google.com")))==TRUE &&
     !is_32bit_windows && 
     #catch server issues - fake id just check it connects
     #Server code: 502; Server is possibly experiencing traffic, trying again...
     is.data.frame(try(gwasinfo(id = c("fake-id"),
                                opengwas_jwt = ieugwasr::get_opengwas_jwt())))){
    
    ### By ID and sample size
    metagwas <-
      try(MungeSumstats::find_sumstats(
        ids = c(
          "ieu-b-4760", "prot-a-1725",
          "prot-a-664"
        ),
        min_sample_size = 1000
      ))
    
    ### By criteria
    metagwas3 <- try(MungeSumstats::find_sumstats(
      traits = c("alzheimer", "parkinson"),
      years = seq(2015, 2021)
    ))
    # test these worked
    if(is.data.frame(metagwas)){
      testthat::expect_gt(nrow(metagwas), 0)
    }else{
      #catch server issues - fake id just check it connects
      #Server code: 502; Server is possibly experiencing traffic, trying again..
      testthat::expect_equal(TRUE, TRUE)
    }
    if(is.data.frame(metagwas3)){
      testthat::expect_gt(nrow(metagwas3), 0)
    }else{
      #catch server issues - fake id just check it connects
      #Server code: 502; Server is possibly experiencing traffic, trying again..
      testthat::expect_equal(TRUE, TRUE)
    }
    
    
    # test download
    datasets <- MungeSumstats::import_sumstats(ids = "ieu-a-298",
                                               ref_genome = "GRCH37")
    # test this worked
    testthat::expect_true(file.exists(datasets$`ieu-a-298`))
    
    
    # issues should be caught
    err_catch <-
      tryCatch({
        MungeSumstats:: import_sumstats(
          ids = "a-fake-id",
          ref_genome = "GRCh37",
          on_ref_genome = FALSE,
          strand_ambig_filter = FALSE,
          bi_allelic_filter = FALSE,
          allele_flip_check = FALSE, 
          force_new = TRUE,
          dbSNP=144)
      },
      error = function(e) e 
      )
    testthat::expect_true(methods::is(err_catch, "error"))
    # try import with axel - again should get warning about 1 thread
    axel_catch <-
      tryCatch(MungeSumstats::import_sumstats(
        ids = "ieu-a-298",
        ref_genome = "GRCh37",
        on_ref_genome = FALSE,
        strand_ambig_filter = FALSE,
        bi_allelic_filter = FALSE,
        allele_flip_check = FALSE,
        force_new = TRUE,
        nThread = 1,
        download_method = "axel",
        dbSNP=144
      ),
      error = function(e) e, 
      warning = function(w) w
      )
    testthat::expect_true(!is(axel_catch, "error"))
    
    # don't run last check too time intensive, it is also in the vignette anyway
    ## test importing
    ### Only use a subset for testing purposes
    #ids <- (dplyr::arrange(metagwas3, nsnp))$id
    # reformatted <- MungeSumstats::import_sumstats(ids = ids[1],
    #                                              ref_genome="GRCh37",
    #                                              on_ref_genome = FALSE,
    #                                              strand_ambig_filter=FALSE,
    #                                              bi_allelic_filter=FALSE,
    #                                              allele_flip_check=FALSE)
    # test this worked
    # testthat::expect_equal(file.exists(out_paths$save_path),TRUE)
    
  }else{
    testthat::expect_equal(TRUE, TRUE)
    testthat::expect_equal(TRUE, TRUE)
    testthat::expect_equal(TRUE, TRUE)
    testthat::expect_equal(TRUE, TRUE)
    testthat::expect_equal(TRUE, TRUE)
    testthat::expect_equal(TRUE, TRUE)
  }
})

#' Check for N column if not present and user wants, impute N based on user's
#' sample size. **NOTE** this will be the same value for each SNP which is not
#' necessarily correct and may cause issues down the line. N can also be
#' inputted with "ldsc", "sum", "giant" or "metal" by passing one or
#' multiple of these.
#'
#' @return \code{list("sumstats_dt"=sumstats_dt)}
#'
#' @param sumstats_dt data table obj of the summary statistics file for the
#' GWAS.
#' @param imputation_ind Binary Should a column be added for each imputation
#' step to show what SNPs have imputed values for differing fields. This
#' includes a field denoting SNP allele flipping (flipped). **Note**
#' these columns will be in the formatted summary statistics returned. Default
#' is FALSE.
#' @param compute_n How to compute per-SNP sample size (new column "N").
#' \itemize{
#' \item{\code{0}: }{N will not be computed.}
#' \item{\code{>0}: }{If any number >0 is provided,
#' that value will be set as N for every row.
#' **Note**: Computing N this way is incorrect and should be avoided
#' if at all possible.}
#' \item{\code{"sum"}: }{N will be computed as:
#' cases (N_CAS) + controls (N_CON), so long as both columns are present}.
#' \item{\code{"ldsc"}: }{N will be computed as effective sample size:
#' Neff =(N_CAS+N_CON)*(N_CAS/(N_CAS+N_CON)) / mean((N_CAS/(N_CAS+N_CON))(N_CAS+N_CON)==max(N_CAS+N_CON))}.
#' \item{\code{"giant"}: }{N will be computed as effective sample size:
#' Neff = 2 / (1/N_CAS + 1/N_CON)}.
#' \item{\code{"metal"}: }{N will be computed as effective sample size:
#' Neff = 4 / (1/N_CAS + 1/N_CON)}.
#' }
#' @param return_list Return the \code{sumstats_dt} within a named list 
#' (default: \code{TRUE}).
#' @inheritParams compute_sample_size
#' @inheritParams read_sumstats
#' @export
#' @examples 
#' sumstats_dt <- MungeSumstats::formatted_example()
#' sumstats_dt2 <- MungeSumstats::compute_nsize(sumstats_dt=sumstats_dt,
#'                                              compute_n=10000)
compute_nsize <- function(sumstats_dt,
                          imputation_ind = FALSE,
                          compute_n = c("ldsc", "giant", "metal", "sum"),
                          standardise_headers=FALSE,
                          force_new = FALSE,
                          return_list=TRUE) {
    ## Avoid confusing BiocCheck.
    IMPUTATION_n <- IMPUTATION_Neff <- NULL;
    if (!is.numeric(compute_n) || (is.numeric(compute_n) && compute_n != 0L)){
      #### Copy data.table ####
      ## IMPORTANT!: This makes it so that any subsequent changes made to 
      ## the internal sumstats_dt variable (and the function output) will not 
      ## alter the original input data as well. 
      sumstats_dt <- data.table::copy(sumstats_dt) 
      #### Standardise the column names before continuing ####
      if (standardise_headers) {
          sumstats_dt <-
              standardise_sumstats_column_headers_crossplatform(
                  sumstats_dt = sumstats_dt, 
              )[["sumstats_dt"]]
      }
      # if you want an Neff column for more than one method need to ensure
      # you can tell which is which
      append_method_name <- FALSE
      if (is.vector(compute_n)) {
          # sum makes an N column not an Neff column
          if (length(compute_n[!compute_n == "sum"]) > 1) {
                append_method_name <- TRUE
            }
      }
      for (method in compute_n) {
          compute_sample_size(
              sumstats_dt = sumstats_dt,
              method = method,
              force_new = force_new,
              append_method_name = append_method_name
          )
      }
      # if user wants information, give SNPs where Z-score calculated
      ## Evaluate the conditions under which N would have been calculate by
      ## compute_sample_size()
      if (imputation_ind &&
          is.numeric(compute_n) && compute_n != 0L &&
          (!"N" %in% names(sumstats_dt))) {
          sumstats_dt[, IMPUTATION_n := TRUE]
      }
      if (imputation_ind &&
          is.character(compute_n)) {
          sumstats_dt[, IMPUTATION_Neff := TRUE]
      }
    }  
    #### Return format ####
    if(return_list){
        return(list("sumstats_dt" = sumstats_dt))
    }else {
        return(sumstats_dt)
    } 
}

#' Determine summary statistics file type and read them into memory
#'
#' @return \code{data.table} of formatted summary statistics
#'
#' @param nrows integer. The (maximal) number of lines to read.
#' If \code{Inf}, will read in all rows.
#' @param standardise_headers Standardise headers first.
#' @inheritParams format_sumstats
#' @inheritParams standardise_header
#' @inheritParams vcf2df
#' @inheritParams read_vcf
#' @inheritParams check_empty_cols
#' 
#' @export
#' @importFrom data.table fread as.data.table setkeyv
#' @examples
#' path <- system.file("extdata", "eduAttainOkbay.txt",
#'     package = "MungeSumstats"
#' )
#' eduAttainOkbay <- read_sumstats(path = path)
read_sumstats <- function(path, 
                          nrows = Inf,
                          standardise_headers = FALSE,
                          samples = 1,
                          sampled_rows = 1e4L,
                          nThread = 1,
                          mapping_file = sumstatsColHeaders) {
    
    if (is.data.frame(path)) {
        message("Summary statistics passed as R object.")
        sumstats_file <- data.table::as.data.table(path)
        if (!is.infinite(nrows)) {
            sumstats_file <- sumstats_file[seq(1, nrows), ]
        }
    } else {
        vcf_suffixes <- supported_suffixes(tabular = FALSE, 
                                           tabular_compressed = FALSE)
        vcf_suffix_regexes <- gsub("\\.", "\\.",  paste0(vcf_suffixes, "$"))
        is_vcf <- grepl(paste(vcf_suffix_regexes, collapse = "|"), path)
        if (isTRUE(is_vcf)) {
            sumstats_file <- read_vcf(path = path,
                                      use_params = TRUE,
                                      samples = samples,
                                      sampled_rows = sampled_rows,
                                      as_datatable = TRUE, 
                                      nThread = nThread)
        } else {
            #### Check if tabular 1: infer from file name ####
            tab_suffixes <- supported_suffixes(vcf = FALSE, 
                                               vcf_compressed = FALSE)
            tab_suffix_regexes <- gsub("\\.", "\\.",  paste0(tab_suffixes, "$"))
            is_tabular <- grepl(paste(tab_suffix_regexes, collapse = "|"), path) 
            #### Check if tabular 2: infer from data ####
            if(isFALSE(is_tabular)){
                header <- read_header(path = path)
                is_tabular <- check_tabular(header = header)
            }
            #### Process tabular ####
            if (isTRUE(is_tabular)) {
                if(endsWith(path,".bgz")){
                    message("Importing tabular bgz file: ", path)
                    sumstats_file <- data.table::fread(
                        text = readLines(con = path),
                        nThread = nThread,
                        nrows = nrows)
                }else {
                    message("Importing tabular file: ", path)
                    sumstats_file <- data.table::fread(
                        path,
                        nThread = nThread,
                        nrows = nrows)
                }
               
            } else {
                suffixes <- supported_suffixes()
                stop(
                    "Unrecognized file format.\n",
                    "Must be one of: \n   ",
                    paste(suffixes, collapse = "\n   ")
                )
            } 
            #### Drop empty cols ####
            remove_empty_cols(sumstats_dt = sumstats_file, 
                              sampled_rows = sampled_rows) 
        }
    }
    #### Standardise colnames ####
    if (isTRUE(standardise_headers)) {
        CHR <- NULL;
        sumstats_file <-
            standardise_sumstats_column_headers_crossplatform(
                sumstats_dt = sumstats_file,
                mapping_file = mapping_file
            )[["sumstats_dt"]]
        #### Ensure CHR is character ####
        if("CHR" %in% names(sumstats_file)) {
            sumstats_file[,CHR:=as.character(CHR)]
        }
        #### Ensure SNP is the key ####
        if("SNP" %in% names(sumstats_file)) {
            data.table::setkeyv(sumstats_file, cols = "SNP")
        } 
    }
    return(sumstats_file)
}

test_that("Check that Z-scores get computed correctly", {
    ## Call uses reference genome as default with more than 2GB of memory,
    ## which is more than what 32-bit Windows can handle so remove tests
    is_32bit_windows <-
        .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
    if (!is_32bit_windows) {
        path <- system.file("extdata", "eduAttainOkbay.txt", package = "MungeSumstats")
        sumstats_dt <- MungeSumstats::read_sumstats(path = path)
        sumstats_dt <- MungeSumstats:::check_zscore(
            sumstats_dt = sumstats_dt, imputation_ind = FALSE,
            compute_z = 'P',force_new_z = TRUE,
            standardise_headers = TRUE,
            mapping_file = sumstatsColHeaders
        )[["sumstats_dt"]]
        sumstats_dt[, newZ := sign(BETA) * sqrt(stats::qchisq(P, 1, 
                                                              lower = FALSE))]
        all_z_equal <- all(sumstats_dt$Z == sumstats_dt$newZ)
        expect_equal(all_z_equal, TRUE)
        #also test BETA/SE
        sumstats_dt <- MungeSumstats:::check_zscore(
          sumstats_dt = sumstats_dt, imputation_ind = FALSE,
          compute_z = 'BETA',force_new_z = TRUE,
          standardise_headers = TRUE,
          mapping_file = sumstatsColHeaders
        )[["sumstats_dt"]]
        sumstats_dt[, newZ := BETA/SE]
        all_z_equal <- all(sumstats_dt$Z == sumstats_dt$newZ)
        expect_equal(all_z_equal, TRUE)
    }    
    else{
        expect_equal(is_32bit_windows, TRUE)
        expect_equal(is_32bit_windows, TRUE)
    }
})

#' Infer if effect relates to a1 or A2 if ambiguously named
#'
#' Three checks are made to infer which allele the effect/frequency information
#' relates to if they are ambiguous (named A0, A1 and A2 or equivalent):
#' 1. Check if ambiguous naming conventions are used (i.e. allele 0, 1 and 2 or 
#' equivalent). If not exit, otherwise continue to next checks. This can be 
#' checked by using the mapping file and splitting A1/A2 mappings by those that 
#' contain 0, 1 or 2 (ambiguous) or doesn't contain 0, 1 or 2 e.g. effect, 
#' tested (unambiguous so fine for MSS to handle as is).
#' 2. Look for effect column/frequency column where the A0/A1/A2 explicitly 
#' mentioned, if found then  we know the direction and should update A0/A1/A2 
#' naming so A2 is the effect column. We can look for such columns by getting 
#' every combination of A0/A1/A2 naming and effect/frq naming.
#' 3. If not found in 2, a final check should be against the reference genome, 
#' whichever of A0, A1 and A2 has more of a match with the reference genome 
#' should be taken as **not** the effect allele. There is an assumption in this 
#' but is still better than guessing the ambiguous allele naming.
#' 
#' Also, if eff_on_minor_alleles=TRUE, check 3 will be used in all cases. 
#' However, This assumes that the effects are majoritively measured on the 
#' minor alleles and should be used with caution as this is an assumption that 
#' won't be appropriate in all cases. However, the benefit is that if we know 
#' the majority of SNPs have their effects based on the minor alleles, we can 
#' catch cases where the allele columns have been mislabelled. IF 
#' eff_on_minor_alleles=TRUE, checks 1 and 2 will be skipped.
#'
#' @inheritParams format_sumstats 
#' @inheritParams compute_nsize
#' @inheritParams get_genome_build
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object
#' @export
#' @importFrom data.table setnames as.data.table := setkey rbindlist data.table
#' @examples
#' sumstats <- MungeSumstats::formatted_example()
#' #for speed, don't run on_ref_genome part of check (on_ref_genome = FALSE)
#' sumstats_dt2<-infer_effect_column(sumstats_dt=sumstats,on_ref_genome = FALSE)
infer_effect_column <-
  function(sumstats_dt,
           dbSNP=155,
           dbSNP_tarball = NULL,
           sampled_snps = 10000,
           mapping_file = sumstatsColHeaders,
           nThread = nThread,
           ref_genome = NULL,
           on_ref_genome = TRUE,
           infer_eff_direction = TRUE,
           eff_on_minor_alleles = FALSE,
           return_list=TRUE) {
    if(isTRUE(infer_eff_direction)||isTRUE(eff_on_minor_alleles)){
      message("Infer Effect Column")
      message("First line of summary statistics file: ")
      msg <- paste0(names(sumstats_dt), split = "\t")
      message(msg)
      #### first make all column headers upper case ####
      column_headers <- names(sumstats_dt) 
      # load synonym mapping - internal data no loading
      # Identify allele mappings which are ambiguous and problematic
      # vs those that are interpretable
      colnames(mapping_file) <- toupper(colnames(mapping_file))
      #A* is A0, A* used since usually if A0/A1 used, meaning of A1 
      #becomes eff allele and A0 is non-eff so need to flip later
      allele_mapping <- mapping_file[mapping_file$CORRECTED %in% c('A1','A2',
                                                                   'A*'),]
      ambig_allele_map <- 
        allele_mapping[grepl('1',allele_mapping$UNCORRECTED)|
                         grepl('2',allele_mapping$UNCORRECTED)|
                         grepl('0',allele_mapping$UNCORRECTED),]
      unambig_allele_map <- 
        allele_mapping[!(grepl('1',allele_mapping$UNCORRECTED)|
                           grepl('2',allele_mapping$UNCORRECTED)|
                           grepl('0',allele_mapping$UNCORRECTED)),]
      #as long as the sumstats contains 1 unambiguous allele column MSS will
      #work as expected
      unambig_cols <- intersect(unambig_allele_map$UNCORRECTED,
                                toupper(column_headers))
      ambig_cols <- intersect(ambig_allele_map$UNCORRECTED,
                              toupper(column_headers))
      #if both ambiguous and unambiguous columns found, rename ambiguous ones
      #so they aren't used later by MSS
      #example: 'A1','A2','EFFECT_ALLELE' all present
      if (length(unambig_cols)>0 && length(ambig_cols)>0 && 
          isFALSE(eff_on_minor_alleles)){
        #find if unambig and ambig relate to the same allele
        #get corrected name for unambig 
        unambig_corrcted <- 
          unique(allele_mapping[allele_mapping$UNCORRECTED %in% unambig_cols,
                                ]$CORRECTED)
        #check if any ambig are to the same allele
        ambig_corrcted <- 
          unique(allele_mapping[allele_mapping$UNCORRECTED %in% ambig_cols,
                                ]$CORRECTED)
        #overlap?
        ambig_corrcted_rnme <- 
          ambig_corrcted[ambig_corrcted %in% unambig_corrcted]
        if (length(ambig_corrcted_rnme)>0){
          message("There are multiple columns relating to the same allele info")
          message("Renaming ambiguous allele columns so they won't be used")
          #get the related ambig naming and change there name so won't be used
          ambig_uncorrcted_rnme <- 
            ambig_allele_map[ambig_allele_map$CORRECTED %in% 
                               ambig_corrcted_rnme,]$UNCORRECTED
          #now rename any matches in sumstats
          chng_nmes <- column_headers[toupper(column_headers) %in% 
                                       ambig_uncorrcted_rnme]
          for(chng_i in chng_nmes){
            data.table::setnames(sumstats_dt, chng_i, 
                                 paste0(chng_i,"_INPUTTED"))
          }
        }
      } else if ((length(unambig_cols)==0 && length(ambig_cols)>=2) || 
                 isTRUE(eff_on_minor_alleles)){
        #first case for ambig allelee where user didn't set eff_on_minor_alleles
        if ((length(unambig_cols)==0 && length(ambig_cols)>=2) && 
            isFALSE(eff_on_minor_alleles)){
          #only continue if no unambiguous columns found but 2 ambig ones are 
          #found- less than 2 in total means allele info is missing which MSS 
          #can try fill in later
          message("Allele columns are ambiguous, attempting to infer direction")
          #get names for allele marked eff/frq columns
          eff_frq_allele_matches <- get_eff_frq_allele_combns()
          #now look for matches in sumstats
          fnd_allele_indicator <- 
            column_headers[toupper(column_headers) %in% 
                             eff_frq_allele_matches$UNCORRECTED]
        } else{
          #for eff_on_minor_alleles = TRUE - 
          #force length(fnd_allele_indicator)>0 to return FALSE
          fnd_allele_indicator<-c()
        }
        if(length(fnd_allele_indicator)>0){
          message("Found direction from effect/frq column naming")
          #fnd_allele_indicator could be >1 so majority vote
          a1_mtch <- sum(grepl("A1",fnd_allele_indicator))
          a2_mtch <- sum(grepl("A2",fnd_allele_indicator))
          a0_mtch <- sum(grepl("A0",fnd_allele_indicator))
          #need to also check if allele 0 & allele 1 found or more normal case
          #of allele 1 & allele 2, as this flips which is interp as the eff 
          #allele by MSS
          samp_dt <- copy(sumstats_dt[1:10])
          samp_dt <- 
            standardise_sumstats_column_headers_crossplatform(samp_dt,
                                                              mapping_file=
                                                                mapping_file,
                                                              convert_A0=FALSE,
                                                              return_list=FALSE)
          formatted_col_headers <- names(samp_dt)
          #check if A0,A1 and A2 present
          a1_found <- "A1" %in% formatted_col_headers
          a2_found <- "A2" %in% formatted_col_headers
          a0_found <- "A*" %in% formatted_col_headers
          #if A2 found at all, it is eff col normally in MSS
          if(a2_mtch>=a1_mtch && a2_found){
            message("Effect/frq column(s) relate to A2 in the sumstat")
            #this is what MSS expects so no action required
          }else if(a2_mtch<a1_mtch && a2_found){
            message("Effect/frq column(s) relate to A1 in the sumstat")
            #this is the opposite to what MSS expects so switch A1/A2 naming
            #first get corrected names for allele columns then switch
            for (headerI in seq_len(nrow(mapping_file))) {
              un <- mapping_file[headerI, "UNCORRECTED"]
              cr <- mapping_file[headerI, "CORRECTED"]
              #note ambig_cols here not all col headers
              if (un %in% ambig_cols & (!cr %in% column_headers)) {
                data.table::setnames(sumstats_dt, un, cr)
              }
            }
            #now switch
            data.table::setnames(sumstats_dt,"A2","A2_INPUTTED_OLD_")
            data.table::setnames(sumstats_dt,"A1","A2")
            data.table::setnames(sumstats_dt,"A2_INPUTTED_OLD_","A1")
          }else if(a1_mtch>=a0_mtch&& a0_found){
            message("Effect/frq column(s) relate to A1 where A0 in the sumstat")
            #this is what MSS expects so no action required
          }else if(a1_mtch<a0_mtch&& a0_found){
            message("Effect/frq column(s) relate to A0 in the sumstat")
            #this is the opposite to what MSS expects so switch A1/A0 naming
            #first get corrected names for allele columns then switch
            for (headerI in seq_len(nrow(mapping_file))) {
              un <- mapping_file[headerI, "UNCORRECTED"]
              cr <- mapping_file[headerI, "CORRECTED"]
              #note ambig_cols here not all col headers
              if (un %in% ambig_cols & (!cr %in% column_headers)) {
                data.table::setnames(sumstats_dt, un, cr)
              }
            }
            #now switch
            data.table::setnames(sumstats_dt,"A*","A0_INPUTTED_OLD_")
            #don't flip A1 as the next step of the mapping is to flip it anyway
            data.table::setnames(sumstats_dt,"A0_INPUTTED_OLD_","A2")
          }else{#unknown
            message("ERROR: Unknown condition, not changing allele mapping.")
          }
          
        }
        else{
          #Either - didn't find any allele specific or set eff_on_minor_alleles
          #last option is to check the reference genome and take the allele with
          #more matches to it as the non-effect allele
          #need to standardise the sumstats for this
          #use get_genome_build function for this
          if(isFALSE(on_ref_genome) && isTRUE(eff_on_minor_alleles)){
            stop("on_ref_genome must equal TRUE to use eff_on_minor_alleles")
          }
          if(isTRUE(on_ref_genome)){
            #Note this check will also work for when A0 is present
            switch_req <- get_genome_build(
              sumstats = copy(sumstats_dt),
              standardise_headers = TRUE,
              sampled_snps = sampled_snps,
              mapping_file = mapping_file,
              dbSNP=dbSNP,
              dbSNP_tarball = dbSNP_tarball,
              nThread = nThread,
              allele_match_ref = TRUE,
              ref_genome = ref_genome
            )
            if(is.logical(switch_req)){
              message(paste0("Found direction from matching reference genome -",
                             " NOTE this assumes non-effect allele will match ",
                             "the reference genome"))
              if(isTRUE(switch_req)){
                #swap A1 and A2
                #this is the opposite to what MSS expects so switch A1/A2 naming
                #first get corrected names for allele columns then switch
                #Make column headers uppercase
                data.table::setnames(sumstats_dt, toupper(names(sumstats_dt)))
                for (headerI in seq_len(nrow(mapping_file))) {
                  un <- mapping_file[headerI, "UNCORRECTED"]
                  cr <- mapping_file[headerI, "CORRECTED"]
                  #note ambig_cols here not all col headers
                  if (un %in% ambig_cols & (!cr %in% column_headers)) {
                    data.table::setnames(sumstats_dt, un, cr)
                  }
                }
                # Special case!! A0/A1 -> ref/alt so A1 flips meaning,
                # A0 is A* in mapping
                # but usually A1/A2 -> ref/alt so if A* found,
                # swap A1 to A2 and make A* -> A1
                new_headers <- colnames(sumstats_dt)
                if ("A*" %in% new_headers) {
                  # if A1 and A2 also present need to rename A2
                  if ("A1" %in% new_headers && "A2" %in% new_headers) {
                    data.table::setnames(sumstats_dt, "A2", "A2_from_input")
                  }
                  # if A1 present change to A2, doesn't have to be, 
                  # can be imputted
                  data.table::setnames(sumstats_dt, "A1", "A2", 
                                       skip_absent = TRUE)
                  data.table::setnames(sumstats_dt, "A*", "A1")
                }
                #now switch
                data.table::setnames(sumstats_dt,"A2","A2_INPUTTED_OLD_")
                data.table::setnames(sumstats_dt,"A1","A2")
                data.table::setnames(sumstats_dt,"A2_INPUTTED_OLD_","A1")
              }
            }
            else{ #couldn't infer
              message(switch_req)
              message("Can't infer allele columns from sumstats")
            }
          }
          else{
            message("Can't infer allele columns from sumstats")
          }
        }
      }
    }  
    #### Return format ####
    if(return_list){
      return(list("sumstats_dt" = sumstats_dt))
    }else {
      return(sumstats_dt)
    }
  }    

#' List supported file formats
#'
#' @param tabular Include tabular formats.
#' @param tabular_compressed Include compressed tabular formats.
#' @param vcf Include Variant Call Format.
#' @param vcf_compressed Include compressed Variant Call Format.
#' @return File formats
#' @keywords internal
supported_suffixes <- function(tabular = TRUE,
                               tabular_compressed = TRUE,
                               vcf = TRUE,
                               vcf_compressed = TRUE) {
    supported <- c()
    suffixes <- c(".tsv", ".txt", ".csv")
    suffixes.gz <- c(paste0(suffixes, ".gz"), paste0(suffixes, ".bgz"))
    suffixes.vcf <- c(".vcf")
    suffixes.vcf.gz <- c(paste0(suffixes.vcf, ".gz"),
                         paste0(suffixes.vcf, ".bgz"),
                         paste0(suffixes.vcf, ".tsv"), 
                         paste0(suffixes.vcf, ".tsv.gz"), 
                         paste0(suffixes.vcf, ".tsv.bgz"))
    if (tabular) supported <- c(supported, suffixes)
    if (tabular_compressed) supported <- c(supported, suffixes.gz)
    if (vcf) supported <- c(supported, suffixes.vcf)
    if (vcf_compressed) supported <- c(supported, suffixes.vcf.gz)
    return(supported)
}

#' Ensure that SNP appears to be valid RSIDs (starts with rs)
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and the log file list.
#' @keywords internal
#' @importFrom data.table setDT
#' @importFrom data.table setkeyv
#' @importFrom data.table :=
#' @importFrom data.table setcolorder
#' @importFrom data.table copy
#' @importFrom data.table tstrsplit
#' @importFrom data.table rbindlist
#' @importFrom BSgenome snpsByOverlaps
#' @importFrom GenomicRanges makeGRangesFromDataFrame
#' @importFrom stringr str_sub
 check_no_rs_snp <- function(sumstats_dt, path, ref_genome, snp_ids_are_rs_ids, indels,
                              imputation_ind, log_folder_ind, check_save_out,
                              tabix_index, nThread, log_files, dbSNP,
                              dbSNP_tarball) {
    SNP <- CHR <- CHR1 <- BP1 <- i.RefSNP_id <- IMPUTATION_SNP <-
        SNP_old_temp <- SNP_INFO <- A1 <- A2 <- .I <- NULL
    # if snp ids aren't rs ids rename the column to ID's 
    # so RSIDs can be inferred
    if ((!snp_ids_are_rs_ids) & sum("SNP" %in% names(sumstats_dt)) == 1) {
        data.table::setnames(sumstats_dt, "SNP", "ID")
    }
    #also check if user didn't set the param snp_ids_are_rs_ids but it's clear
    if("SNP" %in% names(sumstats_dt)){
      #If SNP present, make sure it isn't a proxy for CHR:bp
      #RS ID should be all numeric or should start with rs and then be numeric
      snps <- sumstats_dt$SNP
      snp_check <- suppressMessages(as.numeric(
        stringr::str_sub(string = snps, start = 3, end = -1L) 
      ))
      #this won't catch chr:bp when chr is just number i.e. 1:123456789
      #so second check needed
      snp_check2 <- unique(c(grep(":", snps),
                             grep("-", snps),
                             grep("_", snps)))
      #however if they start with rs they stay i.e. rs140052487:C:A
      snp_check3 <- grep("^rs", snps)
      #remove these from those that passed first check
      if(length(snp_check2)!=0)
        snp_check <- snp_check[-snp_check2]
      num_rsids <- length(snps[!is.na(snp_check)])
      #if num_rsids==0 then they clearly meant SNP col to not represent 
      #RSIDs so rename to avoid errors later
      if(num_rsids==0 && length(snp_check3)==0)
        setnames(sumstats_dt,"SNP","ID")
    }
    # If SNP column doesn't start with rs
    col_headers <- names(sumstats_dt)
    if (sum("SNP" %in% col_headers) == 1) {
        message("Checking SNP RSIDs.")
        # needed for later to join and match SNPs
        if (imputation_ind) {
            # if any are NA, we need to give them a unique ID
            # need to be able to identify to revert back so picked up 
            #by other, NA for RS ID check
            sumstats_dt[is.na(SNP)|SNP=="", SNP := paste0("NA_",.I)]
            sumstats_dt[, SNP_old_temp := SNP]
        }
        miss_rs <- sumstats_dt[!grep("^rs", SNP), ]
        # first case is something other than rs id and chr:bp - impute SNP
        # second case is chr:bp together - impute SNP for these
        miss_rs_chr_bp <- miss_rs[grep(":", SNP),] 
        miss_rs_chr_bp <- miss_rs_chr_bp[!grep(".*:.*:.*", SNP),]
        if (nrow(miss_rs) != nrow(sumstats_dt) && nrow(miss_rs_chr_bp) > 0) {
            # check if impute of correct SNP ID possible
            if (sum(c("CHR", "BP") %in% col_headers) == 2 &&
                nrow(miss_rs[!grep(":", SNP), ]) > 0) {
                bad_snp <- miss_rs[!grep(":", SNP), ]
                msg <- paste0(
                    formatC(nrow(bad_snp), big.mark = ","),
                    " SNP IDs are not correctly formatted.",
                    " These will be corrected from the reference genome."
                )
                message(msg)
                # remove snp column and pass to function to impute snp
                bad_snp <- bad_snp[, SNP := NULL]
                # now impute correct RS ID for those missing it
                corrected_snp <-
                    check_no_snp(
                        sumstats_dt = bad_snp, path = tempfile(),
                        ref_genome = ref_genome,
                        indels = indels,
                        imputation_ind = imputation_ind,
                        log_folder_ind = log_folder_ind,
                        check_save_out = check_save_out, 
                        tabix_index = tabix_index,
                        nThread = nThread, 
                        log_files = log_files, 
                        dbSNP = dbSNP,
                        dbSNP_tarball = dbSNP_tarball,
                        verbose = FALSE
                    )
                log_files <- corrected_snp$log_files
                corrected_snp <- corrected_snp$sumstats_dt
                # make sure columns in correct order
                data.table::setcolorder(corrected_snp, names(sumstats_dt))
                # remove rows missing from the reference genome and combine
                # If IMPUTATION column added add it to other DT
                if (imputation_ind &&
                    !"IMPUTATION_SNP" %in% names(sumstats_dt)) {
                    sumstats_dt[, IMPUTATION_SNP := NA]
                }
                sumstats_dt <-
                    data.table::rbindlist(list(
                        sumstats_dt[grep("^rs", SNP), ],
                        corrected_snp
                    ))
            } else {
                # remove snps missing rs
                # If user wants log, save it to there
                if (log_folder_ind) {
                    name <- "snp_missing_rs"
                    name <- get_unique_name_log_file(name = name,
                                                     log_files = log_files)
                    write_sumstats(
                        sumstats_dt = sumstats_dt[!grepl("^rs", SNP), ],
                        save_path =
                            paste0(
                                check_save_out$log_folder,
                                "/", name,
                                check_save_out$extension
                            ),
                        sep = check_save_out$sep,
                        #don't tab indx as could be miss values & cause err
                        #tabix_index = tabix_index,
                        nThread = nThread
                    )
                    log_files[[name]] <-
                        paste0(check_save_out$log_folder,
                               "/", name, check_save_out$extension)
                }
                sumstats_dt <- sumstats_dt[grep("^rs", SNP), ]
            }
            # check if any have more than 1 ":" remove these
            # If user wants log, save it to there
            if (log_folder_ind) {
                name <- "snp_multi_colon"
                name <- get_unique_name_log_file(name = name,
                                                 log_files = log_files)
                write_sumstats(
                    sumstats_dt = miss_rs_chr_bp[grep(".*:.*:.*", SNP)],
                    save_path =
                        paste0(
                            check_save_out$log_folder,
                            "/", name,
                            check_save_out$extension
                        ),
                    sep = check_save_out$sep,
                    #don't tab indx as could be miss values & cause err
                    #tabix_index = tabix_index,
                    nThread = nThread
                )
                log_files[[name]] <-
                    paste0(
                        check_save_out$log_folder, "/", name,
                        check_save_out$extension
                    )
            }
            #remove cases with more than one colon i.e. not just chr:bp
            miss_rs_chr_bp <- miss_rs_chr_bp[!grep(".*:.*:.*", SNP)]
            msg <- paste0(
                formatC(nrow(miss_rs_chr_bp), big.mark = ","),
                " SNP IDs appear to be made up of ",
                "chr:bp, these will be replaced by their SNP ID from the",
                " reference genome"
            )
            message(msg)
             SNP_LOC_DATA <- load_snp_loc_data(
                 ref_genome = ref_genome,
                 dbSNP = dbSNP,
                 dbSNP_tarball = dbSNP_tarball,
                 msg = NULL
               )
            # split out chr:bp - check if chr or bp first by longer of two
            splits <- strsplit(miss_rs_chr_bp[1, SNP],
                               split = ":", fixed = TRUE)[[1]]
            if (nchar(splits[1]) < nchar(splits[2])) {
                format <- c("CHR1", "BP1")
            } else {
                format <- c("BP1", "CHR1")
            }
            miss_rs_chr_bp[, (format) := data.table::tstrsplit(SNP,
                                                               split = ":", 
                                                               fixed = TRUE)]
            # if BP col has other info after, drop it
            if (sum(grepl("[[:punct:]].*", miss_rs_chr_bp$BP1)) > 0) {
                miss_rs_chr_bp[, BP1 := gsub("([[:punct:]]).*", "", BP1)]
            }
            # ensure integer col
            miss_rs_chr_bp[, BP1 := as.integer(BP1)]
            # now drop SNP
            miss_rs_chr_bp[, SNP := NULL]
            # if chromosome col has chr prefix remove it
            miss_rs_chr_bp[, CHR1 := gsub("chr", "", CHR1)]
            # if chromosome col has other info after, drop it
            if (sum(grepl("[[:punct:]].*", miss_rs_chr_bp$CHR1)) > 0) {
                miss_rs_chr_bp[, CHR1 := gsub("([[:punct:]]).*", "", CHR1)]
            }
            # avoid SNPs with NA values in chr or bp
            gr_snp <- data.table::copy(miss_rs_chr_bp)
            # if indels are in datqset, these should not be imputed as RS ID
            # will instead relate to a SNP at same position - remove these
            if(sum(c("A1", "A2") %in% col_headers) == 2 & indels ){
                #identify Indels based on num char in A1, A2
                num_indels <- nrow(gr_snp[(nchar(A1)>1 | nchar(A2)>1),])
                if(num_indels>0){
                    msg <- paste0("Found ",
                                  formatC(nrow(num_indels),big.mark = ","),
                                  " Indels. These won't",
                                  " be checked against the reference ",
                                  "genome as it does not contain ",
                                  "Indels.\nWARNING If your sumstat ",
                                  "doesn't contain Indels, set the ",
                                  "indel param to FALSE & rerun ",
                                  "MungeSumstats::format_sumstats()")
                    message(msg)
                    gr_snp <- gr_snp[!(nchar(A1)>1 | nchar(A2)>1),]
                }
            }
            if(nrow(gr_snp)>0){
                incl_cols <- c("CHR1", "BP1")
                gr_snp <- gr_snp[complete.cases(
                    gr_snp[, incl_cols, with = FALSE])]
                gr_snp <-
                    GenomicRanges::makeGRangesFromDataFrame(gr_snp,
                                                            keep.extra.columns = TRUE,
                                                            seqnames.field = "CHR1",
                                                            start.field = "BP1",
                                                            end.field = "BP1"
                    )
                gr_rsids <-
                    BSgenome::snpsByOverlaps(SNP_LOC_DATA, ranges = gr_snp)
                rsids <- data.table::setDT(data.frame(gr_rsids))
                data.table::setnames(rsids, "seqnames", "CHR1")
                data.table::setnames(rsids, "pos", "BP1")
                # in case there is CHR8 and chr8
                rsids[, CHR1 := tolower(as.character(CHR1))]
                miss_rs_chr_bp[, CHR1 := tolower(as.character(CHR1))]
                # join on SNP ID to sumstats
                data.table::setkeyv(miss_rs_chr_bp, c("CHR1", "BP1"))
                data.table::setkeyv(rsids, c("CHR1", "BP1"))
                miss_rs_chr_bp[rsids, SNP := i.RefSNP_id]
                # remove rows where SNP couldn't be found
                # If user wants log, save it to there
                if (log_folder_ind) {
                    name <- "snp_not_found_from_bp_chr"
                    name <- get_unique_name_log_file(name = name,
                                                     log_files = log_files)
                    write_sumstats(
                        sumstats_dt =
                            miss_rs_chr_bp[!complete.cases(
                                miss_rs_chr_bp[, "SNP"]), ],
                        save_path =
                            paste0(
                                check_save_out$log_folder,
                                "/", name,
                                check_save_out$extension
                            ),
                        sep = check_save_out$sep,
                        #don't tab indx as could be miss values & cause err
                        #tabix_index = tabix_index,
                        nThread = nThread
                    )
                    log_files[[name]] <-
                        paste0(
                            check_save_out$log_folder, "/", name,
                            check_save_out$extension
                        )
                }
                miss_rs_chr_bp <- miss_rs_chr_bp[complete.cases(
                    miss_rs_chr_bp[, "SNP"]), ]
                # remove temp columns
                miss_rs_chr_bp[, (format) := NULL]
                # join with full dataset
                # If IMPUTATION column added add it to other DT
                if (imputation_ind && 
                    "IMPUTATION_SNP" %in% names(sumstats_dt) &&
                    !"IMPUTATION_SNP" %in% names(miss_rs_chr_bp)) {
                    miss_rs_chr_bp[, IMPUTATION_SNP := NA]
                }
                # get columns in same order as rest of data table
                data.table::setcolorder(miss_rs_chr_bp, col_headers)
                sumstats_dt <- data.table::rbindlist(
                    list(sumstats_dt, miss_rs_chr_bp))
            }    
        }
        if (nrow(miss_rs) != nrow(sumstats_dt) && nrow(miss_rs) != 0) {
            #Prev if (nrow(miss_rs_chr_bp) == 0) {
            if (nrow(miss_rs_chr_bp) < nrow(miss_rs)) {
                # don't filter twice if hit prev condition
                # check if impute of correct SNP ID possible
                if (sum(c("CHR", "BP") %in% col_headers) == 2 &&
                    nrow(sumstats_dt[!grep("^rs", SNP), ]) > 0) {
                    bad_snp <- sumstats_dt[!grep("^rs", SNP), ]
                    msg <- paste0(
                        formatC(nrow(bad_snp), big.mark = ","),
                        " SNP IDs are not correctly formatted.",
                        " These will be corrected from the reference genome."
                    )
                    message(msg)
                    # remove snp column and pass to function to impute snp
                    bad_snp <- bad_snp[, SNP := NULL]
                    if(sum(c("A1", "A2") %in% col_headers) == 2 & indels ){
                        #identify Indels based on num char in A1, A2
                        num_indels <- nrow(bad_snp[(nchar(A1)>1 | 
                                                        nchar(A2)>1),])
                        if(num_indels>0){
                            msg <- paste0("Found ",
                                          formatC(nrow(num_indels),
                                                  big.mark = ","),
                                          " Indels. These won't",
                                          " be checked against the referenc",
                                          "e genome as it does not contain ",
                                          "Indels.\nWARNING If your sumstat ",
                                          "doesn't contain Indels, set the ",
                                          "indel param to FALSE & rerun ",
                                          "MungeSumstats::format_sumstats()")
                            message(msg)
                            bad_snp <- bad_snp[!(nchar(A1)>1 | nchar(A2)>1),]
                        }
                    }
                    # now impute correct RS ID for those missing it
                    corrected_snp <-
                        check_no_snp(
                            sumstats_dt = bad_snp, path = tempfile(),
                            ref_genome = ref_genome, 
                            indels = indels,
                            imputation_ind = imputation_ind,
                            log_folder_ind = log_folder_ind,
                            check_save_out = check_save_out,
                            tabix_index = tabix_index,
                            nThread = nThread, 
                            log_files = log_files,
                            dbSNP=dbSNP,
                            dbSNP_tarball = dbSNP_tarball,
                            verbose = FALSE
                        )
                    log_files <- corrected_snp$log_files
                    corrected_snp <- corrected_snp$sumstats_dt
                    # make sure columns in correct order
                    data.table::setcolorder(corrected_snp,
                                            names(sumstats_dt))
                    # remove rows missing from the reference genome and combine
                    # If IMPUTATION column added add it to other DT
                    if (imputation_ind &&
                        !"IMPUTATION_SNP" %in% names(sumstats_dt)) {
                        sumstats_dt[, IMPUTATION_SNP := NA]
                    }
                    sumstats_dt <-
                        data.table::rbindlist(list(
                            sumstats_dt[grep("^rs", SNP), ],
                            corrected_snp
                        ))
                }
                # remove snps missing rs
                # If user wants log, save it to there
                if (log_folder_ind &&
                    nrow(sumstats_dt[!grep("^rs", SNP), ]) > 0) {
                    #if imputation ind on, NA's will be replaced with NA_i
                    #change back here
                    tmp_rmv <- sumstats_dt[!grepl("^rs", SNP), ]
                    if(imputation_ind){
                      tmp_rmv[, SNP_old_temp := NULL]
                      tmp_rmv[grepl("^NA_",SNP), SNP := NA]
                    }
                    name <- "snp_missing_rs"
                    name <- get_unique_name_log_file(name = name,
                                                     log_files = log_files)
                    write_sumstats(
                        sumstats_dt = tmp_rmv,
                        save_path =
                            paste0(
                                check_save_out$log_folder,
                                "/", name,
                                check_save_out$extension
                            ),
                        sep = check_save_out$sep,
                        #don't tab indx as could be miss values & cause err
                        #tabix_index = tabix_index,
                        nThread = nThread
                    )
                    log_files[[name]] <-
                        paste0(check_save_out$log_folder, "/",
                               name, check_save_out$extension)
                }
                sumstats_dt <- sumstats_dt[grep("^rs", SNP), ]
            }
            # if any weird SNP rows left that aren't 
            # chr:bp or rs id's remove them
            if (sum(c("CHR", "BP") %in% col_headers) != 2) {
                msg <-
                    paste0(
                        formatC(nrow(miss_rs) - nrow(miss_rs_chr_bp),
                                big.mark = ","),
                        " SNP IDs are not correctly",
                        " formatted and will be removed."
                    )
                message(msg)
            }
        }
        # also check for weirdly formatted SNPs like rs1234:.....
        # remove everything after : and put in separate column
        # (can extend code to infer info from this separate column later)
        rs_plus <- sumstats_dt[intersect(grep("^rs", SNP), grep(":", SNP)), ]
        if (nrow(rs_plus) != 0) {
            msg <- paste0(
                formatC(nrow(rs_plus), big.mark = ","),
                " SNP IDs contain other information in the same column.",
                " These will be separated."
            )
            message(msg)
            setnames(rs_plus, "SNP", "SNP_INFO")
            # isolate RS ID
            rs_plus[, SNP := sub("\\:.*", "", SNP_INFO)]
            # isolate extra info
            rs_plus[, SNP_INFO := sub("^.*?:", "", SNP_INFO)]
            # join back
            # add extra column
            sumstats_dt[, SNP_INFO := NA]
            # make sure columns in correct order
            data.table::setcolorder(rs_plus, names(sumstats_dt))
            # update values
            sumstats_dt <-
                data.table::rbindlist(list(
                    sumstats_dt[!intersect(
                        grep("^rs", SNP),
                        grep(":", SNP)
                    ), ],
                    rs_plus
                ))
        }
        # if imputation_ind return column specifying imputed
        if (imputation_ind) {
            # make sure there are rows that would need imputing
            if (nrow(miss_rs) > 0 && nrow(miss_rs) != nrow(sumstats_dt) &&
                (nrow(miss_rs_chr_bp) > 0 | nrow(miss_rs) != 0)) {
                setkey(miss_rs, SNP_old_temp)
                setkey(sumstats_dt, SNP_old_temp)
                sumstats_dt[miss_rs, IMPUTATION_SNP := TRUE]
            }
            # remove temp columns either way
            sumstats_dt[, SNP_old_temp := NULL]
        }
        return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
    } else {
        return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
    }
}

#' Remove empty columns
#' 
#' Remote columns that are empty or contain all the same values in a data.table.
#' @inheritParams format_sumstats
#' @inheritParams check_empty_cols
#' @keywords internal
#' @returns Null output.
remove_empty_cols <- function(sumstats_dt, 
                              sampled_rows=NULL,
                              verbose=TRUE){
    #### Check for empty columns ####
    messager("Checking for empty columns.",v=verbose)
    empty_cols <- check_empty_cols(
        sumstats_dt = sumstats_dt,
        sampled_rows = sampled_rows,
        verbose = FALSE
    )
    #### Remove empty columns #####
    if(length(empty_cols)>0) {
        messager("Removing",length(empty_cols),"empty columns.",v=verbose)
        sumstats_dt[,(names(empty_cols)):=NULL] 
    }
} 

#' Check for empty columns
#'
#' Empty columns contain only ".", NA, or 0
#' @inheritParams format_sumstats
#' @param sampled_rows First N rows to sample.
#' Set \code{NULL} to use full \code{sumstats_file}.
#' when determining whether cols are empty.
#' 
#' @param verbose Print messages.
#' 
#' @return empty_cols
#' @keywords internal
#' @importFrom utils head
check_empty_cols <- function(sumstats_dt,
                             sampled_rows = NULL, 
                             verbose = TRUE) {
    if (is.null(sampled_rows)) {
        sampled_rows <- nrow(sumstats_dt)
    } else {
        sampled_rows <- min(sampled_rows, nrow(sumstats_dt))
    }
    empty_cols <- vapply(
        colnames(sumstats_dt), function(x) {
            dt <- utils::head(sumstats_dt, sampled_rows)
            (sum(unlist(dt[[x]]) != ".") == 0) |
                (sum(!is.na(unlist(dt[[x]]))) == 0) |
                (sum(unlist(dt[[x]]) != 0) == 0)
        },
        FUN.VALUE = logical(1)
    )
    #sometimes NA values appear, they aren't empty so change these to false
    empty_cols <- ifelse(is.na(empty_cols),FALSE,empty_cols)
    empty_cols <- empty_cols[empty_cols]
    messager(length(empty_cols), "empty column(s) detected.",
             v=verbose)
    return(empty_cols)
}

#' Get combinations of uncorrected allele and effect (and frq) columns
#'
#' @inheritParams format_sumstats 
#' @inheritParams compute_nsize
#' @param eff_frq_cols Corrected effect or frequency column names found in a 
#' sumstats. Default of BETA, OR, LOG_ODDS, SIGNED_SUMSTAT, Z and FRQ.
#' @return datatable containing uncorrected and corrected combinations
#' @importFrom data.table setnames as.data.table := setkey rbindlist data.table
get_eff_frq_allele_combns <-
  function(mapping_file = sumstatsColHeaders, 
           eff_frq_cols = c("BETA", "OR", "LOG_ODDS", "SIGNED_SUMSTAT","Z",
                            "FRQ")) {
    ### Add this to avoid confusing BiocCheck
    CORRECTED <- UNCORRECTED <- Var1 <- Var2 <- NULL 
    colnames(mapping_file) <- toupper(colnames(mapping_file))
    #get allele associated effect/FRQ columns
    #get all combinations with allele columns
    eff_frq_cols_uncorrc <- 
      mapping_file[mapping_file$CORRECTED %in% eff_frq_cols,]$UNCORRECTED
    #join with all allele cols
    allele_uncorrc <- 
      mapping_file[mapping_file$CORRECTED %in% c('A1','A2','A*'),]$UNCORRECTED
    #get combinations
    eff_frq_allele_dt <- 
      data.table::as.data.table(expand.grid(eff_frq_cols_uncorrc, 
                                            allele_uncorrc))
    mapping_file_dt <- data.table::as.data.table(mapping_file)
    data.table::setkey(mapping_file_dt,"UNCORRECTED")
    data.table::setkey(eff_frq_allele_dt,"Var1")
    #add corrected
    eff_frq_allele_dt[mapping_file,CORRECTED:=CORRECTED,]
    #now loop through every joining character and join with eff both before
    #and after
    joining_char <- c("","_",".","-"," ")
    all_combns <- vector(mode="list",length = length(joining_char)*2)
    counter <- 1
    for(join_i in joining_char){
      eff_frq_allele_dt_i <- copy(eff_frq_allele_dt)  
      eff_frq_allele_dt_i[,UNCORRECTED:=paste0(Var1,join_i,Var2)]
      all_combns[[counter]] <- 
        eff_frq_allele_dt_i[,c("UNCORRECTED","CORRECTED")]
      counter <- counter+1
      #same for Var 2 in front
      eff_frq_allele_dt_i <- copy(eff_frq_allele_dt)  
      eff_frq_allele_dt_i[,UNCORRECTED:=paste0(Var2,join_i,Var1)]
      all_combns[[counter]] <- 
        eff_frq_allele_dt_i[,c("UNCORRECTED","CORRECTED")]
      counter <- counter+1
    }
    #join all together
    eff_frq_allele_matches <- data.table::rbindlist(all_combns)
    #finally add some custom ones 
    custom_adds <- data.table::data.table("UNCORRECTED" = 
                                            c("BETA1", "BETA2","BETA0",
                                              "AF1","AF2","AF0",
                                              "FREQ.A1.1000G.EUR",
                                              "FREQ.A2.1000G.EUR",
                                              "FREQ.A0.1000G.EUR",
                                              "FREQ.A1.ESP.EUR",
                                              "FREQ.A2.ESP.EUR",
                                              "FREQ.A0.ESP.EUR",
                                              "FREQ.ALLELE1.HAPMAPCEU",
                                              "FREQ.ALLELE2.HAPMAPCEU",
                                              "FREQ.ALLELE0.HAPMAPCEU",
                                              "FREQ1","FREQ2","FREQ0", 
                                              "FREQ1.HAPMAP","FREQ2.HAPMAP",
                                              "FREQ0.HAPMAP"),
                                          "CORRECTED" = 
                                            c("BETA", "BETA","BETA",
                                              "FRQ","FRQ","FRQ",
                                              "FRQ",
                                              "FRQ",
                                              "FRQ",
                                              "FRQ",
                                              "FRQ",
                                              "FRQ",
                                              "FRQ",
                                              "FRQ",
                                              "FRQ",
                                              "FRQ","FRQ","FRQ",
                                              "FRQ","FRQ",
                                              "FRQ"))
    eff_frq_allele_matches <- data.table::rbindlist(list(
      eff_frq_allele_matches,custom_adds))
    
    return(eff_frq_allele_matches)
  }

#' Summary Statistics Column Headers
#'
#' @description List of uncorrected column headers often found in GWAS Summary
#' Statistics column headers. Note the effect allele will always be the A2
#' allele, this is the approach done for
#' VCF(https://www.ncbi.nlm.nih.gov/pmc/articles/PMC7805039/). This is enforced
#' with the column header corrections here and also the check allele flipping
#' test.
#'
#' @source The code to prepare the .Rda file file from the marker file is:
#' \code{
#' # Most the data in the below table comes from the LDSC github wiki
#' data("sumstatsColHeaders")
#' # Make additions to sumstatsColHeaders using github version of MungeSumstats-
#' # Shown is an example of adding new A1 and A2 naming
#' a1_name <- c("NON","RISK","ALLELE")
#' a2_name <- c("RISK","ALLELE")
#' all_delims <- c("_",".",""," ","-")
#' all_uncorr_a1 <- vector(mode="list",length = length(all_delims))
#' all_corr_a1 <- vector(mode="list",length = length(all_delims))
#' all_uncorr_a2 <- vector(mode="list",length = length(all_delims))
#' all_corr_a2 <- vector(mode="list",length = length(all_delims))
#' for(i in seq_along(all_delims)){
#' delim <- all_delims[i]
#' a1 <- unlist(paste(a1_name,collapse=delim))
#' a2 <- unlist(paste(a2_name,collapse=delim))
#' all_uncorr_a1[[i]] <- a1
#' all_uncorr_a2[[i]] <- a2
#' all_corr_a1[[i]] <- "A1"
#'   all_corr_a2[[i]] <- "A2"
#' }
#' se_cols <- data.frame("Uncorrected"=c(unlist(all_uncorr_a1),unlist(all_uncorr_a2)),
#'                      "Corrected"=c(unlist(all_corr_a1),unlist(all_corr_a2)))
#' # Or another example .....
#' # shown is an example of adding columns for Standard Error (SE)
#' se_cols <- data.frame("Uncorrected"=c("SE","se","STANDARD.ERROR",
#'                                       "STANDARD_ERROR","STANDARD-ERROR"),
#'                      "Corrected"=rep("SE",5))
#' sumstatsColHeaders <- rbind(sumstatsColHeaders,se_cols)
#' #Once additions are made, order & save the new mapping dataset
#' #now sort ordering -important for logic that 
#' # uncorrected=corrected comes first
#' sumstatsColHeaders$ordering <-
#'     sumstatsColHeaders$Uncorrected==sumstatsColHeaders$Corrected
#' sumstatsColHeaders <-
#'     sumstatsColHeaders[order(sumstatsColHeaders$Corrected,
#'                              sumstatsColHeaders$ordering,decreasing = TRUE),]
#' rownames(sumstatsColHeaders)<-1:nrow(sumstatsColHeaders)
#' sumstatsColHeaders$ordering <- NULL
#' #manually move FREQUENCY to above MAR - github issue 95
#' frequency <- sumstatsColHeaders[sumstatsColHeaders$Uncorrected=="FREQUENCY",]
#' maf <- sumstatsColHeaders[sumstatsColHeaders$Uncorrected=="MAF",]
#' if(as.integer(rownames(frequency))>as.integer(rownames(maf))){
#'   sumstatsColHeaders[as.integer(rownames(frequency)),] <- maf
#'   sumstatsColHeaders[as.integer(rownames(maf)),] <- frequency
#' }   
#' usethis::use_data(sumstatsColHeaders,overwrite = TRUE, internal=TRUE)
#' save(sumstatsColHeaders,
#'       file="data/sumstatsColHeaders.rda")
#' # You will need to restart your r session for effects to take account
#' }
#' @format dataframe with 2 columns
#' @usage data("sumstatsColHeaders")
"sumstatsColHeaders"


#' GWAS Educational Attainment Okbay 2016 - Subset
#'
#' @description GWAS Summary Statistics on Educational Attainment by Okbay et
#' al 2016:
#' PMID: 27898078 PMCID: PMC5509058 DOI: 10.1038/ng1216-1587b.
#' A subset of 93 SNPs
#'
#' @details GWAS Summary Statistics on Educational Attainment by Okbay et
#' al 2016 has been subsetted here to act as an example summary statistic file
#' which has some issues in the formatting. MungeSumstats can correct these
#' issues.
#'
#' @name raw_eduAttainOkbay
#' @section eduAttainOkbay.txt
#' @source The summary statistics file was downloaded from
#' https://www.nature.com/articles/ng.3552
#' and formatted to a .rda with the following:
#' \code{
#' #Get example dataset, use Educational-Attainment_Okbay_2016
#' link<-"Educational-Attainment_Okbay_2016/EduYears_Discovery_5000.txt"
#' eduAttainOkbay<-readLines(link,n=100)
#' #There is an issue where values end with .0, this 0 is removed in func
#' #There are also SNPs not on ref genome or arebi/tri allelic
#' #So need to remove these in this dataset as its used for testing
#' tmp <- tempfile()
#' writeLines(eduAttainOkbay,con=tmp)
#' eduAttainOkbay <- data.table::fread(tmp) #DT read removes the .0's
#' #remove those not on ref genome and withbi/tri allelic
#' rmv <- c("rs192818565","rs79925071","rs1606974","rs1871109",
#'          "rs73074378","rs7955289")
#' eduAttainOkbay <- eduAttainOkbay[!MarkerName %in% rmv,]
#' data.table::fwrite(eduAttainOkbay,file=tmp,sep="\t")
#' eduAttainOkbay <- readLines(tmp)
#' writeLines(eduAttainOkbay,"inst/extdata/eduAttainOkbay.txt")
#' }
#' @format txt document with 94 items
NULL


#' GWAS Amyotrophic lateral sclerosis ieu open GWAS project - Subset
#'
#' @description VCF (VCFv4.2) of the GWAS Amyotrophic lateral sclerosis ieu
#' open GWAS project Dataset: ebi-a-GCST005647.
#' A subset of 99 SNPs
#'
#' @name raw_ALSvcf
#' @section ALSvcf.vcf
#' @details A VCF file (VCFv4.2) of the GWAS Amyotrophic lateral sclerosis ieu
#' open GWAS project has been subsetted here to act as an example summary
#' statistic file in VCF format which has some issues in the formatting.
#' MungeSumstats can correct these issues and produced a standardised summary
#' statistics format.
#' @source The summary statistics VCF (VCFv4.2) file was downloaded from
#' https://gwas.mrcieu.ac.uk/datasets/ebi-a-GCST005647/
#' and formatted to a .rda with the following:
#' \code{
#' #Get example VCF dataset, use GWAS Amyotrophic lateral sclerosis
#' ALS_GWAS_VCF <- readLines("ebi-a-GCST005647.vcf.gz")
#' #Subset to just the first 99 SNPs
#' ALSvcf <- ALS_GWAS_VCF[1:528]
#' writeLines(ALSvcf,"inst/extdata/ALSvcf.vcf")
#' }
#' @format vcf document with 528 items relating to 99 SNPs
#' @details NULL
NULL

#' UCSC Chain file hg38 to hg19
#'
#' @description UCSC Chain file hg38 to hg19, .chain.gz file, downloaded from 
#' https://hgdownload.cse.ucsc.edu/goldenpath/hg19/liftOver/ on 09/10/21
#'
#' @name hg38ToHg19
#' @section hg38ToHg19.over.chain.gz
#' @details UCSC Chain file hg38 to hg19, .chain.gz file, downloaded on 09/10/21
#' To be used as a back up if the download from UCSC fails.
#' @source The chain file was downloaded from
#' https://hgdownload.cse.ucsc.edu/goldenpath/hg38/liftOver/ 
#' \code{
#' utils::download.file('ftp://hgdownload.cse.ucsc.edu/goldenPath/hg38/liftOver/hg38ToHg19.over.chain.gz',tempdir())
#' }
#' @format gunzipped chain file
#' @details NULL
NULL

#' UCSC Chain file hg19 to hg38
#'
#' @description UCSC Chain file hg19 to hg38, .chain.gz file, downloaded from 
#' https://hgdownload.cse.ucsc.edu/goldenpath/hg19/liftOver/ on 09/10/21
#'
#' @name hg19ToHg38
#' @section hg19ToHg38.over.chain.gz
#' @details UCSC Chain file hg19 to hg38, .chain.gz file, downloaded on 09/10/21
#' To be used as a back up if the download from UCSC fails.
#' @source The chain file was downloaded from
#' https://hgdownload.cse.ucsc.edu/goldenpath/hg19/liftOver/ 
#' \code{
#' utils::download.file('ftp://hgdownload.cse.ucsc.edu/goldenPath/hg19/liftOver/hg19ToHg38.over.chain.gz',tempdir())
#' }
#' @format gunzipped chain file
#' @details NULL
NULL

#' Local ieu-a-298 file from IEU Open GWAS
#'
#' @description Local ieu-a-298 file from IEU Open GWAS, downloaded on 09/10/21.
#'
#' @name ieu-a-298
#' @section ieu-a-298.tsv.gz
#' @details Local ieu-a-298 file from IEU Open GWAS, downlaoded on 09/10/21. 
#' This is done in case the download in the package vignette fails.
#' @source The file was downloaded with:
#' \code{
#' MungeSumstats::import_sumstats(ids = "ieu-a-298",ref_genome = "GRCH37")
#' }
#' @format gunzipped tsv file
#' @details NULL
NULL

#' Import full genome-wide GWAS summary statistics from Open GWAS
#'
#' Requires internet access to run.
#'
#' @param ids List of Open GWAS study IDs 
#' (e.g. \code{c("prot-a-664", "ieu-b-4760")}).
#' @param vcf_download Download the original VCF from Open GWAS.
#' @param vcf_dir Where to download the original VCF from Open GWAS.
#' \emph{WARNING:} This is set to \code{tempdir()} by default.
#' This means the raw (pre-formatted) VCFs be deleted upon ending the R session.
#' Change this to keep the raw VCF file on disk 
#' (e.g. \code{vcf_dir="./raw_vcf"}).
#' @param save_dir Directory to save formatted summary statistics in.
#' @param force_new_vcf Overwrite a previously downloaded VCF 
#' with the same path name.
#' @param parallel_across_ids If \code{parallel_across_ids=TRUE} 
#' and \code{nThread>1}, 
#' then each ID in \code{ids} will be processed in parallel.
#' @param ... Additional arguments passed to 
#' \link[MungeSumstats]{format_sumstats}.
#' @inheritParams format_sumstats
#' @inheritDotParams format_sumstats
#' @inheritParams downloader
#'
#' @return Either a named list of data objects or paths,
#' depending on the arguments passed to \code{format_sumstats}.
#'
#' @examples
#' #only run the examples if user has internet access:
#' if(try(is.character(getURL("www.google.com")))==TRUE){
#' ### Search by criteria
#' metagwas <- find_sumstats(
#'     traits = c("parkinson", "alzheimer"),
#'     min_sample_size = 5000
#' )
#' ### Only use a subset for testing purposes
#' ids <- (dplyr::arrange(metagwas, nsnp))$id
#'
#' ### Default usage
#' ## You can supply \code{import_sumstats()}
#' ## with a list of as many OpenGWAS IDs as you want,
#' ## but we'll just give one to save time.
#'
#' ## Call uses reference genome as default with more than 2GB of memory,
#' ## which is more than what 32-bit Windows can handle so remove certain checks
#' ## commented out down to runtime
#' # datasets <- import_sumstats(ids = ids[1])
#' }
#' @export
#' @importFrom dplyr %>%
#' @importFrom RCurl getURL
import_sumstats <- function(ids,
                            vcf_dir = tempdir(),
                            vcf_download = TRUE,
                            save_dir = tempdir(),
                            write_vcf = FALSE,
                            download_method = "download.file",
                            quiet = TRUE,
                            force_new = FALSE,
                            force_new_vcf = FALSE,
                            nThread = 1,
                            parallel_across_ids = FALSE,
                            ...) {
    # vcf_dir=tempdir(); vcf_download=TRUE;download_method="axel";quiet=FALSE;
    # force_new=FALSE;nThread=10; ids=c("ieu-a-1124","ieu-a-1125"); id=ids[1];
    # ref_genome=NULL;
    
    #### Check download method ####
    msg_dwnld <- paste0(
        "download_method must be `download.file` (single-threaded)",
        "or `axel` (multi-threaded)."
    )
    if (!tolower(download_method) %in% c("download.file", "axel")) {
        stop(msg_dwnld)
    }
    download_method <- tolower(download_method)[1] 
    #### start overall timer ####
    start_all <- Sys.time()
    ids <- unique(ids)
    message("Processing ", length(ids), " datasets from Open GWAS.")
    #### Handle parallelization parameters ####
    if (parallel_across_ids) {
        nThread_acrossIDs <- nThread
        nThread <- 1
        message(
            "parallel_across_ids=TRUE: ",
            "most notes will be hidden in this mode."
        )
    } else {
        nThread_acrossIDs <- 1
    }
    #### Iterate over IDS ####
    ouputs <- parallel::mclapply(ids, function(id) {
        out <- tryCatch(expr = {
            start <- Sys.time()
            message_parallel(
                "\n========== Processing dataset : ", id,
                " ==========\n"
            )
            
            vcf_urls <- ieugwasr::gwasinfo_files(id = id)[[1]] 
            # vcf_url <-
            #     paste(
            #         "https://gwas.mrcieu.ac.uk/files", id,
            #         paste0(id,".vcf.gz"),sep="/"
            #     )
            #### Create path of the output file ####
            vcf_url <- vcf_urls[1]
            id_dir <- file.path(save_dir, id)
            save_path <- file.path(id_dir, basename(vcf_url))
            if (!write_vcf) save_path <- gsub(".vcf.gz", ".tsv.gz", save_path)
            dir.create(id_dir, 
                       showWarnings = FALSE, recursive = TRUE)
            #### Create dataset-specific folders/paths ####
            log_folder <- file.path(id_dir,"logs")
            dir.create(log_folder, showWarnings = FALSE, recursive = TRUE) 
            #### Check if formatted file exists BEFORE downloading VCF ####
            if((!file.exists(save_path)) || isTRUE(force_new)){  
                #### Optional:: download VCF ####
                vcf_paths <- download_vcf(
                    vcf_urls = vcf_urls,
                    vcf_dir = vcf_dir,
                    vcf_download = vcf_download,
                    download_method = download_method,
                    force_new = force_new_vcf,
                    quiet = quiet,
                    nThread = nThread
                ) 
            } 
            #### format_sumstats #### 
            reformatted <- format_sumstats(
                path = vcf_paths$save_path,
                save_path = save_path,
                log_folder = log_folder,
                force_new = force_new,
                nThread = nThread,
                ...
            )
            end <- Sys.time()
            message(
                "\n", id, " : Done in ",
                round(difftime(end, start, units = "mins"), 3), " minutes."
            )
            return(reformatted)
        }, 
        error = function(e){message(e);e}
        ) 
        return(out)
    }, mc.cores = nThread_acrossIDs) %>% `names<-`(ids)
    
    end_all <- Sys.time()
    message(
        "\nDone with all processing in ",
        round(difftime(end_all, start_all, units = "mins"), 2), " minutes."
    )
    return(ouputs)
}

#' Read VCF: MarkerName column
#' 
#' Parse MarkerName/SNP column in VCF file.
#' 
#' @param sumstats_dt Summary stats data.table. 
#' @keywords internal
#' @returns Null output.
read_vcf_markername <- function(sumstats_dt){
    if(!"SNP" %in% colnames(sumstats_dt)){
        if ("MarkerName" %in% colnames(sumstats_dt)) { 
            messager("Renaming MarkerName as SNP.")
            data.table::setnames(x = sumstats_dt,
                                 old = "MarkerName", 
                                 new = "SNP")  
        } else if ("ID" %in% colnames(sumstats_dt) ) { 
            messager("Renaming ID as SNP.")
            data.table::setnames(x = sumstats_dt,
                                 old = "ID", 
                                 new = "SNP")  
        }
    } 
}

#' Ensure all rows have unique positions, drop those that don't
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and log files list
#' @keywords internal
#' @importFrom data.table key
#' @importFrom data.table setkey
check_dup_bp <- function(sumstats_dt,
                         bi_allelic_filter,
                         check_dups,
                         indels,
                         path,
                         log_folder_ind,
                         check_save_out,
                         tabix_index,
                         nThread,
                         log_files) {
    BP <- CHR <- A1 <- A2 <- SNP <- NULL
    col_headers <- names(sumstats_dt)
    #non-bi-allelic SNPs can share same BP position so don't check if selected
    if (sum(c("BP", "CHR") %in% col_headers) == 2 && 
        bi_allelic_filter && check_dups) {
        message("Checking for SNPs with duplicated base-pair positions.")
        # Try to remove duplicated Positions
        data.table::setkey(sumstats_dt, BP, CHR)
        #remove indels from this check if sleected since these can have same pos
        indel_dt <- data.table::data.table()
        if(sum(c("A1", "A2") %in% col_headers) == 2 & indels ){
            #identify Indels based on num char in A1, A2
            num_indels <- nrow(sumstats_dt[(nchar(A1)>1 | nchar(A2)>1),])
            if(num_indels>0){
                msg <- paste0("Found ",
                              formatC(num_indels,big.mark = ","),
                              " Indels. These won't",
                              " be checked for duplicates based on base-pair ",
                              "position as there can be multiples.",
                              "\nWARNING If your sumstat ",
                              "doesn't contain Indels, set the ",
                              "indel param to FALSE & rerun ",
                              "MungeSumstats::format_sumstats()")
                message(msg)
                indel_dt <- sumstats_dt[(nchar(A1)>1 | nchar(A2)>1),]
                #run generic dup check on indels
                indel_dt_rtn <- check_dup_row(
                    sumstats_dt = indel_dt,
                    check_dups = check_dups,
                    path = path,
                    log_folder_ind = log_folder_ind,
                    check_save_out = check_save_out,
                    tabix_index = tabix_index,
                    nThread = nThread,
                    log_files = log_files
                )
                indel_dt <- indel_dt_rtn$sumstats_dt
                # update values
                log_files <- indel_dt_rtn$log_files
                sumstats_dt <- sumstats_dt[!(nchar(A1)>1 | nchar(A2)>1),]
            }
        }
        dups <- duplicated(sumstats_dt, by = data.table::key(sumstats_dt))
        if (sum(dups) > 0) {
            msg <- paste0(
                formatC(sum(dups), big.mark = ","),
                " base-pair positions are",
                " duplicated in the sumstats file. These duplicates will",
                " be removed."
            )
            message(msg)
            # If user wants log, save it to there
            if (log_folder_ind) {
                name <- "dup_base_pair_position"
                name <- get_unique_name_log_file(
                    name = name,
                    log_files = log_files
                )
                write_sumstats(
                    sumstats_dt = sumstats_dt[dups, ],
                    save_path =
                        paste0(
                            check_save_out$log_folder,
                            "/", name,
                            check_save_out$extension
                        ),
                    sep = check_save_out$sep,
                    #don't tab indx as could be miss values & cause err
                    #tabix_index = tabix_index,
                    nThread = nThread
                )
                log_files[[name]] <-
                    paste0(
                        check_save_out$log_folder, "/",
                        name, check_save_out$extension
                    )
            }
            sumstats_dt <- unique(sumstats_dt,
                by = data.table::key(sumstats_dt)
            )
            
            #join back indels
            sumstats_dt <-
                data.table::rbindlist(
                    list(sumstats_dt, indel_dt))

            return(list(
                "sumstats_dt" = sumstats_dt,
                "log_files" = log_files
            ))
        }
        #join back indels
        sumstats_dt <-
            data.table::rbindlist(
                list(sumstats_dt, indel_dt))
    }
    else{
        #run generic dup check
        sumstats_return <- check_dup_row(
            sumstats_dt = sumstats_dt,
            check_dups = check_dups,
            path = path,
            log_folder_ind = log_folder_ind,
            check_save_out = check_save_out,
            tabix_index = tabix_index,
            nThread = nThread,
            log_files = log_files
        )
        sumstats_dt <- sumstats_return$sumstats_dt
        log_files <- sumstats_return$log_files
    }
    return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
}

#' Ensures that parameters are compatible with LDSC format
#'
#' Format summary statistics for direct input to
#' Linkage Disequilibrium SCore (LDSC) regression without the need
#' to use their \code{munge_sumstats.py} script first.
#'
#' \href{https://github.com/bulik/ldsc/wiki/Summary-Statistics-File-Format}{
#' LDSC documentation}.
#'
#' @inheritParams format_sumstats
#' @inheritParams check_zscore
#'
#' @return Formatted summary statistics
#' @source \href{https://github.com/bulik/ldsc}{LDSC GitHub}
check_ldsc_format <- function(sumstats_dt, save_format, convert_n_int,
                              allele_flip_check, compute_z, compute_n) {
    # LDSC Requires SNP,N,Z,A1,A2
    # SNP,A1,A2 is enforced by MungeSumstats automatically
    if (!is.null(save_format) && 
          tolower(save_format)=="ldsc") {
        message("Ensuring parameters comply with LDSC format.")
        # check if columns already exist
        z_present <- "Z" %in% names(sumstats_dt)
        n_present <- "N" %in% names(sumstats_dt)
        if (!convert_n_int) {
            message("Setting `convert_n_int=TRUE` to comply with LDSC format.")
            convert_n_int <- TRUE
        }
        if (!allele_flip_check) {
            msg <- paste(
                "Setting `allele_flip_check=TRUE`",
                "to comply with LDSC format."
            )
            message()
            allele_flip_check <- TRUE
        }
        n_msg <- paste0(
          "LDSC requires an N column but your dataset doesn't ",
          "appear to have one. You can impute an N value for ",
          "all your SNPs\nby setting `compute_n` to this value but",
          " note this is may not be correct and may lead to ",
          "different results from LDSC\nthan if the true N per SNP",
          " was known."
        )
        if (!z_present && isFALSE(compute_z)) {
          beta_se_present <- ("BETA" %in% names(sumstats_dt) && 
                                "SE" %in% names(sumstats_dt))
          p_present <- "P" %in% names(sumstats_dt)
          if(beta_se_present){
            message("Setting `compute_z=BETA` to comply with LDSC format.")
            compute_z <- "BETA"
          }else if(p_present){
            message("Setting `compute_z=P` to comply with LDSC format.")
            compute_z <- "P"
          } else{
            stop(n_msg)  
          } 
        }
        if (compute_n == 0L && !n_present) {
          stop(n_msg)
        }
    }
    return(list(
        save_format = save_format,
        convert_n_int = convert_n_int,
        allele_flip_check = allele_flip_check,
        compute_z = compute_z
    ))
}

#' Remove SNPs with strand-ambiguous alleles
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and the log file list
#' @keywords internal
#' @importFrom data.table setkey
#' @importFrom data.table :=
check_strand_ambiguous <- function(sumstats_dt, 
                                   path, 
                                   ref_genome, 
                                   strand_ambig_filter,
                                   log_folder_ind,
                                   check_save_out, 
                                   tabix_index, 
                                   nThread, 
                                   log_files) {
        CHR <- alleles_as_ambig <- SNP <- A1 <- A2 <- NULL
        # If SNP present and user specified to remove
        col_headers <- names(sumstats_dt)
        if ("SNP" %in% col_headers && !isFALSE(strand_ambig_filter)) {
            message("Checking for strand ambiguous SNPs.")
            A_T_ambig <- sumstats_dt[A1 == "A" & 
                                         A2 == "T" | 
                                         A1 == "T" & 
                                         A2 == "A", ]$SNP
            C_G_ambig <- sumstats_dt[A1 == "C" &
                                         A2 == "G" | 
                                         A1 == "G" & 
                                         A2 == "C", ]$SNP
            num_bad_ids <- length(A_T_ambig) + length(C_G_ambig)
            # check for SNPs not on ref genome
            if (num_bad_ids > 0) {
                msg <- paste0(
                    formatC(num_bad_ids, big.mark = ","),
                    " SNPs are strand-ambiguous alleles including",
                    " ", formatC(length(A_T_ambig), big.mark = ","),
                    " A/T and ", formatC(length(C_G_ambig), big.mark = ","),
                    " C/G ambiguous SNPs. These will be removed"
                )
                message(msg)
                rmv_snps <- c(A_T_ambig, C_G_ambig)
                # join using SNP
                data.table::setkey(sumstats_dt, SNP)
                # remove strand ambiguous SNPs
                # If user wants log, save it to there
                if (log_folder_ind) {
                    name <- "snp_strand_ambiguous"
                    name <- get_unique_name_log_file(name = name,
                                                     log_files = log_files)
                    write_sumstats(
                        sumstats_dt = sumstats_dt[rmv_snps, ],
                        save_path =
                            paste0(
                                check_save_out$log_folder,
                                "/", name,
                                check_save_out$extension
                            ),
                        sep = check_save_out$sep,
                        #don't tab indx as could be miss values & cause err
                        #tabix_index = tabix_index,
                        nThread = nThread
                    )
                    log_files[[name]] <-
                        paste0(
                            check_save_out$log_folder, "/", name,
                            check_save_out$extension
                        )
                }
                sumstats_dt <- sumstats_dt[!rmv_snps, ]
            }
            return(list("sumstats_dt" = sumstats_dt,
                        "log_files" = log_files))
        } else {
            return(list("sumstats_dt" = sumstats_dt,
                        "log_files" = log_files))
        }
    }

#' Formatted example
#' 
#' Returns an example of summary stats that have had their column names 
#' already standardised with 
#' \link[MungeSumstats]{standardise_header}.
#' 
#' @param path Path to raw example file. Default to built-in dataset.
#' @param formatted Whether the column names should be formatted 
#' (default:\code{TRUE}).
#' @param sorted Whether the rows should be sorted by genomic coordinates
#' (default:\code{TRUE}).
#' @return \code{sumstats_dt}
#' @export
#' @examples 
#' sumstats_dt <- MungeSumstats::formatted_example()
formatted_example <- function(path=system.file("extdata", "eduAttainOkbay.txt",
                                               package = "MungeSumstats"),
                              formatted=TRUE,
                              sorted=TRUE){
    sumstats_dt <- suppressMessages(
        read_sumstats(path = path)
    )
    if(formatted){
        sumstats_dt <- standardise_header(sumstats_dt = sumstats_dt,
                                          return_list = FALSE)
    } else {
        if(sorted) {
            messager("Setting sorted=FALSE (required when formatted=FALSE).")
            sorted <- FALSE
        }
    }
    if(sorted){
        sumstats_dt <- sort_coords(sumstats_dt = sumstats_dt)
    }
    return(sumstats_dt)
}

add_col <- function(dt,
                    col,
                    force_new = FALSE) {
    col_exists <- col %in% names(dt)
    if (col_exists) {
        if (force_new) {
            message(col, " already exists (replacing).")
            return(TRUE)
        } else {
            message(col, " already exists (keeping original).")
            return(FALSE)
        }
    } else {
        return(TRUE)
    }
}

#' Unlist a data.table
#' 
#' Identify columns that are lists and turn them into vectors.
#' @param dt data.table
#' @param verbose Print messages.
#' @keywords internal
#' @importFrom data.table .SD :=
#' @importFrom methods is
#' @returns \code{dt} with list columns turned into vectors. 
unlist_dt <- function(dt,
                      verbose=TRUE) {
    .SD <- NULL
    cols <- names(dt)[ unlist(lapply(dt, methods::is,"list")) ]
    if(length(cols)>0){
        messager("Unlisting",length(cols),"columns.",v=verbose)
        dt[ , (cols) := lapply(.SD,unlist), .SDcols = cols]
    } 
}

#' Ensure that there is at least one signed column in summary statistics file
#' Impute beta if user requests
#'
#' @param sumstats_dt data table obj of the summary statistics
#' file for the GWAS
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return null
#' @keywords internal

check_signed_col <-
    function(sumstats_dt,impute_beta, log_folder_ind, rsids, imputation_ind,
             check_save_out, tabix_index, log_files, nThread) {
        BETA <- P <- Z <- N <- FRQ <- SE <- OR <- IMPUTATION_BETA <- 
          LOG_ODDS <- NULL
        col_headers <- names(sumstats_dt)
        signed_stat_column_names <- c("Z", "OR", "BETA",
                                      "LOG_ODDS", "SIGNED_SUMSTAT")
        stp_msg <- paste0(
            "ERROR: cannot find a column name representing signed ",
            "statistic in GWAS sumstats file:\n",
            "'Z','OR','BETA','LOG_ODDS','SIGNED_SUMSTAT'"
        )
        
        no_imp_msg <- "BETA is not present but can be imputed with "
        no_imp_msg2 <- ". Set impute_beta=TRUE and rerun to do this."
        msg <- "The sumstats BETA column is not present..."
        #message about the last way to impute beta from other columns
        imp_cols <- FALSE
        beta_imputed <- FALSE
        #impute BETA from other columns
        if (!"BETA" %in% col_headers) {
            #commented out attempts assume that the model that was fit is from a
            #simple linear regression which is likely not the case
            #if ("Z" %in% col_headers && "N" %in% col_headers &&
            #    "P" %in% col_headers){
            #    imp_cols <- "Z, N & P"
            #    if(impute_beta){
            #        message(paste0(msg,"Deriving BETA from Z, N, and P"))
            #        sumstats_dt[,BETA := Z/sqrt(qchisq(P, N))]
            #        beta_imputed <- TRUE
            #    }  
            #} else if ("Z" %in% col_headers && "N" %in% col_headers &&
            #           "FRQ" %in% col_headers){
            #    imp_cols <- "Z, N & FRQ"
            #    # https://www.biostars.org/p/319584/
            #    # https://www.nature.com/articles/ng.3538
            #    if(impute_beta){
            #        message(paste0(msg,"Deriving BETA from Z, N, and FRQ"))
            #        sumstats_dt[,BETA := Z/sqrt(2*FRQ*(1-FRQ)*(N+Z^2))]
            #        beta_imputed <- TRUE
            #    }  
            #https://huwenboshi.github.io/data%20management/2017/11/23/tips-for-formatting-gwas-summary-stats.html
            #} else if ("Z" %in% col_headers & "SE" %in% col_headers) {
            if ("OR" %in% col_headers || "LOG_ODDS" %in% col_headers) {
              if ("OR" %in% col_headers) {
                imp_cols <- "OR"
                if(impute_beta){
                  messager(paste0(msg,"Deriving BETA from OR"))
                  sumstats_dt[,BETA := log(OR)]
                  beta_imputed <- TRUE
                } 
              }  
              else{ #only log odds not OR
                imp_cols <- "LOG_ODDS"
                if(impute_beta){
                  messager(paste0(msg,"Deriving BETA from LOG ODDS"))
                  sumstats_dt[,BETA := LOG_ODDS]
                  beta_imputed <- TRUE
                } 
              }
            } else if ("Z" %in% col_headers & "SE" %in% col_headers) {
              imp_cols <- "Z & SE"
              if(impute_beta){
                messager(paste0(msg,"Deriving BETA from Z and SE"))
                sumstats_dt[,BETA := Z * SE]
                beta_imputed <- TRUE
              }    
            } else if (sum(signed_stat_column_names %in% col_headers) < 1) {
                stop(stp_msg)
            }
            #tell the user if they could impute beta but didn't because of 
            #input param
            if(!impute_beta && !isFALSE(imp_cols)){
                no_imp_msg <- paste0(no_imp_msg,imp_cols,no_imp_msg2)
                message(no_imp_msg)
            }
            
            # If user wants log, save it to there
            if (log_folder_ind && nrow(sumstats_dt[is.na(BETA), ])>0) {
                name <- "beta_na"
                name <- get_unique_name_log_file(name = name,
                                                 log_files = log_files)
                write_sumstats(
                    sumstats_dt =
                        sumstats_dt[is.na(BETA),],
                    save_path =
                        paste0(
                            check_save_out$log_folder,
                            "/", name,
                            check_save_out$extension
                        ),
                    sep = check_save_out$sep,
                    #don't tab indx as could be miss values & cause err
                    #tabix_index = tabix_index,
                    nThread = nThread
                )
                log_files[[name]] <-
                    paste0(check_save_out$log_folder, "/",
                           name, check_save_out$extension)
            }
            
            # if user specifies add a column to notify of the imputation
            if (imputation_ind && beta_imputed) {
                sumstats_dt[, IMPUTATION_BETA := TRUE]
            }
            
            ## Remove NA values if introduced
            if (impute_beta | "BETA" %in% col_headers ){
                sumstats_dt <- sumstats_dt[!is.na(BETA), ]
            } 
            
            return(list(
                "sumstats_dt" = sumstats_dt,
                "rsids" = rsids, "log_files" = log_files
            ))
        }
        return(list(
            "sumstats_dt" = sumstats_dt,
            "rsids" = rsids, "log_files" = log_files
        ))
    }

#' DataFrame to data.table
#' 
#' Efficiently convert \link[S4Vectors]{DataFrame} to 
#' \link[data.table]{data.table}. 
#' @source \href{https://support.bioconductor.org/p/66874/}{
#' Solution from Bioc forum}
#' 
#' @param DF \link[S4Vectors]{DataFrame} object.
#' 
#' @keywords internal
#' @importFrom data.table as.data.table data.table
#' @importFrom methods is
#' @importFrom Biostrings unstrsplit
#' @importFrom IRanges CharacterList
#' @returns VCF data in data.table format.
DF_to_dt <- function(DF){ 
    #### Check if DF is empty ####
    # DF <- cbind(DF,dummy=NA)
    if(nrow(DF)==0 | ncol(DF)==0) return(data.table::data.table())
    m <- mapply(DF, 
                FUN=function(s){ 
                    # s <- DF[["REF"]]
                    # s <- DF[["ALT"]]
                    # s <- DF[[1]]
                    if(methods::is(s,"DNAStringSet") ){
                        s <- as.character(s)
                    } else if(methods::is(s,"DNAStringSetList")){
                        s <- IRanges::CharacterList(s)
                        s <- Biostrings::unstrsplit(s, sep=",")
                    } else if(methods::is(s,"NumericList")){
                        s <- as.numeric(s)
                    } else if(methods::is(s,"list")){
                        s <- unlist(s)
                    } else {
                        s <- as.vector(s)
                    }
                    #### Check if empty ####
                    if(all(is.na(s)) || 
                       all(s==".") || 
                       all(s=="")){
                        return(NULL)
                    } else {
                        return(s)
                    } 
            }) 
    ## Turn named list or matrix into a data.table
    data.table::as.data.table(m)
}

#' Ensure that SNP is present if not can find it with CHR and BP
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @param verbose should messages be printed. Default it TRUE.
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and the log files list
#' @keywords internal
#' @importFrom data.table setDT
#' @importFrom data.table setkeyv
#' @importFrom data.table :=
#' @importFrom data.table setcolorder
#' @importFrom data.table copy
#' @importFrom BSgenome snpsByOverlaps
#' @importFrom GenomicRanges makeGRangesFromDataFrame
check_no_snp <- function(sumstats_dt, path, ref_genome, snp_ids_are_rs_ids, 
                         indels, imputation_ind, log_folder_ind, check_save_out,
                         tabix_index, nThread, log_files, dbSNP,
                         dbSNP_tarball = NULL,msg = NULL,verbose = TRUE) {
    SNP <- CHR <- i.RefSNP_id <- IMPUTATION_SNP <- BP <- A1 <- A2 <- NULL
    # If CHR and BP are present BUT not SNP then need 
    # to find the relevant SNP ids
    col_headers <- names(sumstats_dt)
    if (sum(c("CHR", "BP") %in% col_headers) == 2 &
        sum("SNP" %in% col_headers) == 0) {
        msg <- "SNP"
        if (isFALSE(verbose)) {
            msg <- NULL
        }
        SNP_LOC_DATA <- load_snp_loc_data(
          ref_genome = ref_genome,
          dbSNP = dbSNP,
          dbSNP_tarball = dbSNP_tarball,
          msg = NULL
        )
        # if chromosome col has chr prefix remove it
        sumstats_dt[, CHR := gsub("chr", "", CHR)]
        # avoid SNPs with NA values in chr or bp
        gr_snp <- data.table::copy(sumstats_dt)
        # if indels are in datqset, these should not be imputed as RS ID
        # will instead relate to a SNP at same position - remove these
        if(sum(c("A1", "A2") %in% col_headers) == 2 & indels ){
            #identify Indels based on num char in A1, A2
            num_indels <- nrow(gr_snp[(nchar(A1)>1 | nchar(A2)>1),])
            if(num_indels>0){
                msg <- paste0("Found ",
                          formatC(num_indels,big.mark = ","),
                          " Indels. These won't",
                          " be checked against the reference ",
                          "genome as it does not contain ",
                          "Indels.\nWARNING If your sumstat ",
                          "doesn't contain Indels, set the ",
                          "indel param to FALSE & rerun ",
                          "MungeSumstats::format_sumstats()")
                message(msg)
                gr_snp <- gr_snp[!(nchar(A1)>1 | nchar(A2)>1),]
            }
        }
        incl_cols <- c("CHR", "BP")
        gr_snp <- gr_snp[complete.cases(gr_snp[, incl_cols, with = FALSE])]
        #could be 0 with indels, causes error
        if(nrow(gr_snp)>0){
            gr_snp <-
                GenomicRanges::makeGRangesFromDataFrame(gr_snp,
                    keep.extra.columns = TRUE,
                    seqnames.field = "CHR",
                    start.field = "BP",
                    end.field = "BP"
                )
            gr_rsids <-
                BSgenome::snpsByOverlaps(SNP_LOC_DATA, ranges = gr_snp)
            rsids <- data.table::setDT(data.frame(gr_rsids))
        }
        else{
            #just add fake rsids so no match found
            rsids <-
                data.table::data.table(seqnames=0,pos=0,strand="*",
                                       RefSNP_id="fake",alleles_as_ambig="Y")
        }
        data.table::setnames(rsids, "seqnames", "CHR")
        data.table::setnames(rsids, "pos", "BP")
        # in case there is CHR8 and chr8 - but keep sex chr as upper
        rsids[, CHR := tolower(as.character(CHR))]
        rsids[, CHR := gsub("x|23", "X", CHR)]
        rsids[, CHR := gsub("y", "Y", CHR)]
        sumstats_dt[, CHR := tolower(as.character(CHR))]
        sumstats_dt[, CHR := gsub("x|23", "X", CHR)]
        sumstats_dt[, CHR := gsub("y", "Y", CHR)]
        # ensure bp is numeric
        sumstats_dt[, BP := as.numeric(BP)]
        # join on SCHR BP to sumstats
        data.table::setkeyv(sumstats_dt, c("CHR", "BP"))
        data.table::setkeyv(rsids, c("CHR", "BP"))
        sumstats_dt[rsids, SNP := i.RefSNP_id]
        # remove rows where SNP couldn't be found
        # If user wants log, save it to there
        if (log_folder_ind) {
            name <- "snp_not_found_from_chr_bp"
            name <- get_unique_name_log_file(name = name,
                                             log_files = log_files)
            write_sumstats(
                sumstats_dt =
                    sumstats_dt[!complete.cases(sumstats_dt[, c("SNP")]), ],
                save_path =
                    paste0(
                        check_save_out$log_folder,
                        "/", name,
                        check_save_out$extension
                    ),
                sep = check_save_out$sep,
                #don't tab index these as could be missing values and cause err
                #tabix_index = tabix_index,
                nThread = nThread
            )
            log_files[[name]] <-
                paste0(check_save_out$log_folder, "/",
                       name, check_save_out$extension)
        }
        sumstats_dt <- sumstats_dt[complete.cases(sumstats_dt[, "SNP"]), ]
        # move SNP to start
        other_cols <- names(sumstats_dt)[names(sumstats_dt) != "SNP"]
        data.table::setcolorder(sumstats_dt, c("SNP", other_cols))

        # if user specifies add a column to notify of the imputation
        if (imputation_ind) {
            sumstats_dt[, IMPUTATION_SNP := TRUE]
        }
        return(list("sumstats_dt" = sumstats_dt,
                    "log_files" = log_files))
    } else {
        return(list("sumstats_dt" = sumstats_dt,
                    "log_files" = log_files))
    }
}

#' Standardize the CHR column
#'
#' Maps chromosome names to the default Ensembl/NCBI naming style and removes
#' SNPs with nonstandard CHR entries. Optionally, also removes SNPs on
#' user-specified chromosomes.
#'
#' @param sumstats_dt data.table with summary statistics
#' @param log_files list of locations for all log files
#' @param check_save_out list of parameters for saved files
#' @inheritParams format_sumstats
#' @return list containing the updated summary statistics data.table and the
#'   updated log file locations list
#' @keywords internal
check_chr <- function(sumstats_dt,
                      log_files = c(),
                      check_save_out=FALSE,
                      rmv_chr = c(),
                      nThread = 1,
                      log_folder_ind=FALSE) {
  CHR <- NULL

  # The CHR column needs to be a character vector for gsub substitution to work
  sumstats_dt[, CHR := as.character(CHR)]

  ### Reformat chromosome names according to the default style (Ensembl/NCBI)
  message("Formatting CHR column (if necessary)- ",
          "Removing chr prefix, converting 23/24 to X/Y and M to MT")
  # Remove the "chr" prefix
  sumstats_dt[, CHR := gsub("chr", "", CHR, ignore.case = TRUE)]
  # Remove the "ch" prefix
  sumstats_dt[, CHR := gsub("ch", "", CHR, ignore.case = TRUE)]
  # Rename "23" to "X"
  sumstats_dt[, CHR := gsub("23", "X", CHR)]
  # Rename "24" to "Y"
  sumstats_dt[, CHR := gsub("24", "Y", CHR)]
  # Rename "M" to "MT"
  sumstats_dt[, CHR := gsub("M", "MT", CHR, ignore.case = TRUE)]
  # Make all chromosome names uppercase
  sumstats_dt[, CHR := toupper(CHR)]

  ### Remove rows with nonstandard CHR entries
  standard_chrs <- c(1:22, "X", "Y", "MT")
  nonstandard_rows <- which(!(sumstats_dt$CHR %in% standard_chrs))
  if (length(nonstandard_rows) > 0L) {
    message("Removing ",
            formatC(length(nonstandard_rows), big.mark = ","),
            " SNPs with nonstandard CHR entries.")
  }

  ### Remove SNPs on user-specified chromosomes, if requested
  rmv_chr_rows <- c()
  if (!is.null(rmv_chr)) {
    # Check for chromosomes to be removed
    rmv_chr_rows <- which(sumstats_dt$CHR %in% rmv_chr)

    if (length(rmv_chr_rows) > 0L) {
      message(
        formatC(length(rmv_chr_rows), big.mark = ","),
        " SNPs are on chromosomes ",
        paste(rmv_chr, collapse = ", "),
        " and will be removed."
      )
    }
  }

  # Vector of row numbers for all removed SNPs
  all_removed_rows <- sort(unique(c(nonstandard_rows, rmv_chr_rows)))

  ### Save a log of removed SNPs if the user wants it
  if (log_folder_ind && (length(all_removed_rows) > 0L)) {
    name <- "chr_excl"
    name <- get_unique_name_log_file(name = name,
                                     log_files = log_files)
    save_path <- paste0(check_save_out$log_folder,
                        "/",
                        name,
                        check_save_out$extension)

    write_sumstats(
      sumstats_dt = sumstats_dt[all_removed_rows],
      save_path = save_path,
      sep = check_save_out$sep,
      nThread = nThread
    )
    log_files[[name]] <- save_path
  }

  # Remove the SNPs identified above, if any
  sumstats_dt <- sumstats_dt[!all_removed_rows]

  return(list(sumstats_dt = sumstats_dt, log_files = log_files))
}

#' Convert to \code{VRanges}
#'
#' @param sumstats_dt data table obj of the summary statistics 
#' file for the GWAS.
#' @return \code{VRanges} object
#' @keywords internal
#' @importFrom GenomicRanges makeGRangesFromDataFrame
#' @importFrom VariantAnnotation makeVRangesFromGRanges
to_vranges <- function(sumstats_dt) {
    gr <- to_granges(sumstats_dt)
    message("Converting summary statistics to VRanges.")
    gr$dummy <- "GWAS"
    vr <- VariantAnnotation::makeVRangesFromGRanges(gr,
                                                    ref.field = "A1", 
                                                    alt.field = "A2",
                                                    keep.extra.columns = TRUE,
                                                    sampleNames.field = "dummy"
    )
    return(vr)
}

params <-
list(cont = "ghcr.io/neurogenomics/MungeSumstats", docker_registry = "ghcr.io", 
    docker_org = "neurogenomics")

## ----setup, include=FALSE-----------------------------------------------------
#### Package name ####
PKG <- read.dcf("../DESCRIPTION", fields = "Package")[1]
library(PKG, character.only = TRUE)
## Docker containers must be lowercase
pkg <- tolower(PKG)
#### Username of DockerHub account ####
docker_org <- params$docker_org
docker_registry <- params$docker_registry 
cont <- params$cont 
docker_url <- if(grepl("ghcr.io",docker_registry)){
  paste("https://ghcr.io",cont,sep="/")
} else {
  paste("https://hub.docker.com/repository/docker",docker_org,pkg,sep="/")
}


## ----Session Info-------------------------------------------------------------
utils::sessionInfo()

#' Download VCF file and its index file from Open GWAS
#'
#'
#' Ideally, we would use \href{https://github.com/MRCIEU/gwasvcf}{gwasvcf}
#' instead but it hasn't been made available on CRAN or Bioconductor yet,
#' so we can't include it as a dep.
#'
#' @return List containing the paths to the downloaded VCF and its index file.
#'
#' @param vcf_urls Remote URL to VCF file.
#' @param force_new Overwrite a previously downloaded VCF
#'  with the same path name.
#' @inheritParams downloader
#' @inheritParams import_sumstats
#' @export
#' @examples
#' #only run the examples if user has internet access:
#' if(try(is.character(getURL("www.google.com")))==TRUE){
#' vcf_urls <- ieugwasr::gwasinfo_files(id = "ieu-a-298")[[1]]
#' out_paths <- download_vcf(vcf_urls = vcf_urls)
#' }
download_vcf <- function(vcf_urls,
                         vcf_dir = tempdir(),
                         vcf_download = TRUE,
                         download_method = "download.file",
                         force_new = FALSE,
                         quiet = FALSE,
                         timeout = 10*60,
                         nThread = 1) {
    #### Create save_path ####
    vcf_url <- vcf_urls[1]
    save_path <- file.path(vcf_dir, basename(vcf_url))
    index_path <- NULL
    
    index_url <- vcf_urls[2]
    # index_url <- paste0(vcf_url, ".tbi")
    #### If actually local ####
    if(file.exists(vcf_url)){
        message("Using local VCF.")
        save_path <- vcf_url
        index_path <- index_url
    #### If remote but already downloaded ####
    } else if (file.exists(save_path) && force_new == FALSE) {
        message("Using previously downloaded VCF.")
        index_path <- paste0(save_path, ".tbi")
    } else {
        if (vcf_download) {
            message("Downloading VCF ==> ", save_path)
            dir.create(dirname(save_path),
                showWarnings = FALSE,
                recursive = TRUE
            )
            #### Download main VCF file
            save_path <- downloader(
                input_url = vcf_url,
                output_path = vcf_dir,
                download_method = download_method,
                force_overwrite = force_new,
                quiet = quiet,
                timeout = timeout,
                nThread = nThread
            )
            #### Download tabix index file 
            message("Downloading VCF index ==> ", index_url)
            index_path <- downloader(
                input_url = index_url,
                output_path = vcf_dir,
                download_method = download_method,
                force_overwrite = force_new,
                quiet = quiet,
                nThread = nThread
            )
        } else {
            messager("Using remote file without downloading.")
            save_path <- vcf_url
            index_path <- index_url
        }
    }
    return(list(
        save_path = save_path,
        index_path = index_path
    ))
}

#' Check numeric columns
#' 
#' Checks for any columns that should be numeric, 
#' and ensures that they are indeed numeric.
#' @param sumstats_dt Summary stats with column names already standardised by
#'  \link[MungeSumstats]{format_sumstats}.
#' @param cols Names of columns that should be numeric. 
#' If any of these columns are not actually present in \code{sumstats_dt},
#' they will be skipped.
#' @returns sumstats_dt 
#' 
#' @keywords internal
#' @importFrom data.table :=
check_numeric <- function(sumstats_dt,
                          cols = c("P","SE","FRQ","MAF","BETA")){
    cols <- cols[cols %in% names(sumstats_dt)]
    if(length(cols)>0){
        sumstats_dt[,(cols):=lapply(.SD, as.numeric), .SDcols=cols]   
    }
    return(sumstats_dt)
}

#' Remove SNPs with missing data
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and a log file list.
#' @keywords internal
#' @importFrom stats complete.cases
check_miss_data <- function(sumstats_dt, path, log_folder_ind, check_save_out,
                            tabix_index, nThread, log_files,
                            drop_na_cols) {
    message("Checking for missing data.")
    col_headers <- names(sumstats_dt)
    # use data table for speed
    # check for rows missing data to be excluded
    # don't check imputation columns
    #also don't check cols MSS creates - SNP_INFO
    ignore_cols <- c(
        col_headers[grepl("^IMPUTATION_", col_headers)],
        "flipped"["flipped" %in% col_headers],
        col_headers[grepl("^convert_", col_headers)],
        "SNP_INFO"["SNP_INFO"%in% col_headers]
    )
    
    if (!is.null(drop_na_cols)) {
      drop_na_cols_in_sumstats <-
        c(drop_na_cols)[drop_na_cols %in% names(sumstats_dt)]
      incl_cols <-
        c(drop_na_cols_in_sumstats)[!drop_na_cols_in_sumstats %in% ignore_cols]
      if(length(incl_cols)<1){
        msg <- paste0(
          "WARNING: None of the inputted columns:\n",
          paste(drop_na_cols,collapse=" "),"\n",
          "To be checked for missing data were found in the sumstats. Sumstats",
          " columns:\n",
          paste(names(sumstats_dt),collapse=" "),"\n",
          "This check will not be run."
        )
        message(msg)
      }
    } else {
      incl_cols <- names(sumstats_dt)[!names(sumstats_dt) %in% ignore_cols]  
    }
    
    if (nrow(sumstats_dt[!complete.cases(sumstats_dt[, incl_cols,
        with = FALSE
    ]), ]) > 0) {
        n_missing <- nrow(
            sumstats_dt[!complete.cases(
                sumstats_dt[, incl_cols, with = FALSE]
            ), ]
        )
        msg <- paste0(
            "WARNING: ",
            formatC(n_missing, big.mark = ","),
            " rows in sumstats file are missing data and will ",
            "be removed."
        )
        message(msg)
        # If user wants log, save it to there
        if (log_folder_ind) {
            name <- "missing_data"
            name <- get_unique_name_log_file(
                name = name,
                log_files = log_files
            )
            write_sumstats(
                sumstats_dt =
                    sumstats_dt[!complete.cases(sumstats_dt[, incl_cols,
                        with = FALSE
                    ])],
                save_path =
                    paste0(
                        check_save_out$log_folder,
                        "/", name,
                        check_save_out$extension
                    ),
                sep = check_save_out$sep,
                #don't tab indx as could be miss values & cause err
                #tabix_index = tabix_index,
                nThread = nThread
            )
            log_files[[name]] <-
                paste0(
                    check_save_out$log_folder, "/",
                    name, check_save_out$extension
                )
        }
        sumstats_dt <-
            sumstats_dt[complete.cases(sumstats_dt[, incl_cols, with = FALSE])]
        if (nrow(sumstats_dt) == 0) {
            stop_msg <- paste(
                "All SNPs have been filtered out of",
                " your summary statistics dataset"
            )
            stop(stop_msg)
        }

        return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
    } else {
        return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
    }
}

#' Ensure that the standard error (se) is positive for all SNPs
#' Also impute se if missing
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and the log file list
#' @keywords internal
#' @importFrom stats qnorm
check_pos_se <- function(sumstats_dt, path, pos_se, log_folder_ind, imputation_ind,
                         check_save_out, tabix_index, nThread, log_files,
                         impute_se) {
    SE <- .SD <- BETA <- P <- Z <- IMPUTATION_SE <- NULL
    col_headers <- names(sumstats_dt)
    no_imp_msg <- "SE is not present but can be imputed with "
    no_imp_msg2 <- ". Set impute_se=TRUE and rerun to do this."
    #message about the last way to impute beta from other columns
    imp_cols <- FALSE
    se_imputed <- FALSE
    
    if (!"SE" %in% col_headers) {
        
        derive_msg <- "The sumstats SE column is not present..."
        
        if ("BETA" %in% col_headers & "P" %in% col_headers) {
            imp_cols <- "BETA & P"
            if(impute_se){
                # https://www.biostars.org/p/431875/
                messager(paste0(derive_msg,"Deriving SE from Beta and P"))
                sumstats_dt[,SE := abs(BETA/ qnorm(P/2))]
                se_imputed <- TRUE
            }  
        } else if ("Z" %in% col_headers & "BETA" %in% col_headers) {
            imp_cols <- "Z & BETA"
            if(impute_se){
                messager(paste0(derive_msg,"Deriving SE from Z and BETA"))
                sumstats_dt[,SE := BETA / Z]
                se_imputed <- TRUE
            }  
        }  
        #tell the user if they could impute beta but didn't because of input param
        if(!impute_se && !isFALSE(imp_cols)){
            no_imp_msg <- paste0(no_imp_msg,imp_cols,no_imp_msg2)
            message(no_imp_msg)
        }
        
        # If user wants log, save it to there
        if (log_folder_ind && nrow(sumstats_dt[is.na(SE), ])>0) {
            name <- "se_na"
            name <- get_unique_name_log_file(name = name,
                                             log_files = log_files)
            write_sumstats(
                sumstats_dt =
                    sumstats_dt[is.na(SE),],
                save_path =
                    paste0(
                        check_save_out$log_folder,
                        "/", name,
                        check_save_out$extension
                    ),
                sep = check_save_out$sep,
                #don't tab indx as could be miss values & cause err
                #tabix_index = tabix_index,
                nThread = nThread
            )
            log_files[[name]] <-
                paste0(check_save_out$log_folder, "/",
                       name, check_save_out$extension)
        }
        
        # if user specifies add a column to notify of the imputation
        if (imputation_ind && se_imputed) {
            sumstats_dt[, IMPUTATION_SE := TRUE]
        }
        
        ## Remove NA values if introduced
        if (impute_se | "SE" %in% col_headers ){
            sumstats_dt <- sumstats_dt[!is.na(SE), ]
        } 
        
    }
    
    if ("SE" %in% col_headers && pos_se) {
        message("Filtering SNPs, ensuring SE>0.")
        # use data table for speed
        num_bad_ids <- nrow(sumstats_dt[SE <= 0, ])
        if (num_bad_ids > 0) {
            msg <- paste0(
                formatC(num_bad_ids, big.mark = ","), " SNPs",
                " have SE values <= 0 and will be removed"
            )
            message(msg)
            # If user wants log, save it to there
            if (log_folder_ind) {
                name <- "se_neg"
                name <- get_unique_name_log_file(name = name,
                                                 log_files = log_files)
                write_sumstats(
                    sumstats_dt = sumstats_dt[SE <= 0, ],
                    save_path =
                        paste0(
                            check_save_out$log_folder,
                            "/", name,
                            check_save_out$extension
                        ),
                    sep = check_save_out$sep,
                    tabix_index = tabix_index,
                    nThread = nThread
                )
                log_files[[name]] <-
                    paste0(
                        check_save_out$log_folder, "/", name,
                        check_save_out$extension
                    )
            }
            sumstats_dt <- sumstats_dt[SE > 0, ]
        }
        return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
    } else {
        return(list("sumstats_dt" = sumstats_dt, "log_files" = log_files))
    }
}

#' Get VCF sample ID(s)
#'
#' @inheritParams format_sumstats
#' @importFrom VariantAnnotation scanVcfHeader
#' @return sample_id
#' @keywords internal
get_vcf_sample_ids <- function(path) { 
    header <- VariantAnnotation::scanVcfHeader(file = path)
    sample_id <- tryCatch(expr = {header@samples},
                          error=function(e){NULL})
    if (is.null(sample_id)) {
        header <- readLines(path, 100)
        sample_id <- header[grepl("^##SAMPLE", header)] # gets ##SAMPLE
        if (length(sample_id) == 0) {
            ### Try again with more rows
            header <- readLines(path, 500)
            sample_id <- header[grepl("^##SAMPLE", header)] # gets ##SAMPLE
        }
        # get rid of everything after ID
        sample_id <- gsub(",.*$", "", sample_id)
        # rmv ##SAMPLE=
        sample_id <- base::substr(sample_id, 10, nchar(sample_id))
        # rmv things before equals
        sample_id <- sub(".+=(.+)", "\\1", sample_id)
    }
    if (length(sample_id) == 0) {
        message(
            "No ##SAMPLE row found.",
            "Will infer sample name(s) from data colnames."
        )
        return(NULL)
    } else {
        return(sample_id)
    }
}

#' Compute Neff/N
#'
#' @inheritParams compute_sample_size
#' @return No return
#' @keywords internal
compute_sample_size_neff <- function(sumstats_dt,
                                     method,
                                     force_new = FALSE,
                                     append_method_name = FALSE) {

    # Avoid confusing Biocheck
    Neff <- N <- N_ldsc <- P_ldsc <- N_CAS <- N_CON <- NULL

    if (is.character(method) &
        all(c("N_CAS", "N_CON") %in% colnames(sumstats_dt))) {

        #### Standardize method ####
        method <- tolower(method)[1]
        # get N col name
        N_col <- "Neff"
        if ((method %in% c("ldsc", TRUE))) {
            if (add_col(sumstats_dt, N_col, force_new)) {
                if (append_method_name) {
                      N_col <- "Neff_ldsc"
                  }
                #### Compute sample size: ldsc ####
                message(
                    "Computing effective sample size using the LDSC method:\n ",
                    "Neff = (N_CAS+N_CON) * (N_CAS/(N_CAS+N_CON)) /",
                    " mean((N_CAS/(N_CAS+N_CON))",
                    "[(N_CAS+N_CON)==max(N_CAS+N_CON)]))"
                )
                ### Create tmp cols (formula gets too confusing otherwise)
                #### Original python code in LDSC (converted below to R code)
                # N = dat.N_CAS + dat.N_CON
                # P = dat.N_CAS / N
                # dat['N'] = N * P / P[N == N.max()].mean()

                ## N_ldsc = Sum of cases vs. controls
                sumstats_dt[, N_ldsc := N_CAS + N_CON]
                ## P_ldsc = Proportion of cases vs. controls
                sumstats_dt[, P_ldsc := N_CAS / N_ldsc]

                sumstats_dt[, eval(N_col) :=
                    as.integer(N_ldsc * P_ldsc / 
                                   mean(P_ldsc[N_ldsc == max(
                                       N_ldsc, na.rm = TRUE)],
                                        na.rm=TRUE ))]
                ### Drop tmp cols
                sumstats_dt[, c("N_ldsc", "P_ldsc") := NULL]
                ### All in one go *but super confusing a liable to typos!
                # sumstats_dt[,Neff:=as.integer((N_CAS+N_CON) *
                # (N_CAS/(N_CAS+N_CON)) / 
                # mean((N_CAS/(N_CAS+N_CON))[(N_CAS+N_CON)
                # =max(N_CAS+N_CON)]))]
            }
        } else if (method == "metal") {
            if (add_col(sumstats_dt, N_col, force_new)) {
                if (append_method_name) {
                      N_col <- "Neff_metal"
                  }
                #### Compute sample size: metal ####
                message(
                    "Computing effective sample size",
                    " using the METAL method:\n ",
                    "Neff = 4 / (1/N_CAS + 1/N_CON)"
                )
                sumstats_dt[, eval(N_col) :=
                    as.integer(4L / (1L / N_CAS + 1L / N_CON))]
            }
        } else if (method == "giant") {
            if (add_col(sumstats_dt, N_col, force_new)) {
                if (append_method_name) {
                      N_col <- "Neff_giant"
                  }
                #### Compute sample size: giant ####
                message(
                    "Computing effective sample size",
                    " using the GIANT method:\n ",
                    "Neff = 2 / (1/N_CAS + 1/N_CON)"
                )
                sumstats_dt[, eval(N_col) :=
                    as.integer(2L / (1L / N_CAS + 1L / N_CON))]
            }
        } else if (method == "sum") {
            if (add_col(sumstats_dt, "N", force_new)) {
                #### Compute sample size: giant ####
                message(
                    "Computing sample size using the sum method:\n ",
                    "N = N_CAS + N_CON"
                )
                sumstats_dt[, N := as.integer(N_CAS + N_CON)]
            }
        } else {
            all_methods <- c("ldsc", "giant", "metal", "sum")
            msg <- paste0(
                "method must be one of:\n",
                paste0(" - ", all_methods, collapse = "\n")
            )
            message(msg)
        }
    } else {
        msg_err <- paste0(
            "WARNING: Neff column could not be calculated as the",
            " columns N_CAS & N_CON were not found in the datset"
        )
        message(msg_err)
    }
}

#' Ensure that CHR and BP are missing if SNP is present, can find them
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return A list containing two data tables:
#' \describe{
#'   \item{\code{sumstats_dt}}{The modified summary statistics data table.}
#'   \item{\code{rsids}}{`snpsById`, filtered to SNPs of interest if loaded 
#'   already, or else `NULL`.}
#'   \item{\code{log_files}}{List of log files.}
#' }
#' @keywords internal
#' @importFrom data.table setDT
#' @importFrom data.table setkey
#' @importFrom data.table :=
#' @importFrom data.table setnames
#' @importFrom data.table setcolorder
#' @importFrom BSgenome snpsById
#' @importFrom data.table setorder
#' @importFrom data.table copy
check_no_chr_bp <- function(sumstats_dt, 
                            path, 
                            ref_genome,
                            rsids,
                            imputation_ind,
                            log_folder_ind,
                            check_save_out,
                            tabix_index, 
                            nThread,
                            log_files,
                            dbSNP,
                            dbSNP_tarball) {
    SNP <- i.seqnames <- CHR <- BP <- i.pos <- LP <- P <- IMPUTATION_CHR <-
        IMPUTATION_BP <- NULL
    # If SNP present but no CHR/BP then need to find them
    col_headers <- names(sumstats_dt)
    if (sum(c("CHR", "BP") %in% col_headers) <= 1 &
        sum("SNP" %in% col_headers) == 1) {
        # if dataset has one of CHR or BP remove it and take from re dataset
        if (sum(c("CHR", "BP") %in% col_headers) == 1) {
            colsToDelete <- c("CHR", "BP")[c("CHR", "BP") %in% col_headers]
            sumstats_dt[, (colsToDelete) := NULL]
        }
        # check if rsids loaded if not do so
        if (is.null(rsids)) {
            rsids <-
                load_ref_genome_data(
                    data.table::copy(sumstats_dt$SNP), 
                    ref_genome = ref_genome,
                    dbSNP = dbSNP,
                    dbSNP_tarball = dbSNP_tarball,
                    msg="Chromosome or Base Pair Position"
                )
        } else {
            print_msg <- paste0(
                "There is no Chromosome or Base Pair Position column",
                " found within the data. It must be inferred from ",
                " other column information."
            )
            message(print_msg)
        }
        # ensure rsids is up-to-date with filtered sumstats_dt
        rsids <- rsids[unique(sumstats_dt$SNP), , nomatch = NULL]
        data.table::setkey(rsids, SNP)
        # join on CHR BP to sumstats
        data.table::setkey(sumstats_dt, SNP)
        sumstats_dt[rsids, CHR := i.seqnames]
        sumstats_dt[rsids, BP := i.pos]
        # remove rows where CHR/BP couldn't be found
        # If user wants log, save it to there
        if (log_folder_ind) {
            name <- "chr_bp_not_found_from_snp"
            name <- get_unique_name_log_file(name = name,
                                             log_files = log_files)
            write_sumstats(
                sumstats_dt =
                    sumstats_dt[!complete.cases(sumstats_dt[, c(
                        "CHR",
                        "BP"
                    )]), ],
                save_path =
                    paste0(
                        check_save_out$log_folder,
                        "/", name,
                        check_save_out$extension
                    ),
                sep = check_save_out$sep,
                #don't tab indx as could be miss values & cause err
                #tabix_index = tabix_index,
                nThread = nThread
            )
            log_files[[name]] <-
                paste0(check_save_out$log_folder, "/",
                       name, check_save_out$extension)
        }
        sumstats_dt <- sumstats_dt[complete.cases(
            sumstats_dt[, c("CHR", "BP")]), ]
        # move SNP, CHR, BP to start
        other_cols <-
            names(sumstats_dt)[!names(sumstats_dt) %in% c("SNP", "CHR", "BP")]
        data.table::setcolorder(sumstats_dt,
                                c("SNP", "CHR", "BP", other_cols))

        # if user specifies add a column to notify of the imputation
        if (imputation_ind) {
            sumstats_dt[, IMPUTATION_CHR := TRUE]
            sumstats_dt[, IMPUTATION_BP := TRUE]
        }

        return(list("sumstats_dt" = sumstats_dt,
                    "rsids" = rsids, 
                    "log_files" = log_files))
    }
    #also check if bp and chr are present but values are na
    if(sum("SNP" %in% col_headers) == 1){
      na_chr_bp <- 
        sumstats_dt[grep("^rs", SNP),][is.na(CHR) & is.na(BP),]
      if (nrow(na_chr_bp)>0 && 
          sum(c("CHR", "BP","SNP") %in% col_headers) == 3){
        #impute the chr,bp data
        # if dataset has one of CHR or BP remove it and take from re dataset
        if (sum(c("CHR", "BP") %in% col_headers) >= 1) {
          colsToDelete <- c("CHR", "BP")[c("CHR", "BP") %in% col_headers]
          na_chr_bp[, (colsToDelete) := NULL]
        }
        #pass the dataset without chr bp to be imputed
        #keep old rsids to update
        old_rsids <- na_chr_bp$SNP
        na_chr_bp <-
          check_no_chr_bp(sumstats_dt=na_chr_bp,path=path,ref_genome=ref_genome,
                          rsids=rsids,imputation_ind=imputation_ind,
                          log_folder_ind=log_folder_ind,
                          check_save_out=check_save_out,
                          tabix_index=tabix_index,nThread=nThread,
                          log_files=log_files,dbSNP=dbSNP,
                          dbSNP_tarball=dbSNP_tarball) 
        #join back on the sumstats
        sumstats_dt <- sumstats_dt[!SNP %in% na_chr_bp$sumstats_dt$SNP,]
        sumstats_dt <- rbindlist(list(sumstats_dt,na_chr_bp$sumstats_dt),
                                 fill=TRUE)
        #join on the log files
        log_files <- c(log_files,na_chr_bp$log_files)
        #update rsids
        old_rsids_drop <- old_rsids[!old_rsids %in% na_chr_bp$sumstats_dt]
        rsids <- rsids[!rsids %in% old_rsids_drop]
      }
    }
    return(list("sumstats_dt" = sumstats_dt, 
                "rsids" = rsids,
                "log_files" = log_files))
}

#' Preview formatted sum stats saved to disk
#'
#' Prints the first \code{n} lines of the sum stats.
#'
#' @return No return
#'
#' @inheritParams format_sumstats
#' @keywords internal
#' @importFrom utils capture.output
preview_sumstats <- function(save_path,
                             nrows = 5L) {
    message("Successfully finished preparing sumstats file, preview:")
    vcf_suffixes <- supported_suffixes(tabular = FALSE,
                                       tabular_compressed = FALSE)
    preview <- read_header(
        path = save_path,
        n = nrows,
        skip_vcf_metadata = TRUE)
    message(paste0(capture.output(preview), collapse = "\n"))
}

#' Check for Z-score column
#'
#' The following ensures that a Z-score column is present.
#' The Z-score formula we used here is a R implementation of the formula
#' used in \href{https://github.com/bulik/ldsc/blob/aa33296abac9569a6422ee6ba7eb4b902422cc74/munge_sumstats.py#L363}{LDSC's munge_sumstats.py}:
#'
#' \code{np.sqrt(chi2.isf(P, 1))}
#'
#' The R implementation is adapted from the \code{GenomicSEM::munge} function,
#' after optimizing for speed using \code{data.table}:
#'
#' \code{sumstats_dt[,Z:=sign(BETA)*sqrt(stats::qchisq(P,1,lower=FALSE))]}
#'
#' \emph{NOTE}: \code{compute_z} is set to \code{TRUE} by 
#' default to ensure standardisation
#' of the "Z" column (which can be computed differently in different datasets).
#'
#' @return \code{list("sumstats_dt"=sumstats_dt)}
#'
#' @param sumstats_dt data table obj of the summary statistics file for the
#' GWAS.
#' @param imputation_ind Binary Should a column be added for each imputation
#' step to show what SNPs have imputed values for differing fields. This
#' includes a field denoting SNP allele flipping (flipped). **Note**
#' these columns will be in the formatted summary statistics returned. Default
#' is FALSE.
#' @param compute_z Whether to compute Z-score column. Default is FALSE. This 
#' can be computed from Beta and SE with (Beta/SE) or P 
#' (Z:=sign(BETA)*sqrt(stats::qchisq(P,1,lower=FALSE))).
#' **Note** that imputing the Z-score from P for every SNP will not be
#' perfectly correct and may result in a loss of power. This should only be done
#' as a last resort. Use 'BETA' to impute by BETA/SE and 'P' to impute by SNP
#' p-value.
#' @param force_new_z When a "Z" column already exists, it will be used by
#' default. To override and compute a new Z-score column from P set
#' \code{force_new_z=TRUE}.
#' @param standardise_headers Run
#' \code{standardise_sumstats_column_headers_crossplatform} first.
#' @param mapping_file MungeSumstats has a pre-defined column-name mapping file
#' which should cover the most common column headers and their interpretations.
#' However, if a column header that is in your file is missing of the mapping we
#' give is incorrect you can supply your own mapping file. Must be a 2 column
#' dataframe with column names "Uncorrected" and "Corrected". See
#' data(sumstatsColHeaders) for default mapping and necessary format.
#'
#' @keywords internal
#' @importFrom stats qchisq
check_zscore <- function(sumstats_dt,
                         imputation_ind,
                         compute_z = 'BETA',
                         force_new_z = FALSE,
                         standardise_headers = FALSE,
                         mapping_file) {
    ## Set variables to be used in in place data.table functions to NULL
    ## to avoid confusing BiocCheck.
    Z <- BETA <- SE <- P <- IMPUTATION_z_score_beta_se <- 
      IMPUTATION_z_score_p <- IMPUTATION_p_for_zero <- NULL

    if (standardise_headers) {
        sumstats_dt <-
            standardise_sumstats_column_headers_crossplatform(
                sumstats_dt = sumstats_dt,
                mapping_file = mapping_file
            )[["sumstats_dt"]]
    }

    if (!isFALSE(compute_z)) {
        # message("Checking Z-score.")
        col_headers <- names(sumstats_dt)
        if ("Z" %in% col_headers && (!force_new_z)) {
            message("Keeping existing Z-score column.")
        } else if(toupper(compute_z)=='BETA'){
            if ("BETA" %in% col_headers && "SE" %in% col_headers){
              message(
                "Computing Z-score from BETA and SE using formula:",
                " `BETA/SE`"
              )
              # ensure BETA, P are numeric
              sumstats_dt[, BETA := as.numeric(BETA)]
              sumstats_dt[, SE := as.numeric(SE)]
              sumstats_dt[, Z := BETA/SE]
              # if user wants information, give SNPs where Z-score calculated
              if (imputation_ind) {
                sumstats_dt[, IMPUTATION_z_score_beta_se := TRUE]
              }
            }
            else{
              msg <- paste0("Can't compute Z-score from BETA and SE as both ",
                            "aren't in the sumstats.\nPlease choose another ",
                            "option for `compute_z`")
              stop(msg)
            }
          
        } else{ #P-value
            message(
                "Computing Z-score from P using formula:",
                " `sign(BETA)*sqrt(stats::qchisq(P,1,lower=FALSE)`"
            )
            # ensure BETA, P are numeric
            sumstats_dt[, BETA := as.numeric(BETA)]
            sumstats_dt[, P := as.numeric(P)]
            
            # check for P-values equal to 0
            n_zero <- sumstats_dt[, sum(P == 0)]
            if (n_zero > 0) {
              message(paste0("Found ", n_zero, " p-values equal to 0. ",
                              "These should not be present and indicate a ",
                              "rounding issue in your pipeline. ",
                              "Replacing these with 1e-300."))
              # if user wants information, give SNPs where changed from 0
              if (imputation_ind) {
                sumstats_dt[P == 0, IMPUTATION_p_for_zero := TRUE]
              }
              sumstats_dt[P == 0, P := 1e-300]
            }
            
            sumstats_dt[, Z := sign(BETA) *
                sqrt(stats::qchisq(P, 1, lower = FALSE))]
            # if user wants information, give SNPs where Z-score calculated
            if (imputation_ind) {
                sumstats_dt[, IMPUTATION_z_score_p := TRUE]
            }
        }
    }
    return(list("sumstats_dt" = sumstats_dt))
}

#' Drop Indels from summary statistics
#'
#' @param sumstats_dt data table obj of the summary statistics file for the GWAS
#' @inheritParams format_sumstats
#' @source 
#' \code{
#' sumstats_dt <- MungeSumstats:::formatted_example()
#' sumstats <- check_drop_indels(sumstats_dt = sumstats_dt, 
#'                               drop_indels = TRUE)

#' }
#' @returns list containing sumstats_dt, 
#' the modified summary statistics data table object
#' @keywords internal
#' @importFrom data.table :=
check_drop_indels <- function(sumstats_dt, 
                              drop_indels,
                              path,
                              log_folder_ind,
                              check_save_out,
                              tabix_index,
                              nThread,
                              log_files) {
    A1 <- A2 <- NULL
    # Make sure A1 and A2 are present
    col_headers <- names(sumstats_dt)
    if (sum(c("A1", "A2") %in% col_headers) == 2 & drop_indels) {
        # Check for indels
        #identify Indels based on num char in A1, A2
        indels_dt <- sumstats_dt[(nchar(A1)>1 | nchar(A2)>1),]
        num_indels <- nrow(indels_dt)
        if (num_indels > 0) {
            msg <- paste0("Found ",
                        formatC(num_indels,big.mark = ","),
                        " Indels. These will",
                        " be removed from the sumstats. ",
                        "\nWARNING If you want ",
                        "to keep Indels, set the ",
                        "drop_indel param to FALSE & rerun ",
                        "MungeSumstats::format_sumstats()")
            message(msg)
            #remove the indels
            sumstats_dt <- sumstats_dt[!(nchar(A1)>1 | nchar(A2)>1),]
            # If user wants log, save it to there
            if (log_folder_ind) {
              name <- "indel"
              name <- get_unique_name_log_file(
                name = name,
                log_files = log_files
              )
              write_sumstats(
                sumstats_dt = indels_dt,
                save_path =
                  paste0(
                    check_save_out$log_folder,
                    "/", name,
                    check_save_out$extension
                  ),
                sep = check_save_out$sep,
                #don't tab indx as could be miss values & cause err
                #tabix_index = tabix_index,
                nThread = nThread
              )
              log_files[[name]] <-
                paste0(
                  check_save_out$log_folder, "/",
                  name, check_save_out$extension
                )  
            } 
        }
    }    
    return(list("sumstats_dt" = sumstats_dt,
                "log_files" = log_files))
}

#' Select VCF fields
#' 
#' Select non-empty columns from each VCF field type.
#' @param verbose Print messages.
#' @inheritParams read_vcf
#' @inheritParams check_empty_cols
#' @inheritParams VariantAnnotation::ScanVcfParam
#' 
#' @returns \code{ScanVcfParam} object.
#' @keywords internal
#' @importFrom VariantAnnotation scanVcfHeader ScanVcfParam 
#' @importFrom VariantAnnotation readVcf vcfFields vcfWhich
#' @importFrom GenomicRanges GRanges
#' @importFrom methods is
select_vcf_fields <- function(path,
                              sampled_rows=1e4L,
                              which=NULL,
                              samples=NULL,
                              nThread=1,
                              verbose=TRUE){
    #### Read header ####
    ## Read the first n rows to determine which columns are useful.
    messager("Finding empty VCF columns based on first",
             formatC(sampled_rows,big.mark = ","),"rows.",
             v=verbose)  
    #### Get header to extract first chromosome name ####
    # header <- VariantAnnotation::scanVcfHeader(file = path)
    # # #### Construct ScanVcfParam object ####
    # param <- VariantAnnotation::ScanVcfParam(
    #     which = GenomicRanges::GRanges(
    #         paste0(header@reference[[1]],":1-",as.integer(sampled_rows))
    #     )
    # )
    vcf_file <- VariantAnnotation::VcfFile(file = path,
                                           index = paste0(path,".tbi"),
                                           yieldSize=sampled_rows) 
    vcf_top <- VariantAnnotation::readVcf(file = vcf_file)
    fields <- VariantAnnotation::vcfFields(x = vcf_top)
    # #### Warnings generated bc 0 rows are present ####
    df <-  vcf2df(vcf = vcf_top,
                  add_sample_names = FALSE,
                  add_rowranges = FALSE,
                  verbose = FALSE)
    remove(vcf_top)
    #### Check n rows returned ####
    if(nrow(df)==0) {
        stop("Query returned no rows. Increase sampled_rows.")
    }
    #### Check for empty cols #####
    remove_empty_cols(sumstats_dt = df,
                      verbose = FALSE)
    for(x in names(fields)[names(fields)!="samples"]){
        fields[[x]] <- fields[[x]][ 
            fields[[x]] %in% names(df)
        ]
    } 
    #### Select samples ####
    all_samples <- fields$samples
    if(!is.null(samples)){
        #### use first sample only ####
        if(samples==1){
            if(length(all_samples)>1){
                messager(length(all_samples),"samples detected.",
                         "Only using first:",all_samples[1]) 
                all_samples <- all_samples[1] 
            } else if (length(all_samples)==1){
                messager("1 sample detected:",all_samples) 
            } 
            #### User-specified samples #####
        } else if(methods::is(samples,"character")){
            all_samples <- all_samples[
                toupper(all_samples) %in% toupper(samples)
            ]
        }
    }
    ## Filter fields$samples 
    fields$samples <- fields$samples[
        fields$samples %in% all_samples
    ] 
    messager("Constructing ScanVcfParam object.")
    #### Select non-empty columns ####
    param <- VariantAnnotation::ScanVcfParam(
        fixed = fields$fixed, 
        info = fields$info, 
        geno = fields$geno, 
        samples = fields$samples,
        trimEmpty = TRUE)
    #### Add genomic ranges if supplied ####
    ## By default, is IRanges::IRangesList() of length 0  
    if(!is.null(which)){
        VariantAnnotation::vcfWhich(param) <- which
    }
    return(param)
}

#' Ensure that the N column is all integers
#'
#' @param sumstats_dt data table obj of the summary statistics file for the GWAS
#' @param path Filepath for the summary statistics file to be formatted
#' @param convert_n_int Binary, if N (the number of samples) is not an integer,
#' should this be rounded? Default is TRUE.
#' @param imputation_ind Binary Should a column be added for each imputation
#' step to show what SNPs have imputed values for differing fields. This
#' includes a field denoting SNP allele flipping (flipped). **Note**
#' these columns will be in the formatted summary statistics returned. Default
#' is FALSE.
#' @return list containing sumstats_dt, the modified summary 
#' statistics data table object.
#' @keywords internal
#' @importFrom data.table :=
#' @importFrom methods is
check_n_int <- function(sumstats_dt,
                        path,
                        convert_n_int,
                        imputation_ind) {
    N <- N_tmp <- convert_n_integer <- NULL
    # Sometimes the N column is not all integers... so round it up
    col_headers <- names(sumstats_dt)
    if ("N" %in% col_headers) {
        if (!is.integer(sumstats_dt$N)) { # check if any decimal places
            msg <- paste0(
                "The sumstats N column is not all integers, this could ",
                "effect downstream analysis."
            )
            if (convert_n_int) { # if user wants to correct
                message("Ensuring that the N column is all integers.")
                msg2 <- paste0(msg, " These will be converted to integers.")
                message(msg2)
                # if user wants information, give SNPs without integer N
                if (imputation_ind) {
                    sumstats_dt[N %% 1 != 0, convert_n_integer := TRUE]
                }
                if (is(sumstats_dt$N, "character")) {
                    suppressWarnings(sumstats_dt[, N := as.integer(N)])
                }
                sumstats_dt[, N := round(N, 0)]
                return(list("sumstats_dt" = sumstats_dt))
            } else {
                msg2 <- paste0(msg, "These will NOT be converted to integers.")
                message(msg2)
            }
        }
    }
    return(list("sumstats_dt" = sumstats_dt))
}

#' To \code{GRanges}
#' 
#' 
#' Convert a \link[data.table]{data.table} to \link[GenomicRanges]{GRanges}.
#' @param sumstats_dt data table obj of the summary statistics file 
#' for the GWAS.
#' @param style \code{GRanges} style to convert to, "NCBI" or "UCSC".
#' @inheritParams GenomicRanges::makeGRangesFromDataFrame
#' @return \code{GRanges} object
#' @keywords internal
#' @importFrom GenomicRanges makeGRangesFromDataFrame
#' @importFrom GenomeInfoDb seqlevelsStyle
to_granges <- function(sumstats_dt,
                       seqnames.field = "CHR",
                       start.field = "BP",
                       end.field = "BP",
                       style = c("NCBI", "UCSC")) {
    message("Converting summary statistics to GenomicRanges.")
    gr <- GenomicRanges::makeGRangesFromDataFrame(
        df = sumstats_dt,
        keep.extra.columns = TRUE,
        seqnames.field = seqnames.field,
        start.field = start.field,
        end.field = end.field
    )
    
    suppressMessages(suppressWarnings(
        GenomeInfoDb::seqlevelsStyle(gr) <- style[1]
    ))
    return(gr)
}

#' Parse number of SNPs with p-values >1
#' 
#' Support function for \link[MungeSumstats]{parse_logs}.
#' 
#' @param l Lines of text from log file.
#' 
#' @return Numeric
#' @keywords internal
parse_pval_large <- function(l){
    line <- grep(
        "p-values are >1 which LDSC/MAGMA may not be able to handle",l,
        value = TRUE)[1]
    if(is.na(line)) return(NA)
    as.integer(trimws(gsub(",","",strsplit(line," ")[[1]][1])))
}

#' Ensure that the non-negative p-values are not 5e-324 or lower, if so set to 0
#'
#' @param sumstats_dt data table obj of the summary statistics file for the GWAS
#' @inheritParams format_sumstats
#' @source 
#' \code{
#' sumstats_dt <- MungeSumstats:::formatted_example()
#' sumstats_dt$P[1:3] <- 5e-324
#' sumstats_dt$P[6:10] <- "5e-324"
#' sumstats <- check_small_p_val(sumstats_dt = sumstats_dt,
#'                               convert_small_p = TRUE, 
#'                               imputation_ind = TRUE)
#' }
#' @returns list containing sumstats_dt, 
#' the modified summary statistics data table object
#' @keywords internal
#' @importFrom data.table :=
check_small_p_val <- function(sumstats_dt,  
                              convert_small_p,
                              imputation_ind) {
    P <- convert_small_p_0 <- NULL
    # Sometimes the N column is not all integers... so round it up
    col_headers <- names(sumstats_dt)
    if ("P" %in% col_headers) {
        # get smallest p-val - seems to change to character if < xe-300
        char_check <- FALSE
        num_check <- FALSE
        # Let negative p-values be handled by check_range_pval in the next step
        small_bool <- as.numeric(sumstats_dt$P) <= 5e-324 & 
                      as.numeric(sumstats_dt$P) > 0L
        small_n <-  sum(small_bool, na.rm = TRUE)
        
        if (is.numeric(sumstats_dt$P)) {
            if (small_n > 0) {
                num_check <- TRUE
            }
        } else { # char check
            max_minus_power <- max(
                as.numeric(gsub(".*-", "", sumstats_dt$P)),
                na.rm = TRUE)
            if (max_minus_power >= 324) {
                char_check <- TRUE
            }
        }   
        
        if (char_check | num_check) { 
            # check if any smaller or equal to 5e-324 limit
            msg <- paste0(
                formatC(small_n, big.mark = ","),
                " p-values are <=5e-324 which ",
                "LDSC/MAGMA may not be able to handle. "
            )
            if (convert_small_p) { # if user wants to correct
                msg2 <- paste0(msg, "These will be converted to 0.")
                message(msg2) 
                # if users want edited snps, return information 
                if (imputation_ind) {
                    sumstats_dt[small_bool, convert_small_p_0 := TRUE]
                }
                sumstats_dt[small_bool, P := 0]
            } else {
                msg2 <- paste0(msg, "These will NOT be converted.")
                message(msg2)
            }
        }
    }
    return(list("sumstats_dt" = sumstats_dt))
}

#' Tabix-index file: table
#' 
#' Convert summary stats file to tabix format.
#'
#' @source Borrowed function from 
#' \href{https://github.com/RajLabMSSM/echotabix/blob/main/R/convert.R}{
#' echotabix}.
#' 
#' @param path Path to GWAS summary statistics file.
#' @param remove_tmp Remove the temporary uncompressed version of the file 
#' (\emph{.tsv}). 
#' @param verbose Print messages.
#' @inheritParams liftover
#' @inheritParams Rsamtools::bgzip
#' 
#' @return Path to tabix-indexed tabular file
#'
#' @family tabix
#' @export
#' @importFrom R.utils gunzip isGzipped
#' @examples
#' sumstats_dt <- MungeSumstats::formatted_example() 
#' path <- tempfile(fileext = ".tsv")
#' MungeSumstats::write_sumstats(sumstats_dt = sumstats_dt, save_path = path)
#' indexed_file <- MungeSumstats::index_tabular(path = path)
index_tabular <- function(path,
                          chrom_col = "CHR",
                          start_col = "BP",
                          end_col = start_col,
                          overwrite = TRUE,
                          remove_tmp = TRUE,
                          verbose = TRUE) {
    msg <- paste("Converting full summary stats file to",
                 "tabix format for fast querying...")
    messager(msg,v=verbose) 
    #### Make sure input file isn't empty ####
    if(!file.exists(path)){
        stp <- paste("File does not exist: ",path)
        stop(stp)
    }
    if (file.size(path) == 0) {
        msg2 <- paste("Removing empty file:", path)
        messager(msg2,v=verbose)
        out <- file.remove(path)
    }
    #### Ensure it's not already compressed ####
    if(R.utils::isGzipped(path)){
        path <- R.utils::gunzip(path, overwrite = TRUE)
    }
    #### Read header and make dictionary ####
    cdict <- column_dictionary(file_path = path)
    #### Check column exist ####
    if(!chrom_col %in% names(cdict)) stop("chrom_col not found in file.")
    if(!start_col %in% names(cdict)) stop("start_col not found in file.")
    if(!end_col %in% names(cdict)) stop("end_col not found in file.")
    ### File MUST be bgzipped first
    messager("Ensuring file is bgzipped.",v=verbose)
    bgz_file <- Rsamtools::bgzip(file = path,
                                 dest = sprintf("%s.bgz",
                                                sub("\\.gz$|\\.bgz$", "",
                                                    path)),
                                 overwrite = overwrite)
    ### Tabix-index file
    messager("Tabix-indexing file.",v=verbose)  
    tbi_file <- Rsamtools::indexTabix(file = bgz_file, 
                                      seq = cdict[[chrom_col]],
                                      start = cdict[[start_col]],
                                      end = cdict[[end_col]],
                                      comment = names(cdict)[1]) 
    if(isTRUE(remove_tmp) && 
       file.exists(path)){
        messager("Removing temporary .tsv file.",v=verbose)  
        out <- file.remove(path)
    }
    return(bgz_file)
}

#' Ensure all SNPs have N less than X std dev below mean
#'
#' In case some SNPs were genotyped by a specialized genotyping array and
#' have substantially more samples than others. These will be removed.
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and the log file list
#' @keywords internal
#' @importFrom stats sd
check_n_num <- function(sumstats_dt, 
                        path, 
                        N_std, 
                        N_dropNA = FALSE,
                        log_folder_ind,
                        check_save_out, 
                        tabix_index, 
                        nThread, 
                        log_files) {
    message("Ensuring all SNPs have N<", N_std, " std dev above mean.")
    N <- NULL
    col_headers <- names(sumstats_dt)
    if ("N" %in% col_headers && N_std > 0) {
        mean_N <- mean(sumstats_dt$N)
        sd_N <- stats::sd(sumstats_dt$N)
        num_bad_ids <- nrow(sumstats_dt[N > ((N_std * sd_N) + mean_N), ])
        if (num_bad_ids > 0) {
            msg <- paste0(
                formatC(num_bad_ids, big.mark = ","), " SNPs have N values ",
                N_std, " standard deviations above the mean",
                " and will be removed"
            )
            message(msg)
            # If user wants log, save it to there
            if (log_folder_ind) {
                name <- "n_large"
                name <- get_unique_name_log_file(name = name,
                                                 log_files = log_files)
                write_sumstats(
                    sumstats_dt = sumstats_dt[N > ((N_std * sd_N) + mean_N), ],
                    save_path =
                        paste0(
                            check_save_out$log_folder,
                            "/", name,
                            check_save_out$extension
                        ),
                    sep = check_save_out$sep,
                    #don't tab indx as could be miss values & cause err
                    #tabix_index = tabix_index,
                    nThread = nThread
                )
                log_files[[name]] <-
                    paste0(
                        check_save_out$log_folder, "/", name,
                        check_save_out$extension
                    )
            }
            sumstats_dt <- sumstats_dt[N <= ((N_std * sd_N) + mean_N), ]
        }
        if (!N_dropNA) {
            message("Removing rows where is.na(N)")
            n_NAs <- sum(is.na(sumstats_dt$N))
            message(
                formatC(n_NAs, big.mark = ","),
                " SNPs have N values that are NA and will be removed."
            )
            # If user wants log, save it to there
            if (log_folder_ind) {
                name <- "n_null"
                name <- get_unique_name_log_file(name = name,
                                                 log_files = log_files)
                write_sumstats(
                    sumstats_dt = sumstats_dt[!complete.cases(N)],
                    save_path =
                        paste0(
                            check_save_out$log_folder,
                            "/", name,
                            check_save_out$extension
                        ),
                    sep = check_save_out$sep,
                    tabix_index = tabix_index,
                    nThread = nThread
                )
                log_files[[name]] <-
                    paste0(
                        check_save_out$log_folder, "/", name,
                        check_save_out$extension
                    )
            }
            sumstats_dt <- sumstats_dt[complete.cases(N)]
        }
        return(list("sumstats_dt" = sumstats_dt,
                    "log_files" = log_files))
    } else {
        return(list("sumstats_dt" = sumstats_dt,
                    "log_files" = log_files))
    }
}

#' Ensure all rows have unique SNP IDs, drop those that don't
#'
#' @inheritParams format_sumstats
#' @param log_files list of log file locations
#' @return list containing sumstats_dt, the modified summary statistics data
#' table object and log files list
#' @keywords internal
#' @importFrom data.table key
#' @importFrom data.table setkey
check_dup_snp <- function(sumstats_dt,
                          indels,
                          path,
                          log_folder_ind,
                          check_save_out,
                          tabix_index,
                          nThread,
                          log_files,
                          bi_allelic_filter,
                          check_dups) {
    SNP <- A1 <- A2 <- NULL
    col_headers <- names(sumstats_dt)
    #only remove dups if bi-allelic filter selected, RS IDs are not unique for
    #non bi-allelic SNPs
    if ("SNP" %in% col_headers && bi_allelic_filter && check_dups) {
        message("Checking for duplicate SNPs from SNP ID.")
        #remove indels from this check if sleected since these can have same pos
        indel_dt <- data.table::data.table()
        if(sum(c("A1", "A2") %in% col_headers) == 2 & indels){
          #identify Indels based on num char in A1, A2
          num_indels <- nrow(sumstats_dt[(nchar(A1)>1 | nchar(A2)>1),])
          if(num_indels>0){
            msg <- paste0("Found ",
                          formatC(num_indels,big.mark = ","),
                          " Indels. These won't",
                          " be checked for duplicates based on RS ID ",
                          "as there can be multiples.",
                          "\nWARNING If your sumstat ",
                          "doesn't contain Indels, set the ",
                          "indel param to FALSE & rerun ",
                          "MungeSumstats::format_sumstats()")
            message(msg)
            indel_dt <- sumstats_dt[(nchar(A1)>1 | nchar(A2)>1),]
            #update sumstats to excl indels for check, add back later
            sumstats_dt <- sumstats_dt[!(nchar(A1)>1 | nchar(A2)>1),]
          }
        }
        # Try to remove duplicated RSIDs
        data.table::setkey(sumstats_dt, SNP)
        dups <- duplicated(sumstats_dt,
            by = data.table::key(sumstats_dt)
        )
        if (sum(dups) > 0) {
            msg <- paste0(
                formatC(sum(dups), big.mark = ","), " RSIDs are duplicated ",
                "in the sumstats file. These duplicates will be removed"
            )
            message(msg)
            # If user wants log, save it to there
            if (log_folder_ind) {
                name <- "dup_snp_id"
                name <- get_unique_name_log_file(
                    name = name,
                    log_files = log_files
                )
                write_sumstats(
                    sumstats_dt = sumstats_dt[dups, ],
                    save_path =
                        paste0(
                            check_save_out$log_folder,
                            "/", name,
                            check_save_out$extension
                        ),
                    sep = check_save_out$sep,
                    #don't tab indx as could be miss values & cause err
                    #tabix_index = tabix_index,
                    nThread = nThread
                )
                log_files[[name]] <-
                    paste0(
                        check_save_out$log_folder, "/",
                        name, check_save_out$extension
                    )
            }
            sumstats_dt <- unique(sumstats_dt,
                by = data.table::key(sumstats_dt)
            )
            #join back indels
            sumstats_dt <-
              data.table::rbindlist(
                list(sumstats_dt, indel_dt))
            return(list(
                "sumstats_dt" = sumstats_dt,
                "log_files" = log_files
            ))
        }
        #join back indels
        sumstats_dt <-
          data.table::rbindlist(
            list(sumstats_dt, indel_dt))
    }
    return(list(
        "sumstats_dt" = sumstats_dt,
        "log_files" = log_files
    ))
}

test_that("standardise_sumstats_column_headers_crossplatform works", {
    
    sumstats_dt <- data.table::fread(
        system.file("extdata", "eduAttainOkbay.txt",
                    package = "MungeSumstats"))
    sumstats_dt$Support <- 1
    #### Internal version ####
    sumstats_dt2 <- 
        MungeSumstats:::standardise_sumstats_column_headers_crossplatform(
            ## Important! Must copy input data to avoid it also being modified 
            ## by the function.
            sumstats_dt = data.table::copy(sumstats_dt), 
            uppercase_unmapped = FALSE,
            return_list = FALSE)
    testthat::expect_true("Support" %in% colnames(sumstats_dt))
    testthat::expect_true("Pval" %in% colnames(sumstats_dt))
    testthat::expect_true("Support" %in% colnames(sumstats_dt2))
    testthat::expect_true("P" %in% colnames(sumstats_dt2))
    
    
    #### Exported version ####
    sumstats_dt3 <- 
        MungeSumstats::standardise_header(
            ## Important! Must copy input data to avoid it also being modified 
            ## by the function.
            sumstats_dt = data.table::copy(sumstats_dt),  
            uppercase_unmapped = FALSE,
            return_list = FALSE)
    testthat::expect_true("Support" %in% colnames(sumstats_dt))
    testthat::expect_true("Pval" %in% colnames(sumstats_dt))
    testthat::expect_true("Support" %in% colnames(sumstats_dt3))
    testthat::expect_true("P" %in% colnames(sumstats_dt3))
})

test_that("zzz works", {
    ## The following test uses more than 2GB of memory, which is more
    ## than what 32-bit Windows can handle:
    is_32bit_windows <- .Platform$OS.type == "windows" ##&&
    ##.Platform$r_arch == "i386"
    #only run test if user has internet access
    #capture internet outage or server issues
    if(try(is.character(getURL("www.google.com")))==TRUE &&
       !is_32bit_windows){
        library(MungeSumstats)
        opts <- options()
        
        #testthat::expect_equal(opts$googleAuthR.batch_endpoint,
        #                       "https://www.googleapis.com/batch")
        testthat::expect_equal(opts$gargle_oauth_cache,
                               "ieugwasr_oauth")
        testthat::expect_equal(opts$googleAuthR.webapp.client_secret,
                               "I7Gqp83Ku4KJxL9zHWYxG_gD")
    }
    else{
        #expect_equal(TRUE, TRUE)
        expect_equal(TRUE, TRUE)
        expect_equal(TRUE, TRUE)
    }
})

---
title: Docker/Singularity Containers
author: '<h4>Authors: <i>`r auths <- eval(parse(text = gsub("person","c",read.dcf("../DESCRIPTION",
  fields = "Authors@R"))));paste(auths[names(auths)=="given"],auths[names(auths)=="family"],
  collapse = ", ")`</i></h4>'
date: '<h4>Vignette updated: <i>`r format( Sys.Date(), "%b-%d-%Y")`</i></h4>'
output:
  BiocStyle::html_document:
    md_extensions: -autolink_bare_uris
params:
  cont:
    value: ghcr.io/neurogenomics/MungeSumstats
  docker_registry:
    value: ghcr.io
  docker_org:
    value: neurogenomics
vignette: |
  %\VignetteIndexEntry{docker}
  %\usepackage[utf8]{inputenc}
  %\VignetteEngine{knitr::rmarkdown}
---


```{r setup, include=FALSE}
#### Package name ####
PKG <- read.dcf("../DESCRIPTION", fields = "Package")[1]
library(PKG, character.only = TRUE)
## Docker containers must be lowercase
pkg <- tolower(PKG)
#### Username of DockerHub account ####
docker_org <- params$docker_org
docker_registry <- params$docker_registry 
cont <- params$cont 
docker_url <- if(grepl("ghcr.io",docker_registry)){
  paste("https://ghcr.io",cont,sep="/")
} else {
  paste("https://hub.docker.com/repository/docker",docker_org,pkg,sep="/")
}

```

# Installation 

`r PKG` is now available via [`r docker_registry`](`r docker_url`) 
as a containerised environment with Rstudio and 
all necessary dependencies pre-installed.

## Method 1: via Docker

First, [install Docker](https://docs.docker.com/get-docker/) 
if you have not already. 

Create an image of the [Docker](https://www.docker.com/) container 
in command line:  

```
docker pull `r cont`
```

Once the image has been created, you can launch it with:  

```
docker run \
  -d \
  -e ROOT=true \
  -e PASSWORD="<your_password>" \
  -v ~/Desktop:/Desktop \
  -v /Volumes:/Volumes \
  -p 8900:8787 \
  `r cont`
```  

### NOTES

* Make sure to replace `<your_password>` above with whatever you want your password to be.  
* Change the paths supplied to the `-v` flags for your particular use case. 
* The `-d` ensures the container will run in "detached" mode,
which means it will persist even after you've closed your command line session.  
* The username will be *"rstudio"* by default.  
* Optionally, you can also install the [Docker Desktop](https://www.docker.com/products/docker-desktop/) 
to easily manage your containers.  

## Method 2: via Singularity

If you are using a system that does not allow Docker 
(as is the case for many institutional computing clusters), 
you can instead [install Docker images via Singularity](https://docs.sylabs.io/guides/2.6/user-guide/singularity_and_docker.html).  

```
singularity pull docker://`r cont`
```

For troubleshooting, see the [Singularity documentation](https://docs.sylabs.io/guides/latest/user-guide/singularity_and_docker.html#github-container-registry).

# Usage 

Finally, launch the containerised Rstudio by entering the 
following URL in any web browser:
*http://localhost:8900/*

Login using the credentials set during the Installation steps.  


# Session Info 

<details> 

```{r Session Info}
utils::sessionInfo()
```

</details>  

<br>

---
title: "`MungeSumstats`: Getting started"
author: "<h5><i>Authors</i>: Alan Murphy, Brian Schilder and Nathan Skene</h5>"
date: "<h5><i>Updated</i>: `r format(Sys.Date(), '%b-%d-%Y')`</h5>"
csl: nature.csl
output:
  BiocStyle::html_document:
vignette: >
    %\VignetteIndexEntry{MungeSumstats} 
    %\usepackage[utf8]{inputenc}
    %\VignetteEngine{knitr::rmarkdown} 
bibliography: MungeSumstats.bib
editor_options: 
  markdown: 
    wrap: 72
---

# Citation

If you use the *MungeSumstats* package, please cite

[Murphy et al. MungeSumstats: A Bioconductor package for the
standardisation and quality control of many GWAS summary
statistics](https://academic.oup.com/bioinformatics/advance-article/doi/10.1093/bioinformatics/btab665/6380562).

# Overview

The *MungeSumstats* package is designed to facilitate the
standardisation of GWAS summary statistics as utilised in our Nature
Genetics paper [@Skene2018].

The package is designed to handle the lack of standardisation of output
files by the GWAS community. There is a group who have now manually
standardised many GWAS: [R interface to the IEU GWAS database API •
ieugwasr](https://mrcieu.github.io/ieugwasr/) and
[gwasvcf](https://github.com/MRCIEU/gwasvcf) but because a lot of GWAS
remain closed access, these repositories are not all encompassing.

The [GWAS-Download
project](https://github.com/mikegloudemans/gwas-download) has collated
summary statistics from 200+ GWAS. This repository has been utilsed to
identify the most common formats, all of which can be standardised with
*MungeSumstats*.

Moreover, there is an emerging standard of VCF format for summary
statistics files with multiple, useful, associated R packages such as
*vcfR*. However, there is currently no method to convert VCF formats to
a standardised format that matches older approaches.

The *MungeSumstats* package standardises both VCF and the most common
summary statistic file formats to enable downstream integration and
analysis.

*MungeSumstats* also offers comprehensive Quality Control (QC) steps
which are important prerequisites for downstream analysis like Linkage
disequilibrium score regression (LDSC) and MAGMA.

Moreover, *MungeSumstats* is efficiently written resulting in all
reformatting and quality control checks completing in minutes for GWAS
summary statistics with 500k SNPs on a standard desktop machine. This
speed can be increased further by increasing the number of threads
(nThread) for `data.table` to use.

Currently *MungeSumstats* only works on data from humans, as it uses
human-based genome references.

# Aim

*MungeSumstats* will ensure that the all essential columns for analysis
are present and syntactically correct. Generally, summary statistic
files include (but are not limited to) the columns:

-   SNP : SNP ID (rs IDs)
-   CHR : Chromosome number
-   BP : Base pair positions
-   A1 : reference allele
-   A2 : alternative allele
-   Z : Z-score
-   BETA : Effect size estimate relative to the alternative allele
-   P : Unadjusted p-value for SNP
-   SE : The standard error
-   N : Sample size
-   INFO: The imputation information score
-   FRQ: The minor/effect allele frequency (MAF/EAF) of the SNP

*MungeSumstats* uses a mapping file to infer the inputted column names
(run `data("sumstatsColHeaders")` to view these). This mapping file is
far more comprehensive than any other publicly available munging tool
containing more than 200 unique mappings at the time of writing this
vignette. However, if your column headers are missing or if you want to
change the mapping, you can do so by passing your own mapping file (see
`format_sumstats(mapping_file)`).

*MungeSumstats* offers unmatched levels of quality control to ensure,
for example, consistency of allele assignment and direction of effects.
Tests run by *MungeSumstats* include:

-   Check VCF format
-   Check tab, space or comma delimited, zipped, csv or tsv file
-   Check for header name synonyms
-   Check for multiple models or traits in GWAS
-   Check for uniformity in SNP ID - no mix of rs/missing rs/chr:bp
-   Check for CHR:BP:A2:A1 all in one column
-   Check for CHR:BP in one column
-   Check for A1/A2 in one column
-   Check if CHR and/or BP is missing (infer from reference genome)
-   Check if SNP ID is missing (infer from reference genome)
-   Check if A1 and/or A2 are missing (infer from reference genome)
-   Check that vital columns are present (SNP,CHR,BP,P,A1,A2)
-   Check for one signed/effect column
    (Z,OR,BETA,LOG_ODDS,SIGNED_SUMSTAT)
-   Check for missing data
-   Check for duplicated columns
-   Check for small p-values (lower than 5e-324)
-   Check N column is an integer
-   Check for SNPs with N greater than 5 times standard dev. plus the
    mean
-   Check SNPs are RS ID's
-   Check for uniformity of SNP ID format
-   Check for duplicated rows, based on SNP ID
-   Check for duplicated rows, based on base-pair position
-   Check for SNPs on reference genome. Correct not found SNP IDs using
    CHR and BP (infer from reference genome)
-   Check INFO score
-   Check FRQ value
-   Check FRQ is minor allele frequency (MAF)
-   Check that the SNPs' standard error (SE) is positive
-   Check that SNPs' effect columns (like BETA) aren't equal to 0
-   Check for strand-ambiguous SNPs
-   Check for non-biallelic SNPs (infer from reference genome)
-   Check for allele flipping
-   Check for SNPs with nonstandard chromosome names
-   Check for CHR format of X/Y chromosome - converting 23/24 to X/Y and M to MT
-   Check for SNPs on excluded chromosomes (removes non-autosomal SNPs by default)
-   Check for z-score (Z) and impute if missing
-   Check for N and impute if missing
-   Check output format is LDSC ready
-   Check output format is IEU OpenGWAS ready
-   Check and perform liftover to desired reference genome if necessary
-   Check for indels in the sumstats and drop them if found (not run by default)

Users can specify which checks to run on their data. A **note** on the
allele flipping check: **MungeSumstats** infers the effect allele will
always be the A2 allele, this is the approach done for [IEU GWAS
VCF](https://www.ncbi.nlm.nih.gov/pmc/articles/PMC7805039/) and has such
also been adopted here. This inference is first from the inputted file's
column headers however, the allele flipping check ensures this by
comparing A1, what should be the reference allele, to the reference
genome. If a SNP's A1 DNA base doesn't match the reference genome but
it's A2 (what should be the alternative allele) does, the alleles will
be flipped along with the effect information (e.g. Beta, Odds Ratio,
signed summary statistics, FRQ, Z-score\*).

\*-by default the Z-score is assumed to be calculated off the effect
size not the P-value and so will be flipped. This can be changed by a
user.

If a test is failed, the user will be notified and if possible, the
input will be corrected. The QC steps from the checks above can also be
adjusted to suit the user's analysis, see
`MungeSumstats::format_sumstats`.

*MungeSumstats* can handle VCF, txt, tsv, csv file types or .gz/.bgz
versions of these file types. The package also gives the user the
flexibility to export the reformatted file as tab-delimited, VCF or R
native objects such as data.table, GRanges or VRanges objects. The
output can also be outputted in an **LDSC ready** format which means the
file can be fed directly into LDSC without the need for additional
munging. **NOTE** - If LDSC format is used, the naming convention of A1 as the 
reference (genome build) allele and A2 as the effect allele will be reversed
to match LDSC (A1 will now be the effect allele). See more info on this 
[here](https://groups.google.com/g/ldsc_users/c/S7FZK743w68). Note that any 
effect columns (e.g. Z) will be inrelation to A1 now instead of A2.

Please read carefully through our [FAQ Website](https://github.com/Al-Murphy/MungeSumstats/wiki/FAQ)
to gain insight on how best to run MungeSumstats on your data.

# Data

The *MungeSumstats* package contains small subsets of GWAS summary
statistics files. Firstly, on Educational Attainment by Okbay et al
2016: PMID: 27898078 PMCID: PMC5509058 DOI: 10.1038/ng1216-1587b.

Secondly, a VCF file (VCFv4.2) relating to the GWAS Amyotrophic lateral
sclerosis from ieu open GWAS project. Dataset: ebi-a-GCST005647:
<https://gwas.mrcieu.ac.uk/datasets/ebi-a-GCST005647/>

These datasets will be used to showcase *MungeSumstats* functionality.

# Running *MungeSumstats*

*MungeSumstats* is available on Bioconductor. To install the package on
Bioconductor run the following lines of code:

    if (!require("BiocManager")) install.packages("BiocManager")
    BiocManager::install("MungeSumstats")

Once installed, load the package:

```{r setup}
library(MungeSumstats)
```

To standardise the summary statistics' file format, simply call
`format_sumstats()` passing in the path to your summary statistics file
or directly pass the summary statistics as a dataframe or datatable. You
can specify which genome build was used in the GWAS(GRCh37 or GRCh38)
or, as default, infer the genome build from the data.The reference
genome is used for multiple checks like deriving missing data such
SNP/BP/CHR/A1/A2 and for QC steps like removing non-biallelic SNPs,
strand-ambiguous SNPs or ensuring correct allele and direction of SNP
effects. The path to the reformatted summary statistics file can be
returned by the function call, the user can specify a location to save
the file or the user can return an R native object for the data:
data.table, VRanges or GRanges object.

Note that for a number of the checks implored by *MungeSumstats* a
reference genome is used. If your GWAS summary statistics file of
interest relates to *GRCh38*, you will need to install
`SNPlocs.Hsapiens.dbSNP155.GRCh38` and `BSgenome.Hsapiens.NCBI.GRCh38`
from Bioconductor as follows:

```
#increase permissible time to download data, in case of slow internet access
options(timeout=2000)
BiocManager::install("SNPlocs.Hsapiens.dbSNP155.GRCh38")
BiocManager::install("BSgenome.Hsapiens.NCBI.GRCh38")
```

If your GWAS summary statistics file of interest relates to *GRCh37*,
you will need to install `SNPlocs.Hsapiens.dbSNP155.GRCh37` and
`BSgenome.Hsapiens.1000genomes.hs37d5` from Bioconductor as follows:

```
BiocManager::install("SNPlocs.Hsapiens.dbSNP155.GRCh37")
BiocManager::install("BSgenome.Hsapiens.1000genomes.hs37d5")
```

These may take some time to install and are not included in the package
as some users may only need one of *GRCh37*/*GRCh38*.

The Educational Attainment by Okbay GWAS summary statistics file is
saved as a text document in the package's external data folder so we can
just pass the file path to it straight to *MungeSumstats*.

**NOTE** - By default, Formatted results will be saved to `tempdir()`.
This means all formatted summary stats will be deleted upon ending the R
session if not copied to a local file path. Otherwise, to keep formatted
summary stats, change `save_path` (
e.g.`file.path('./formatted',basename(path))`), or make sure to copy
files elsewhere after processing (
e.g.`file.copy(save_path, './formatted/' )`.

```{r, eval=FALSE, message=TRUE}
eduAttainOkbayPth <- system.file("extdata","eduAttainOkbay.txt",
                                  package="MungeSumstats")
reformatted <- 
  MungeSumstats::format_sumstats(path=eduAttainOkbayPth,
                                 ref_genome="GRCh37")
```

```{r,echo=FALSE}
#don't run time intensive checks
eduAttainOkbayPth <- system.file("extdata","eduAttainOkbay.txt",
                                  package="MungeSumstats")
reformatted <- 
  MungeSumstats::format_sumstats(path=eduAttainOkbayPth,
                                 on_ref_genome = FALSE,
                                 strand_ambig_filter = FALSE,
                                 bi_allelic_filter = FALSE,
                                 allele_flip_check = FALSE,
                                 ref_genome="GRCh37")
```

Here we know the summary statistics are based on the reference genome GRCh37, 
GRCh38 can also be inputted. Moreover, if you are unsure of the genome build, 
leave it as `NULL` and Mungesumstats will infer it from the data.

Also note that the default dbSNP version used along with the reference genome is
the latest version available on Bioconductor (currently dbSNP 155) but older 
package versions are also available - Use the `dbSNP` input parameter to 
control this.

Moreover, newer/different versions can be sued by passing a local tarball 
package. Use the `dbSNP_tarball` parameter for this. `dbSNP_tarball` was enabled
to help with dbSNP versions >=156, after the decision to no longer provide dbSNP
releases as bioconductor packages. dbSNP 156 tarball is available 
[here](http://149.165.171.124/SNPlocs/).

The arguments `format_sumstats` in that control the level of QC
conducted by *MungeSumstats* are:

-   **convert_small_p** Binary, should `p-values < 5e-324` be converted
    to 0? Small p-values pass the R limit and can cause errors with
    LDSC/MAGMA and should be converted. Default is TRUE.
-   **convert_large_p** Binary, should p-values \>1 be converted to 1?
    P-values \>1 should not be possible and can cause errors with
    LDSC/MAGMA and should be converted. Default is TRUE.
-   **convert_neg_p** Binary, should p-values \<0 be converted to 0?
    Negative p-values should not be possible and can cause errors with
    LDSC/MAGMA and should be converted. Default is TRUE.
-   **compute_z** Whether to compute Z-score column from P. Default is
    FALSE. **Note** that imputing the Z-score for every SNP will not
    correct be perfectly correct and may result in a loss of power. This
    should only be done as a last resort.
-   **force_new_z** When a "Z" column already exists, it will be used by
    default. To override and compute a new Z-score column from P set to
    TRUE.
-   **compute_n** Whether to impute N. Default of 0 won't impute, any
    other integer will be imputed as the N (sample size) for every SNP
    in the dataset. **Note** that imputing the sample size for every SNP
    is not correct and should only be done as a last resort. N can also
    be inputted with "ldsc", "sum", "giant" or "metal" by passing one of
    these for this field or a vector of multiple. Sum and an integer
    value creates an N column in the output whereas giant, metal or ldsc
    create an Neff or effective sample size. If multiples are passed,
    the formula used to derive it will be indicated.
-   **convert_n\_int** Binary, if N (the number of samples) is not an
    integer, should this be rounded? Default is TRUE. analysis_trait If
    multiple traits were studied, name of the trait for analysis from
    the GWAS. Default is NULL.
-   **impute_beta** Binary, whether BETA should be imputed using other
    effect data if it isn't present in the sumstats. Note that this
    imputation is an approximation so could have an effect on downstream
    analysis. Use with caution. The different methods MungeSumstats will
    try and impute beta (in this order or priority) are: 1. log(OR) 2. Z
    x SE. Default value is FALSE.
-   **es_is_beta** Binary, whether to map ES to BETA. We take BETA to be any
    BETA-like value (including Effect Size). If this is not the case for your 
    sumstats, change this to FALSE. Default is TRUE.
-   **impute_se** Binary, whether the standard error should be imputed
    using other effect data if it isn't present in the sumstats. Note
    that this imputation is an approximation so could have an effect on
    downstream analysis. Use with caution. The different methods
    MungeSumstats will try and impute se (in this order or priority)
    are: 1. BETA / Z
    2.  abs(BETA/ qnorm(P/2)). Default value is FALSE.
-   **analysis_trait** If multiple traits were studied, name of the
    trait for analysis from the GWAS. Default is NULL.
-   **INFO_filter** 0-1 The minimum value permissible of the imputation
    information score (if present in sumstatsfile). Default 0.9
-   **FRQ_filter** 0-1 The minimum value permissible of the
    frequency(FRQ) of the SNP (i.e. Allele Frequency (AF)) (if present
    in sumstats file). By default no filtering is done, i.e. value of
    0.\
-   **pos_se** Binary Should the standard Error (SE) column be checked
    to ensure it is greater than 0? Those that are, are removed (if
    present in sumstats file). Default TRUE.
-   **effect_columns_nonzero** Binary should the effect columns in the
    data BETA,OR (odds ratio),LOG_ODDS,SIGNED_SUMSTAT be checked to
    ensure no SNP=0. Those that do are removed(if present in sumstats
    file). Default TRUE.\
-   **N_std** Numeric, the number of standard deviations above the mean
    a SNP's N is needed to be removed. Default is 5. **N_dropNA**
    controls whether the SNPs with a missing N value are dropped or not
    (Default is TRUE).
-   **N_dropNA** Drop rows where N is missing.Default is TRUE.
-   **chr_style** Chromosome naming style to use in the formatted summary
    statistics file ("NCBI", "UCSC", "dbSNP", or "Ensembl"). The NCBI and
    Ensembl styles both code chromosomes as `1-22, X, Y, MT`; the UCSC
    style is `chr1-chr22, chrX, chrY, chrM`; and the dbSNP style is
    `ch1-ch22, chX, chY, chMT`. Default is Ensembl.
-   **rmv_chr** Chromosomes to exclude from the formatted summary
    statistics file. Use NULL if no filtering is necessary. Default is
    `c("X", "Y", "MT")` which removes all non-autosomal SNPs.
-   **on_ref_genome** Binary, should a check take place that all SNPs
    are on the reference genome by SNP ID. Any SNPs not on the reference
    genome, will be corrected from the reference genome (if possible)
    using the chromosome and base pair position data. Default is TRUE
-   **convert_ref_genome** name of the reference genome to convert to
    ("GRCh37" or "GRCh38"). This will only occur if the current genome
    build does not match. Default is not to convert the genome build
    (NULL).\
-   **strand_ambig_filter** Binary, should SNPs with strand-ambiguous
    alleles be removed. Default is FALSE
-   **allele_flip_check** Binary, should the allele columns be checked
    against reference genome to infer if flipping is necessary. Default
    is TRUE. **allele_flip_drop** controls whether the SNPs for which
    neither their A1 or A2 base pair values match a reference genome be
    dropped. Default is TRUE. **allele_flip_z** controls whether the
    Z-score value should be flipped along with effect and FRQ columns
    (e.g. Beta). Default is TRUE. **allele_flip_frq** controls whether
    the frequency (FRQ) value should be flipped along with effect and
    Z-score columns (e.g. Beta). Default is TRUE.
-   **bi_allelic_filter** Binary, should non-biallelic SNPs be removed.
    Default is TRUE
-   **flip_frq_as_biallelic** Binary, Should non-bi-allelic SNPs frequency 
    values be flipped as 1-p despite there being other alternative alleles? 
    Default is FALSE but if set to TRUE, this allows non-bi-allelic SNPs to be 
    kept despite needing flipping.    
-   **snp_ids_are_rs_ids** Binary, should the SNP IDs inputted be
    inferred as RS IDs or some arbitrary ID. Default is TRUE.\
-   **remove_multi_rs_snp** Binary Sometimes summary statistics can have
    multiple RSIDs on one row (i.e. related to one SNP), for example
    "rs5772025_rs397784053". This can cause an error so by default, the
    first RS ID will be kept and the rest removed e.g."rs5772025". If
    you want to just remove these SNPs entirely, set it to TRUE. Default
    is FALSE.
-   **frq_is_maf** Binary, conventionally the FRQ column is intended to
    show the minor/effect allele frequency (MAF) but sometimes the major
    allele frequency can be inferred as the FRQ column. This logical
    variable indicates that the FRQ column should be renamed to
    MAJOR_ALLELE_FRQ if the frequency values appear to relate to the
    major allele i.e. \>0.5. By default mapping won't occur i.e. is
    TRUE.
-   **indels** Binary does your Sumstats file contain Indels? These
    don't exist in our reference file so they will be excluded from
    checks if this value is TRUE. Further information -the reference 
    dataset we use in MSS (dbSNP) does not include indels so any 
    checks like is the SNP on the reference genome, attempts to impute 
    any missing data for indels or check the direction of the effect 
    columns can not be done for indels. Indels will be kept in the 
    dataset if possible but certain situations (like if there is missing
    data) can cause an indel to be removed. See the printed information by
    MSS during your run to know if this affects you. Default is TRUE.
-   **drop_indels** Binary should any indels found in the sumstats be 
    dropped? These can not be checked against a reference dataset and will have 
    the same RS ID and position as SNPs which can affect downstream analysis. 
    Default is False.    
-   **drop_na_cols** A character vector of column names to be checked for 
    missing values. Rows with missing values in any of these columns (if present 
    in the dataset) will be dropped. If `NULL`, all columns will be checked for 
    missing values. Default columns are SNP, chromosome, position, allele 1, 
    allele 2, effect columns (frequency, beta, Z-score, standard error, 
    log odds, signed sumstats, odds ratio), p value and N columns.
-   **dbSNP** The dbSNP version to use as a reference - defaults to the most 
    recent version available (155). Note that with the 9x more SNPs in dbSNP 
    155 vs 144, run times will increase.
-   **dbSNP_tarball** Pass local versions of dbSNP in tarball format. Default of 
    NULL uses the dbSNP version passed in `dbSNP` parmeter. `dbSNP_tarball` was 
    enabled to help with dbSNP versions >=156, after the decision to no 
    longer provide dbSNP releases as bioconductor packages. dbSNP 156 tarball is 
    available here: http://149.165.171.124/SNPlocs/. 
-   **sort_coordinates** Whether to sort by coordinates of resulting
    sumstats.\
-   **nThread** Number of threads to use for parallel processes.
-   **write_vcf** Whether to write as VCF (TRUE) or tabular file
    (FALSE). While **tabix_index** is a binary input for whether to
    index the formatted summary statistics with
    [tabix](http://www.htslib.org/doc/tabix.html) for fast querying.
-   **return_data** Return `data.table`, `GRanges` or `VRanges`directly
    to user. Otherwise, return the path to the save data. Default is
    FALSE.
-   **return_format** If return_data is TRUE. Object type to be returned
    ("data.table","vranges","granges").
-   **save_format** Ensure that output format meets all requirements to
    be passed directly into LDSC ("ldsc") without the need for additional
    munging or for IEU OpenGWAS format ("opengwas") before saving as a VCF.
    **NOTE** - If LDSC format is used, the naming convention of A1 as the 
    reference (genome build) allele and A2 as the effect allele will be reversed
    to match LDSC (A1 will now be the effect allele). See more info on this 
    [here](https://groups.google.com/g/ldsc_users/c/S7FZK743w68). Note that any 
    effect columns (e.g. Z) will be inrelation to A1 now instead of A2.
-   **log_folder_ind** Should log files be stored containing all
    filtered out SNPs (separate file per filter). The data is outputted
    in the same format specified for the resulting sumstats file.
-   **log_mungesumstats_msgs** Binary Should a log be stored containing
    all messages and errors printed by MungeSumstats in a run.
-   **imputation_ind** Binary Should a column be added for each
    imputation step to show what SNPs have imputed values for differing
    fields. This includes a field denoting SNP allele flipping
    (flipped). On the flipped value, this denoted whether the alelles
    where switched based on MungeSumstats initial choice of A1, A2 from
    the input column headers and thus may not align with what the
    creator intended.**Note** these columns will be in the formatted
    summary statistics returned.
-   **log_folder** File path to the directory for the log files and the
    log of MungeSumstats messages to be stored. Default is a temporary
    directory.
-   **force_new** If a formatted file of the same names as
    \code{save_path} exists, formatting will be skipped and this file
    will be imported instead (default). Set \code{force_new=TRUE} to
    override this.
-   **mapping_file** MungeSumstats has a pre-defined column-name mapping
    file which should cover the most common column headers and their
    interpretations. However, if a column header that is in youf file is
    missing of the mapping we give is incorrect you can supply your own
    mapping file. Must be a 2 column dataframe with column names
    "Uncorrected" and "Corrected". See `data(sumstatsColHeaders)` for
    default mapping and necessary format.

See `?MungeSumstats::format_sumstats()` for the full list of parameters
to control MungeSumstats QC and standardisation steps.

VCF files can also be standardised to the same format as other summary
statistic files. A subset of the Amyotrophic lateral sclerosis GWAS from
the ieu open GWAS project (a .vcf file) has been added to
*MungeSumstats* to demonstrate this functionality.Simply pass the path
to the file in the same manner you would for other summary statistic
files:

```{r, message=TRUE}
#save ALS GWAS from the ieu open GWAS project to a temp directory
ALSvcfPth <- system.file("extdata","ALSvcf.vcf", package="MungeSumstats")
```

```{r,eval=FALSE}
reformatted_vcf <- 
  MungeSumstats::format_sumstats(path=ALSvcfPth, 
                                 ref_genome="GRCh37")
```

You can also get more information on the SNPs which have had data
imputed or have been filtered out by *MungeSumstats* by using the
`imputation_ind` and `log_folder_ind` parameters respectively. For
example:

```{r, eval=FALSE, message=FALSE}
#set
reformatted_vcf_2 <- 
  MungeSumstats::format_sumstats(path=ALSvcfPth,
                                 ref_genome="GRCh37",
                                 log_folder_ind=TRUE,
                                 imputation_ind=TRUE,
                                 log_mungesumstats_msgs=TRUE)
```

```{r,echo=FALSE,message=FALSE}
#don't run time intensive checks
reformatted_vcf_2 <- 
  MungeSumstats::format_sumstats(path=ALSvcfPth,
                                 ref_genome="GRCh37",
                                 log_folder_ind=TRUE,
                                 imputation_ind=TRUE,
                                 log_mungesumstats_msgs=TRUE,
                                 on_ref_genome = FALSE,
                                 strand_ambig_filter = FALSE,
                                 bi_allelic_filter = FALSE,
                                 allele_flip_check = FALSE)
```

Check the file `snp_bi_allelic.tsv.gz` in the `log_folder` directory you supply 
(by default a temp directory), for a list of SNPs removed as they are 
non-bi-allelic. The text files containing the console output and messages are 
also stored in the same directory.

Note you can also control the dbSNP version used as a reference dataset by 
MungeSumstats using the `dbSNP` parameter. By default this will be set to the 
most recent dbSNP version available (155).

Note that using `log_folder_ind` returns a list from `format_sumstats`
which includes the file locations of the differing classes of removed
SNPs. Using `log_mungesumstats_msgs` saves the messages to the console
to a file which is returned in the same list. Note that not all the
messages will also print to screen anymore when you set
`log_mungesumstats_msgs`:

```{r, message=TRUE}
names(reformatted_vcf_2)
```

A user can load a file to view the excluded SNPs.

In this case, SNPs were filtered based on non-bi-allelic criterion:

```{r, message=TRUE}
print(reformatted_vcf_2$log_files$snp_bi_allelic)
```

The different types of exclusion which lead to the names are explained
below:

-   **snp_multi_rs_one_row** - Where the SNP (RS ID) contained more than
    one RS ID.
-   **snp_missing_rs** - Where the SNP (RS ID) was missing the rs
    prefix. Note that these are only removed when other snps have an rs
    prefix.
-   **snp_multi_colon** - Where the SNP ID has mutliple colons (":") in
    one SNP.
-   **snp_not_found_from_bp_chr** - Where the RS ID was attempted to be
    imputed from the CHR and BP (Base-Pair) information, using the
    reference genome, but wasn't successful.
-   **chr_bp_not_found_from_snp** - Where the CHR and BP (Base-Pair) was
    attempted to be imputed from the SNP (RS ID), using the reference
    genome, but wasn't successful.
-   **alleles_not_found_from_snp** - Where the alleles (A1 and/or A2)
    was attempted to be imputed from the SNP (RS ID), using the
    reference genome, but wasn't successful.
-   **alleles_dont_match_ref_gen** - Where the alleles (A1 and/or A2)
    don't match what's on the reference genome.
-   **missing_data** - Where there is data missing across the inputted
    columns.
-   **dup_snp_id** - Where the SNP ID is duplicated in the input.
-   **dup_base_pair_position** - Where the base-pair position is
    duplicated in the input.
-   **info_filter** - SNP INFO value below the specified threshold.
-   **se_neg** - SNPs SE (Standard Error) value is 0 or negative.
-   **effect_col_zero** - SNPs effect column(s) value is zero e.g.
    BETA=0.
-   **n_large** - SNPs N is N standard deviations greater than the mean.
-   **n_null** - SNPs N is null.
-   **chr_excl** - SNP has an unrecognized chromosome name or is on a
    chromosome that was specified to be excluded.
-   **snp_strand_ambiguous** - SNP is strand ambiguous.
-   **snp_bi_allelic** - SNP is not bi-allelic.
-   **MungeSumstats_log_msg** - Text file of all messages to the console
    created during MungeSumstats run.
-   **MungeSumstats_log_output** - Text file of all errors to the
    console created during MungeSumstats run.

Note to export to another type such as R native objects including
data.table, GRanges, VRanges or save as a VCF file, set `return_data=TRUE` and
choose your `return_format`:

```{r, message=FALSE,eval=FALSE}
#set
reformatted_vcf_2 <- 
  MungeSumstats::format_sumstats(path=ALSvcfPth,
                                 ref_genome="GRCh37", 
                                 log_folder_ind=TRUE,
                                 imputation_ind=TRUE,
                                 log_mungesumstats_msgs=TRUE,
                                 return_data=TRUE,
                                 return_format="GRanges")
```


Also you can now output a VCF compatible with [IEU OpenGWAS](https://gwas.mrcieu.ac.uk/)
format (Note that currently all IEU OpenGWAS sumstats are GRCh37, MungeSumstats 
will throw a warning if your data isn't GRCh37 when saving):

```{r, message=FALSE,eval=FALSE}
#set
reformatted_vcf_2 <- 
  MungeSumstats::format_sumstats(path=ALSvcfPth,
                                 ref_genome="GRCh37", 
                                 write_vcf=TRUE,
                                 save_format ="openGWAS")
```

See our publication for further discussion of these checks and options:

[Murphy et al. MungeSumstats: A Bioconductor package for the
standardisation and quality control of many GWAS summary
statistics](https://academic.oup.com/bioinformatics/advance-article/doi/10.1093/bioinformatics/btab665/6380562).

# Extra Functionality

## Get genome builds

*MungeSumstats* also contains a function to quickly infer the genome
build of multiple summary statistic files. This can be called separately
to `format_sumstats()` which is useful if you want to just quickly check
the genome build:

```{r, message=FALSE,eval=FALSE}
# Pass path to Educational Attainment Okbay sumstat file to a temp directory
eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
                                  package = "MungeSumstats")
ALSvcfPth <- system.file("extdata","ALSvcf.vcf", package="MungeSumstats")
sumstats_list <- list(ss1 = eduAttainOkbayPth, ss2 = ALSvcfPth)

ref_genomes <- MungeSumstats::get_genome_builds(sumstats_list = sumstats_list)

```

## Liftover

*MungeSumstats* exposes the `liftover()` function as a general utility
for users.

Useful features include: - Automatic standardisation of genome build
names (i.e. "hg19", "hg37", and "GRCh37" will all be recognized as the
same genome build.) - Ability to specify `chrom_col` as well as both
`start_col` and `end_col` (for variants that span \>1bp). - Ability to
return in `data.table` or `GRanges` format. - Ability to specify which
chromosome format (e.g. "chr1" vs. 1) to return `GRanges` as.

```{r}
sumstats_dt <- MungeSumstats::formatted_example()
sumstats_dt_hg38 <- MungeSumstats::liftover(sumstats_dt = sumstats_dt, 
                                            ref_genome = "hg19",
                                            convert_ref_genome = "hg38")
knitr::kable(head(sumstats_dt_hg38))
```

## Quick formatting

In some cases, users may not want to run the full munging pipeline
provided by\
`MungeSumstats::format_sumstats`, but still would like to take advantage
of the file type conversion and column header standardisation features.
This will not be nearly as robust as the full pipeline, but can still be
helpful.

### From disk

To do this, simply run the following:

```{r}
eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
                                  package = "MungeSumstats")
formatted_path <- tempfile(fileext = "_eduAttainOkbay_standardised.tsv.gz")


#### 1. Read in the data and standardise header names ####
dat <- MungeSumstats::read_sumstats(path = eduAttainOkbayPth, 
                                    standardise_headers = TRUE)
knitr::kable(head(dat))
#### 2. Write to disk as a compressed, tab-delimited, tabix-indexed file ####
formatted_path <- MungeSumstats::write_sumstats(sumstats_dt = dat,
                                                save_path = formatted_path,
                                                tabix_index = TRUE,
                                                write_vcf = FALSE,
                                                return_path = TRUE)   
```

### From `data.table`

If you already have your data imported as an `data.table`, you can also
standardise its headers like so:

```{r}
#### Mess up some column names ####
dat_raw <- data.table::copy(dat)
data.table::setnames(dat_raw, c("SNP","CHR"), c("rsID","Seqnames"))
#### Add a non-standard column that I want to keep the casing for ####
dat_raw$Support <- runif(nrow(dat_raw))

dat2 <- MungeSumstats::standardise_header(sumstats_dt = dat_raw,
                                          uppercase_unmapped = FALSE, 
                                          return_list = FALSE )
knitr::kable(head(dat2))
```

# Future Enhancements

The *MungeSumstats* package aims to be able to handle the most common
summary statistic file formats including VCF. If your file can not be
formatted by *MungeSumstats* feel free to report the bug on github:
<https://github.com/neurogenomics/MungeSumstats> along with your summary
statistic file header.

We also encourage people to edit the code to resolve their particular
issues too and are happy to incorporate these through pull requests on
github. If your summary statistic file headers are not recognised by
*MungeSumstats* but correspond to one of:

    SNP, BP, CHR, A1, A2, P, Z, OR, BETA, LOG_ODDS,
    SIGNED_SUMSTAT, N, N_CAS, N_CON, NSTUDY, INFO or FRQ 

feel free to update the `MungeSumstats::sumstatsColHeaders` following
the approach in the data.R file and add your mapping. Then use a pull
request on github and we will incorporate this change into the package.

A note on `MungeSumstats::sumstatsColHeaders` for summary statistic
files with A0/A1. The mapping in `MungeSumstats::sumstatsColHeaders`
converts A0 to A\*, this is a special case so that the code knows to map
A0/A1 to A1/A2 (ref/alt). The special case is needed since ordinarily A1
refers to the reference not the alternative allele.

A note on `MungeSumstats::sumstatsColHeaders` for summary statistic
files with Effect Size (ES). By default, MSS takes BETA to be any BETA-like 
value (including ES). This is coded into the mapping file - 
`MungeSumstats::sumstatsColHeaders`. If this isn't the case for your sumstats, 
you can set the `es_is_beta` parameter in `MungeSumstats::format_sumstats()` to 
FALSE to avoid this. Note this is done to try and capture most use cases of MSS.

# Further functionality

See the [Open GWAS
vignette](https://neurogenomics.github.io/MungeSumstats/articles/OpenGWAS.html)
for how MungeSumstats can be used along with data from the MRC IEU Open
GWAS Project and also Mungesumstats' functionality to handle lists of
summary statistics files.

# Session Information

<details>

```{r, message=TRUE, echo=FALSE}
utils::sessionInfo()
```

</details>

# References

---
title: "Import GWAS summary statistics from Open GWAS"
author: "<h5><i>Authors</i>: Alan Murphy, Brian Schilder and Nathan Skene</h5>"
date: "<h5><i>Updated</i>: `r format(Sys.Date(), '%b-%d-%Y')`</h5>"
csl: nature.csl
output:
  BiocStyle::html_document:
vignette: >
    %\VignetteIndexEntry{OpenGWAS} 
    %\usepackage[utf8]{inputenc}
    %\VignetteEngine{knitr::rmarkdown}
---

```{r style, echo=FALSE}
knitr::opts_chunk$set(tidy = FALSE,
                      message = FALSE)
```

```{r}
library(MungeSumstats)
```

MungeSumstats now offers high throughput query and import functionality to data 
from the MRC IEU [Open GWAS Project](https://gwas.mrcieu.ac.uk/).

This is made possible by the use the 
[IEU OpwnGWAS R package](https://github.com/MRCIEU/ieugwasr): `ieugwasr`.

Before you can use this functionality however, please complete the following steps:

# Authenticate Access IEU OpenGWAS API

To authenticate, you need to generate a token from the OpenGWAS website. The 
token behaves like a password, and it will be used to authorise the requests 
you make to the OpenGWAS API. Here are the steps to generate the token and then 
have `ieugwasr` automatically use it for your queries:
  
1. Login to https://api.opengwas.io/profile/
2. Generate a new token
3. Add `OPENGWAS_JWT=<token>` to your .Renviron file, thi can be edited in R by 
running `usethis::edit_r_environ()`
4. Restart your R session
5. To check that your token is being recognised, run 
`ieugwasr::get_opengwas_jwt()`. If it returns a long random string then you are 
authenticated.
6. To check that your token is working, run `ieugwasr::user()`. It will make a 
request to the API for your user information using your token. It should return 
a list with your user information. If it returns an error, then your token is 
not working.
7. Make sure you have submitted user information to increasse you API limit at
https://api.opengwas.io/profile/.




# Find GWAS datasets 

We can search by terms and with other filters like sample size:

```{r,eval=FALSE}
#### Search for datasets ####
metagwas <- MungeSumstats::find_sumstats(traits = c("parkinson","alzheimer"), 
                                         min_sample_size = 1000)
head(metagwas,3)
ids <- (dplyr::arrange(metagwas, nsnp))$id  
```

```{r,echo=FALSE}
#### Search for datasets ####
#error_dwnld <-
#            tryCatch(
#              metagwas <- MungeSumstats::find_sumstats(traits = c("parkinson",
#                                                                  "alzheimer"), 
#                                         min_sample_size = 1000),
#            error = function(e) e,
#            warning = function(w) w
#            )
#if(exists("metagwas")&&is.data.frame(metagwas)){#if exists downloaded fine
#  head(metagwas,3)
#  ids <- (dplyr::arrange(metagwas, nsnp))$id  
#}

#to speed up build just create results
metagwas2 <- 
    data.frame(
        id=c("ieu-a-298","ieu-b-2","ieu-a-297"),
        trait = rep("Alzheimer's disease",3),
        group_name = rep("public",3),
        year=c(2013, 2019, 2013),
        author=c("Lambert","Kunkle BW","Lambert"),
        consortium=c("IGAP",
                     "Alzheimer Disease Genetics Consortium (ADGC), European Alzheimer's Disease Initiative (EADI), Cohorts for Heart and Aging Research in Genomic Epidemiology Consortium (CHARGE), Genetic and Environmental Risk in AD/Defining Genetic, Polygenic and Environmental Risk for Alzheimer's Disease Consortium (GERAD/PERADES),",
                     "IGAP" ),
        sex=rep("Males and Females",3),
        population=rep("European",3),
        unit=c("log odds","NA","log odds"),
        nsnp=c(11633,10528610,7055882),
        sample_size=c(74046,63926,54162),
        build=rep("HG19/GRCh37",3),
        category=c("Disease","Binary","Disease"),
        subcategory=rep("Psychiatric / neurological",3),
        ontology=rep("NA",3),
        mr=rep(1,3),
        priority=c(1,0,2),
        pmid=c(24162737,30820047,24162737),
        sd=rep(NA,3),
        note=c("Exposure only; Effect allele frequencies are missing; forward(+) strand",
               "NA","Effect allele frequencies are missing; forward(+) strand"),
        ncase=c(25580,21982,17008),
        ncontrol=c(48466,41944,37154),
        N=c(74046,63926,54162)
    )
print(head(metagwas2,3))
```


You can also search by ID:

```{r,eval=FALSE}
### By ID and sample size
metagwas <- find_sumstats(
  ids = c("ieu-b-4760", "prot-a-1725", "prot-a-664"),
  min_sample_size = 5000
)
```

# Import full results

You can supply `import_sumstats()` with a list of as many OpenGWAS IDs as you 
want, but we'll just give one to save time. 

```{r,eval=FALSE}
datasets <- MungeSumstats::import_sumstats(ids = "ieu-a-298",
                                           ref_genome = "GRCH37")
```

```{r,echo=FALSE}
#don't actually run as this takes some time, use stashed version
datasets <- list("ieu-a-298"=paste0(tempdir(),"/ieu-a-298.tsv.gz"))
#stashed value
datasets_data <- list("ieu-a-298"=system.file("extdata","ieu-a-298.tsv.gz",
                                                package="MungeSumstats"))

```

## Summarise results 

By default, `import_sumstats` results a named list where the names are the Open 
GWAS dataset IDs and the items are the respective paths to the formatted summary
statistics.

```{r}
print(datasets)
```

You can easily turn this into a data.frame as well. 

```{r}
results_df <- data.frame(id=names(datasets), 
                         path=unlist(datasets))
print(results_df)
```




# Import full results (parallel)

*Optional*: Speed up with multi-threaded download via [axel](https://github.com/axel-download-accelerator/axel).  

```{r, eval=FALSE}
datasets <- MungeSumstats::import_sumstats(ids = ids, 
                                           vcf_download = TRUE, 
                                           download_method = "axel", 
                                           nThread = max(2,future::availableCores()-2))
```

# Further functionality

See the [Getting started vignette](https://neurogenomics.github.io/MungeSumstats/articles/MungeSumstats.html)
for more information on how to use MungeSumstats and its functionality.


# Session Info

<details>

```{r}
utils::sessionInfo()
```

</details>

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_vcf.R
\name{read_vcf}
\alias{read_vcf}
\title{Read in VCF file}
\source{
\code{
#### Benchmarking ####
library(VCFWrenchR)
library(VariantAnnotation)
path <- "https://gwas.mrcieu.ac.uk/files/ubm-a-2929/ubm-a-2929.vcf.gz"
vcf <- VariantAnnotation::readVcf(file = path)
N <- 1e5
vcf_sub <- vcf[1:N,]
res <- microbenchmark::microbenchmark(
    "vcf2df"={dat1 <- MungeSumstats:::vcf2df(vcf = vcf_sub)},
    "VCFWrenchR"= {dat2 <- as.data.frame(x = vcf_sub)},
    "VRanges"={dat3 <- data.table::as.data.table(
        methods::as(vcf_sub, "VRanges"))},
    times=1
)
}

\href{https://github.com/Bioconductor/VariantAnnotation/issues/57}{
Discussion on VariantAnnotation GitHub}

\href{https://github.com/Bioconductor/VariantAnnotation/issues/59}{
Discussion on VariantAnnotation GitHub}
}
\usage{
read_vcf(
  path,
  as_datatable = TRUE,
  save_path = NULL,
  tabix_index = FALSE,
  samples = 1,
  which = NULL,
  use_params = TRUE,
  sampled_rows = 10000L,
  download = TRUE,
  vcf_dir = tempdir(),
  download_method = "download.file",
  force_new = FALSE,
  mt_thresh = 100000L,
  nThread = 1,
  verbose = TRUE
)
}
\arguments{
\item{path}{Path to local or remote VCF file.}

\item{as_datatable}{Return the data as a
\link[data.table]{data.table} (default: \code{TRUE})
or a \link[VariantAnnotation]{VCF} (\code{FALSE}).}

\item{save_path}{File path to save formatted data. Defaults to
\code{tempfile(fileext=".tsv.gz")}.}

\item{tabix_index}{Index the formatted summary statistics with
\href{http://www.htslib.org/doc/tabix.html}{tabix} for fast querying.}

\item{samples}{Which samples to use:
\itemize{
\item{1 : }{Only the first sample will be used (\emph{DEFAULT}).}
\item{NULL : }{All samples will be used.}
\item{c("<sample_id1>","<sample_id2>",...) : }{
Only user-selected samples will be used (case-insensitive).}
}}

\item{which}{Genomic ranges to be added if supplied. Default is NULL.}

\item{use_params}{When \code{TRUE} (default), increases the speed of reading in the VCF by
omitting columns that are empty based on the head of the VCF (NAs only).
NOTE that that this requires the VCF to be sorted, bgzip-compressed,
tabix-indexed, which \link[MungeSumstats]{read_vcf} will attempt to do.}

\item{sampled_rows}{First N rows to sample.
Set \code{NULL} to use full \code{sumstats_file}.
when determining whether cols are empty.}

\item{download}{Download the VCF (and its index file)
to a temp folder before reading it into R.
This is important to keep \code{TRUE} when \code{nThread>1} to avoid
making too many queries to remote file.}

\item{vcf_dir}{Where to download the original VCF from Open GWAS.
\emph{WARNING:} This is set to \code{tempdir()} by default.
This means the raw (pre-formatted) VCFs be deleted upon ending the R session.
Change this to keep the raw VCF file on disk
(e.g. \code{vcf_dir="./raw_vcf"}).}

\item{download_method}{\code{"axel"} (multi-threaded) or
\code{"download.file"} (single-threaded) .}

\item{force_new}{If a formatted file of the same names as \code{save_path}
exists, formatting will be skipped and this file will be imported instead
(default). Set \code{force_new=TRUE} to override this.}

\item{mt_thresh}{When the number of rows (variants) in the VCF is
\code{< mt_thresh}, only use single-threading for reading in the VCF.
This is because the overhead of parallelisation outweighs the speed benefits
when VCFs are small.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{verbose}{Print messages.}
}
\value{
The VCF file in data.table format.
}
\description{
Read in a VCF file as a \link[VariantAnnotation]{VCF} or a
\link[data.table]{data.table}.
Can optionally save the VCF/data.table as well.
}
\examples{
#### Local file ####
path <- system.file("extdata","ALSvcf.vcf", package="MungeSumstats")
sumstats_dt <- read_vcf(path = path)

#### Remote file ####
## Small GWAS (0.2Mb)
# path <- "https://gwas.mrcieu.ac.uk/files/ieu-a-298/ieu-a-298.vcf.gz"
# sumstats_dt2 <- read_vcf(path = path)

## Large GWAS (250Mb)
# path <- "https://gwas.mrcieu.ac.uk/files/ubm-a-2929/ubm-a-2929.vcf.gz"
# sumstats_dt3 <- read_vcf(path = path, nThread=11)

### Very large GWAS (500Mb)
# path <- "https://gwas.mrcieu.ac.uk/files/ieu-a-1124/ieu-a-1124.vcf.gz"
# sumstats_dt4 <- read_vcf(path = path, nThread=11)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/granges_to_dt.R
\name{granges_to_dt}
\alias{granges_to_dt}
\title{GenomicRanges to data.table}
\source{
\href{https://rdrr.io/github/databio/GenomicDistributions/src/R/utility.R}{
Code adapted from GenomicDistributions.}
}
\usage{
granges_to_dt(gr)
}
\arguments{
\item{gr}{A \link[GenomicRanges]{GRanges} object.}
}
\value{
A data.table object.
}
\description{
Convert a \link[GenomicRanges]{GRanges} into a \link[data.table]{data.table}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vcf2df.R
\name{vcf2df}
\alias{vcf2df}
\title{VCF to DF}
\source{
\href{https://gist.github.com/zhujack/849b75f5a8305edaeca1001dfb9c3fe9}{
Original code source}

{
\subsection{vcfR}{

if(!require("pinfsc50")) install.packages("pinfsc50")
vcf_file <- system.file("extdata", "pinf_sc50.vcf.gz", package = "pinfsc50")
vcf <- read.vcfR( vcf_file, verbose = FALSE )
vcf_df_list <- vcfR::vcfR2tidy(vcf, single_frame=TRUE)
vcf_df <- data.table::data.table(vcf_df_list$dat)
}
}
}
\usage{
vcf2df(
  vcf,
  add_sample_names = TRUE,
  add_rowranges = TRUE,
  drop_empty_cols = TRUE,
  unique_cols = TRUE,
  unique_rows = TRUE,
  unlist_cols = TRUE,
  sampled_rows = NULL,
  verbose = TRUE
)
}
\arguments{
\item{vcf}{Variant Call Format (VCF) file imported into R
as a \pkg{VariantAnnotation}
\link[VariantAnnotation]{CollapsedVCF}/
\link[VariantAnnotation]{ExpandedVCF} object.}

\item{add_sample_names}{Append sample names to column names
(e.g. "EZ" --> "EZ_ubm-a-2929").}

\item{add_rowranges}{Include \code{rowRanges} from VCF as well.}

\item{drop_empty_cols}{Drop columns that are filled entirely with:
\code{NA}, \code{"."}, or \code{""}.}

\item{unique_cols}{Only keep uniquely named columns.}

\item{unique_rows}{Only keep unique rows.}

\item{unlist_cols}{If any columns are lists instead of vectors, unlist them.
Required to be \code{TRUE} when \code{unique_rows=TRUE}.}

\item{sampled_rows}{First N rows to sample.
Set \code{NULL} to use full \code{sumstats_file}.
when determining whether cols are empty.}

\item{verbose}{Print messages.}
}
\value{
data.frame version of VCF
}
\description{
Function to convert a \pkg{VariantAnnotation}
\code{CollapsedVCF}/\code{ExpandedVCF}
object to a \code{data.frame}.
}
\examples{
  
#### VariantAnnotation ####
# path <- "https://github.com/brentp/vcfanno/raw/master/example/exac.vcf.gz"
path <- system.file("extdata", "ALSvcf.vcf",
                    package = "MungeSumstats")
                    
vcf <- VariantAnnotation::readVcf(file = path)
vcf_df <- MungeSumstats:::vcf2df(vcf = vcf)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_zscore.R
\name{check_zscore}
\alias{check_zscore}
\title{Check for Z-score column}
\usage{
check_zscore(
  sumstats_dt,
  imputation_ind,
  compute_z = "BETA",
  force_new_z = FALSE,
  standardise_headers = FALSE,
  mapping_file
)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics file for the
GWAS.}

\item{imputation_ind}{Binary Should a column be added for each imputation
step to show what SNPs have imputed values for differing fields. This
includes a field denoting SNP allele flipping (flipped). \strong{Note}
these columns will be in the formatted summary statistics returned. Default
is FALSE.}

\item{compute_z}{Whether to compute Z-score column. Default is FALSE. This
can be computed from Beta and SE with (Beta/SE) or P
(Z:=sign(BETA)*sqrt(stats::qchisq(P,1,lower=FALSE))).
\strong{Note} that imputing the Z-score from P for every SNP will not be
perfectly correct and may result in a loss of power. This should only be done
as a last resort. Use 'BETA' to impute by BETA/SE and 'P' to impute by SNP
p-value.}

\item{force_new_z}{When a "Z" column already exists, it will be used by
default. To override and compute a new Z-score column from P set
\code{force_new_z=TRUE}.}

\item{standardise_headers}{Run
\code{standardise_sumstats_column_headers_crossplatform} first.}

\item{mapping_file}{MungeSumstats has a pre-defined column-name mapping file
which should cover the most common column headers and their interpretations.
However, if a column header that is in your file is missing of the mapping we
give is incorrect you can supply your own mapping file. Must be a 2 column
dataframe with column names "Uncorrected" and "Corrected". See
data(sumstatsColHeaders) for default mapping and necessary format.}
}
\value{
\code{list("sumstats_dt"=sumstats_dt)}
}
\description{
The following ensures that a Z-score column is present.
The Z-score formula we used here is a R implementation of the formula
used in \href{https://github.com/bulik/ldsc/blob/aa33296abac9569a6422ee6ba7eb4b902422cc74/munge_sumstats.py#L363}{LDSC's munge_sumstats.py}:
}
\details{
\code{np.sqrt(chi2.isf(P, 1))}

The R implementation is adapted from the \code{GenomicSEM::munge} function,
after optimizing for speed using \code{data.table}:

\code{sumstats_dt[,Z:=sign(BETA)*sqrt(stats::qchisq(P,1,lower=FALSE))]}

\emph{NOTE}: \code{compute_z} is set to \code{TRUE} by
default to ensure standardisation
of the "Z" column (which can be computed differently in different datasets).
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compute_nsize.R
\name{compute_nsize}
\alias{compute_nsize}
\title{Check for N column if not present and user wants, impute N based on user's
sample size. \strong{NOTE} this will be the same value for each SNP which is not
necessarily correct and may cause issues down the line. N can also be
inputted with "ldsc", "sum", "giant" or "metal" by passing one or
multiple of these.}
\usage{
compute_nsize(
  sumstats_dt,
  imputation_ind = FALSE,
  compute_n = c("ldsc", "giant", "metal", "sum"),
  standardise_headers = FALSE,
  force_new = FALSE,
  return_list = TRUE
)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics file for the
GWAS.}

\item{imputation_ind}{Binary Should a column be added for each imputation
step to show what SNPs have imputed values for differing fields. This
includes a field denoting SNP allele flipping (flipped). \strong{Note}
these columns will be in the formatted summary statistics returned. Default
is FALSE.}

\item{compute_n}{How to compute per-SNP sample size (new column "N").
\itemize{
\item{\code{0}: }{N will not be computed.}
\item{\code{>0}: }{If any number >0 is provided,
that value will be set as N for every row.
\strong{Note}: Computing N this way is incorrect and should be avoided
if at all possible.}
\item{\code{"sum"}: }{N will be computed as:
cases (N_CAS) + controls (N_CON), so long as both columns are present}.
\item{\code{"ldsc"}: }{N will be computed as effective sample size:
Neff =(N_CAS+N_CON)*(N_CAS/(N_CAS+N_CON)) / mean((N_CAS/(N_CAS+N_CON))(N_CAS+N_CON)==max(N_CAS+N_CON))}.
\item{\code{"giant"}: }{N will be computed as effective sample size:
Neff = 2 / (1/N_CAS + 1/N_CON)}.
\item{\code{"metal"}: }{N will be computed as effective sample size:
Neff = 4 / (1/N_CAS + 1/N_CON)}.
}}

\item{standardise_headers}{Standardise headers first.}

\item{force_new}{If "Neff" (or "N") already exists in \code{sumstats_dt},
replace it with the recomputed version.}

\item{return_list}{Return the \code{sumstats_dt} within a named list
(default: \code{TRUE}).}
}
\value{
\code{list("sumstats_dt"=sumstats_dt)}
}
\description{
Check for N column if not present and user wants, impute N based on user's
sample size. \strong{NOTE} this will be the same value for each SNP which is not
necessarily correct and may cause issues down the line. N can also be
inputted with "ldsc", "sum", "giant" or "metal" by passing one or
multiple of these.
}
\examples{
sumstats_dt <- MungeSumstats::formatted_example()
sumstats_dt2 <- MungeSumstats::compute_nsize(sumstats_dt=sumstats_dt,
                                             compute_n=10000)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{ieu-a-298}
\alias{ieu-a-298}
\title{Local ieu-a-298 file from IEU Open GWAS}
\format{
gunzipped tsv file
}
\source{
The file was downloaded with:
\code{
MungeSumstats::import_sumstats(ids = "ieu-a-298",ref_genome = "GRCH37")
}
}
\description{
Local ieu-a-298 file from IEU Open GWAS, downloaded on 09/10/21.
}
\details{
Local ieu-a-298 file from IEU Open GWAS, downlaoded on 09/10/21.
This is done in case the download in the package vignette fails.
}
\section{ieu-a-298.tsv.gz}{
NA
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compute_sample_size.R
\name{compute_sample_size}
\alias{compute_sample_size}
\title{Compute (effective) sample size}
\usage{
compute_sample_size(
  sumstats_dt,
  method = c("ldsc", "giant", "metal", "sum"),
  force_new = FALSE,
  append_method_name = FALSE
)
}
\arguments{
\item{sumstats_dt}{Summary statistics data.table.}

\item{method}{Method for computing (effective) sample size.

\itemize{

\item{"ldsc" : \cr}{
\eqn{Neff = (N_CAS+N_CON) * (N_CAS/(N_CAS+N_CON)) /
 mean((N_CAS/(N_CAS+N_CON))[(N_CAS+N_CON)==max(N_CAS+N_CON)]))}\cr
\href{https://github.com/bulik/ldsc/issues/95}{
bulik/ldsc GitHub Issue}
\href{https://github.com/bulik/ldsc/blob/aa33296abac9569a6422ee6ba7eb4b902422cc74/munge_sumstats.py#L321}{
bulik/ldsc GitHub code}
}

\item{"giant" : \cr}{
\eqn{Neff = 2 / (1/N_CAS + 1/N_CON)}\cr
\href{https://www.nature.com/articles/nprot.2014.071}{
Winkler et al. 2014, Nature}
}

\item{"metal" : \cr}{
\eqn{Neff = 4 / (1/N_CAS + 1/N_CON)}\cr
\href{https://pubmed.ncbi.nlm.nih.gov/20616382/}{
Willer et al. 2010, Bioinformatics}
}

\item{"sum" : \cr}{
\eqn{N = N_CAS + N_CON}\cr
Simple summation of cases and controls
that does not account for class imbalance.
}

\item{"\\<integer\\>" : \cr}{
\code{N = \\<integer\\>}\cr
If method is a positive integer, it will be used as N
for every row.
}

}}

\item{force_new}{If "Neff" (or "N") already exists in \code{sumstats_dt},
replace it with the recomputed version.}

\item{append_method_name}{should Neff column have an indicator to explain the
method that makes it., Default is FALSE unless multiple methods are passed}
}
\value{
A data.table with a new column "Neff" or "N"
}
\description{
Computes sample sum (as new column "N") or
effective sample size (ESS) (as new column "Neff").
Computing ESS is important as it takes into account
the proportion of cases to controls (i.e. class imbalance) so as not to
overestimate your statistical power.
}
\details{
There are many different formulas for calculating ESS,
but LDSC is probably the best method available here, as it
doesn't assume that the proportion of controls:cases
is 2:1 (as in GIANT) or 4:1 (as in METAL).
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parse_genome_build.R
\name{parse_genome_build}
\alias{parse_genome_build}
\title{Genome build inferred from the summary statistics}
\usage{
parse_genome_build(l)
}
\arguments{
\item{l}{Lines of text from log file.}
}
\value{
Character
}
\description{
Support function for \link[MungeSumstats]{parse_logs}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/load_ref_genome_data.R
\name{load_ref_genome_data}
\alias{load_ref_genome_data}
\title{Load the reference genome data for SNPs of interest}
\source{
\code{
sumstats_dt <- formatted_example()
rsids <- MungeSumstats:::load_ref_genome_data(snps = sumstats_dt$SNP,
                                              ref_genome = "GRCH37",
                                              dbSNP=144)
}
}
\usage{
load_ref_genome_data(
  snps,
  ref_genome,
  dbSNP = c(144, 155),
  dbSNP_tarball = NULL,
  msg = NULL,
  chr_filt = NULL
)
}
\arguments{
\item{snps}{Character vector SNPs by rs_id from sumstats file of interest.}

\item{ref_genome}{Name of the reference genome used for the GWAS
(GRCh37 or GRCh38)}

\item{dbSNP}{version of dbSNP to be used (144 or 155)}

\item{dbSNP_tarball}{Pass local versions of dbSNP in tarball format. Default
of NULL uses the dbSNP version passed in \code{dbSNP} parmeter. \code{dbSNP_tarball}
was enabled to help with dbSNP versions >=156, after the decision to no
longer provide dbSNP releases as bioconductor packages. dbSNP 156 tarball is
available here: http://149.165.171.124/SNPlocs/.}

\item{msg}{Optional name of the column missing from the dataset in question.
Default is NULL}

\item{chr_filt}{Internal for testing - filter reference genomes and sumstats
to specific chromosomes for testing. Pass a list of chroms in format:
c("1","2"). Default is NULL i.e. no filtering.}
}
\value{
data table of snpsById, filtered to SNPs of interest.
}
\description{
Load the reference genome data for SNPs of interest
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_save_path.R
\name{check_save_path}
\alias{check_save_path}
\title{Check if save path and log folder is appropriate}
\usage{
check_save_path(
  save_path,
  log_folder,
  log_folder_ind,
  tabix_index,
  write_vcf = FALSE,
  verbose = TRUE
)
}
\arguments{
\item{save_path}{File path to save formatted data. Defaults to
\code{tempfile(fileext=".tsv.gz")}.}

\item{log_folder}{Filepath to the directory for the log files and the log of
MungeSumstats messages to be stored. Default is a temporary directory. Note
the name of the log files (log messages and log outputs) are now the same as
the name of the file specified in the save path parameter with the extension
'_log_msg.txt' and '_log_output.txt' respectively.}

\item{log_folder_ind}{Binary Should log files be stored containing all
filtered out SNPs (separate file per filter). The data is outputted in the
same format specified for the resulting sumstats file. The only exception to
this rule is if output is vcf, then log file saved as .tsv.gz. Default is
FALSE.}

\item{tabix_index}{Index the formatted summary statistics with
\href{http://www.htslib.org/doc/tabix.html}{tabix} for fast querying.}

\item{write_vcf}{Whether to write as VCF (TRUE) or tabular file (FALSE).}

\item{verbose}{Print messages.}
}
\value{
Corrected \code{save_path}, the file type, the separator, corrected
\code{log_folder},the log file extension.
}
\description{
Check if save path and log folder is appropriate
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{hg38ToHg19}
\alias{hg38ToHg19}
\title{UCSC Chain file hg38 to hg19}
\format{
gunzipped chain file
}
\source{
The chain file was downloaded from
https://hgdownload.cse.ucsc.edu/goldenpath/hg38/liftOver/
\code{
utils::download.file('ftp://hgdownload.cse.ucsc.edu/goldenPath/hg38/liftOver/hg38ToHg19.over.chain.gz',tempdir())
}
}
\description{
UCSC Chain file hg38 to hg19, .chain.gz file, downloaded from
https://hgdownload.cse.ucsc.edu/goldenpath/hg19/liftOver/ on 09/10/21
}
\details{
UCSC Chain file hg38 to hg19, .chain.gz file, downloaded on 09/10/21
To be used as a back up if the download from UCSC fails.
}
\section{hg38ToHg19.over.chain.gz}{
NA
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_vital_col.R
\name{check_vital_col}
\alias{check_vital_col}
\title{Ensure that all necessary columns are in the summary statistics file}
\usage{
check_vital_col(sumstats_dt)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics file for the GWAS}
}
\value{
null
}
\description{
Ensure that all necessary columns are in the summary statistics file
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/axel.R
\name{axel}
\alias{axel}
\title{axel downloader}
\usage{
axel(
  input_url,
  output_path,
  background = FALSE,
  nThread = 1,
  force_overwrite = FALSE,
  quiet = TRUE,
  alternate = TRUE,
  check_certificates = FALSE
)
}
\arguments{
\item{input_url}{input_url.}

\item{output_path}{output_path.}

\item{background}{Run in background}

\item{nThread}{Number of threads to parallelize over.}

\item{force_overwrite}{Overwrite existing file.}

\item{quiet}{Run quietly.}

\item{alternate}{alternate,}

\item{check_certificates}{check_certificates}
}
\value{
Path where the file has been downloaded
}
\description{
R wrapper for axel, which enables multi-threaded download
of a single large file.
}
\seealso{
\url{https://github.com/axel-download-accelerator/axel/}

Other downloaders: 
\code{\link{downloader}()}
}
\concept{downloaders}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_drop_indels.R
\name{check_drop_indels}
\alias{check_drop_indels}
\title{Drop Indels from summary statistics}
\source{
\code{
sumstats_dt <- MungeSumstats:::formatted_example()
sumstats <- check_drop_indels(sumstats_dt = sumstats_dt, 
                              drop_indels = TRUE)
}
}
\usage{
check_drop_indels(
  sumstats_dt,
  drop_indels,
  path,
  log_folder_ind,
  check_save_out,
  tabix_index,
  nThread,
  log_files
)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics file for the GWAS}

\item{drop_indels}{Binary, should any indels found in the sumstats be
dropped? These can not be checked against a reference dataset and will have
the same RS ID and position as SNPs which can affect downstream analysis.
Default is False.}

\item{path}{Filepath for the summary statistics file to be formatted. A
dataframe or datatable of the summary statistics file can also be passed
directly to MungeSumstats using the path parameter.}

\item{log_folder_ind}{Binary Should log files be stored containing all
filtered out SNPs (separate file per filter). The data is outputted in the
same format specified for the resulting sumstats file. The only exception to
this rule is if output is vcf, then log file saved as .tsv.gz. Default is
FALSE.}

\item{tabix_index}{Index the formatted summary statistics with
\href{http://www.htslib.org/doc/tabix.html}{tabix} for fast querying.}

\item{nThread}{Number of threads to use for parallel processes.}
}
\value{
list containing sumstats_dt,
the modified summary statistics data table object
}
\description{
Drop Indels from summary statistics
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{raw_ALSvcf}
\alias{raw_ALSvcf}
\title{GWAS Amyotrophic lateral sclerosis ieu open GWAS project - Subset}
\format{
vcf document with 528 items relating to 99 SNPs
}
\source{
The summary statistics VCF (VCFv4.2) file was downloaded from
https://gwas.mrcieu.ac.uk/datasets/ebi-a-GCST005647/
and formatted to a .rda with the following:
\code{
#Get example VCF dataset, use GWAS Amyotrophic lateral sclerosis
ALS_GWAS_VCF <- readLines("ebi-a-GCST005647.vcf.gz")
#Subset to just the first 99 SNPs
ALSvcf <- ALS_GWAS_VCF[1:528]
writeLines(ALSvcf,"inst/extdata/ALSvcf.vcf")
}
}
\description{
VCF (VCFv4.2) of the GWAS Amyotrophic lateral sclerosis ieu
open GWAS project Dataset: ebi-a-GCST005647.
A subset of 99 SNPs
}
\details{
A VCF file (VCFv4.2) of the GWAS Amyotrophic lateral sclerosis ieu
open GWAS project has been subsetted here to act as an example summary
statistic file in VCF format which has some issues in the formatting.
MungeSumstats can correct these issues and produced a standardised summary
statistics format.
}
\section{ALSvcf.vcf}{
NA
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/select_vcf_fields.R
\name{select_vcf_fields}
\alias{select_vcf_fields}
\title{Select VCF fields}
\usage{
select_vcf_fields(
  path,
  sampled_rows = 10000L,
  which = NULL,
  samples = NULL,
  nThread = 1,
  verbose = TRUE
)
}
\arguments{
\item{path}{Path to local or remote VCF file.}

\item{sampled_rows}{First N rows to sample.
Set \code{NULL} to use full \code{sumstats_file}.
when determining whether cols are empty.}

\item{which}{Genomic ranges to be added if supplied. Default is NULL.}

\item{samples}{Which samples to use:
\itemize{
\item{1 : }{Only the first sample will be used (\emph{DEFAULT}).}
\item{NULL : }{All samples will be used.}
\item{c("<sample_id1>","<sample_id2>",...) : }{
Only user-selected samples will be used (case-insensitive).}
}}

\item{nThread}{Number of threads to use for parallel processes.}

\item{verbose}{Print messages.}
}
\value{
\code{ScanVcfParam} object.
}
\description{
Select non-empty columns from each VCF field type.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in
%   R/standardise_sumstats_column_headers_crossplatform.R
\name{standardise_header}
\alias{standardise_header}
\title{Standardise the column headers in the Summary Statistics files}
\usage{
standardise_header(
  sumstats_dt,
  mapping_file = sumstatsColHeaders,
  uppercase_unmapped = TRUE,
  convert_A0 = TRUE,
  return_list = TRUE
)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics file for the
GWAS.}

\item{mapping_file}{MungeSumstats has a pre-defined column-name mapping file
which should cover the most common column headers and their interpretations.
However, if a column header that is in youf file is missing of the mapping we
give is incorrect you can supply your own mapping file. Must be a 2 column
dataframe with column names "Uncorrected" and "Corrected". See
data(sumstatsColHeaders) for default mapping and necessary format.}

\item{uppercase_unmapped}{For columns that could not be identified in
the \code{mapping_file}, return them in the same format they were input as
(without forcing them to uppercase).}

\item{convert_A0}{Whether to convert A* (representing A0) to A1/A2. This
should be done unless checking if A0 was present in the input as if you do
it you can't infer this. Default is TRUE}

\item{return_list}{Return the \code{sumstats_dt} within a named list
(default: \code{TRUE}).}
}
\value{
list containing sumstats_dt, the modified summary statistics data
table object
}
\description{
Use a reference data table of common column header names (stored in
\code{sumstatsColHeaders} or user inputted mapping file) to convert them to a
standard set, i.e. chromosome -> CHR. This function does not check that all
the required column headers are present. The amended header is written
directly back into the file
}
\examples{
sumstats_dt <- data.table::fread(system.file("extdata", "eduAttainOkbay.txt",
                                             package = "MungeSumstats"))
sumstats_dt2 <- standardise_header(sumstats_dt=sumstats_dt)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sort_coords_datatable.R
\name{sort_coords_datatable}
\alias{sort_coords_datatable}
\title{Sort sum stats: data.table}
\usage{
sort_coords_datatable(
  sumstats_dt,
  chr_col = "CHR",
  start_col = "BP",
  end_col = start_col
)
}
\arguments{
\item{sumstats_dt}{\link[data.table]{data.table} obj of the
summary statistics file for the GWAS.}

\item{chr_col}{Chromosome column name.}

\item{start_col}{Genomic end position column name.}
}
\value{
Sorted sumstats_dt
}
\description{
Sort summary statistics table by genomic coordinates using a fast
\code{data.table}-native strategy
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_multi_rs_snp.R
\name{check_multi_rs_snp}
\alias{check_multi_rs_snp}
\title{Ensure that SNP ids don't have multiple rs ids on one line}
\usage{
check_multi_rs_snp(
  sumstats_dt,
  path,
  remove_multi_rs_snp,
  imputation_ind,
  log_folder_ind,
  check_save_out,
  tabix_index,
  nThread,
  log_files
)
}
\arguments{
\item{path}{Filepath for the summary statistics file to be formatted. A
dataframe or datatable of the summary statistics file can also be passed
directly to MungeSumstats using the path parameter.}

\item{remove_multi_rs_snp}{Binary Sometimes summary statistics can have
multiple RSIDs on one row (i.e. related to one SNP), for example
"rs5772025_rs397784053". This can cause an error so by default, the first
RS ID will be kept and the rest removed e.g."rs5772025". If you want to just
remove these SNPs entirely, set it to TRUE. Default is FALSE.}

\item{imputation_ind}{Binary Should a column be added for each imputation
step to show what SNPs have imputed values for differing fields. This
includes a field denoting SNP allele flipping (flipped). On the flipped
value, this denoted whether the alelles where switched based on
MungeSumstats initial choice of A1, A2 from the input column headers and thus
may not align with what the creator intended.\strong{Note} these columns will be
in the formatted summary statistics returned. Default is FALSE.}

\item{log_folder_ind}{Binary Should log files be stored containing all
filtered out SNPs (separate file per filter). The data is outputted in the
same format specified for the resulting sumstats file. The only exception to
this rule is if output is vcf, then log file saved as .tsv.gz. Default is
FALSE.}

\item{tabix_index}{Index the formatted summary statistics with
\href{http://www.htslib.org/doc/tabix.html}{tabix} for fast querying.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{log_files}{list of log file locations}
}
\value{
list containing sumstats_dt, the modified summary statistics data
table object and the log file list.
}
\description{
Ensure that SNP ids don't have multiple rs ids on one line
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DF_to_dt.R
\name{DF_to_dt}
\alias{DF_to_dt}
\title{DataFrame to data.table}
\source{
\href{https://support.bioconductor.org/p/66874/}{
Solution from Bioc forum}
}
\usage{
DF_to_dt(DF)
}
\arguments{
\item{DF}{\link[S4Vectors]{DataFrame} object.}
}
\value{
VCF data in data.table format.
}
\description{
Efficiently convert \link[S4Vectors]{DataFrame} to
\link[data.table]{data.table}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_vcf_sample_ids.R
\name{get_vcf_sample_ids}
\alias{get_vcf_sample_ids}
\title{Get VCF sample ID(s)}
\usage{
get_vcf_sample_ids(path)
}
\arguments{
\item{path}{Filepath for the summary statistics file to be formatted. A
dataframe or datatable of the summary statistics file can also be passed
directly to MungeSumstats using the path parameter.}
}
\value{
sample_id
}
\description{
Get VCF sample ID(s)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_vcf.R
\name{check_vcf}
\alias{check_vcf}
\title{Check if the inputted file is in VCF format}
\usage{
check_vcf(header)
}
\arguments{
\item{header}{Header of the GWAS summary statistics file.}
}
\value{
Whether the file is vcf or not
}
\description{
Check if the inputted file is in VCF format
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_empty_cols.R
\name{check_empty_cols}
\alias{check_empty_cols}
\title{Check for empty columns}
\usage{
check_empty_cols(sumstats_dt, sampled_rows = NULL, verbose = TRUE)
}
\arguments{
\item{sampled_rows}{First N rows to sample.
Set \code{NULL} to use full \code{sumstats_file}.
when determining whether cols are empty.}

\item{verbose}{Print messages.}
}
\value{
empty_cols
}
\description{
Empty columns contain only ".", NA, or 0
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_log_pval.R
\name{read_log_pval}
\alias{read_log_pval}
\title{Read -log10 p-value column}
\usage{
read_log_pval(
  sumstats_dt,
  mapping_file = sumstatsColHeaders,
  return_list = TRUE
)
}
\arguments{
\item{sumstats_dt}{Summary stats data.table.}

\item{mapping_file}{MungeSumstats has a pre-defined column-name mapping file
which should cover the most common column headers and their interpretations.
However, if a column header that is in youf file is missing of the mapping we
give is incorrect you can supply your own mapping file. Must be a 2 column
dataframe with column names "Uncorrected" and "Corrected". See
data(sumstatsColHeaders) for default mapping and necessary format.}

\item{return_list}{Binary, whether to return the dt in a list or not - list
is standard for the \code{format_sumstats()} function.}
}
\value{
Null output.
}
\description{
Parse p-value column in VCF file.of other general -loq10 p-values
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_allele_flip.R
\name{check_allele_flip}
\alias{check_allele_flip}
\title{Ensure A1 & A2 are correctly named, if GWAS SNP constructed as
Alternative/Reference or Risk/Nonrisk alleles these SNPs will need to be
converted to Reference/Alternative or Nonrisk/Risk. Here non-risk is defined
as what's on the reference genome (this may not always be the case).}
\usage{
check_allele_flip(
  sumstats_dt,
  path,
  ref_genome,
  rsids,
  allele_flip_check,
  allele_flip_drop,
  allele_flip_z,
  allele_flip_frq,
  bi_allelic_filter,
  flip_frq_as_biallelic,
  imputation_ind,
  log_folder_ind,
  check_save_out,
  tabix_index,
  nThread,
  log_files,
  standardise_headers = FALSE,
  mapping_file,
  dbSNP,
  dbSNP_tarball
)
}
\arguments{
\item{path}{Filepath for the summary statistics file to be formatted. A
dataframe or datatable of the summary statistics file can also be passed
directly to MungeSumstats using the path parameter.}

\item{ref_genome}{name of the reference genome used for the GWAS ("GRCh37" or
"GRCh38"). Argument is case-insensitive. Default is NULL which infers the
reference genome from the data.}

\item{allele_flip_check}{Binary Should the allele columns be checked against
reference genome to infer if flipping is necessary. Default is TRUE.}

\item{allele_flip_drop}{Binary Should the SNPs for which neither their A1 or
A2 base pair values match a reference genome be dropped. Default is TRUE.}

\item{allele_flip_z}{Binary should the Z-score be flipped along with effect
and FRQ columns like Beta? It is assumed to be calculated off the effect size
not the P-value and so will be flipped i.e. default TRUE.}

\item{allele_flip_frq}{Binary should the frequency (FRQ) column be flipped
along with effect and z-score columns like Beta? Default TRUE.}

\item{bi_allelic_filter}{Binary Should non-bi-allelic SNPs be removed.
Default is TRUE.}

\item{flip_frq_as_biallelic}{Binary Should non-bi-allelic SNPs frequency
values be flipped as 1-p despite there being other alternative alleles?
Default is FALSE but if set to TRUE, this allows non-bi-allelic SNPs to be
kept despite needing flipping.}

\item{imputation_ind}{Binary Should a column be added for each imputation
step to show what SNPs have imputed values for differing fields. This
includes a field denoting SNP allele flipping (flipped). On the flipped
value, this denoted whether the alelles where switched based on
MungeSumstats initial choice of A1, A2 from the input column headers and thus
may not align with what the creator intended.\strong{Note} these columns will be
in the formatted summary statistics returned. Default is FALSE.}

\item{log_folder_ind}{Binary Should log files be stored containing all
filtered out SNPs (separate file per filter). The data is outputted in the
same format specified for the resulting sumstats file. The only exception to
this rule is if output is vcf, then log file saved as .tsv.gz. Default is
FALSE.}

\item{tabix_index}{Index the formatted summary statistics with
\href{http://www.htslib.org/doc/tabix.html}{tabix} for fast querying.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{log_files}{list of log file locations}

\item{standardise_headers}{Run
\code{standardise_sumstats_column_headers_crossplatform} first.}

\item{mapping_file}{MungeSumstats has a pre-defined column-name mapping file
which should cover the most common column headers and their interpretations.
However, if a column header that is in youf file is missing of the mapping we
give is incorrect you can supply your own mapping file. Must be a 2 column
dataframe with column names "Uncorrected" and "Corrected". See
data(sumstatsColHeaders) for default mapping and necessary format.}

\item{dbSNP}{version of dbSNP to be used for imputation (144 or 155). See
\code{dbSNP_tarball} for different versions of dbSNP (including newer releases).}

\item{dbSNP_tarball}{Pass local versions of dbSNP in tarball format. Default
of NULL uses the dbSNP version passed in \code{dbSNP} parmeter. \code{dbSNP_tarball}
was enabled to help with dbSNP versions >=156, after the decision to no
longer provide dbSNP releases as bioconductor packages. dbSNP 156 tarball is
available here: http://149.165.171.124/SNPlocs/.}
}
\value{
A list containing two data tables:
\itemize{
\item \code{sumstats_dt}: the modified summary statistics
\code{data.table} object.
\item \code{rsids}: snpsById, filtered to SNPs of interest if
loaded already. Or else NULL.
\item \code{log_files}: log file list
}
}
\description{
Ensure A1 & A2 are correctly named, if GWAS SNP constructed as
Alternative/Reference or Risk/Nonrisk alleles these SNPs will need to be
converted to Reference/Alternative or Nonrisk/Risk. Here non-risk is defined
as what's on the reference genome (this may not always be the case).
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_miss_data.R
\name{check_miss_data}
\alias{check_miss_data}
\title{Remove SNPs with missing data}
\usage{
check_miss_data(
  sumstats_dt,
  path,
  log_folder_ind,
  check_save_out,
  tabix_index,
  nThread,
  log_files,
  drop_na_cols
)
}
\arguments{
\item{path}{Filepath for the summary statistics file to be formatted. A
dataframe or datatable of the summary statistics file can also be passed
directly to MungeSumstats using the path parameter.}

\item{log_folder_ind}{Binary Should log files be stored containing all
filtered out SNPs (separate file per filter). The data is outputted in the
same format specified for the resulting sumstats file. The only exception to
this rule is if output is vcf, then log file saved as .tsv.gz. Default is
FALSE.}

\item{tabix_index}{Index the formatted summary statistics with
\href{http://www.htslib.org/doc/tabix.html}{tabix} for fast querying.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{log_files}{list of log file locations}

\item{drop_na_cols}{A character vector of column names to be checked for
missing values. Rows with missing values in any of these columns (if present
in the dataset) will be dropped. If \code{NULL}, all columns will be checked for
missing values. Default columns are SNP, chromosome, position, allele 1,
allele2, effect columns (frequency, beta, Z-score, standard error, log odds,
signed sumstats, odds ratio), p value and N columns.}
}
\value{
list containing sumstats_dt, the modified summary statistics data
table object and a log file list.
}
\description{
Remove SNPs with missing data
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_chr.R
\name{check_chr}
\alias{check_chr}
\title{Standardize the CHR column}
\usage{
check_chr(
  sumstats_dt,
  log_files = c(),
  check_save_out = FALSE,
  rmv_chr = c(),
  nThread = 1,
  log_folder_ind = FALSE
)
}
\arguments{
\item{sumstats_dt}{data.table with summary statistics}

\item{log_files}{list of locations for all log files}

\item{check_save_out}{list of parameters for saved files}

\item{rmv_chr}{Chromosomes to exclude from the formatted summary statistics
file. Use NULL if no filtering is necessary. Default is \code{c("X", "Y", "MT")}
which removes all non-autosomal SNPs.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{log_folder_ind}{Binary Should log files be stored containing all
filtered out SNPs (separate file per filter). The data is outputted in the
same format specified for the resulting sumstats file. The only exception to
this rule is if output is vcf, then log file saved as .tsv.gz. Default is
FALSE.}
}
\value{
list containing the updated summary statistics data.table and the
updated log file locations list
}
\description{
Maps chromosome names to the default Ensembl/NCBI naming style and removes
SNPs with nonstandard CHR entries. Optionally, also removes SNPs on
user-specified chromosomes.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supported_suffixes.R
\name{supported_suffixes}
\alias{supported_suffixes}
\title{List supported file formats}
\usage{
supported_suffixes(
  tabular = TRUE,
  tabular_compressed = TRUE,
  vcf = TRUE,
  vcf_compressed = TRUE
)
}
\arguments{
\item{tabular}{Include tabular formats.}

\item{tabular_compressed}{Include compressed tabular formats.}

\item{vcf}{Include Variant Call Format.}

\item{vcf_compressed}{Include compressed Variant Call Format.}
}
\value{
File formats
}
\description{
List supported file formats
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_numeric.R
\name{check_numeric}
\alias{check_numeric}
\title{Check numeric columns}
\usage{
check_numeric(sumstats_dt, cols = c("P", "SE", "FRQ", "MAF", "BETA"))
}
\arguments{
\item{sumstats_dt}{Summary stats with column names already standardised by
\link[MungeSumstats]{format_sumstats}.}

\item{cols}{Names of columns that should be numeric.
If any of these columns are not actually present in \code{sumstats_dt},
they will be skipped.}
}
\value{
sumstats_dt
}
\description{
Checks for any columns that should be numeric,
and ensures that they are indeed numeric.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_vcf_info.R
\name{read_vcf_info}
\alias{read_vcf_info}
\title{Read VCF: INFO column}
\usage{
read_vcf_info(sumstats_dt)
}
\arguments{
\item{sumstats_dt}{Summary stats data.table.}
}
\value{
Null output.
}
\description{
Parse INFO column in VCF file.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parse_snps_freq_05.R
\name{parse_snps_freq_05}
\alias{parse_snps_freq_05}
\title{Parse number/percent of SNPs with FREQ values >0.5}
\usage{
parse_snps_freq_05(l, percent = FALSE)
}
\arguments{
\item{l}{Lines of text from log file.}
}
\value{
Numeric
}
\description{
Support function for \link[MungeSumstats]{parse_logs}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/index_vcf.R
\name{index_vcf}
\alias{index_vcf}
\title{Tabix-index file: VCF}
\source{
Borrowed function from
\href{https://github.com/RajLabMSSM/echotabix/blob/main/R/convert.R}{
echotabix}.
}
\usage{
index_vcf(path, verbose = TRUE)
}
\arguments{
\item{path}{Path to VCF.}

\item{verbose}{Print messages.}
}
\value{
Path to tabix-indexed tabular file
}
\description{
Convert summary stats file to tabix format
}
\examples{
eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
                                 package = "MungeSumstats")
sumstats_dt <- data.table::fread(eduAttainOkbayPth, nThread = 1)
sumstats_dt <- 
MungeSumstats:::standardise_sumstats_column_headers_crossplatform(
    sumstats_dt = sumstats_dt)$sumstats_dt
sumstats_dt <- MungeSumstats:::sort_coords(sumstats_dt = sumstats_dt)
path <- tempfile(fileext = ".tsv")
MungeSumstats::write_sumstats(sumstats_dt = sumstats_dt, save_path = path)
    
indexed_file <- MungeSumstats::index_tabular(path = path)
}
\seealso{
Other tabix: 
\code{\link{index_tabular}()}
}
\concept{tabix}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sort_coord_genomicranges.R
\name{sort_coord_genomicranges}
\alias{sort_coord_genomicranges}
\title{Sort sum stats: GenomicRanges}
\usage{
sort_coord_genomicranges(sumstats_dt)
}
\arguments{
\item{sumstats_dt}{\link[data.table]{data.table} obj of the
summary statistics file for the GWAS.}
}
\value{
Sorted sumstats_dt
}
\description{
Sort summary statistics table by genomic coordinates using a slower
(but in some cases more robust) \code{GenomicRanges} strategy
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_no_chr_bp.R
\name{check_no_chr_bp}
\alias{check_no_chr_bp}
\title{Ensure that CHR and BP are missing if SNP is present, can find them}
\usage{
check_no_chr_bp(
  sumstats_dt,
  path,
  ref_genome,
  rsids,
  imputation_ind,
  log_folder_ind,
  check_save_out,
  tabix_index,
  nThread,
  log_files,
  dbSNP,
  dbSNP_tarball
)
}
\arguments{
\item{path}{Filepath for the summary statistics file to be formatted. A
dataframe or datatable of the summary statistics file can also be passed
directly to MungeSumstats using the path parameter.}

\item{ref_genome}{name of the reference genome used for the GWAS ("GRCh37" or
"GRCh38"). Argument is case-insensitive. Default is NULL which infers the
reference genome from the data.}

\item{imputation_ind}{Binary Should a column be added for each imputation
step to show what SNPs have imputed values for differing fields. This
includes a field denoting SNP allele flipping (flipped). On the flipped
value, this denoted whether the alelles where switched based on
MungeSumstats initial choice of A1, A2 from the input column headers and thus
may not align with what the creator intended.\strong{Note} these columns will be
in the formatted summary statistics returned. Default is FALSE.}

\item{log_folder_ind}{Binary Should log files be stored containing all
filtered out SNPs (separate file per filter). The data is outputted in the
same format specified for the resulting sumstats file. The only exception to
this rule is if output is vcf, then log file saved as .tsv.gz. Default is
FALSE.}

\item{tabix_index}{Index the formatted summary statistics with
\href{http://www.htslib.org/doc/tabix.html}{tabix} for fast querying.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{log_files}{list of log file locations}

\item{dbSNP}{version of dbSNP to be used for imputation (144 or 155). See
\code{dbSNP_tarball} for different versions of dbSNP (including newer releases).}

\item{dbSNP_tarball}{Pass local versions of dbSNP in tarball format. Default
of NULL uses the dbSNP version passed in \code{dbSNP} parmeter. \code{dbSNP_tarball}
was enabled to help with dbSNP versions >=156, after the decision to no
longer provide dbSNP releases as bioconductor packages. dbSNP 156 tarball is
available here: http://149.165.171.124/SNPlocs/.}
}
\value{
A list containing two data tables:
\describe{
\item{\code{sumstats_dt}}{The modified summary statistics data table.}
\item{\code{rsids}}{\code{snpsById}, filtered to SNPs of interest if loaded
already, or else \code{NULL}.}
\item{\code{log_files}}{List of log files.}
}
}
\description{
Ensure that CHR and BP are missing if SNP is present, can find them
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/download_vcf.R
\name{download_vcf}
\alias{download_vcf}
\title{Download VCF file and its index file from Open GWAS}
\usage{
download_vcf(
  vcf_urls,
  vcf_dir = tempdir(),
  vcf_download = TRUE,
  download_method = "download.file",
  force_new = FALSE,
  quiet = FALSE,
  timeout = 10 * 60,
  nThread = 1
)
}
\arguments{
\item{vcf_urls}{Remote URL to VCF file.}

\item{vcf_dir}{Where to download the original VCF from Open GWAS.
\emph{WARNING:} This is set to \code{tempdir()} by default.
This means the raw (pre-formatted) VCFs be deleted upon ending the R session.
Change this to keep the raw VCF file on disk
(e.g. \code{vcf_dir="./raw_vcf"}).}

\item{vcf_download}{Download the original VCF from Open GWAS.}

\item{download_method}{\code{"axel"} (multi-threaded) or
\code{"download.file"} (single-threaded) .}

\item{force_new}{Overwrite a previously downloaded VCF
with the same path name.}

\item{quiet}{Run quietly.}

\item{timeout}{How many seconds before giving up on download.
Passed to \code{download.file}. Default: \code{10*60} (10min).}

\item{nThread}{Number of threads to parallelize over.}
}
\value{
List containing the paths to the downloaded VCF and its index file.
}
\description{
Ideally, we would use \href{https://github.com/MRCIEU/gwasvcf}{gwasvcf}
instead but it hasn't been made available on CRAN or Bioconductor yet,
so we can't include it as a dep.
}
\examples{
#only run the examples if user has internet access:
if(try(is.character(getURL("www.google.com")))==TRUE){
vcf_urls <- ieugwasr::gwasinfo_files(id = "ieu-a-298")[[1]]
out_paths <- download_vcf(vcf_urls = vcf_urls)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preview_sumstats.R
\name{preview_sumstats}
\alias{preview_sumstats}
\title{Preview formatted sum stats saved to disk}
\usage{
preview_sumstats(save_path, nrows = 5L)
}
\arguments{
\item{save_path}{File path to save formatted data. Defaults to
\code{tempfile(fileext=".tsv.gz")}.}
}
\value{
No return
}
\description{
Prints the first \code{n} lines of the sum stats.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/to_GRanges.R
\name{to_granges}
\alias{to_granges}
\title{To \code{GRanges}}
\usage{
to_granges(
  sumstats_dt,
  seqnames.field = "CHR",
  start.field = "BP",
  end.field = "BP",
  style = c("NCBI", "UCSC")
)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics file
for the GWAS.}

\item{seqnames.field}{
    A character vector of recognized names for the column in \code{df}
    that contains the chromosome name (a.k.a. sequence name) associated
    with each genomic range.
    Only the first name in \code{seqnames.field} that is found
    in \code{colnames(df)} is used.
    If no one is found, then an error is raised.
  }

\item{start.field}{
    A character vector of recognized names for the column in \code{df}
    that contains the start positions of the genomic ranges.
    Only the first name in \code{start.field} that is found
    in \code{colnames(df)} is used.
    If no one is found, then an error is raised.
  }

\item{end.field}{
    A character vector of recognized names for the column in \code{df}
    that contains the end positions of the genomic ranges.
    Only the first name in \code{start.field} that is found
    in \code{colnames(df)} is used.
    If no one is found, then an error is raised.
  }

\item{style}{\code{GRanges} style to convert to, "NCBI" or "UCSC".}
}
\value{
\code{GRanges} object
}
\description{
Convert a \link[data.table]{data.table} to \link[GenomicRanges]{GRanges}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/to_VRanges.R
\name{to_vranges}
\alias{to_vranges}
\title{Convert to \code{VRanges}}
\usage{
to_vranges(sumstats_dt)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics
file for the GWAS.}
}
\value{
\code{VRanges} object
}
\description{
Convert to \code{VRanges}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_ldsc_format.R
\name{check_ldsc_format}
\alias{check_ldsc_format}
\title{Ensures that parameters are compatible with LDSC format}
\source{
\href{https://github.com/bulik/ldsc}{LDSC GitHub}
}
\usage{
check_ldsc_format(
  sumstats_dt,
  save_format,
  convert_n_int,
  allele_flip_check,
  compute_z,
  compute_n
)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics file for the
GWAS.}

\item{save_format}{Output format of sumstats. Options are NULL - standardised
output format from MungeSumstats, LDSC - output format compatible with LDSC
and openGWAS - output compatible with openGWAS VCFs. Default is NULL.
\strong{NOTE} - If LDSC format is used, the naming convention of A1 as the
reference (genome build) allele and A2 as the effect allele will be reversed
to match LDSC (A1 will now be the effect allele). See more info on this
\href{https://groups.google.com/g/ldsc_users/c/S7FZK743w68}{here}. Note that any
effect columns (e.g. Z) will be inrelation to A1 now instead of A2.}

\item{convert_n_int}{Binary, if N (the number of samples) is not an integer,
should this be rounded? Default is TRUE.}

\item{allele_flip_check}{Binary Should the allele columns be checked against
reference genome to infer if flipping is necessary. Default is TRUE.}

\item{compute_z}{Whether to compute Z-score column. Default is FALSE. This
can be computed from Beta and SE with (Beta/SE) or P
(Z:=sign(BETA)*sqrt(stats::qchisq(P,1,lower=FALSE))).
\strong{Note} that imputing the Z-score from P for every SNP will not be
perfectly correct and may result in a loss of power. This should only be done
as a last resort. Use 'BETA' to impute by BETA/SE and 'P' to impute by SNP
p-value.}

\item{compute_n}{Whether to impute N. Default of 0 won't impute, any other
integer will be imputed as the N (sample size) for every SNP in the dataset.
\strong{Note} that imputing the sample size for every SNP is not correct and
should only be done as a last resort. N can also be inputted with "ldsc",
"sum", "giant" or "metal" by passing one of these for this field or a vector
of multiple. Sum and an integer value creates an N column in the output
whereas giant, metal or ldsc create an Neff or effective sample size. If
multiples are passed, the formula used to derive it will be indicated.}
}
\value{
Formatted summary statistics
}
\description{
Format summary statistics for direct input to
Linkage Disequilibrium SCore (LDSC) regression without the need
to use their \code{munge_sumstats.py} script first.
}
\details{
\href{https://github.com/bulik/ldsc/wiki/Summary-Statistics-File-Format}{
LDSC documentation}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parse_logs.R
\name{parse_logs}
\alias{parse_logs}
\title{Parse data from log files}
\usage{
parse_logs(
  save_dir = getwd(),
  pattern = "MungeSumstats_log_msg.txt$",
  verbose = TRUE
)
}
\arguments{
\item{save_dir}{Top-level directory to recursively search
for log files within.}

\item{pattern}{Regex pattern to search for files with.}

\item{verbose}{Print messages.}
}
\value{
\link[data.table]{data.table} of parsed log data.
}
\description{
Parses data from the log files generated by
\link[MungeSumstats]{format_sumstats} or
\link[MungeSumstats]{import_sumstats} when the argument
\code{log_mungesumstats_msgs} is set to \code{TRUE}.
}
\examples{
save_dir <- system.file("extdata",package = "MungeSumstats")
log_data <- MungeSumstats::parse_logs(save_dir = save_dir)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/write_sumstats.R
\name{write_sumstats}
\alias{write_sumstats}
\title{Write sum stats file to disk}
\source{
\href{https://github.com/Bioconductor/VariantAnnotation/issues/35}{
VariantAnnotation::writeVcf has some unexpected/silent
file renaming behavior}
}
\usage{
write_sumstats(
  sumstats_dt,
  save_path,
  ref_genome = NULL,
  sep = "\\t",
  write_vcf = FALSE,
  save_format = NULL,
  tabix_index = FALSE,
  nThread = 1,
  return_path = FALSE,
  save_path_check = FALSE
)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics
file for the GWAS.}

\item{save_path}{File path to save formatted data. Defaults to
\code{tempfile(fileext=".tsv.gz")}.}

\item{ref_genome}{name of the reference genome used for the GWAS ("GRCh37" or
"GRCh38"). Argument is case-insensitive. Default is NULL which infers the
reference genome from the data.}

\item{sep}{ The separator between columns. Defaults to the character in the set \code{[,\\t |;:]} that separates the sample of rows into the most number of lines with the same number of fields. Use \code{NULL} or \code{""} to specify no separator; i.e. each line a single character column like \code{base::readLines} does.}

\item{write_vcf}{Whether to write as VCF (TRUE) or tabular file (FALSE).}

\item{save_format}{Output format of sumstats. Options are NULL - standardised
output format from MungeSumstats, LDSC - output format compatible with LDSC
and openGWAS - output compatible with openGWAS VCFs. Default is NULL.
\strong{NOTE} - If LDSC format is used, the naming convention of A1 as the
reference (genome build) allele and A2 as the effect allele will be reversed
to match LDSC (A1 will now be the effect allele). See more info on this
\href{https://groups.google.com/g/ldsc_users/c/S7FZK743w68}{here}. Note that any
effect columns (e.g. Z) will be inrelation to A1 now instead of A2.}

\item{tabix_index}{Index the formatted summary statistics with
\href{http://www.htslib.org/doc/tabix.html}{tabix} for fast querying.}

\item{nThread}{The number of threads to use. Experiment to see what works best for your data on your hardware.}

\item{return_path}{Return \code{save_path}.
This will have been modified in some cases
(e.g. after compressing and tabix-indexing a
previously un-compressed file).}

\item{save_path_check}{Ensure path name is valid (given the other arguments)
before writing (default: FALSE).}
}
\value{
If \code{return_path=TRUE}, returns \code{save_path}.
Else returns \code{NULL}.
}
\description{
Write sum stats file to disk
}
\examples{
path <- system.file("extdata", "eduAttainOkbay.txt",
    package = "MungeSumstats"
)
eduAttainOkbay <- read_sumstats(path = path)
write_sumstats(
    sumstats_dt = eduAttainOkbay,
    save_path = tempfile(fileext = ".tsv.gz")
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_dup_col.R
\name{check_dup_col}
\alias{check_dup_col}
\title{Ensure that no columns are duplicated}
\usage{
check_dup_col(sumstats_dt, path)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics file for the GWAS}

\item{path}{Filepath for the summary statistics file to be formatted}
}
\value{
list containing sumstats_dt, the modified
summary statistics data table object
}
\description{
Ensure that no columns are duplicated
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_multi_gwas.R
\name{check_multi_gwas}
\alias{check_multi_gwas}
\title{Ensure that only one model in GWAS sumstats or only one trait tested}
\usage{
check_multi_gwas(
  sumstats_dt,
  path,
  analysis_trait,
  ignore_multi_trait,
  mapping_file
)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics file for the GWAS}

\item{path}{Filepath for the summary statistics file to be formatted}

\item{analysis_trait}{If multiple traits were studied, name of the trait for
analysis from the GWAS. Default is NULL}

\item{mapping_file}{MungeSumstats has a pre-defined column-name mapping file
which should cover the most common column headers and their interpretations.
However, if a column header that is in youf file is missing of the mapping we
give is incorrect you can supply your own mapping file. Must be a 2 column
dataframe with column names "Uncorrected" and "Corrected". See
data(sumstatsColHeaders) for default mapping and necessary format.}
}
\value{
list containing sumstats_dt, the modified summary statistics data
table object
}
\description{
Ensure that only one model in GWAS sumstats or only one trait tested
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/drop_duplicate_rows.R
\name{drop_duplicate_rows}
\alias{drop_duplicate_rows}
\title{Drop duplicate rows}
\usage{
drop_duplicate_rows(dt, verbose = TRUE)
}
\arguments{
\item{dt}{data.table}

\item{verbose}{Print messages.}
}
\value{
Filtered \code{dt}.
}
\description{
Drop rows with duplicate values across all columns.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{raw_eduAttainOkbay}
\alias{raw_eduAttainOkbay}
\title{GWAS Educational Attainment Okbay 2016 - Subset}
\format{
txt document with 94 items
}
\source{
The summary statistics file was downloaded from
https://www.nature.com/articles/ng.3552
and formatted to a .rda with the following:
\code{
#Get example dataset, use Educational-Attainment_Okbay_2016
link<-"Educational-Attainment_Okbay_2016/EduYears_Discovery_5000.txt"
eduAttainOkbay<-readLines(link,n=100)
#There is an issue where values end with .0, this 0 is removed in func
#There are also SNPs not on ref genome or arebi/tri allelic
#So need to remove these in this dataset as its used for testing
tmp <- tempfile()
writeLines(eduAttainOkbay,con=tmp)
eduAttainOkbay <- data.table::fread(tmp) #DT read removes the .0's
#remove those not on ref genome and withbi/tri allelic
rmv <- c("rs192818565","rs79925071","rs1606974","rs1871109",
         "rs73074378","rs7955289")
eduAttainOkbay <- eduAttainOkbay[!MarkerName %in% rmv,]
data.table::fwrite(eduAttainOkbay,file=tmp,sep="\t")
eduAttainOkbay <- readLines(tmp)
writeLines(eduAttainOkbay,"inst/extdata/eduAttainOkbay.txt")
}
}
\description{
GWAS Summary Statistics on Educational Attainment by Okbay et
al 2016:
PMID: 27898078 PMCID: PMC5509058 DOI: 10.1038/ng1216-1587b.
A subset of 93 SNPs
}
\details{
GWAS Summary Statistics on Educational Attainment by Okbay et
al 2016 has been subsetted here to act as an example summary statistic file
which has some issues in the formatting. MungeSumstats can correct these
issues.
}
\section{eduAttainOkbay.txt}{
NA
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/report_summary.R
\name{report_summary}
\alias{report_summary}
\title{Report info on current state of the summary statistics}
\usage{
report_summary(sumstats_dt, orig_dims = NULL)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary
statistics file for the GWAS.}
}
\value{
No return
}
\description{
Prints report.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_signed_col.R
\name{check_signed_col}
\alias{check_signed_col}
\title{Ensure that there is at least one signed column in summary statistics file
Impute beta if user requests}
\usage{
check_signed_col(
  sumstats_dt,
  impute_beta,
  log_folder_ind,
  rsids,
  imputation_ind,
  check_save_out,
  tabix_index,
  log_files,
  nThread
)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics
file for the GWAS}

\item{impute_beta}{Binary, whether BETA should be imputed using other effect
data if it isn't present in the sumstats. Note that this imputation is an
approximation (for Z & SE approach) so could have an effect on downstream
analysis. Use with caution. The different methods MungeSumstats will try and
impute beta (in this order or priority) are:
\enumerate{
\item log(OR)  2. Z x SE
Default value is FALSE.
}}

\item{log_folder_ind}{Binary Should log files be stored containing all
filtered out SNPs (separate file per filter). The data is outputted in the
same format specified for the resulting sumstats file. The only exception to
this rule is if output is vcf, then log file saved as .tsv.gz. Default is
FALSE.}

\item{imputation_ind}{Binary Should a column be added for each imputation
step to show what SNPs have imputed values for differing fields. This
includes a field denoting SNP allele flipping (flipped). On the flipped
value, this denoted whether the alelles where switched based on
MungeSumstats initial choice of A1, A2 from the input column headers and thus
may not align with what the creator intended.\strong{Note} these columns will be
in the formatted summary statistics returned. Default is FALSE.}

\item{tabix_index}{Index the formatted summary statistics with
\href{http://www.htslib.org/doc/tabix.html}{tabix} for fast querying.}

\item{log_files}{list of log file locations}

\item{nThread}{Number of threads to use for parallel processes.}
}
\value{
null
}
\description{
Ensure that there is at least one signed column in summary statistics file
Impute beta if user requests
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/formatted_example.R
\name{formatted_example}
\alias{formatted_example}
\title{Formatted example}
\usage{
formatted_example(
  path = system.file("extdata", "eduAttainOkbay.txt", package = "MungeSumstats"),
  formatted = TRUE,
  sorted = TRUE
)
}
\arguments{
\item{path}{Path to raw example file. Default to built-in dataset.}

\item{formatted}{Whether the column names should be formatted
(default:\code{TRUE}).}

\item{sorted}{Whether the rows should be sorted by genomic coordinates
(default:\code{TRUE}).}
}
\value{
\code{sumstats_dt}
}
\description{
Returns an example of summary stats that have had their column names
already standardised with
\link[MungeSumstats]{standardise_header}.
}
\examples{
sumstats_dt <- MungeSumstats::formatted_example()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/logs_example.R
\name{logs_example}
\alias{logs_example}
\title{Example logs file}
\source{
\code{
eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
                                 package = "MungeSumstats")
sumstats_dt <- data.table::fread(eduAttainOkbayPth)
#### Introduce values that need to be fixed ####
sumstats_dt$Pval[10:15] <- 5
sumstats_dt$Pval[20:22] <- -5
sumstats_dt$Pval[23:25] <- "5e-324"
ss_path <- tempfile()
data.table::fwrite(sumstats_dt, ss_path)
log_folder <- tempdir()
reformatted <- MungeSumstats::format_sumstats(
    path = ss_path,
    ref_genome = "GRCh37",
    log_folder = log_folder,
    log_mungesumstats_msgs = TRUE,
    log_folder_ind = TRUE,
)
file.copy(reformatted$log_files$MungeSumstats_log_msg,
          "inst/extdata",overwrite = TRUE)
}
}
\usage{
logs_example(read = FALSE)
}
\arguments{
\item{read}{Whether to read the logs file into memory.}
}
\value{
Path to logs file.
}
\description{
Example logs file produced by \link[MungeSumstats]{format_sumstats}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parse_pval_neg.R
\name{parse_pval_neg}
\alias{parse_pval_neg}
\title{Parse number of SNPs with p-values <0}
\usage{
parse_pval_neg(l)
}
\arguments{
\item{l}{Lines of text from log file.}
}
\value{
Numeric
}
\description{
Support function for \link[MungeSumstats]{parse_logs}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_allele_merge.R
\name{check_allele_merge}
\alias{check_allele_merge}
\title{Ensure that A1:A2 or A1/A2 or A1>A2 or A2>A1 aren't merged into 1 column}
\usage{
check_allele_merge(sumstats_dt, path)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics file for the GWAS}

\item{path}{Filepath for the summary statistics file to be formatted}
}
\value{
list containing sumstats_dt, the modified summary
statistics data table object.
}
\description{
Ensure that A1:A2 or A1/A2 or A1>A2 or A2>A1 aren't merged into 1 column
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{hg19ToHg38}
\alias{hg19ToHg38}
\title{UCSC Chain file hg19 to hg38}
\format{
gunzipped chain file
}
\source{
The chain file was downloaded from
https://hgdownload.cse.ucsc.edu/goldenpath/hg19/liftOver/
\code{
utils::download.file('ftp://hgdownload.cse.ucsc.edu/goldenPath/hg19/liftOver/hg19ToHg38.over.chain.gz',tempdir())
}
}
\description{
UCSC Chain file hg19 to hg38, .chain.gz file, downloaded from
https://hgdownload.cse.ucsc.edu/goldenpath/hg19/liftOver/ on 09/10/21
}
\details{
UCSC Chain file hg19 to hg38, .chain.gz file, downloaded on 09/10/21
To be used as a back up if the download from UCSC fails.
}
\section{hg19ToHg38.over.chain.gz}{
NA
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/unlist_dt.R
\name{unlist_dt}
\alias{unlist_dt}
\title{Unlist a data.table}
\usage{
unlist_dt(dt, verbose = TRUE)
}
\arguments{
\item{dt}{data.table}

\item{verbose}{Print messages.}
}
\value{
\code{dt} with list columns turned into vectors.
}
\description{
Identify columns that are lists and turn them into vectors.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parse_flipped.R
\name{parse_flipped}
\alias{parse_flipped}
\title{Parse number of SNPs flipped to align with the ref genome}
\usage{
parse_flipped(l)
}
\arguments{
\item{l}{Lines of text from log file.}
}
\value{
Numeric
}
\description{
Support function for \link[MungeSumstats]{parse_logs}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_dup_row.R
\name{check_dup_row}
\alias{check_dup_row}
\title{Ensure all rows are unique based on SNP,CHR,BP,A1,A2, drop those that aren't}
\usage{
check_dup_row(
  sumstats_dt,
  check_dups,
  path,
  log_folder_ind,
  check_save_out,
  tabix_index,
  nThread,
  log_files
)
}
\arguments{
\item{check_dups}{whether to check for duplicates - if formatting QTL
datasets this should be set to FALSE otherwise keep as TRUE. Default is TRUE.}

\item{path}{Filepath for the summary statistics file to be formatted. A
dataframe or datatable of the summary statistics file can also be passed
directly to MungeSumstats using the path parameter.}

\item{log_folder_ind}{Binary Should log files be stored containing all
filtered out SNPs (separate file per filter). The data is outputted in the
same format specified for the resulting sumstats file. The only exception to
this rule is if output is vcf, then log file saved as .tsv.gz. Default is
FALSE.}

\item{tabix_index}{Index the formatted summary statistics with
\href{http://www.htslib.org/doc/tabix.html}{tabix} for fast querying.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{log_files}{list of log file locations}
}
\value{
list containing sumstats_dt, the modified summary statistics data
table object and log files list
}
\description{
Ensure all rows are unique based on SNP,CHR,BP,A1,A2, drop those that aren't
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/drop_duplicate_cols.R
\name{drop_duplicate_cols}
\alias{drop_duplicate_cols}
\title{Drop duplicate columns}
\usage{
drop_duplicate_cols(dt)
}
\arguments{
\item{dt}{data.table}
}
\value{
Null output
}
\description{
Drop columns with identical names (if any exist) within a data.table.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compute_sample_size_neff.R
\name{compute_sample_size_neff}
\alias{compute_sample_size_neff}
\title{Compute Neff/N}
\usage{
compute_sample_size_neff(
  sumstats_dt,
  method,
  force_new = FALSE,
  append_method_name = FALSE
)
}
\arguments{
\item{sumstats_dt}{Summary statistics data.table.}

\item{method}{Method for computing (effective) sample size.

\itemize{

\item{"ldsc" : \cr}{
\eqn{Neff = (N_CAS+N_CON) * (N_CAS/(N_CAS+N_CON)) /
 mean((N_CAS/(N_CAS+N_CON))[(N_CAS+N_CON)==max(N_CAS+N_CON)]))}\cr
\href{https://github.com/bulik/ldsc/issues/95}{
bulik/ldsc GitHub Issue}
\href{https://github.com/bulik/ldsc/blob/aa33296abac9569a6422ee6ba7eb4b902422cc74/munge_sumstats.py#L321}{
bulik/ldsc GitHub code}
}

\item{"giant" : \cr}{
\eqn{Neff = 2 / (1/N_CAS + 1/N_CON)}\cr
\href{https://www.nature.com/articles/nprot.2014.071}{
Winkler et al. 2014, Nature}
}

\item{"metal" : \cr}{
\eqn{Neff = 4 / (1/N_CAS + 1/N_CON)}\cr
\href{https://pubmed.ncbi.nlm.nih.gov/20616382/}{
Willer et al. 2010, Bioinformatics}
}

\item{"sum" : \cr}{
\eqn{N = N_CAS + N_CON}\cr
Simple summation of cases and controls
that does not account for class imbalance.
}

\item{"\\<integer\\>" : \cr}{
\code{N = \\<integer\\>}\cr
If method is a positive integer, it will be used as N
for every row.
}

}}

\item{force_new}{If "Neff" (or "N") already exists in \code{sumstats_dt},
replace it with the recomputed version.}

\item{append_method_name}{should Neff column have an indicator to explain the
method that makes it., Default is FALSE unless multiple methods are passed}
}
\value{
No return
}
\description{
Compute Neff/N
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/liftover.R
\name{liftover}
\alias{liftover}
\title{Genome build liftover}
\source{
\href{https://doi.org/doi:10.18129/B9.bioc.liftOver}{liftOver}

\href{https://hgdownload.cse.ucsc.edu/goldenpath/hg19/liftOver/}{
UCSC chain files}

\href{https://ftp.ensembl.org/pub/assembly_mapping/homo_sapiens/}{
Ensembl chain files}
}
\usage{
liftover(
  sumstats_dt,
  convert_ref_genome,
  ref_genome,
  chain_source = "ensembl",
  imputation_ind = TRUE,
  chrom_col = "CHR",
  start_col = "BP",
  end_col = start_col,
  as_granges = FALSE,
  style = "NCBI",
  local_chain = NULL,
  rmv_chr = c(),
  verbose = TRUE
)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics
file for the GWAS.}

\item{convert_ref_genome}{name of the reference genome to convert to
("GRCh37" or "GRCh38"). This will only occur if the current genome build does
not match. Default is not to convert the genome build (NULL).}

\item{ref_genome}{name of the reference genome used for the GWAS ("GRCh37" or
"GRCh38"). Argument is case-insensitive. Default is NULL which infers the
reference genome from the data.}

\item{chain_source}{chain file source used ("ucsc" as default, or "ensembl")}

\item{imputation_ind}{Binary Should a column be added for each imputation
step to show what SNPs have imputed values for differing fields. This
includes a field denoting SNP allele flipping (flipped). On the flipped
value, this denoted whether the alelles where switched based on
MungeSumstats initial choice of A1, A2 from the input column headers and thus
may not align with what the creator intended.\strong{Note} these columns will be
in the formatted summary statistics returned. Default is FALSE.}

\item{chrom_col}{Name of the chromosome column in
\code{sumstats_dt} (e.g. "CHR").}

\item{start_col}{Name of the starting genomic position
column in \code{sumstats_dt} (e.g. "POS","start").}

\item{end_col}{Name of the ending genomic position
column in \code{sumstats_dt} (e.g. "POS","end").
Can be the same as \code{start_col} when \code{sumstats_dt}
only contains SNPs that span 1 base pair (bp) each.}

\item{as_granges}{Return results as \link[GenomicRanges]{GRanges}
instead of a \link[data.table]{data.table} (default: \code{FALSE}).}

\item{style}{Style to return \link[GenomicRanges]{GRanges} object in
(e.g.  "NCBI" = 4; "UCSC" = "chr4";) (default: \code{"NCBI"}).}

\item{local_chain}{Path to local chain file to use instead of downlaoding.
Default of NULL i.e. no local file to use. NOTE if passing a local chain file
make sure to specify the path to convert from and to the correct build like
GRCh37 to GRCh38. We can not sense check this for local files. The chain file
can be submitted as a gz file (as downloaed from source) or unzipped.}

\item{rmv_chr}{Chromosomes to exclude from the formatted summary statistics
file. Use NULL if no filtering is necessary. Default is \code{c("X", "Y", "MT")}
which removes all non-autosomal SNPs.}

\item{verbose}{Print messages.}
}
\value{
Lifted summary stats in \code{data.table}
or \link[GenomicRanges]{GRanges} format.
}
\description{
Transfer genomic coordinates from one genome build to another.
}
\examples{
sumstats_dt <- MungeSumstats::formatted_example()

sumstats_dt_hg38 <- liftover(sumstats_dt=sumstats_dt, 
                             ref_genome = "hg19",
                             convert_ref_genome="hg38")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_unique_name_log_file.R
\name{get_unique_name_log_file}
\alias{get_unique_name_log_file}
\title{Simple function to ensure the new entry name to a list doesn't have the same
name as another entry}
\usage{
get_unique_name_log_file(name, log_files)
}
\arguments{
\item{name}{proposed name for the entry}

\item{log_files}{list of log file locations}
}
\value{
a unique name (character)
}
\description{
Simple function to ensure the new entry name to a list doesn't have the same
name as another entry
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/load_snp_loc_data.R
\name{load_snp_loc_data}
\alias{load_snp_loc_data}
\title{Loads the SNP locations and alleles for Homo sapiens from dbSNP builds}
\usage{
load_snp_loc_data(ref_genome, dbSNP, dbSNP_tarball = NULL, msg = NULL)
}
\arguments{
\item{ref_genome}{character, "GRCh37" or "GRCh38"}

\item{dbSNP}{integer, dbSNP build number (144, 155, or any installed
SNPlocs package)}

\item{dbSNP_tarball}{Optional path to a .tar.gz containing:
one or more .rds files (Bioc SNPlocs package layout).}

\item{msg}{optional character to message before loading}
}
\value{
A data.table or OnDiskLongTable of SNP locations
}
\description{
Loads the SNP locations and alleles for Homo sapiens from dbSNP builds
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/convert_sumstats.R
\name{convert_sumstats}
\alias{convert_sumstats}
\title{Convert summary statistics to desired object type}
\usage{
convert_sumstats(
  sumstats_dt,
  return_format = c("data.table", "vranges", "granges")
)
}
\arguments{
\item{return_format}{Object type to convert to;
\code{"data.table"}, \code{"GenomicRanges"} or
\code{"VRanges"}(default is \code{"data.table"}).}
}
\value{
Summary statistics in the converted format
}
\description{
Convert summary statistics to desired object type
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/column_dictionary.R
\name{column_dictionary}
\alias{column_dictionary}
\title{Map column names to positions.}
\source{
Borrowed function from
\href{https://github.com/RajLabMSSM/echotabix/blob/main/R/convert.R}{
echotabix}.

\code{
eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
    package = "MungeSumstats"
)
tmp <- tempfile(fileext = ".tsv")
file.copy(eduAttainOkbayPth, tmp)
cdict <- MungeSumstats:::column_dictionary(file_path = tmp)
}
}
\usage{
column_dictionary(file_path)
}
\arguments{
\item{file_path}{Path to full summary stats file
(or any really file you want to make a column dictionary for).}
}
\value{
Named list of column positions.
}
\description{
Useful in situations where you need to specify columns by
index instead of name (e.g. awk queries).
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_small_p_val.R
\name{check_small_p_val}
\alias{check_small_p_val}
\title{Ensure that the non-negative p-values are not 5e-324 or lower, if so set to 0}
\source{
\code{
sumstats_dt <- MungeSumstats:::formatted_example()
sumstats_dt$P[1:3] <- 5e-324
sumstats_dt$P[6:10] <- "5e-324"
sumstats <- check_small_p_val(sumstats_dt = sumstats_dt,
                              convert_small_p = TRUE, 
                              imputation_ind = TRUE)
}
}
\usage{
check_small_p_val(sumstats_dt, convert_small_p, imputation_ind)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics file for the GWAS}

\item{convert_small_p}{Binary, should non-negative
p-values <= 5e-324 be converted to 0?
Small p-values pass the R limit and can cause errors with LDSC/MAGMA and
should be converted. Default is TRUE.}

\item{imputation_ind}{Binary Should a column be added for each imputation
step to show what SNPs have imputed values for differing fields. This
includes a field denoting SNP allele flipping (flipped). On the flipped
value, this denoted whether the alelles where switched based on
MungeSumstats initial choice of A1, A2 from the input column headers and thus
may not align with what the creator intended.\strong{Note} these columns will be
in the formatted summary statistics returned. Default is FALSE.}
}
\value{
list containing sumstats_dt,
the modified summary statistics data table object
}
\description{
Ensure that the non-negative p-values are not 5e-324 or lower, if so set to 0
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/is_tabix.R
\name{is_tabix}
\alias{is_tabix}
\title{Is tabix}
\usage{
is_tabix(path)
}
\arguments{
\item{path}{Path to file.}
}
\value{
logical: whether the file is tabix-indexed or not.

logical
}
\description{
Is a file bgz-compressed and tabix-indexed.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make_allele_upper.R
\name{make_allele_upper}
\alias{make_allele_upper}
\title{Ensure A1 and A2 are upper case}
\usage{
make_allele_upper(sumstats_dt, log_files)
}
\arguments{
\item{log_files}{list of log file locations}
}
\value{
list containing sumstats_dt, the modified summary statistics data
table object and the log file list
}
\description{
Ensure A1 and A2 are upper case
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_vcf_genome.R
\name{read_vcf_genome}
\alias{read_vcf_genome}
\title{Read VCF genome}
\usage{
read_vcf_genome(
  header = NULL,
  validate = FALSE,
  default_genome = "HG19/GRCh37",
  verbose = TRUE
)
}
\arguments{
\item{header}{Header extracted by \link[VariantAnnotation]{scanVcfHeader}.}

\item{validate}{Validate genome name using
\link[GenomeInfoDb]{mapGenomeBuilds}.}

\item{default_genome}{When no genome can be extracted,
default to this genome build.}

\item{verbose}{Print messages.}
}
\value{
genome
}
\description{
Get the genome build of a remote or local VCF file.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_header.R
\name{read_header}
\alias{read_header}
\title{Read in file header}
\usage{
read_header(path, n = 2L, skip_vcf_metadata = FALSE, nThread = 1)
}
\arguments{
\item{path}{Filepath for the summary statistics file to be formatted. A
dataframe or datatable of the summary statistics file can also be passed
directly to MungeSumstats using the path parameter.}

\item{n}{integer. The (maximal) number of lines to read. Negative values
indicate that one should read up to the end of input on the connection.}

\item{skip_vcf_metadata}{logical, should VCF metadata be ignored}

\item{nThread}{Number of threads to use for parallel processes.}
}
\value{
First \code{n} lines of the VCF header
}
\description{
Read in file header
}
\examples{
path <- system.file("extdata", "eduAttainOkbay.txt", 
                    package = "MungeSumstats") 
header <- read_header(path = path)                    
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/index_tabular.R
\name{index_tabular}
\alias{index_tabular}
\title{Tabix-index file: table}
\source{
Borrowed function from
\href{https://github.com/RajLabMSSM/echotabix/blob/main/R/convert.R}{
echotabix}.
}
\usage{
index_tabular(
  path,
  chrom_col = "CHR",
  start_col = "BP",
  end_col = start_col,
  overwrite = TRUE,
  remove_tmp = TRUE,
  verbose = TRUE
)
}
\arguments{
\item{path}{Path to GWAS summary statistics file.}

\item{chrom_col}{Name of the chromosome column in
\code{sumstats_dt} (e.g. "CHR").}

\item{start_col}{Name of the starting genomic position
column in \code{sumstats_dt} (e.g. "POS","start").}

\item{end_col}{Name of the ending genomic position
column in \code{sumstats_dt} (e.g. "POS","end").
Can be the same as \code{start_col} when \code{sumstats_dt}
only contains SNPs that span 1 base pair (bp) each.}

\item{overwrite}{A logical(1) indicating whether \code{dest} should
    be over-written, if it already exists.}

\item{remove_tmp}{Remove the temporary uncompressed version of the file
(\emph{.tsv}).}

\item{verbose}{Print messages.}
}
\value{
Path to tabix-indexed tabular file
}
\description{
Convert summary stats file to tabix format.
}
\examples{
sumstats_dt <- MungeSumstats::formatted_example() 
path <- tempfile(fileext = ".tsv")
MungeSumstats::write_sumstats(sumstats_dt = sumstats_dt, save_path = path)
indexed_file <- MungeSumstats::index_tabular(path = path)
}
\seealso{
Other tabix: 
\code{\link{index_vcf}()}
}
\concept{tabix}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/infer_effect_column.R
\name{infer_effect_column}
\alias{infer_effect_column}
\title{Infer if effect relates to a1 or A2 if ambiguously named}
\usage{
infer_effect_column(
  sumstats_dt,
  dbSNP = 155,
  dbSNP_tarball = NULL,
  sampled_snps = 10000,
  mapping_file = sumstatsColHeaders,
  nThread = nThread,
  ref_genome = NULL,
  on_ref_genome = TRUE,
  infer_eff_direction = TRUE,
  eff_on_minor_alleles = FALSE,
  return_list = TRUE
)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics file for the
GWAS.}

\item{dbSNP}{version of dbSNP to be used for imputation (144 or 155). See
\code{dbSNP_tarball} for different versions of dbSNP (including newer releases).}

\item{dbSNP_tarball}{Pass local versions of dbSNP in tarball format. Default
of NULL uses the dbSNP version passed in \code{dbSNP} parmeter. \code{dbSNP_tarball}
was enabled to help with dbSNP versions >=156, after the decision to no
longer provide dbSNP releases as bioconductor packages. dbSNP 156 tarball is
available here: http://149.165.171.124/SNPlocs/.}

\item{sampled_snps}{Downsample the number of SNPs used when inferring genome
build to save time.}

\item{mapping_file}{MungeSumstats has a pre-defined column-name mapping file
which should cover the most common column headers and their interpretations.
However, if a column header that is in youf file is missing of the mapping we
give is incorrect you can supply your own mapping file. Must be a 2 column
dataframe with column names "Uncorrected" and "Corrected". See
data(sumstatsColHeaders) for default mapping and necessary format.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{ref_genome}{name of the reference genome used for the GWAS ("GRCh37" or
"GRCh38"). Argument is case-insensitive. Default is NULL which infers the
reference genome from the data.}

\item{on_ref_genome}{Binary Should a check take place that all SNPs are on
the reference genome by SNP ID. Default is TRUE.}

\item{infer_eff_direction}{Binary Should a check take place to ensure the
alleles match the effect direction? Default is TRUE.}

\item{eff_on_minor_alleles}{Binary Should MungeSumstats assume that the
effects are majoritively measured on the minor alleles? Default is FALSE as
this is an assumption that won't be appropriate in all cases. However, the
benefit is that if we know the majority of SNPs have their effects based on
the minor alleles, we can catch cases where the allele columns have been
mislabelled.}

\item{return_list}{Return the \code{sumstats_dt} within a named list
(default: \code{TRUE}).}
}
\value{
list containing sumstats_dt, the modified summary statistics data
table object
}
\description{
Three checks are made to infer which allele the effect/frequency information
relates to if they are ambiguous (named A0, A1 and A2 or equivalent):
\enumerate{
\item Check if ambiguous naming conventions are used (i.e. allele 0, 1 and 2 or
equivalent). If not exit, otherwise continue to next checks. This can be
checked by using the mapping file and splitting A1/A2 mappings by those that
contain 0, 1 or 2 (ambiguous) or doesn't contain 0, 1 or 2 e.g. effect,
tested (unambiguous so fine for MSS to handle as is).
\item Look for effect column/frequency column where the A0/A1/A2 explicitly
mentioned, if found then  we know the direction and should update A0/A1/A2
naming so A2 is the effect column. We can look for such columns by getting
every combination of A0/A1/A2 naming and effect/frq naming.
\item If not found in 2, a final check should be against the reference genome,
whichever of A0, A1 and A2 has more of a match with the reference genome
should be taken as \strong{not} the effect allele. There is an assumption in this
but is still better than guessing the ambiguous allele naming.
}
}
\details{
Also, if eff_on_minor_alleles=TRUE, check 3 will be used in all cases.
However, This assumes that the effects are majoritively measured on the
minor alleles and should be used with caution as this is an assumption that
won't be appropriate in all cases. However, the benefit is that if we know
the majority of SNPs have their effects based on the minor alleles, we can
catch cases where the allele columns have been mislabelled. IF
eff_on_minor_alleles=TRUE, checks 1 and 2 will be skipped.
}
\examples{
sumstats <- MungeSumstats::formatted_example()
#for speed, don't run on_ref_genome part of check (on_ref_genome = FALSE)
sumstats_dt2<-infer_effect_column(sumstats_dt=sumstats,on_ref_genome = FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_genome_build.R
\name{get_genome_build}
\alias{get_genome_build}
\title{Infers the genome build of the summary statistics file (GRCh37 or GRCh38)
from the data. Uses SNP (RSID) & CHR & BP to get genome build.}
\usage{
get_genome_build(
  sumstats,
  nThread = 1,
  sampled_snps = 10000,
  standardise_headers = TRUE,
  mapping_file = sumstatsColHeaders,
  dbSNP = 155,
  dbSNP_tarball = NULL,
  header_only = FALSE,
  allele_match_ref = FALSE,
  ref_genome = NULL,
  chr_filt = NULL
)
}
\arguments{
\item{sumstats}{data table/data frame obj of the summary statistics file for
the GWAS ,or file path to summary statistics file.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{sampled_snps}{Downsample the number of SNPs used when inferring genome
build to save time.}

\item{standardise_headers}{Run
\code{standardise_sumstats_column_headers_crossplatform}.}

\item{mapping_file}{\pkg{MungeSumstats} has a pre-defined
column-name mapping file
which should cover the most common column headers and their interpretations.
However, if a column header that is in your file is missing of the mapping we
give is incorrect you can supply your own mapping file. Must be a 2 column
dataframe with column names "Uncorrected" and "Corrected". See
\code{data(sumstatsColHeaders)} for default mapping and necessary format.}

\item{dbSNP}{version of dbSNP to be used (144 or 155). Default is 155.}

\item{dbSNP_tarball}{Pass local versions of dbSNP in tarball format. Default
of NULL uses the dbSNP version passed in \code{dbSNP} parmeter. \code{dbSNP_tarball}
was enabled to help with dbSNP versions >=156, after the decision to no
longer provide dbSNP releases as bioconductor packages. dbSNP 156 tarball is
available here: http://149.165.171.124/SNPlocs/.}

\item{header_only}{Instead of reading in the entire \code{sumstats} file,
only read in the first N rows where N=\code{sampled_snps}.
This should help speed up cases where you have to read in \code{sumstats}
from disk each time.}

\item{allele_match_ref}{Instead of returning the genome_build this will
return the proportion of matches to each genome build for each allele
(A1,A2).}

\item{ref_genome}{name of the reference genome used for the GWAS ("GRCh37" or
"GRCh38"). Argument is case-insensitive. Default is NULL which infers the
reference genome from the data.}

\item{chr_filt}{Internal for testing - filter reference genomes and sumstats
to specific chromosomes for testing. Pass a list of chroms in format:
c("1","2"). Default is NULL i.e. no filtering}
}
\value{
ref_genome the genome build of the data
}
\description{
Infers the genome build of the summary statistics file (GRCh37 or GRCh38)
from the data. Uses SNP (RSID) & CHR & BP to get genome build.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{sumstatsColHeaders}
\alias{sumstatsColHeaders}
\title{Summary Statistics Column Headers}
\format{
dataframe with 2 columns
}
\source{
The code to prepare the .Rda file file from the marker file is:
\code{
# Most the data in the below table comes from the LDSC github wiki
data("sumstatsColHeaders")
# Make additions to sumstatsColHeaders using github version of MungeSumstats-
# Shown is an example of adding new A1 and A2 naming
a1_name <- c("NON","RISK","ALLELE")
a2_name <- c("RISK","ALLELE")
all_delims <- c("_",".",""," ","-")
all_uncorr_a1 <- vector(mode="list",length = length(all_delims))
all_corr_a1 <- vector(mode="list",length = length(all_delims))
all_uncorr_a2 <- vector(mode="list",length = length(all_delims))
all_corr_a2 <- vector(mode="list",length = length(all_delims))
for(i in seq_along(all_delims)){
delim <- all_delims[i]
a1 <- unlist(paste(a1_name,collapse=delim))
a2 <- unlist(paste(a2_name,collapse=delim))
all_uncorr_a1[[i]] <- a1
all_uncorr_a2[[i]] <- a2
all_corr_a1[[i]] <- "A1"
  all_corr_a2[[i]] <- "A2"
}
se_cols <- data.frame("Uncorrected"=c(unlist(all_uncorr_a1),unlist(all_uncorr_a2)),
                     "Corrected"=c(unlist(all_corr_a1),unlist(all_corr_a2)))
# Or another example .....
# shown is an example of adding columns for Standard Error (SE)
se_cols <- data.frame("Uncorrected"=c("SE","se","STANDARD.ERROR",
                                      "STANDARD_ERROR","STANDARD-ERROR"),
                     "Corrected"=rep("SE",5))
sumstatsColHeaders <- rbind(sumstatsColHeaders,se_cols)
#Once additions are made, order & save the new mapping dataset
#now sort ordering -important for logic that 
# uncorrected=corrected comes first
sumstatsColHeaders$ordering <-
    sumstatsColHeaders$Uncorrected==sumstatsColHeaders$Corrected
sumstatsColHeaders <-
    sumstatsColHeaders[order(sumstatsColHeaders$Corrected,
                             sumstatsColHeaders$ordering,decreasing = TRUE),]
rownames(sumstatsColHeaders)<-1:nrow(sumstatsColHeaders)
sumstatsColHeaders$ordering <- NULL
#manually move FREQUENCY to above MAR - github issue 95
frequency <- sumstatsColHeaders[sumstatsColHeaders$Uncorrected=="FREQUENCY",]
maf <- sumstatsColHeaders[sumstatsColHeaders$Uncorrected=="MAF",]
if(as.integer(rownames(frequency))>as.integer(rownames(maf))){
  sumstatsColHeaders[as.integer(rownames(frequency)),] <- maf
  sumstatsColHeaders[as.integer(rownames(maf)),] <- frequency
}   
usethis::use_data(sumstatsColHeaders,overwrite = TRUE, internal=TRUE)
save(sumstatsColHeaders,
      file="data/sumstatsColHeaders.rda")
# You will need to restart your r session for effects to take account
}
}
\usage{
data("sumstatsColHeaders")
}
\description{
List of uncorrected column headers often found in GWAS Summary
Statistics column headers. Note the effect allele will always be the A2
allele, this is the approach done for
VCF(https://www.ncbi.nlm.nih.gov/pmc/articles/PMC7805039/). This is enforced
with the column header corrections here and also the check allele flipping
test.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_col_order.R
\name{check_col_order}
\alias{check_col_order}
\title{Ensure that the first three columns are SNP, CHR, BP in that order and
then A1, A2 if present}
\usage{
check_col_order(sumstats_dt, path)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics file for the GWAS}

\item{path}{Filepath for the summary statistics file to be formatted}
}
\value{
list containing sumstats_dt, the modified summary statistics
data table object
}
\description{
Ensure that the first three columns are SNP, CHR, BP in that order and
then A1, A2 if present
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/messager.R
\name{messager}
\alias{messager}
\title{Print messages}
\usage{
messager(..., v = TRUE)
}
\arguments{
\item{...}{Message input.}

\item{v}{Whether to print messages.}
}
\value{
Null output.
}
\description{
Print messages with option to silence.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_n_int.R
\name{check_n_int}
\alias{check_n_int}
\title{Ensure that the N column is all integers}
\usage{
check_n_int(sumstats_dt, path, convert_n_int, imputation_ind)
}
\arguments{
\item{sumstats_dt}{data table obj of the summary statistics file for the GWAS}

\item{path}{Filepath for the summary statistics file to be formatted}

\item{convert_n_int}{Binary, if N (the number of samples) is not an integer,
should this be rounded? Default is TRUE.}

\item{imputation_ind}{Binary Should a column be added for each imputation
step to show what SNPs have imputed values for differing fields. This
includes a field denoting SNP allele flipping (flipped). \strong{Note}
these columns will be in the formatted summary statistics returned. Default
is FALSE.}
}
\value{
list containing sumstats_dt, the modified summary
statistics data table object.
}
\description{
Ensure that the N column is all integers
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_genome_builds.R
\name{get_genome_builds}
\alias{get_genome_builds}
\title{Infer genome builds}
\usage{
get_genome_builds(
  sumstats_list,
  header_only = TRUE,
  sampled_snps = 10000,
  names_from_paths = FALSE,
  dbSNP = 155,
  dbSNP_tarball = NULL,
  nThread = 1,
  chr_filt = NULL
)
}
\arguments{
\item{sumstats_list}{A named list of paths to summary statistics,
or a named list of \code{data.table} objects.}

\item{header_only}{Instead of reading in the entire \code{sumstats} file,
only read in the first N rows where N=\code{sampled_snps}.
This should help speed up cases where you have to read in \code{sumstats}
from disk each time.}

\item{sampled_snps}{Downsample the number of SNPs used when inferring genome
build to save time.}

\item{names_from_paths}{Infer the name of each item in \code{sumstats_list}
from its respective file path.
Only works if \code{sumstats_list} is a list of paths.}

\item{dbSNP}{version of dbSNP to be used (144 or 155). Default is 155.}

\item{dbSNP_tarball}{Pass local versions of dbSNP in tarball format. Default
of NULL uses the dbSNP version passed in \code{dbSNP} parmeter. \code{dbSNP_tarball}
was enabled to help with dbSNP versions >=156, after the decision to no
longer provide dbSNP releases as bioconductor packages. dbSNP 156 tarball is
available here: http://149.165.171.124/SNPlocs/.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{chr_filt}{Internal for testing - filter reference genomes and sumstats
to specific chromosomes for testing. Pass a list of chroms in format:
c("1","2"). Default is NULL i.e. no filtering}
}
\value{
ref_genome the genome build of the data
}
\description{
Infers the genome build of  summary statistics files (GRCh37 or GRCh38)
from the data. Uses SNP (RSID) & CHR & BP to get genome build.
}
\details{
Iterative version of \code{get_genome_build}.
}
\examples{
# Pass path to Educational Attainment Okbay sumstat file to a temp directory

eduAttainOkbayPth <- system.file("extdata", "eduAttainOkbay.txt",
    package = "MungeSumstats"
)
sumstats_list <- list(ss1 = eduAttainOkbayPth, ss2 = eduAttainOkbayPth)

## Call uses reference genome as default with more than 2GB of memory,
## which is more than what 32-bit Windows can handle so remove certain checks
is_32bit_windows <-
    .Platform$OS.type == "windows" && .Platform$r_arch == "i386"
if (!is_32bit_windows) {
    
    #multiple sumstats can be passed at once to get all their genome builds:
    #ref_genomes <- get_genome_builds(sumstats_list = sumstats_list)
    #just passing first here for speed
    sumstats_list_quick <- list(ss1 = eduAttainOkbayPth)
    ref_genomes <- get_genome_builds(sumstats_list = sumstats_list_quick,
                                     dbSNP=144)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_chain_file.R
\name{get_chain_file}
\alias{get_chain_file}
\title{Download chain file for liftover}
\source{
\href{https://hgdownload.cse.ucsc.edu/goldenpath/hg19/liftOver/}{
UCSC chain files}

\href{https://ftp.ensembl.org/pub/assembly_mapping/homo_sapiens/}{
Ensembl chain files}
}
\usage{
get_chain_file(
  from = c("hg38", "hg19"),
  to = c("hg19", "hg38"),
  chain_source = c("ucsc", "ensembl"),
  save_dir = tempdir(),
  verbose = TRUE
)
}
\arguments{
\item{from}{genome build converted from ("hg38", "hg19")}

\item{to}{genome build converted to ("hg19", "hg38")}

\item{chain_source}{chain file source used ("ucsc" as default, or "ensembl")}

\item{save_dir}{where is the chain file saved? Default is a temp directory}

\item{verbose}{extra messages printed? Default is TRUE}
}
\value{
loaded chain file for liftover
}
\description{
Download chain file for liftover
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_frq_maf.R
\name{check_frq_maf}
\alias{check_frq_maf}
\title{Check that FRQ column refers to minor/effect allele frequency not major}
\usage{
check_frq_maf(sumstats_dt, frq_is_maf)
}
\arguments{
\item{frq_is_maf}{Conventionally the FRQ column is intended to show the
minor/effect allele frequency (MAF) but sometimes the major allele frequency
can be inferred as the FRQ column. This logical variable indicates that the
FRQ column should be renamed to MAJOR_ALLELE_FRQ if the frequency values
appear to relate to the major allele i.e. >0.5. By default this mapping won't
occur i.e. is TRUE.}
}
\value{
sumstats_dt, the modified summary statistics data table object
}
\description{
Check that FRQ column refers to minor/effect allele frequency not major
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/register_cores.R
\name{register_cores}
\alias{register_cores}
\title{Register cores}
\usage{
register_cores(workers = 1, progressbar = TRUE)
}
\arguments{
\item{workers}{

    \code{integer(1)} Number of workers. Defaults to the maximum of 1 or
    the number of cores determined by \code{detectCores} minus 2 unless
    environment variables \code{R_PARALLELLY_AVAILABLECORES_FALLBACK} or
    \code{BIOCPARALLEL_WORKER_NUMBER} are set otherwise. For a
    \code{SOCK} cluster, \code{workers} can be a \code{character()}
    vector of host names.

  }

\item{progressbar}{
    \code{logical(1)} Enable progress bar (based on plyr:::progress_text).
  }
}
\value{
Null output.
}
\description{
Register a multi-threaded instances using \pkg{BiocParallel}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/import_sumstats.R
\name{import_sumstats}
\alias{import_sumstats}
\title{Import full genome-wide GWAS summary statistics from Open GWAS}
\usage{
import_sumstats(
  ids,
  vcf_dir = tempdir(),
  vcf_download = TRUE,
  save_dir = tempdir(),
  write_vcf = FALSE,
  download_method = "download.file",
  quiet = TRUE,
  force_new = FALSE,
  force_new_vcf = FALSE,
  nThread = 1,
  parallel_across_ids = FALSE,
  ...
)
}
\arguments{
\item{ids}{List of Open GWAS study IDs
(e.g. \code{c("prot-a-664", "ieu-b-4760")}).}

\item{vcf_dir}{Where to download the original VCF from Open GWAS.
\emph{WARNING:} This is set to \code{tempdir()} by default.
This means the raw (pre-formatted) VCFs be deleted upon ending the R session.
Change this to keep the raw VCF file on disk
(e.g. \code{vcf_dir="./raw_vcf"}).}

\item{vcf_download}{Download the original VCF from Open GWAS.}

\item{save_dir}{Directory to save formatted summary statistics in.}

\item{write_vcf}{Whether to write as VCF (TRUE) or tabular file (FALSE).}

\item{download_method}{\code{"axel"} (multi-threaded) or
\code{"download.file"} (single-threaded) .}

\item{quiet}{Run quietly.}

\item{force_new}{If a formatted file of the same names as \code{save_path}
exists, formatting will be skipped and this file will be imported instead
(default). Set \code{force_new=TRUE} to override this.}

\item{force_new_vcf}{Overwrite a previously downloaded VCF
with the same path name.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{parallel_across_ids}{If \code{parallel_across_ids=TRUE}
and \code{nThread>1},
then each ID in \code{ids} will be processed in parallel.}

\item{...}{
  Arguments passed on to \code{\link[=format_sumstats]{format_sumstats}}
  \describe{
    \item{\code{path}}{Filepath for the summary statistics file to be formatted. A
dataframe or datatable of the summary statistics file can also be passed
directly to MungeSumstats using the path parameter.}
    \item{\code{ref_genome}}{name of the reference genome used for the GWAS ("GRCh37" or
"GRCh38"). Argument is case-insensitive. Default is NULL which infers the
reference genome from the data.}
    \item{\code{convert_ref_genome}}{name of the reference genome to convert to
("GRCh37" or "GRCh38"). This will only occur if the current genome build does
not match. Default is not to convert the genome build (NULL).}
    \item{\code{chain_source}}{source of the chain file to use in liftover, if converting
genome build ("ucsc" or "ensembl"). Note that the UCSC chain files require a
license for commercial use. The Ensembl chain is used by default ("ensembl").}
    \item{\code{local_chain}}{Path to local chain file to use instead of downlaoding.
Default of NULL i.e. no local file to use. NOTE if passing a local chain file
make sure to specify the path to convert from and to the correct build like
GRCh37 to GRCh38. We can not sense check this for local files. The chain file
can be submitted as a gz file (as downloaed from source) or unzipped.}
    \item{\code{convert_small_p}}{Binary, should non-negative
p-values <= 5e-324 be converted to 0?
Small p-values pass the R limit and can cause errors with LDSC/MAGMA and
should be converted. Default is TRUE.}
    \item{\code{convert_large_p}}{Binary, should p-values >1 be converted to 1?
P-values >1 should not be possible and can cause errors with LDSC/MAGMA and
should be converted. Default is TRUE.}
    \item{\code{convert_neg_p}}{Binary, should p-values <0 be converted to 0?
Negative p-values should not be possible and can cause errors
with LDSC/MAGMA and should be converted. Default is TRUE.}
    \item{\code{compute_z}}{Whether to compute Z-score column. Default is FALSE. This
can be computed from Beta and SE with (Beta/SE) or P
(Z:=sign(BETA)*sqrt(stats::qchisq(P,1,lower=FALSE))).
\strong{Note} that imputing the Z-score from P for every SNP will not be
perfectly correct and may result in a loss of power. This should only be done
as a last resort. Use 'BETA' to impute by BETA/SE and 'P' to impute by SNP
p-value.}
    \item{\code{force_new_z}}{When a "Z" column already exists, it will be used by
default. To override and compute a new Z-score column from P set
\code{force_new_z=TRUE}.}
    \item{\code{compute_n}}{Whether to impute N. Default of 0 won't impute, any other
integer will be imputed as the N (sample size) for every SNP in the dataset.
\strong{Note} that imputing the sample size for every SNP is not correct and
should only be done as a last resort. N can also be inputted with "ldsc",
"sum", "giant" or "metal" by passing one of these for this field or a vector
of multiple. Sum and an integer value creates an N column in the output
whereas giant, metal or ldsc create an Neff or effective sample size. If
multiples are passed, the formula used to derive it will be indicated.}
    \item{\code{convert_n_int}}{Binary, if N (the number of samples) is not an integer,
should this be rounded? Default is TRUE.}
    \item{\code{impute_beta}}{Binary, whether BETA should be imputed using other effect
data if it isn't present in the sumstats. Note that this imputation is an
approximation (for Z & SE approach) so could have an effect on downstream
analysis. Use with caution. The different methods MungeSumstats will try and
impute beta (in this order or priority) are:
\enumerate{
\item log(OR)  2. Z x SE
Default value is FALSE.
}}
    \item{\code{es_is_beta}}{Binary, whether to map ES to BETA. We take BETA to be any
BETA-like value (including Effect Size). If this is not the case for your
sumstats, change this to FALSE. Default is TRUE.}
    \item{\code{impute_se}}{Binary, whether the standard error should be imputed using
other effect data if it isn't present in the sumstats. Note that this
imputation is an approximation so could have an effect on downstream
analysis. Use with caution. The different methods MungeSumstats will try and
impute se (in this order or priority) are:
\enumerate{
\item BETA / Z  2. abs(BETA/ qnorm(P/2))
Default is FALSE.
}}
    \item{\code{analysis_trait}}{If multiple traits were studied, name of the trait for
analysis from the GWAS. Default is NULL.}
    \item{\code{ignore_multi_trait}}{If you have multiple traits (p-values) in the study
but you want to ignorwe these and instead use a standard named p-value, set
to TRUE. By default is FALSE which will check for multi-traits.}
    \item{\code{INFO_filter}}{numeric The minimum value permissible of the imputation
information score (if present in sumstats file). Default 0.9.}
    \item{\code{FRQ_filter}}{numeric The minimum value permissible of the frequency(FRQ)
of the SNP (i.e. Allele Frequency (AF)) (if present in sumstats file). By
default no filtering is done, i.e. value of 0.}
    \item{\code{pos_se}}{Binary Should the standard Error (SE) column be checked to
ensure it is greater than 0? Those that are, are removed (if present in
sumstats file). Default TRUE.}
    \item{\code{effect_columns_nonzero}}{Binary should the effect columns in the data
BETA,OR (odds ratio),LOG_ODDS,SIGNED_SUMSTAT be checked to ensure no SNP=0.
Those that do are removed(if present in sumstats file). Default FALSE.}
    \item{\code{N_std}}{numeric The number of standard deviations above the mean a SNP's
N is needed to be removed. Default is 5.}
    \item{\code{N_dropNA}}{Drop rows where N is missing.Default is TRUE.}
    \item{\code{chr_style}}{Chromosome naming style to use in the formatted summary
statistics file ("NCBI", "UCSC", "dbSNP", or "Ensembl"). The NCBI and
Ensembl styles both code chromosomes as \verb{1-22, X, Y, MT}; the UCSC style is
\verb{chr1-chr22, chrX, chrY, chrM}; and the dbSNP style is
\verb{ch1-ch22, chX, chY, chMT}. Default is Ensembl.}
    \item{\code{rmv_chrPrefix}}{Is now deprecated, do. not use. Use chr_style instead -
chr_style = 'Ensembl' will give the same result as rmv_chrPrefix=TRUE used to
give.}
    \item{\code{rmv_chr}}{Chromosomes to exclude from the formatted summary statistics
file. Use NULL if no filtering is necessary. Default is \code{c("X", "Y", "MT")}
which removes all non-autosomal SNPs.}
    \item{\code{on_ref_genome}}{Binary Should a check take place that all SNPs are on
the reference genome by SNP ID. Default is TRUE.}
    \item{\code{infer_eff_direction}}{Binary Should a check take place to ensure the
alleles match the effect direction? Default is TRUE.}
    \item{\code{eff_on_minor_alleles}}{Binary Should MungeSumstats assume that the
effects are majoritively measured on the minor alleles? Default is FALSE as
this is an assumption that won't be appropriate in all cases. However, the
benefit is that if we know the majority of SNPs have their effects based on
the minor alleles, we can catch cases where the allele columns have been
mislabelled.}
    \item{\code{strand_ambig_filter}}{Binary Should SNPs with strand-ambiguous alleles
be removed. Default is FALSE.}
    \item{\code{allele_flip_check}}{Binary Should the allele columns be checked against
reference genome to infer if flipping is necessary. Default is TRUE.}
    \item{\code{allele_flip_drop}}{Binary Should the SNPs for which neither their A1 or
A2 base pair values match a reference genome be dropped. Default is TRUE.}
    \item{\code{allele_flip_z}}{Binary should the Z-score be flipped along with effect
and FRQ columns like Beta? It is assumed to be calculated off the effect size
not the P-value and so will be flipped i.e. default TRUE.}
    \item{\code{allele_flip_frq}}{Binary should the frequency (FRQ) column be flipped
along with effect and z-score columns like Beta? Default TRUE.}
    \item{\code{bi_allelic_filter}}{Binary Should non-bi-allelic SNPs be removed.
Default is TRUE.}
    \item{\code{flip_frq_as_biallelic}}{Binary Should non-bi-allelic SNPs frequency
values be flipped as 1-p despite there being other alternative alleles?
Default is FALSE but if set to TRUE, this allows non-bi-allelic SNPs to be
kept despite needing flipping.}
    \item{\code{snp_ids_are_rs_ids}}{Binary Should the supplied SNP ID's be assumed to
be RSIDs. If not, imputation using the SNP ID for other columns like
base-pair position or chromosome will not be possible. If set to FALSE, the
SNP RS ID will be imputed from the reference genome if possible. Default is
TRUE.}
    \item{\code{remove_multi_rs_snp}}{Binary Sometimes summary statistics can have
multiple RSIDs on one row (i.e. related to one SNP), for example
"rs5772025_rs397784053". This can cause an error so by default, the first
RS ID will be kept and the rest removed e.g."rs5772025". If you want to just
remove these SNPs entirely, set it to TRUE. Default is FALSE.}
    \item{\code{frq_is_maf}}{Conventionally the FRQ column is intended to show the
minor/effect allele frequency (MAF) but sometimes the major allele frequency
can be inferred as the FRQ column. This logical variable indicates that the
FRQ column should be renamed to MAJOR_ALLELE_FRQ if the frequency values
appear to relate to the major allele i.e. >0.5. By default this mapping won't
occur i.e. is TRUE.}
    \item{\code{indels}}{Binary does your Sumstats file contain Indels? These don't
exist in our reference file so they will be excluded from checks if this
value is TRUE. Default is TRUE.}
    \item{\code{drop_indels}}{Binary, should any indels found in the sumstats be
dropped? These can not be checked against a reference dataset and will have
the same RS ID and position as SNPs which can affect downstream analysis.
Default is False.}
    \item{\code{drop_na_cols}}{A character vector of column names to be checked for
missing values. Rows with missing values in any of these columns (if present
in the dataset) will be dropped. If \code{NULL}, all columns will be checked for
missing values. Default columns are SNP, chromosome, position, allele 1,
allele2, effect columns (frequency, beta, Z-score, standard error, log odds,
signed sumstats, odds ratio), p value and N columns.}
    \item{\code{dbSNP}}{version of dbSNP to be used for imputation (144 or 155). See
\code{dbSNP_tarball} for different versions of dbSNP (including newer releases).}
    \item{\code{dbSNP_tarball}}{Pass local versions of dbSNP in tarball format. Default
of NULL uses the dbSNP version passed in \code{dbSNP} parmeter. \code{dbSNP_tarball}
was enabled to help with dbSNP versions >=156, after the decision to no
longer provide dbSNP releases as bioconductor packages. dbSNP 156 tarball is
available here: http://149.165.171.124/SNPlocs/.}
    \item{\code{check_dups}}{whether to check for duplicates - if formatting QTL
datasets this should be set to FALSE otherwise keep as TRUE. Default is TRUE.}
    \item{\code{sort_coordinates}}{Whether to sort by coordinates of resulting sumstats}
    \item{\code{save_path}}{File path to save formatted data. Defaults to
\code{tempfile(fileext=".tsv.gz")}.}
    \item{\code{tabix_index}}{Index the formatted summary statistics with
\href{http://www.htslib.org/doc/tabix.html}{tabix} for fast querying.}
    \item{\code{return_data}}{Return \code{data.table}, \code{GRanges} or \code{VRanges}
directly to user. Otherwise, return the path to the save data. Default is
FALSE.}
    \item{\code{return_format}}{If return_data is TRUE. Object type to be returned
("data.table","vranges","granges").}
    \item{\code{ldsc_format}}{DEPRECATED, do not use. Use save_format="LDSC" instead.}
    \item{\code{save_format}}{Output format of sumstats. Options are NULL - standardised
output format from MungeSumstats, LDSC - output format compatible with LDSC
and openGWAS - output compatible with openGWAS VCFs. Default is NULL.
\strong{NOTE} - If LDSC format is used, the naming convention of A1 as the
reference (genome build) allele and A2 as the effect allele will be reversed
to match LDSC (A1 will now be the effect allele). See more info on this
\href{https://groups.google.com/g/ldsc_users/c/S7FZK743w68}{here}. Note that any
effect columns (e.g. Z) will be inrelation to A1 now instead of A2.}
    \item{\code{log_folder_ind}}{Binary Should log files be stored containing all
filtered out SNPs (separate file per filter). The data is outputted in the
same format specified for the resulting sumstats file. The only exception to
this rule is if output is vcf, then log file saved as .tsv.gz. Default is
FALSE.}
    \item{\code{log_mungesumstats_msgs}}{Binary Should a log be stored containing all
messages and errors printed by MungeSumstats in a run. Default is FALSE}
    \item{\code{log_folder}}{Filepath to the directory for the log files and the log of
MungeSumstats messages to be stored. Default is a temporary directory. Note
the name of the log files (log messages and log outputs) are now the same as
the name of the file specified in the save path parameter with the extension
'_log_msg.txt' and '_log_output.txt' respectively.}
    \item{\code{imputation_ind}}{Binary Should a column be added for each imputation
step to show what SNPs have imputed values for differing fields. This
includes a field denoting SNP allele flipping (flipped). On the flipped
value, this denoted whether the alelles where switched based on
MungeSumstats initial choice of A1, A2 from the input column headers and thus
may not align with what the creator intended.\strong{Note} these columns will be
in the formatted summary statistics returned. Default is FALSE.}
    \item{\code{mapping_file}}{MungeSumstats has a pre-defined column-name mapping file
which should cover the most common column headers and their interpretations.
However, if a column header that is in youf file is missing of the mapping we
give is incorrect you can supply your own mapping file. Must be a 2 column
dataframe with column names "Uncorrected" and "Corrected". See
data(sumstatsColHeaders) for default mapping and necessary format.}
  }}
}
\value{
Either a named list of data objects or paths,
depending on the arguments passed to \code{format_sumstats}.
}
\description{
Requires internet access to run.
}
\examples{
#only run the examples if user has internet access:
if(try(is.character(getURL("www.google.com")))==TRUE){
### Search by criteria
metagwas <- find_sumstats(
    traits = c("parkinson", "alzheimer"),
    min_sample_size = 5000
)
### Only use a subset for testing purposes
ids <- (dplyr::arrange(metagwas, nsnp))$id

### Default usage
## You can supply \code{import_sumstats()}
## with a list of as many OpenGWAS IDs as you want,
## but we'll just give one to save time.

## Call uses reference genome as default with more than 2GB of memory,
## which is more than what 32-bit Windows can handle so remove certain checks
## commented out down to runtime
# datasets <- import_sumstats(ids = ids[1])
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_tabular.R
\name{check_tabular}
\alias{check_tabular}
\title{Ensure valid tabular format}
\usage{
check_tabular(header)
}
\arguments{
\item{header}{The summary statistics file for the GWAS}
}
\value{
Whether the file is tabular
}
\description{
Ensure valid tabular format
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_sumstats.R
\name{read_sumstats}
\alias{read_sumstats}
\title{Determine summary statistics file type and read them into memory}
\usage{
read_sumstats(
  path,
  nrows = Inf,
  standardise_headers = FALSE,
  samples = 1,
  sampled_rows = 10000L,
  nThread = 1,
  mapping_file = sumstatsColHeaders
)
}
\arguments{
\item{path}{Filepath for the summary statistics file to be formatted. A
dataframe or datatable of the summary statistics file can also be passed
directly to MungeSumstats using the path parameter.}

\item{nrows}{integer. The (maximal) number of lines to read.
If \code{Inf}, will read in all rows.}

\item{standardise_headers}{Standardise headers first.}

\item{samples}{Which samples to use:
\itemize{
\item{1 : }{Only the first sample will be used (\emph{DEFAULT}).}
\item{NULL : }{All samples will be used.}
\item{c("<sample_id1>","<sample_id2>",...) : }{
Only user-selected samples will be used (case-insensitive).}
}}

\item{sampled_rows}{First N rows to sample.
Set \code{NULL} to use full \code{sumstats_file}.
when determining whether cols are empty.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{mapping_file}{MungeSumstats has a pre-defined column-name mapping file
which should cover the most common column headers and their interpretations.
However, if a column header that is in youf file is missing of the mapping we
give is incorrect you can supply your own mapping file. Must be a 2 column
dataframe with column names "Uncorrected" and "Corrected". See
data(sumstatsColHeaders) for default mapping and necessary format.}
}
\value{
\code{data.table} of formatted summary statistics
}
\description{
Determine summary statistics file type and read them into memory
}
\examples{
path <- system.file("extdata", "eduAttainOkbay.txt",
    package = "MungeSumstats"
)
eduAttainOkbay <- read_sumstats(path = path)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sort_coords.R
\name{sort_coords}
\alias{sort_coords}
\title{Sort sum stats}
\usage{
sort_coords(
  sumstats_dt,
  sort_coordinates = TRUE,
  sort_method = c("data.table", "GenomicRanges")
)
}
\arguments{
\item{sumstats_dt}{\link[data.table]{data.table} obj of the
summary statistics file for the GWAS.}

\item{sort_method}{Method to sort coordinates by:
\itemize{
\item{"data.table" (default)}{Uses \link[data.table]{setorderv},
which is must faster than "GenomicRanges"
but less robust to variations in some sum stats files.}
\item{"GenomicRanges"}{Uses \link[GenomicRanges]{sort.GenomicRanges},
which is more robust to variations in sum stats files
but much slower than the "data.table" method.}
}}

\item{sort_coords}{Whether to sort by coordinates.}
}
\value{
Sorted sumstats_dt
}
\description{
Sort summary statistics table by genomic coordinates.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_eff_frq_allele_combns.R
\name{get_eff_frq_allele_combns}
\alias{get_eff_frq_allele_combns}
\title{Get combinations of uncorrected allele and effect (and frq) columns}
\usage{
get_eff_frq_allele_combns(
  mapping_file = sumstatsColHeaders,
  eff_frq_cols = c("BETA", "OR", "LOG_ODDS", "SIGNED_SUMSTAT", "Z", "FRQ")
)
}
\arguments{
\item{mapping_file}{MungeSumstats has a pre-defined column-name mapping file
which should cover the most common column headers and their interpretations.
However, if a column header that is in youf file is missing of the mapping we
give is incorrect you can supply your own mapping file. Must be a 2 column
dataframe with column names "Uncorrected" and "Corrected". See
data(sumstatsColHeaders) for default mapping and necessary format.}

\item{eff_frq_cols}{Corrected effect or frequency column names found in a
sumstats. Default of BETA, OR, LOG_ODDS, SIGNED_SUMSTAT, Z and FRQ.}
}
\value{
datatable containing uncorrected and corrected combinations
}
\description{
Get combinations of uncorrected allele and effect (and frq) columns
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_info_score.R
\name{check_info_score}
\alias{check_info_score}
\title{Ensure all SNPs have info score above threshold}
\usage{
check_info_score(
  sumstats_dt,
  INFO_filter,
  log_folder_ind,
  check_save_out,
  tabix_index,
  nThread,
  log_files
)
}
\arguments{
\item{INFO_filter}{numeric The minimum value permissible of the imputation
information score (if present in sumstats file). Default 0.9.}

\item{log_folder_ind}{Binary Should log files be stored containing all
filtered out SNPs (separate file per filter). The data is outputted in the
same format specified for the resulting sumstats file. The only exception to
this rule is if output is vcf, then log file saved as .tsv.gz. Default is
FALSE.}

\item{tabix_index}{Index the formatted summary statistics with
\href{http://www.htslib.org/doc/tabix.html}{tabix} for fast querying.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{log_files}{list of log file locations.}
}
\value{
list containing sumstats_dt, the modified summary statistics data
table object and the log file list
}
\description{
Ensure all SNPs have info score above threshold
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_pos_se.R
\name{check_pos_se}
\alias{check_pos_se}
\title{Ensure that the standard error (se) is positive for all SNPs
Also impute se if missing}
\usage{
check_pos_se(
  sumstats_dt,
  path,
  pos_se,
  log_folder_ind,
  imputation_ind,
  check_save_out,
  tabix_index,
  nThread,
  log_files,
  impute_se
)
}
\arguments{
\item{path}{Filepath for the summary statistics file to be formatted. A
dataframe or datatable of the summary statistics file can also be passed
directly to MungeSumstats using the path parameter.}

\item{pos_se}{Binary Should the standard Error (SE) column be checked to
ensure it is greater than 0? Those that are, are removed (if present in
sumstats file). Default TRUE.}

\item{log_folder_ind}{Binary Should log files be stored containing all
filtered out SNPs (separate file per filter). The data is outputted in the
same format specified for the resulting sumstats file. The only exception to
this rule is if output is vcf, then log file saved as .tsv.gz. Default is
FALSE.}

\item{imputation_ind}{Binary Should a column be added for each imputation
step to show what SNPs have imputed values for differing fields. This
includes a field denoting SNP allele flipping (flipped). On the flipped
value, this denoted whether the alelles where switched based on
MungeSumstats initial choice of A1, A2 from the input column headers and thus
may not align with what the creator intended.\strong{Note} these columns will be
in the formatted summary statistics returned. Default is FALSE.}

\item{tabix_index}{Index the formatted summary statistics with
\href{http://www.htslib.org/doc/tabix.html}{tabix} for fast querying.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{log_files}{list of log file locations}

\item{impute_se}{Binary, whether the standard error should be imputed using
other effect data if it isn't present in the sumstats. Note that this
imputation is an approximation so could have an effect on downstream
analysis. Use with caution. The different methods MungeSumstats will try and
impute se (in this order or priority) are:
\enumerate{
\item BETA / Z  2. abs(BETA/ qnorm(P/2))
Default is FALSE.
}}
}
\value{
list containing sumstats_dt, the modified summary statistics data
table object and the log file list
}
\description{
Ensure that the standard error (se) is positive for all SNPs
Also impute se if missing
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/list_sumstats.R
\name{list_sumstats}
\alias{list_sumstats}
\title{List munged summary statistics}
\usage{
list_sumstats(
  save_dir = getwd(),
  pattern = "*.tsv.gz$",
  ids_from_file = TRUE,
  verbose = TRUE
)
}
\arguments{
\item{save_dir}{Top-level directory to recursively search
for summary statistics files within.}

\item{pattern}{Regex pattern to search for files with.}

\item{ids_from_file}{Try to extract dataset IDs from file names.
If \code{FALSE}, will infer IDs from the directory names instead.}

\item{verbose}{Print messages.}
}
\value{
Named vector of summary stats paths.
}
\description{
Searches for and lists local GWAS summary statistics files munged by
\link[MungeSumstats]{format_sumstats} or
\link[MungeSumstats]{import_sumstats}.
}
\examples{
save_dir <- system.file("extdata",package = "MungeSumstats")
munged_files <- MungeSumstats::list_sumstats(save_dir = save_dir)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_vcf_parallel.R
\name{read_vcf_parallel}
\alias{read_vcf_parallel}
\title{Read VCF: parallel}
\source{
\code{
path <- "https://gwas.mrcieu.ac.uk/files/ieu-a-298/ieu-a-298.vcf.gz"
#### Single-threaded ####
vcf <- MungeSumstats:::read_vcf_parallel(path = path)
#### Parallel ####
vcf2 <- MungeSumstats:::read_vcf_parallel(path = path, nThread=11)
}
}
\usage{
read_vcf_parallel(
  path,
  samples = 1,
  which = NULL,
  use_params = TRUE,
  as_datatable = TRUE,
  sampled_rows = 10000L,
  include_xy = FALSE,
  download = TRUE,
  vcf_dir = tempdir(),
  download_method = "download.file",
  force_new = FALSE,
  tilewidth = NULL,
  mt_thresh = 100000L,
  nThread = 1,
  ntile = nThread,
  verbose = TRUE
)
}
\arguments{
\item{path}{Path to local or remote VCF file.}

\item{samples}{Which samples to use:
\itemize{
\item{1 : }{Only the first sample will be used (\emph{DEFAULT}).}
\item{NULL : }{All samples will be used.}
\item{c("<sample_id1>","<sample_id2>",...) : }{
Only user-selected samples will be used (case-insensitive).}
}}

\item{which}{Genomic ranges to be added if supplied. Default is NULL.}

\item{use_params}{When \code{TRUE} (default), increases the speed of reading in the VCF by
omitting columns that are empty based on the head of the VCF (NAs only).
NOTE that that this requires the VCF to be sorted, bgzip-compressed,
tabix-indexed, which \link[MungeSumstats]{read_vcf} will attempt to do.}

\item{as_datatable}{Return the data as a
\link[data.table]{data.table} (default: \code{TRUE})
or a \link[VariantAnnotation]{VCF} (\code{FALSE}).}

\item{sampled_rows}{First N rows to sample.
Set \code{NULL} to use full \code{sumstats_file}.
when determining whether cols are empty.}

\item{download}{Download the VCF (and its index file)
to a temp folder before reading it into R.
This is important to keep \code{TRUE} when \code{nThread>1} to avoid
making too many queries to remote file.}

\item{vcf_dir}{Where to download the original VCF from Open GWAS.
\emph{WARNING:} This is set to \code{tempdir()} by default.
This means the raw (pre-formatted) VCFs be deleted upon ending the R session.
Change this to keep the raw VCF file on disk
(e.g. \code{vcf_dir="./raw_vcf"}).}

\item{download_method}{\code{"axel"} (multi-threaded) or
\code{"download.file"} (single-threaded) .}

\item{force_new}{If a formatted file of the same names as \code{save_path}
exists, formatting will be skipped and this file will be imported instead
(default). Set \code{force_new=TRUE} to override this.}

\item{tilewidth}{
    The desired tile width. The effective tile width might be slightly
    different but is guaranteed to never be more than the desired width.
  }

\item{mt_thresh}{When the number of rows (variants) in the VCF is
\code{< mt_thresh}, only use single-threading for reading in the VCF.
This is because the overhead of parallelisation outweighs the speed benefits
when VCFs are small.}

\item{nThread}{Number of threads to use for parallel processes.}

\item{ntile}{
    The number of tiles to generate.
  }

\item{verbose}{Print messages.}
}
\value{
VCF file.
}
\description{
Read a VCF file across 1 or more threads in parallel.
If \code{tilewidth} is not specified, the size of each chunk will be
determined by total genome size divided by \code{ntile}.
By default, \code{ntile} is equal to the number of threads, \code{nThread}.
For further discussion on how this function was optimised,
see
\href{https://github.com/Bioconductor/VariantAnnotation/issues/59}{here}
and
\href{https://github.com/Bioconductor/VariantAnnotation/issues/57}{here}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/downloader.R
\name{downloader}
\alias{downloader}
\title{downloader wrapper}
\source{
\href{https://stackoverflow.com/a/66602496/13214824}{
Suggestion to avoid 'proc$get_built_file() : Build process failed'}
}
\usage{
downloader(
  input_url,
  output_path,
  download_method = "axel",
  background = FALSE,
  force_overwrite = FALSE,
  quiet = TRUE,
  show_progress = TRUE,
  continue = TRUE,
  nThread = 1,
  alternate = TRUE,
  check_certificates = TRUE,
  timeout = 10 * 60
)
}
\arguments{
\item{input_url}{input_url.}

\item{output_path}{output_path.}

\item{download_method}{\code{"axel"} (multi-threaded) or
\code{"download.file"} (single-threaded) .}

\item{background}{Run in background}

\item{force_overwrite}{Overwrite existing file.}

\item{quiet}{Run quietly.}

\item{show_progress}{show_progress.}

\item{continue}{continue.}

\item{nThread}{Number of threads to parallelize over.}

\item{alternate}{alternate,}

\item{check_certificates}{check_certificates}

\item{timeout}{How many seconds before giving up on download.
Passed to \code{download.file}. Default: \code{10*60} (10min).}
}
\value{
Local path to downloaded file.
}
\description{
R wrapper for
\href{https://github.com/axel-download-accelerator/axel}{axel}
(multi-threaded) and
\link[utils]{download.file} (single-threaded)
download functions.
}
\seealso{
Other downloaders: 
\code{\link{axel}()}
}
\concept{downloaders}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/find_sumstats.R
\name{find_sumstats}
\alias{find_sumstats}
\title{Search Open GWAS for datasets matching criteria}
\usage{
find_sumstats(
  ids = NULL,
  traits = NULL,
  years = NULL,
  consortia = NULL,
  authors = NULL,
  populations = NULL,
  categories = NULL,
  subcategories = NULL,
  builds = NULL,
  pmids = NULL,
  min_sample_size = NULL,
  min_ncase = NULL,
  min_ncontrol = NULL,
  min_nsnp = NULL,
  include_NAs = FALSE
)
}
\arguments{
\item{ids}{List of Open GWAS study IDs
(e.g. \code{c("prot-a-664", "ieu-b-4760")}).}

\item{traits}{List of traits
(e.g. \code{c("parkinson", "Alzheimer")}).}

\item{years}{List of years
(e.g. \code{seq(2015,2021)} or \code{c(2010, 2012, 2021)}).}

\item{consortia}{List of consortia
(e.g. \code{c("MRC-IEU","Neale Lab")}.}

\item{authors}{List of authors
(e.g. \code{c("Elsworth","Kunkle","Neale")}).}

\item{populations}{List of populations
(e.g. \code{c("European","Asian")}).}

\item{categories}{List of categories
(e.g. \code{c("Binary","Continuous","Disease","Risk factor"))}).}

\item{subcategories}{List of categories
(e.g. \code{c("neurological","Immune","cardio"))}).}

\item{builds}{List of genome builds
(e.g. \code{c("hg19","grch37")}).}

\item{pmids}{List of PubMed ID (exact matches only)
(e.g. \code{c(29875488, 30305740, 28240269)}).}

\item{min_sample_size}{Minimum total number of study participants
(e.g. \code{5000}).}

\item{min_ncase}{Minimum number of case participants
(e.g. \code{1000}).}

\item{min_ncontrol}{Minimum number of control participants
(e.g. \code{1000}).}

\item{min_nsnp}{Minimum number of SNPs
(e.g. \code{200000}).}

\item{include_NAs}{Include datasets with missing metadata for size criteria
(i.e. \code{min_sample_size}, \code{min_ncase}, or \code{min_ncontrol}).}
}
\value{
(Filtered) GWAS metadata table.
}
\description{
For each  argument, searches for any datasets matching
a case-insensitive substring search in the respective metadata column.
Users can supply a single character string or a
list/vector of character strings.
}
\details{
To authenticate, you need to generate a token from the OpenGWAS website. The
token behaves like a password, and it will be used to authorise the requests
you make to the OpenGWAS API. Here are the steps to generate the token and
then have \code{ieugwasr} automatically use it for your queries:
\enumerate{
\item Login to https://api.opengwas.io/profile/
\item Generate a new token
\item Add \verb{OPENGWAS_JWT=<token>} to your .Renviron file, thi can be edited in R
by running \code{usethis::edit_r_environ()}
\item Restart your R session
\item To check that your token is being recognised, run
\code{ieugwasr::get_opengwas_jwt()}. If it returns a long random string then you
are authenticated.
\item To check that your token is working, run \code{ieugwasr::user()}. It will make a
a request to the API for your user information using your token. It should
return a list with your user information. If it returns an error, then your
token is not working.
\item Make sure you have submitted use
}

By default, returns metadata for all studies currently in Open GWAS database.
}
\examples{
# Only run the examples if user has internet access
# and if access token has been added
if(try(is.character(getURL("www.google.com")))==TRUE && ieugwasr::get_opengwas_jwt()!=""){
### By ID
metagwas <- find_sumstats(ids = c(
    "ieu-b-4760",
    "prot-a-1725",
    "prot-a-664"
))
### By ID and sample size
metagwas <- find_sumstats(
    ids = c("ieu-b-4760", "prot-a-1725", "prot-a-664"),
    min_sample_size = 5000
)
### By criteria
metagwas <- find_sumstats(
    traits = c("alzheimer", "parkinson"),
    years = seq(2015, 2021)
)
}
}
